package br.com.centralit.api.dao;

import java.util.Collection;

import br.com.centralit.api.model.CredencialProcesso;
import br.com.centralit.api.viewHelper.GrupoUsuarioVH;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAO;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 08/03/2016 - 16:42:12
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
public interface CredencialProcessoDao extends CitGenericDAO {

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por listar grupos e usuarios do sistema
	 * 
	 * @author rogerio.costa
	 * 
	 * @return Collection<GrupoUsuarioVH>
	 */
	Collection<GrupoUsuarioVH> findGrupoUsuarioByName(String nome);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por obter através do id do usuario e processo selecionado
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idProcesso
	 * @param idUsuario
	 * @return CredencialProcesso
	 */
	CredencialProcesso obterPorUsuarioEProcesso(Long idProcesso, Long idUsuario);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por obter através do id do grupo e processo selecionado
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idProcesso
	 * @param idUsuario
	 * @return CredencialProcesso
	 */
	CredencialProcesso obterPorGrupoEProcesso(Long idProcesso, Long idGrupo);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por verificar se o usuario contem credencial
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idUsuario
	 * @param idProcesso
	 * @return Boolean
	 */
	Boolean contemCredencial(Long idUsuario, Long idProcesso);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por listar através do id do processo
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idProcesso
	 * @return Collection<CredencialProcesso>
	 */
	Collection<CredencialProcesso> findByIdProcesso(Long idProcesso);

}
