package br.com.centralit.api.dao;

import java.util.Calendar;
import java.util.Collection;

import br.com.centralit.api.model.DocumentoGed;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAO;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 08/03/2016 - 16:41:49
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
public interface DocumentoGedDao extends CitGenericDAO {

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por encontrar documentos ged pelo id do processo
	 * 
	 * @author halan.lima
	 * 
	 * @param idProcesso
	 * @return
	 */
	Collection<DocumentoGed> findByProcesso(Long idProcesso);

	Collection<DocumentoGed> findByIdProcessoUltimaVersao(Long id);

	Collection<DocumentoGed> findByIdDocumentoTodasVersoes(Long id);

	Collection<DocumentoGed> findByIdDocumentoTodasVersoesAtivas(Long id);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por obter documento através do processo, tipoDocumento e numero
	 * 
	 * @author rogerio.costa
	 * 
	 * @param documentoGed
	 * 
	 * @return DocumentoGed
	 */
	DocumentoGed obterPorProcessoTipoDocumentoENumero(DocumentoGed documentoGed);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por obter o ultimo numero do processo e tipoProcesso
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idTipoDocumento
	 * @param idProcesso
	 * @return
	 */
	Long obterQuantidadePorTipoDocumentoEDataCriacao(Long idTipoDocumento, Calendar dataInicial, Calendar dataFinal);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por obter através do id do PlanoClassificacao
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idPlanoClassificacao
	 * 
	 * @return Collection<Processo>
	 */
	Collection<DocumentoGed> findPorPlanoClassificacao(Long idPlanoClassificacao);

	/**
	 * 
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por
	 * 
	 * @author andre.silva
	 * 
	 * @param idProcesso
	 * @return
	 */
	Collection<DocumentoGed> findByProcessoSigilo(Long idProcesso);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por verificar se o documento é sigiloso através do id
	 * 
	 * @author rogerio.costa
	 * 
	 * @param id
	 * 
	 * @return Sigilo
	 */
	Boolean isSigiloso(Long id);

}
