package br.com.centralit.api.dao;

import java.util.Collection;

import br.com.centralit.api.model.HistoricoAlteracaoProcesso;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAO;

public interface HistoricoAlteracaoProcessoDao extends CitGenericDAO {

	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por retornar o numero de historicos de um determinado processo
	 *
	 * @author halan.lima
	 *
	 * @param idProcesso
	 * @return
	 */
	Integer countByProcesso(Long idProcesso);
	
	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por buscar historicos por processo e paginacao
	 *
	 * @author halan.lima
	 *
	 * @param idProcesso
	 * @param inicio
	 * @param max
	 * @return
	 */
	Collection<HistoricoAlteracaoProcesso> findByProcessoPaginado(Long idProcesso, Integer inicio, Integer max);
}
