package br.com.centralit.api.dao;

import br.com.centralit.api.model.TarjaAssinatura;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAO;
import br.com.centralit.framework.model.Dominio;


/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governan&ccedil;a Corporativa - </p>
 *
 * <p><b>Description: </b></p>
 * Interface DAO para itera&ccedil;&atilde;o com banco de dados para os objetos de {@link TarjaAssinaturaDao}
 *
 * @since 14 de abr de 2016 - 10:21:47
 * @version 1.0.0
 * @author ciro.junior (<a href="mailto:ciro.junior@centralit.com.br">ciro.junior@centralit.com.br</a>)
 *
 */
public interface TarjaAssinaturaDao extends CitGenericDAO {
	
	/**
	 * Método responsável por obter tarja assinatura interna
	 * @author rogerio.cassimiro
	 * @param dominio
	 * @return {@link TarjaAssinatura}
	 */
	TarjaAssinatura getTarjaAssinaturaInterna(Dominio dominio);
}
