package br.com.centralit.api.dao;

import org.springframework.stereotype.Repository;

import br.com.centralit.api.model.TarjaAssinatura;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;
import br.com.centralit.framework.dao.arquitetura.SearchSeven;
import br.com.centralit.framework.model.Dominio;

/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governan&ccedil;a Corporativa - </p>
 *
 * <p><b>Description: </b></p>
 * Interface DAO para itera&ccedil;&atilde;o com banco de dados para os objetos de {@link TarjaAssinaturaDao}
 *
 * @since 14 de abr de 2016 - 10:21:47
 * @version 1.0.0
 * @author ciro.junior (<a href="mailto:ciro.junior@centralit.com.br">ciro.junior@centralit.com.br</a>)
 *
 */
@Repository("tarjaAssinaturaDao")
public class TarjaAssinaturaDaoHibernate extends CitGenericDAOImpl implements TarjaAssinaturaDao {

	public TarjaAssinaturaDaoHibernate() {
		super(TarjaAssinatura.class);
	}

	/**
	 * Método responsável por obter tarja assinatura interna
	 * @author rogerio.cassimiro
	 * @param dominio
	 * @return {@link TarjaAssinatura}
	 */
	@Override
	public TarjaAssinatura getTarjaAssinaturaInterna(Dominio dominio){
		SearchSeven searchSeven = new SearchSeven(Boolean.TRUE);
		searchSeven.addFilterEqual("tipoAssinatura.id", dominio.getId());
		return searchUnique(searchSeven);
	}
}
