package br.com.centralit.api.dao;

import java.util.Collection;

import br.com.centralit.api.model.Processo;
import br.com.centralit.api.model.UnidadeProcesso;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAO;
import br.com.centralit.framework.model.Usuario;

import com.googlecode.genericdao.search.ISearch;
import com.googlecode.genericdao.search.SearchResult;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 05/01/2016 - 14:46:14
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
public interface UnidadeProcessoDao extends CitGenericDAO {

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idProcesso
	 * @return
	 */
	Collection<UnidadeProcesso> findByIdProcesso(Long idProcesso);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por verificar se o processo foi concluido em todas as unidades
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idProcesso
	 * 
	 * @return Boolean
	 */
	Boolean isProcessoConcluidoEmTodasUnidades(Long idProcesso);

	/**
	 * 
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por
	 * 
	 * @author andre.silva
	 * 
	 * @param processo
	 * @return
	 */
	Collection<UnidadeProcesso> findProcesso(Processo processo);
	
	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por
	 *
	 * @author maycon.silva
	 *
	 * @param processo
	 * @return
	 */
	public Collection<UnidadeProcesso> findByPorIdProcessoEmExecucao(Long idProcesso);
	

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por obter através da unidade e processo
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idProcesso
	 * @param idUnidade
	 * @return UnidadeProcesso
	 */
	UnidadeProcesso obterPorUnidadeEProcesso(Long idProcesso, Long idUnidade);
	
	
	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por
	 *
	 * @author maycon.silva
	 *
	 * @param idProcesso
	 * @param idUnidade
	 * @return
	 */
	UnidadeProcesso obterPorUnidadeEProcessoEmExecucao(Long idProcesso, Long idUnidade);

	/**
	 * Método responsável por listar processos através da unidade do usuário
	 * 
	 * @author rogerio.cassimiro
	 * @param search
	 * @param usuario
	 * @param idStatus
	 * @return <RT> SearchResult<RT>
	 */
	<RT> SearchResult<RT> searchAndCountPorUnidade(ISearch search, Usuario usuario, Long idStatus);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por verificar se o processo foi enviado para outra unidade
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idProcesso
	 * 
	 * @return Boolean
	 */
	Boolean isProcessoEnviado(Long idProcesso);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por verificar se o processo pertence a unidade
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idProcesso
	 * @param idUnidade
	 * @return boolean
	 */
	boolean isProcessoNaUnidadeUsuarioLogado(Long idProcesso, Long idUnidade);

}
