package br.com.centralit.api.dao.impl;

import java.util.Collection;

import org.hibernate.Criteria;
import org.hibernate.Session;
import org.hibernate.criterion.Restrictions;
import org.springframework.stereotype.Repository;

import br.com.centralit.api.dao.AnexarProcessoDao;
import br.com.centralit.api.model.AnexoProcesso;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;
import br.com.centralit.framework.dao.arquitetura.SearchSeven;
import br.com.centralit.framework.util.UtilColecao;

/**
 * 
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 10/02/2016 - 16:44:19
 * 
 * @version 1.0.0
 * 
 * @author andre.silva
 * 
 */

@Repository("anexarProcessoDao")
public class AnexarProcessoDaoHibernate extends CitGenericDAOImpl implements AnexarProcessoDao {

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 */
	public AnexarProcessoDaoHibernate() {

		super(AnexoProcesso.class);
	}

	@SuppressWarnings("unchecked")
	@Override
	public Collection<AnexoProcesso> findByIdProcesso(Long id) {

		Session session = (Session) this.em().getDelegate();

		Criteria criteria = session.createCriteria(persistentClass);

		criteria.createAlias("processos", "processo");

		criteria.add(Restrictions.eq("processo.id", id));

		return criteria.list();
	}

	@Override
	public AnexoProcesso anexoProcessoByIdProcesso(Long idProcesso, Long idProcessoAnexado) {

		SearchSeven search = new SearchSeven(persistentClass);

		search.addFilterEqual("processo.id", idProcessoAnexado);

		search.addFilterEqual("processoAnexado.id", idProcesso);

		search(search, AnexoProcesso.class);

		return searchUnique(search);
	}

	@SuppressWarnings("unchecked")
	@Override
	public Collection<AnexoProcesso> findByIdAnexoProcesso(Long id) {

		Session session = (Session) this.em().getDelegate();

		Criteria criteria = session.createCriteria(persistentClass);

		criteria.createAlias("processos", "processo");

		criteria.add(Restrictions.ne("processo.id", id));

		return criteria.list();
	}

	
	@Override
	public boolean isExisteAnexoProcesso(Long idProcessoAnexado) {

		SearchSeven searchSeven = new SearchSeven();
		
		searchSeven.addFilterEqual("processoAnexado.id", idProcessoAnexado);
		
		return !UtilColecao.isVazio(this.search(searchSeven));
		
	}

}
