package br.com.centralit.api.dao.impl;

import org.springframework.stereotype.Repository;

import br.com.centralit.api.dao.AssinaturaDao;
import br.com.centralit.api.model.Assinatura;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;
import br.com.centralit.framework.dao.arquitetura.SearchSeven;


/**
 * <p><b>Title: </b></p>
 * <p><b>Description: </b></p>
 * 
 * @since 22/04/2016 - 11:54:06
 * @author rogerio.cassimiro
 *	
 */
@Repository("assinaturaDao")
public class AssinaturaDaoHibernate extends CitGenericDAOImpl implements AssinaturaDao{

	public AssinaturaDaoHibernate() {
		super(Assinatura.class);
	}
	
	/**
	 * Método responsável por validar se o usuário já teve assinatura anterior para o documento informado
	 * @author rogerio.cassimiro
	 * @param idDocumento
	 * @param idUsuario
	 * @return {@link Boolean}
	 */
	@Override
	public Boolean validarAssinaturaPorUsuario(Long idDocumento, Long idUsuario) {
		SearchSeven searchSeven = new SearchSeven();
		searchSeven.addFilterEqual("documentoGed.id", idDocumento);
		searchSeven.addFilterEqual("usuario.id", idUsuario);
		return this.count(searchSeven) > 0;
	}
	
}