package br.com.centralit.api.dao.impl;

import java.util.Collection;
import java.util.List;

import org.springframework.stereotype.Repository;

import br.com.centralit.api.dao.ConfiguracaoUsuarioUnidadeDao;
import br.com.centralit.api.model.ConfiguracaoUsuarioUnidade;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;
import br.com.centralit.framework.dao.arquitetura.SearchSeven;
import br.com.centralit.framework.model.Usuario;
import br.com.centralit.framework.model.arquitetura.PersistentObject;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 08/12/2015 - 09:51:51
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Repository("configuracaoUsuarioUnidadeDao")
public class ConfiguracaoUsuarioUnidadeDaoHibernate extends CitGenericDAOImpl implements ConfiguracaoUsuarioUnidadeDao {

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 */
	public ConfiguracaoUsuarioUnidadeDaoHibernate() {

		super(ConfiguracaoUsuarioUnidade.class);
	}

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por listar configuracaoUnidade através do usuario logado e organização ativa
	 * 
	 * @author rogerio.costa
	 * 
	 * @param usuario
	 * @return Collection<ConfiguracaoUsuarioUnidade>
	 */
	public Collection<ConfiguracaoUsuarioUnidade> findPorUsuarioOrganizacao(Usuario usuario) {

		SearchSeven searchSeven = new SearchSeven();

		searchSeven.addFilterEqual("usuario.id", usuario.getId());

		searchSeven.addFilterEqual("organizacao.id", usuario.getOrganizacao().getId());

		return search(searchSeven);
	}

	@Override
	public Collection<ConfiguracaoUsuarioUnidade> findPorIdEstruturaOrganizacionalECM(Long idEstruturaECM) {

		SearchSeven searchSeven = new SearchSeven();

		searchSeven.addFilterEqual("estruturaOrganizacionalECM.id", idEstruturaECM);

		return this.search(searchSeven);
	}

	@Override
	public List<PersistentObject> findAll() {

		SearchSeven searchSeven = new SearchSeven();

		return this.search(searchSeven, this.persistentClass);
	}

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por listar usuarios através da unidade e username
	 * 
	 * @author rogerio.costa
	 * 
	 * @param username
	 * @param idUnidade
	 * @return Collection<Usuario>
	 */
	public Collection<ConfiguracaoUsuarioUnidade> findPorUsernameUsuarioAndUnidade(String username, Long idUnidade) {

		SearchSeven searchSeven = new SearchSeven();

		searchSeven.addFilterILike("usuario.username", "%" + username + "%");

		searchSeven.addFilterEqual("estruturaOrganizacionalECM.id", idUnidade);

		return this.search(searchSeven);
	}

}
