package br.com.centralit.api.dao.impl;

import java.util.List;

import org.springframework.stereotype.Repository;

import br.com.centralit.api.dao.EstruturaOrganizacionalECMDao;
import br.com.centralit.api.model.EstruturaOrganizacionalECM;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;
import br.com.centralit.framework.dao.arquitetura.SearchSeven;

import com.googlecode.genericdao.search.Filter;
import com.googlecode.genericdao.search.Sort;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 14/12/2015 - 09:27:53
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Repository("estruturaOrganizacionalECMDao")
public class EstruturaOrganizacionalECMDaoHibernate extends CitGenericDAOImpl implements EstruturaOrganizacionalECMDao {

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 */
	public EstruturaOrganizacionalECMDaoHibernate() {

		super(EstruturaOrganizacionalECM.class);
	}

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por
	 * 
	 * @author rogerio.costa
	 * 
	 * @param nome
	 * @param idOrganizacao
	 * @return
	 */
	public List<EstruturaOrganizacionalECM> findPorNomeEstruturaOrganizacional(String nome, Long idOrganizacao) {

		SearchSeven search = new SearchSeven(this.persistentClass);

		search.addFilterOr(Filter.ilike("estruturaOrganizacional.nome", "%" + nome + "%"), Filter.ilike("estruturaOrganizacional.classificacao", "%" + nome + "%"), Filter.ilike("estruturaOrganizacional.codigo", "%" + nome + "%"));

		search.addFilterEqual("organizacao.id", idOrganizacao);

		search.addSort(Sort.asc("nome"));

		search.setMaxResults(10);

		return this.search(search, this.persistentClass);
	}

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por obter através do id da estruturaOrganizacional.
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idEstrutura
	 * 
	 * @return EstruturaOrganizacionalECM
	 */
	public EstruturaOrganizacionalECM obterPorIdEstruturaOrganizacional(Long idEstrutura) {

		SearchSeven search = new SearchSeven(this.persistentClass);

		search.addFilterEqual("estruturaOrganizacional.id", idEstrutura);

		return this.searchUnique(search, persistentClass);
	}

}
