package br.com.centralit.api.dao.impl;

import java.util.Collection;

import org.springframework.stereotype.Repository;

import com.googlecode.genericdao.search.Filter;

import br.com.centralit.api.dao.HipoteseLegalDao;
import br.com.centralit.api.model.HipoteseLegal;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;
import br.com.centralit.framework.dao.arquitetura.SearchSeven;

@Repository("hipoteseLegalDao")
public class HipoteseLegalDaoHibernate extends CitGenericDAOImpl implements HipoteseLegalDao {

	public HipoteseLegalDaoHibernate() {

		super(HipoteseLegal.class);
	}

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por listar através do nivelAcesso
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idNivelAcesso
	 * 
	 * @return Collection<HipoteseLegal>
	 */
	public Collection<HipoteseLegal> findPorNivelAcesso(Long idNivelAcesso) {

		SearchSeven searchSeven = new SearchSeven();

		searchSeven.addFilterOr(Filter.equal("nivelAcesso.id", idNivelAcesso), Filter.equal("sigilo.id", idNivelAcesso));

		return this.search(searchSeven);

	}
}
