package br.com.centralit.api.dao.impl;

import java.util.Collection;

import org.springframework.stereotype.Repository;

import br.com.centralit.api.dao.HistoricoAlteracaoProcessoDao;
import br.com.centralit.api.model.HistoricoAlteracaoProcesso;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;
import br.com.centralit.framework.dao.arquitetura.SearchSeven;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 04/01/2016 - 17:22:17
 * 
 * @version 1.0.0
 * 
 * @author halan.lima
 * 
 */
@Repository("historicoAlteracaoProcessoDaoDao")
public class HistoricoAlteracaoProcessoDaoHibernate extends CitGenericDAOImpl implements HistoricoAlteracaoProcessoDao {

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 */
	public HistoricoAlteracaoProcessoDaoHibernate() {

		super(HistoricoAlteracaoProcesso.class);
	}

	@Override
	public Integer countByProcesso(Long idProcesso) {

		SearchSeven searchSeven = new SearchSeven();

		searchSeven.addFilterEqual("processo.id", idProcesso);

		return this.count(searchSeven);
	}

	@Override
	public Collection<HistoricoAlteracaoProcesso> findByProcessoPaginado(Long idProcesso, Integer inicio, Integer max) {

		SearchSeven searchSeven = new SearchSeven();

		searchSeven.addFilterEqual("processo.id", idProcesso);

		if (null != inicio) {
			searchSeven.setFirstResult(inicio);
		}

		if (null != max) {
			searchSeven.setMaxResults(max);
		}

		searchSeven.addSortDesc("dataRegistro");

		return this.search(searchSeven);
	}

}
