package br.com.centralit.api.dao.impl;

import org.springframework.stereotype.Repository;

import br.com.centralit.api.dao.HistoricoAtribuicaoProcessoDao;
import br.com.centralit.api.model.HistoricoAtribuicaoProcesso;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;
import br.com.centralit.framework.dao.arquitetura.SearchSeven;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 02/04/2016 - 10:41:26
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Repository("historicoAtribuicaoProcessoDao")
public class HistoricoAtribuicaoProcessoDaoHibernate extends CitGenericDAOImpl implements HistoricoAtribuicaoProcessoDao {

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 */
	public HistoricoAtribuicaoProcessoDaoHibernate() {

		super(HistoricoAtribuicaoProcesso.class);
	}

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por obter utima atribuição através do id da unidadeProcesso
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idUnidadeProcesso
	 * @return HistoricoAtribuicaoProcesso
	 */
	public HistoricoAtribuicaoProcesso obterAtualPorUnidadeProcesso(Long idUnidadeProcesso) {

		SearchSeven searchSeven = new SearchSeven();

		searchSeven.addFilterEqual("unidadeProcesso.id", idUnidadeProcesso);

		searchSeven.addFilterEmpty("dataRemocao");

		searchSeven.setMaxResults(1);

		return this.searchUnique(searchSeven);
	}
}
