package br.com.centralit.api.dao.impl;

import java.util.Collection;

import org.springframework.stereotype.Repository;

import br.com.centralit.api.dao.HistoricoCredencialProcessoDao;
import br.com.centralit.api.model.CredencialProcesso;
import br.com.centralit.api.model.HistoricoCredencialProcesso;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;
import br.com.centralit.framework.dao.arquitetura.SearchSeven;
import br.com.centralit.framework.util.UtilObjeto;

import com.googlecode.genericdao.search.Filter;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 11/03/2016 - 15:47:49
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Repository("historicoCredencialProcessoDao")
public class HistoricoCredencialProcessoDaoHibernate extends CitGenericDAOImpl implements HistoricoCredencialProcessoDao {

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 */
	public HistoricoCredencialProcessoDaoHibernate() {

		super(HistoricoCredencialProcesso.class);
	}

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por listar através do id do processo e processoRemocao
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idProcesso
	 * 
	 * @return Collection<HistoricoCredencialProcesso>
	 */
	public Collection<HistoricoCredencialProcesso> findByIdProcessoAndIdProcessoRemocao(Long idProcesso) {

		SearchSeven searchSeven = new SearchSeven();

		searchSeven.addFilterOr(Filter.equal("credencialProcesso.processo.id", idProcesso), Filter.equal("credencialProcesso.processoRemocao.id", idProcesso));

		return this.search(searchSeven);

	}

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por listar através da credencial e credenciado
	 * 
	 * @author rogerio.costa
	 * 
	 * @param credencialProcesso
	 * 
	 * @return HistoricoCredencialProcesso
	 */
	public HistoricoCredencialProcesso findByCredencialAndCredenciado(CredencialProcesso credencialProcesso) {

		SearchSeven searchSeven = new SearchSeven();
		
		searchSeven.addFilterEqual("credencialProcesso.id", credencialProcesso.getId());

		if (UtilObjeto.isReferencia(credencialProcesso.getGrupo())) {

			searchSeven.addFilterEqual("grupo.id", credencialProcesso.getGrupo().getId());
		} else {

			searchSeven.addFilterEqual("usuario.id", credencialProcesso.getUsuario().getId());
		}

		return this.searchUnique(searchSeven);
	}

}
