package br.com.centralit.api.dao.impl;

import java.util.Collection;

import org.hibernate.Criteria;
import org.hibernate.Session;
import org.hibernate.criterion.Restrictions;
import org.springframework.stereotype.Repository;

import br.com.centralit.api.dao.ProcessoRelacionadoDao;
import br.com.centralit.api.model.ProcessoRelacionado;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;
import br.com.centralit.framework.dao.arquitetura.SearchSeven;

@Repository("ProcessoRelacionadoDao")
public class ProcessoRelacionadoDaoHibernate extends CitGenericDAOImpl implements ProcessoRelacionadoDao {

	public ProcessoRelacionadoDaoHibernate() {

		super(ProcessoRelacionado.class);
	}

	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por consultar uma lista de processo filho
	 *
	 * @author maycon.silva
	 *
	 * @param idProcesso (Processo Pai)
	 * @return lista de processo relacionado
	 */
	@SuppressWarnings("unchecked")
	@Override
	public Collection<ProcessoRelacionado> findByIdProcesso(Long id) {

		Session session = (Session) this.em().getDelegate();

		Criteria criteria = session.createCriteria(persistentClass);

		criteria.createAlias("processos", "processo");

		criteria.add(Restrictions.eq("processo.id", id));

		return criteria.list();
	}
	
	
	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por
	 *
	 * @author maycon.silva
	 *
	 * @param idProcesso (Processo Pai)
	 * @param idProcessoRelacionado (Processo Filho)
	 * @return
	 */
	public ProcessoRelacionado processoRelacionadoByIdProcesso(Long idProcesso, Long idProcessoRelacionado) {	
		
	    SearchSeven search = new SearchSeven(persistentClass); 
		
		search.addFilterEqual("processo.id", idProcessoRelacionado);
		
		search.addFilterEqual("processoRelacionado.id", idProcesso);
		
		search(search, ProcessoRelacionado.class);
		
		return searchUnique(search);

	}
}
