package br.com.centralit.api.dao.impl;

import java.util.Collection;
import java.util.List;

import javax.persistence.Query;

import org.springframework.stereotype.Repository;

import br.com.centralit.api.dao.TipoProcessoDao;
import br.com.centralit.api.model.TipoProcesso;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;

@Repository("tipoProcessoDao")
public class TipoProcessoDaoHibernate extends CitGenericDAOImpl implements TipoProcessoDao {

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 */
	public TipoProcessoDaoHibernate() {

		super(TipoProcesso.class);
	}

	@Override
	public Collection<TipoProcesso> getTipoProcessoByNome(String nome) {
		Query query = em().createQuery("select tipoProcesso from TipoProcesso tipoProcesso where tipoProcesso.nome = :nome or UPPER(tipoProcesso.nome) = UPPER(:nome)");
		query.setParameter("nome", nome);

		List tiposProcessos = query.getResultList();

		return tiposProcessos;
	}
}
