package br.com.centralit.api.dao.impl;

import java.util.Collection;

import org.springframework.stereotype.Repository;

import br.com.centralit.api.dao.TipoProcessoPlanoClassificacaoDao;
import br.com.centralit.api.model.TipoProcessoPlanoClassificacao;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;
import br.com.centralit.framework.dao.arquitetura.SearchSeven;

@Repository("tipoProcessoPlanoClassificacaoDao")
@SuppressWarnings("unchecked")
public class TipoProcessoPlanoClassificacaoDaoHibernate extends CitGenericDAOImpl implements TipoProcessoPlanoClassificacaoDao {

	public TipoProcessoPlanoClassificacaoDaoHibernate() {

		super(TipoProcessoPlanoClassificacao.class);
	}

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por listar através do id do tipoProcesso
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idTipoProcesso
	 * @return Collection<TipoProcessoPlanoClassificacao>
	 */
	public Collection<TipoProcessoPlanoClassificacao> findPorIdTipoProcesso(Long idTipoProcesso) {

		SearchSeven searchSeven = new SearchSeven(TipoProcessoPlanoClassificacao.class);

		searchSeven.addFilterEqual("tipoProcesso.id", idTipoProcesso);

		return this._search(searchSeven);

	}
}
