package br.com.centralit.api.model;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;

import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObject;

import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 11/01/2016 - 11:46:18
 * 
 * @version 1.0.0
 * 
 * @author halan.lima
 * 
 */
@Entity
public class AcaoHistoricoAlteracaoProcesso extends PersistentObject {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 3898316448079015318L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	private String chave;

	private String acao;

	private String descricao;
	
	public static String ASSINAR_DOCUMENTO_CHAVE = "ASSINAR_DOCUMENTO";
	public static String ASSINAR_DOCUMENTO_ACAO = "Assinatura de documento";
	public static String ASSINAR_DOCUMENTO_DESCRICAO =	"O documento <<tipo_documento>> <<numero_documento>> foi assinado por <<usuario>>.";
	
	public static String ALTERAR_ATRIBUICAO_PROCESSO_DESCRICAO = "Processo atribuído a <<usuario>>.";
	public static String ALTERAR_ATRIBUICAO_PROCESSO_ACAO =  "Alteração de atribuição de Processo";
	public static String ALTERAR_ATRIBUICAO_PROCESSO_CHAVE = "ALTERAR_ATRIBUICAO_PROCESSO";
	
	public static String INICIAR_ATRIBUICAO_PROCESSO_DESCRICAO = "Processo atribuído a <<usuario>>.";
	public static String INICIAR_ATRIBUICAO_PROCESSO_ACAO =  "Atribuição do processo";
	public static String INICIAR_ATRIBUICAO_PROCESSO_CHAVE = "INICIAR_ATRIBUICAO_PROCESSO";
	
	public static String INCLUSAO_PROCESSO_DESCRICAO = "Processo <<protocolo>> criado.";
	public static String INCLUSAO_PROCESSO_ACAO =  "Inclusão do processo";
	public static String INCLUSAO_PROCESSO_CHAVE = "INCLUSAO_PROCESSO";
	
	public static String REABERTURA_DE_PROCESSO_DESCRICAO = "Processo <<protocolo>> reaberto.";
	public static String REABERTURA_DE_PROCESSO_ACAO =  "Reabertura de processo";
	public static String REABERTURA_DE_PROCESSO_CHAVE = "REABERTURA_DE_PROCESSO";
	

	public AcaoHistoricoAlteracaoProcesso() {

		super();
	}

	public AcaoHistoricoAlteracaoProcesso( String chave, String acao, String descricao ) {

		this.chave = chave;
		this.acao = acao;
		this.descricao = descricao;
	}

	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	@Override
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>acao</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getAcao() {

		return acao;
	}

	/**
	 * Define o valor do atributo <code>acao</code>.
	 * 
	 * @param acao
	 */
	public void setAcao(String acao) {

		this.acao = acao;
	}

	/**
	 * Retorna o valor do atributo <code>descricao</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getDescricao() {

		return descricao;
	}

	/**
	 * Define o valor do atributo <code>descricao</code>.
	 * 
	 * @param descricao
	 */
	public void setDescricao(String descricao) {

		this.descricao = descricao;
	}

	/**
	 * Retorna o valor do atributo <code>chave</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getChave() {

		return chave;
	}

	/**
	 * Define o valor do atributo <code>chave</code>.
	 * 
	 * @param chave
	 */
	public void setChave(String chave) {

		this.chave = chave;
	}

}
