package br.com.centralit.api.model;

import java.util.Calendar;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import br.com.centralit.framework.json.JsonCalendarSimpleDateDeserializer;
import br.com.centralit.framework.json.JsonCalendarSimpleDateSerializer;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAudit;

import com.fasterxml.jackson.annotation.JsonView;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>AcessoExterno
 * </p>
 * 
 * <p>
 * <b>Description: </b>Modelo de entidade<code>AcessoExterno</code>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 16/10/2015 - 14:06:54
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Entity
public class AcessoExterno extends PersistentObjectAudit {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 5738964350521138142L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo chaveAcesso. */
	private String chaveAcesso;

	/** Atributo dataFimAcesso. */
	@Temporal(TemporalType.TIMESTAMP)
	@JsonSerialize(using = JsonCalendarSimpleDateSerializer.class)
	@JsonDeserialize(using = JsonCalendarSimpleDateDeserializer.class)
	private Calendar dataFimAcesso;

	/** Atributo emailDestinatario. */
	private String emailDestinatario;

	/** Atributo processo. */
	@ManyToOne(fetch = FetchType.LAZY)
	private Processo processo;

	/** Atributo pocumento. */
	@ManyToOne(fetch = FetchType.LAZY)
	private Documento documento;

	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>chaveAcesso</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getChaveAcesso() {

		return chaveAcesso;
	}

	/**
	 * Define o valor do atributo <code>chaveAcesso</code>.
	 * 
	 * @param chaveAcesso
	 */
	public void setChaveAcesso(String chaveAcesso) {

		this.chaveAcesso = chaveAcesso;
	}

	/**
	 * Retorna o valor do atributo <code>dataFimAcesso</code>
	 * 
	 * @return <code>Calendar</code>
	 */
	public Calendar getDataFimAcesso() {

		return dataFimAcesso;
	}

	/**
	 * Define o valor do atributo <code>dataFimAcesso</code>.
	 * 
	 * @param dataFimAcesso
	 */
	public void setDataFimAcesso(Calendar dataFimAcesso) {

		this.dataFimAcesso = dataFimAcesso;
	}

	/**
	 * Retorna o valor do atributo <code>emailDestinatario</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getEmailDestinatario() {

		return emailDestinatario;
	}

	/**
	 * Define o valor do atributo <code>emailDestinatario</code>.
	 * 
	 * @param emailDestinatario
	 */
	public void setEmailDestinatario(String emailDestinatario) {

		this.emailDestinatario = emailDestinatario;
	}

	/**
	 * Retorna o valor do atributo <code>processo</code>
	 * 
	 * @return <code>Processo</code>
	 */
	public Processo getProcesso() {

		return processo;
	}

	/**
	 * Define o valor do atributo <code>processo</code>.
	 * 
	 * @param processo
	 */
	public void setProcesso(Processo processo) {

		this.processo = processo;
	}

	/**
	 * Retorna o valor do atributo <code>documento</code>
	 * 
	 * @return <code>Documento</code>
	 */
	public Documento getDocumento() {

		return documento;
	}

	/**
	 * Define o valor do atributo <code>documento</code>.
	 * 
	 * @param documento
	 */
	public void setDocumento(Documento documento) {

		this.documento = documento;
	}

}
