package br.com.centralit.api.model;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToOne;
import javax.persistence.Transient;

import org.springframework.web.multipart.MultipartFile;

import br.com.centralit.api.framework.json.ViewsEcm;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.Dominio;
import br.com.centralit.framework.service.arquitetura.DocumentoGedInterface;

import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 16/12/2015 - 15:31:08
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Entity
public class AnexoGed extends PersistentObjectUnidade implements DocumentoGedInterface {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = -1705013531566490993L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo versionKey. */
	private String versionKey;

	/** Atributo entityKey. */
	private String entityKey;

	/** Atributo directoryKey. */
	private String directoryKey;

	/** Atributo documentKey. */
	private String documentKey;

	/** Atributo descricao. */
	@JsonView({ ViewsEcm.DocumentoGedEdit.class, Views.ProcessoEdit.class })
	private String descricao;

	/** Atributo tamanho. */
	@JsonView({ ViewsEcm.DocumentoGedEdit.class, Views.ProcessoEdit.class })
	private Long tamanho;

	/** Atributo documentoGed. */
	@OneToOne
	@JoinColumn(name = "documento")
	private DocumentoGed documentoGed;

	/** Atributo documentoRemocao. */
	@ManyToOne(fetch = FetchType.LAZY)
	private DocumentoGed documentoRemocao;

	/** Atributo dominioTipoAnexo. */
	@ManyToOne(fetch = FetchType.EAGER, optional = true)
	@JsonView({ ViewsEcm.DocumentoGedEdit.class, Views.ProcessoEdit.class, Views.ProcessoVHView.class})
	private Dominio dominioTipoAnexo;

	/** Atributo MultipartFile. */
	@Transient
	private MultipartFile file;

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * 
	 * @param directoryKey
	 * @param entityKey
	 * @param documentKey
	 * @param versionKey
	 * @param file
	 */
	public AnexoGed( String descricao, Long tamanho, String directoryKey, String entityKey, String documentKey, String versionKey, MultipartFile file ) {

		this.descricao = descricao;

		this.tamanho = tamanho;

		this.directoryKey = directoryKey;

		this.entityKey = entityKey;

		this.documentKey = documentKey;

		this.versionKey = versionKey;

		this.file = file;

	}

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 */
	public AnexoGed() {

		super();
	}

	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>versionKey</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getVersionKey() {

		return versionKey;
	}

	/**
	 * Define o valor do atributo <code>versionKey</code>.
	 * 
	 * @param versionKey
	 */
	public void setVersionKey(String versionKey) {

		this.versionKey = versionKey;
	}

	/**
	 * Retorna o valor do atributo <code>entityKey</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getEntityKey() {

		return entityKey;
	}

	/**
	 * Define o valor do atributo <code>entityKey</code>.
	 * 
	 * @param entityKey
	 */
	public void setEntityKey(String entityKey) {

		this.entityKey = entityKey;
	}

	/**
	 * Retorna o valor do atributo <code>directoryKey</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getDirectoryKey() {

		return directoryKey;
	}

	/**
	 * Define o valor do atributo <code>directoryKey</code>.
	 * 
	 * @param directoryKey
	 */
	public void setDirectoryKey(String directoryKey) {

		this.directoryKey = directoryKey;
	}

	/**
	 * Retorna o valor do atributo <code>documentKey</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getDocumentKey() {

		return documentKey;
	}

	/**
	 * Define o valor do atributo <code>documentKey</code>.
	 * 
	 * @param documentKey
	 */
	public void setDocumentKey(String documentKey) {

		this.documentKey = documentKey;
	}

	/**
	 * Retorna o valor do atributo <code>file</code>
	 * 
	 * @return <code>File</code>
	 */
	public MultipartFile getFile() {

		return file;
	}

	/**
	 * Define o valor do atributo <code>file</code>.
	 * 
	 * @param file
	 */
	public void setFile(MultipartFile file) {

		this.file = file;
	}

	/**
	 * Retorna o valor do atributo <code>documentoGed</code>
	 * 
	 * @return <code>DocumentoGed</code>
	 */
	public DocumentoGed getDocumentoGed() {

		return documentoGed;
	}

	/**
	 * Define o valor do atributo <code>documentoGed</code>.
	 * 
	 * @param documentoGed
	 */
	public void setDocumentoGed(DocumentoGed documentoGed) {

		this.documentoGed = documentoGed;
	}

	/**
	 * Retorna o valor do atributo <code>descricao</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getDescricao() {

		return descricao;
	}

	/**
	 * Define o valor do atributo <code>descricao</code>.
	 * 
	 * @param descricao
	 */
	public void setDescricao(String descricao) {

		this.descricao = descricao;
	}

	/**
	 * Retorna o valor do atributo <code>tamanho</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getTamanho() {

		return tamanho;
	}

	/**
	 * Define o valor do atributo <code>tamanho</code>.
	 * 
	 * @param tamanho
	 */
	public void setTamanho(Long tamanho) {

		this.tamanho = tamanho;
	}

	/**
	 * Retorna o valor do atributo <code>documentoRemocao</code>
	 * 
	 * @return <code>DocumentoGed</code>
	 */
	public DocumentoGed getDocumentoRemocao() {

		return documentoRemocao;
	}

	/**
	 * Define o valor do atributo <code>documentoRemocao</code>.
	 * 
	 * @param documentoRemocao
	 */
	public void setDocumentoRemocao(DocumentoGed documentoRemocao) {

		this.documentoRemocao = documentoRemocao;
	}

	/**
	 * Retorna o valor do atributo <code>dominioTipoAnexo</code>
	 * 
	 * @return <code>Dominio</code>
	 */
	public Dominio getDominioTipoAnexo() {

		return dominioTipoAnexo;
	}

	/**
	 * Define o valor do atributo <code>dominioTipoAnexo</code>.
	 * 
	 * @param dominioTipoAnexo
	 */
	public void setDominioTipoAnexo(Dominio dominioTipoAnexo) {

		this.dominioTipoAnexo = dominioTipoAnexo;
	}

}
