package br.com.centralit.api.model;

import java.util.Collection;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToMany;
import javax.persistence.ManyToOne;

import br.com.centralit.framework.json.Views;

import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>AnexoProcesso
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 20/10/2015 - 09:56:53
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Entity
public class AnexoProcesso extends PersistentObjectUnidade {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = -5171132775026669273L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;
	
	/** Atributo processo. */
	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	@JsonView({ Views.GenericView.class })
	private Processo processoAnexado;

	/** Atributo processo. */
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ Views.GenericView.class })
	private Processo processo;

	/** Atributo processo. */
	private Processo processoRemocao;

	/** Atributo processos. */
	@ManyToMany(cascade = { CascadeType.PERSIST, CascadeType.MERGE }, mappedBy = "anexados", targetEntity = Processo.class)
	private Collection<Processo> processos;
	
	
	@JsonView({ Views.AnexarProcesso.class })
	private Boolean anexado;


	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	
	/**
	 * Retorna o valor do atributo <code>processoAnexado</code>
	 *
	 * @return <code>Processo</code>
	 */
	public Processo getProcessoAnexado() {
	
		return processoAnexado;
	}

	
	/**
	 * Define o valor do atributo <code>processoAnexado</code>.
	 *
	 * @param processoAnexado 
	 */
	public void setProcessoAnexado(Processo processoAnexado) {
	
		this.processoAnexado = processoAnexado;
	}

	
	/**
	 * Retorna o valor do atributo <code>processo</code>
	 *
	 * @return <code>Processo</code>
	 */
	public Processo getProcesso() {
	
		return processo;
	}

	
	/**
	 * Define o valor do atributo <code>processo</code>.
	 *
	 * @param processo 
	 */
	public void setProcesso(Processo processo) {
	
		this.processo = processo;
	}

	
	/**
	 * Retorna o valor do atributo <code>processoRemocao</code>
	 *
	 * @return <code>Processo</code>
	 */
	public Processo getProcessoRemocao() {
	
		return processoRemocao;
	}

	
	/**
	 * Define o valor do atributo <code>processoRemocao</code>.
	 *
	 * @param processoRemocao 
	 */
	public void setProcessoRemocao(Processo processoRemocao) {
	
		this.processoRemocao = processoRemocao;
	}

	
	/**
	 * Retorna o valor do atributo <code>processos</code>
	 *
	 * @return <code>Collection<Processo></code>
	 */
	public Collection<Processo> getProcessos() {
	
		return processos;
	}

	
	/**
	 * Define o valor do atributo <code>processos</code>.
	 *
	 * @param processos 
	 */
	public void setProcessos(Collection<Processo> processos) {
	
		this.processos = processos;
	}

	
	/**
	 * Retorna o valor do atributo <code>anexado</code>
	 *
	 * @return <code>Boolean</code>
	 */
	public Boolean getAnexado() {
	
		return anexado;
	}

	
	/**
	 * Define o valor do atributo <code>anexado</code>.
	 *
	 * @param anexado 
	 */
	public void setAnexado(Boolean anexado) {
	
		this.anexado = anexado;
	}

}
