package br.com.centralit.api.model;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToOne;
import javax.persistence.Transient;

import br.com.centralit.api.framework.json.ViewsEcm;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.Dominio;
import br.com.centralit.framework.model.Usuario;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAudit;

import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>Assinatura
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 20/10/2015 - 09:59:02
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Entity
public class Assinatura extends PersistentObjectAudit {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = -3864895853020891862L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo usuario. */
	@JsonView({ Views.DocumentoGedEdit.class, ViewsEcm.DocumentoGedEdit.class })
	@ManyToOne(fetch = FetchType.LAZY)
	private Usuario usuario;

	/** Atributo documentoGed. */
	@JsonView({ ViewsEcm.AssinaturaEdit.class })
	@ManyToOne(fetch = FetchType.LAZY)
	private DocumentoGed documentoGed;

	/** Atributo tipoAssinatura. */
	@JsonView({ Views.DocumentoGedEdit.class, ViewsEcm.DocumentoGedEdit.class })
	@ManyToOne(fetch = FetchType.LAZY)
	private Dominio tipoAssinatura;

	/** Atributo funcao. */
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ Views.DocumentoGedEdit.class, ViewsEcm.DocumentoGedEdit.class })
	private Funcao funcao;

	/** Atributo idTask. */
	@Transient
	private Long idTask;

	/** Atributo password. */
	@Transient
	private String password;

	/** Atributo conteudoTarja. */
	@OneToOne(cascade = CascadeType.ALL, fetch = FetchType.EAGER)
	@JsonView({ Views.DocumentoGedEdit.class, ViewsEcm.AssinaturaEdit.class })
	private ConteudoTarja conteudoTarja;

	/** Atributo pessoa. */
	@JsonView({ Views.DocumentoGedEdit.class, ViewsEcm.DocumentoGedEdit.class })
	@ManyToOne(fetch = FetchType.LAZY)
	private Pessoa pessoa;

	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>usuario</code>
	 * 
	 * @return <code>Usuario</code>
	 */
	public Usuario getUsuario() {

		return usuario;
	}

	/**
	 * Define o valor do atributo <code>usuario</code>.
	 * 
	 * @param usuario
	 */
	public void setUsuario(Usuario usuario) {

		this.usuario = usuario;
	}

	/**
	 * Retorna o valor do atributo <code>documentoGed</code>
	 * 
	 * @return <code>DocumentoGed</code>
	 */
	public DocumentoGed getDocumentoGed() {

		return documentoGed;
	}

	/**
	 * Define o valor do atributo <code>documentoGed</code>.
	 * 
	 * @param documentoGed
	 */
	public void setDocumentoGed(DocumentoGed documentoGed) {

		this.documentoGed = documentoGed;
	}

	/**
	 * Retorna o valor do atributo <code>tipoAssinatura</code>
	 * 
	 * @return <code>Dominio</code>
	 */
	public Dominio getTipoAssinatura() {

		return tipoAssinatura;
	}

	/**
	 * Define o valor do atributo <code>tipoAssinatura</code>.
	 * 
	 * @param tipoAssinatura
	 */
	public void setTipoAssinatura(Dominio tipoAssinatura) {

		this.tipoAssinatura = tipoAssinatura;
	}

	/**
	 * Retorna o valor do atributo <code>funcao</code>
	 * 
	 * @return <code>Funcao</code>
	 */
	public Funcao getFuncao() {

		return funcao;
	}

	/**
	 * Define o valor do atributo <code>funcao</code>.
	 * 
	 * @param funcao
	 */
	public void setFuncao(Funcao funcao) {

		this.funcao = funcao;
	}

	/**
	 * Retorna o valor do atributo <code>idTask</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getIdTask() {

		return idTask;
	}

	/**
	 * Define o valor do atributo <code>idTask</code>.
	 * 
	 * @param idTask
	 */
	public void setIdTask(Long idTask) {

		this.idTask = idTask;
	}

	/**
	 * Retorna o valor do atributo <code>conteudoTarja</code>
	 * 
	 * @return <code>ConteudoTarja</code>
	 */
	public ConteudoTarja getConteudoTarja() {

		return conteudoTarja;
	}

	/**
	 * Define o valor do atributo <code>conteudoTarja</code>.
	 * 
	 * @param conteudoTarja
	 */
	public void setConteudoTarja(ConteudoTarja conteudoTarja) {

		this.conteudoTarja = conteudoTarja;
	}

	/**
	 * Retorna o valor do atributo <code>password</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getPassword() {

		return password;
	}

	/**
	 * Define o valor do atributo <code>password</code>.
	 * 
	 * @param password
	 */
	public void setPassword(String password) {

		this.password = password;
	}

	/**
	 * Retorna o valor do atributo <code>pessoa</code>
	 * 
	 * @return <code>Pessoa</code>
	 */
	public Pessoa getPessoa() {

		return pessoa;
	}

	/**
	 * Define o valor do atributo <code>pessoa</code>.
	 * 
	 * @param pessoa
	 */
	public void setPessoa(Pessoa pessoa) {

		this.pessoa = pessoa;
	}

}
