package br.com.centralit.api.model;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToOne;

import com.fasterxml.jackson.annotation.JsonView;

import br.com.centralit.api.framework.json.ViewsEcm;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAudit;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 19/01/2016 - 16:27:32
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Entity
public class CancelamentoDocumentoGed extends PersistentObjectAudit {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 5475560623135006219L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo justificativa. */
	@JsonView({ ViewsEcm.CancelamentoDocumentoView.class })
	private String justificativa;

	/** Atributo solicitante. */
	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	@JsonView({ ViewsEcm.CancelamentoDocumentoView.class })
	private Pessoa solicitante;

	/** Atributo documentoGed. */
	@OneToOne
	@JoinColumn(name = "documento")
	private DocumentoGed documentoGed;

	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	@Override
	public Long getId() {

		return this.id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>justificativa</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getJustificativa() {

		return this.justificativa;
	}

	/**
	 * Define o valor do atributo <code>justificativa</code>.
	 * 
	 * @param justificativa
	 */
	public void setJustificativa(String justificativa) {

		this.justificativa = justificativa;
	}

	/**
	 * Retorna o valor do atributo <code>solicitante</code>
	 * 
	 * @return <code>Pessoa</code>
	 */
	public Pessoa getSolicitante() {

		return this.solicitante;
	}

	/**
	 * Define o valor do atributo <code>solicitante</code>.
	 * 
	 * @param solicitante
	 */
	public void setSolicitante(Pessoa solicitante) {

		this.solicitante = solicitante;
	}

	/**
	 * Retorna o valor do atributo <code>documentoGed</code>
	 * 
	 * @return <code>DocumentoGed</code>
	 */
	public DocumentoGed getDocumentoGed() {

		return documentoGed;
	}

	/**
	 * Define o valor do atributo <code>documentoGed</code>.
	 * 
	 * @param documentoGed
	 */
	public void setDocumentoGed(DocumentoGed documentoGed) {

		this.documentoGed = documentoGed;
	}

}
