package br.com.centralit.api.model;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;

import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.Dominio;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAudit;

import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>ConfiguracaoPlanoClassificacao
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 20/10/2015 - 14:21:28
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Entity
public class ConfiguracaoPlanoClassificacao extends PersistentObjectAudit {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = -7642225865955485243L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo faseCorrente. */
	private Integer faseCorrente;

	/** Atributo faseIntermediaria. */
	private Integer faseIntermediaria;

	/** Atributo tipoDestinacao. */
	@ManyToOne(fetch = FetchType.LAZY)
	private Dominio tipoDestinacao;

	/** Atributo tipoTemporalidade. */
	@ManyToOne(fetch = FetchType.LAZY)
	private Dominio tipoTemporalidade;

	/** Atributo planoClassificacao. */
	@ManyToOne(fetch = FetchType.LAZY)
	private PlanoClassificacao planoClassificacao;

	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>faseCorrente</code>
	 * 
	 * @return <code>int</code>
	 */
	public int getFaseCorrente() {

		return faseCorrente;
	}

	/**
	 * Define o valor do atributo <code>faseCorrente</code>.
	 * 
	 * @param faseCorrente
	 */
	public void setFaseCorrente(int faseCorrente) {

		this.faseCorrente = faseCorrente;
	}

	/**
	 * Retorna o valor do atributo <code>faseIntermediaria</code>
	 * 
	 * @return <code>int</code>
	 */
	public int getFaseIntermediaria() {

		return faseIntermediaria;
	}

	/**
	 * Define o valor do atributo <code>faseIntermediaria</code>.
	 * 
	 * @param faseIntermediaria
	 */
	public void setFaseIntermediaria(int faseIntermediaria) {

		this.faseIntermediaria = faseIntermediaria;
	}

	/**
	 * Retorna o valor do atributo <code>tipoDestinacao</code>
	 * 
	 * @return <code>Dominio</code>
	 */
	public Dominio getTipoDestinacao() {

		return tipoDestinacao;
	}

	/**
	 * Define o valor do atributo <code>tipoDestinacao</code>.
	 * 
	 * @param tipoDestinacao
	 */
	public void setTipoDestinacao(Dominio tipoDestinacao) {

		this.tipoDestinacao = tipoDestinacao;
	}

	/**
	 * Retorna o valor do atributo <code>tipoTemporalidade</code>
	 * 
	 * @return <code>Dominio</code>
	 */
	public Dominio getTipoTemporalidade() {

		return tipoTemporalidade;
	}

	/**
	 * Define o valor do atributo <code>tipoTemporalidade</code>.
	 * 
	 * @param tipoTemporalidade
	 */
	public void setTipoTemporalidade(Dominio tipoTemporalidade) {

		this.tipoTemporalidade = tipoTemporalidade;
	}

	/**
	 * Retorna o valor do atributo <code>planoClassificacao</code>
	 * 
	 * @return <code>PlanoClassificacao</code>
	 */
	public PlanoClassificacao getPlanoClassificacao() {

		return planoClassificacao;
	}

	/**
	 * Define o valor do atributo <code>planoClassificacao</code>.
	 * 
	 * @param planoClassificacao
	 */
	public void setPlanoClassificacao(PlanoClassificacao planoClassificacao) {

		this.planoClassificacao = planoClassificacao;
	}

}
