package br.com.centralit.api.model;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;

import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.Usuario;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAudit;

import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>ConfiguracaoUsuario
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 20/10/2015 - 14:28:01
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Entity
public class ConfiguracaoUsuario extends PersistentObjectAudit {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = -6610274917922078903L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo configuracaoSistemaSIGAD. */
	@ManyToOne(fetch = FetchType.LAZY)
	private ConfiguracaoSistemaSIGAD configuracaoSistemaSIGAD;

	/** Atributo usuario. */
	@ManyToOne(fetch = FetchType.LAZY)
	private Usuario usuario;

	/** Atributo unidade. */
	@ManyToOne(fetch = FetchType.LAZY)
	private EstruturaOrganizacional unidade;

	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>configuracaoSistemaSIGAD</code>
	 * 
	 * @return <code>ConfiguracaoSistemaSIGAD</code>
	 */
	public ConfiguracaoSistemaSIGAD getConfiguracaoSistemaSIGAD() {

		return configuracaoSistemaSIGAD;
	}

	/**
	 * Define o valor do atributo <code>configuracaoSistemaSIGAD</code>.
	 * 
	 * @param configuracaoSistemaSIGAD
	 */
	public void setConfiguracaoSistemaSIGAD(ConfiguracaoSistemaSIGAD configuracaoSistemaSIGAD) {

		this.configuracaoSistemaSIGAD = configuracaoSistemaSIGAD;
	}

	/**
	 * Retorna o valor do atributo <code>usuario</code>
	 * 
	 * @return <code>Usuario</code>
	 */
	public Usuario getUsuario() {

		return usuario;
	}

	/**
	 * Define o valor do atributo <code>usuario</code>.
	 * 
	 * @param usuario
	 */
	public void setUsuario(Usuario usuario) {

		this.usuario = usuario;
	}

	/**
	 * Retorna o valor do atributo <code>unidade</code>
	 * 
	 * @return <code>EstruturaOrganizacional</code>
	 */
	public EstruturaOrganizacional getUnidade() {

		return unidade;
	}

	/**
	 * Define o valor do atributo <code>unidade</code>.
	 * 
	 * @param unidade
	 */
	public void setUnidade(EstruturaOrganizacional unidade) {

		this.unidade = unidade;
	}

}
