package br.com.centralit.api.model;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;

import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.Organizacao;
import br.com.centralit.framework.model.Usuario;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAuditOrganizacao;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>UserOrganizacaoUnidade
 * </p>
 * 
 * <p>
 * <b>Description: </b> Classe responsável por definir as configurações do usuario para organização, tais como visibilidade e permissões
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 20/10/2015 - 08:45:48
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Entity
@JsonIgnoreProperties({ "$selected" })
public class ConfiguracaoUsuarioUnidade extends PersistentObjectAuditOrganizacao {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = -5868190673899038174L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo usuarioOrganizacao. */
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ Views.ConfiguracaoUsuarioUnidadeEditView.class })
	private Organizacao organizacaoUsuario;

	/** Atributo usuarioOrganizacao. */
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ Views.ConfiguracaoUsuarioUnidadeListView.class, Views.EstruturaOrganizacionalECMEditView.class, Views.UsuarioAutoCompleteView.class })
	private Usuario usuario;

	/** Atributo estruturaOrganizacional. */
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ Views.ConfiguracaoUsuarioUnidadeListView.class })
	private EstruturaOrganizacionalECM estruturaOrganizacionalECM;

	/** Atributo estruturaOrganizacionalECMRemocao. */
	@ManyToOne(fetch = FetchType.LAZY)
	private EstruturaOrganizacionalECM estruturaOrganizacionalECMRemocao;

	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>organizacaoUsuario</code>
	 * 
	 * @return <code>Organizacao</code>
	 */
	public Organizacao getOrganizacaoUsuario() {

		return organizacaoUsuario;
	}

	/**
	 * Define o valor do atributo <code>organizacaoUsuario</code>.
	 * 
	 * @param organizacaoUsuario
	 */
	public void setOrganizacaoUsuario(Organizacao organizacaoUsuario) {

		this.organizacaoUsuario = organizacaoUsuario;
	}

	/**
	 * Retorna o valor do atributo <code>estruturaOrganizacionalECM</code>
	 * 
	 * @return <code>EstruturaOrganizacionalECM</code>
	 */
	public EstruturaOrganizacionalECM getEstruturaOrganizacionalECM() {

		return estruturaOrganizacionalECM;
	}

	/**
	 * Define o valor do atributo <code>estruturaOrganizacionalECM</code>.
	 * 
	 * @param estruturaOrganizacionalECM
	 */
	public void setEstruturaOrganizacionalECM(EstruturaOrganizacionalECM estruturaOrganizacionalECM) {

		this.estruturaOrganizacionalECM = estruturaOrganizacionalECM;
	}

	/**
	 * Retorna o valor do atributo <code>usuario</code>
	 * 
	 * @return <code>Usuario</code>
	 */
	public Usuario getUsuario() {

		return usuario;
	}

	/**
	 * Define o valor do atributo <code>usuario</code>.
	 * 
	 * @param usuario
	 */
	public void setUsuario(Usuario usuario) {

		this.usuario = usuario;
	}

	/**
	 * Retorna o valor do atributo <code>estruturaOrganizacionalECMRemocao</code>
	 * 
	 * @return <code>EstruturaOrganizacionalECM</code>
	 */
	public EstruturaOrganizacionalECM getEstruturaOrganizacionalECMRemocao() {

		return estruturaOrganizacionalECMRemocao;
	}

	/**
	 * Define o valor do atributo <code>estruturaOrganizacionalECMRemocao</code>.
	 * 
	 * @param estruturaOrganizacionalECMRemocao
	 */
	public void setEstruturaOrganizacionalECMRemocao(EstruturaOrganizacionalECM estruturaOrganizacionalECMRemocao) {

		this.estruturaOrganizacionalECMRemocao = estruturaOrganizacionalECMRemocao;
	}

}
