package br.com.centralit.api.model;

import javax.persistence.Basic;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Lob;
import javax.persistence.OneToOne;
import javax.persistence.Transient;

import org.hibernate.annotations.Type;

import br.com.centralit.api.framework.json.ViewsEcm;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.AnexoImagem;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAudit;

import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <b>Title: </b>
 * </p>
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * @since 27/04/2016 - 08:22:01
 * @author rogerio.cassimiro
 * 
 */
@Entity
public class ConteudoTarja extends PersistentObjectAudit {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = -7167017379907431453L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	@JsonView({ Views.DocumentoGedEdit.class, ViewsEcm.AssinaturaEdit.class })
	@Transient
	private String conteudo;

	@Lob
	@Basic(fetch = FetchType.LAZY)
	@Type(type = "org.hibernate.type.BinaryType")
	private byte[] conteudoCriptografado;

	@OneToOne
	@JsonView({ ViewsEcm.AssinaturaEdit.class })
	private AnexoImagem anexoImagem;

	@Transient
	private Long idTarjaAssinatura;

	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>conteudo</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getConteudo() {

		return conteudo;
	}

	/**
	 * Define o valor do atributo <code>conteudo</code>.
	 * 
	 * @param conteudo
	 */
	public void setConteudo(String conteudo) {

		this.conteudo = conteudo;
	}

	/**
	 * Retorna o valor do atributo <code>conteudoCriptografado</code>
	 * 
	 * @return <code>byte[]</code>
	 */
	public byte[] getConteudoCriptografado() {

		return conteudoCriptografado;
	}

	/**
	 * Define o valor do atributo <code>conteudoCriptografado</code>.
	 * 
	 * @param conteudoCriptografado
	 */
	public void setConteudoCriptografado(byte[] conteudoCriptografado) {

		this.conteudoCriptografado = conteudoCriptografado;
	}

	/**
	 * Retorna o valor do atributo <code>idTarjaAssinatura</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getIdTarjaAssinatura() {

		return idTarjaAssinatura;
	}

	/**
	 * Define o valor do atributo <code>idTarjaAssinatura</code>.
	 * 
	 * @param idTarjaAssinatura
	 */
	public void setIdTarjaAssinatura(Long idTarjaAssinatura) {

		this.idTarjaAssinatura = idTarjaAssinatura;
	}

	/**
	 * Retorna o valor do atributo <code>anexoImagem</code>
	 * 
	 * @return <code>AnexoImagem</code>
	 */
	public AnexoImagem getAnexoImagem() {

		return anexoImagem;
	}

	/**
	 * Define o valor do atributo <code>anexoImagem</code>.
	 * 
	 * @param anexoImagem
	 */
	public void setAnexoImagem(AnexoImagem anexoImagem) {

		this.anexoImagem = anexoImagem;
	}

}
