package br.com.centralit.api.model;

import java.util.Collection;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Transient;

import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.Grupo;
import br.com.centralit.framework.model.Usuario;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAudit;
import br.com.centralit.framework.util.UtilObjeto;

import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 08/03/2016 - 16:34:15
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Entity
public class CredencialProcesso extends PersistentObjectAudit {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 7634956891506695682L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo permiteCredenciar. */
	@JsonView({ Views.CredencialProcessoView.class })
	private Boolean permiteCredenciar;

	/** Atributo icon. */
	@JsonView({ Views.CredencialProcessoView.class })
	private String icon;

	/** Atributo idTask. */
	@JsonView({ Views.CredencialProcessoView.class })
	private Long idTask;

	/** Atributo permiteEdicao. */
	@Transient
	@JsonView({ Views.CredencialProcessoView.class })
	private Boolean permiteEdicao;

	/** Atributo processo. */
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ Views.CredencialProcessoView.class })
	private Processo processo;

	/** Atributo processoRemocao. */
	@ManyToOne(fetch = FetchType.LAZY)
	private Processo processoRemocao;

	/** Atributo grupo. */
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ Views.CredencialProcessoView.class, Views.HistoricoCredencialProcesso.class })
	private Grupo grupo;

	/** Atributo usuario. */
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ Views.CredencialProcessoView.class, Views.HistoricoCredencialProcesso.class })
	private Usuario usuario;

	/** Atributo historicoCredencialProcessos. */
	@OneToMany(fetch = FetchType.LAZY, mappedBy = "credencialProcesso", cascade = CascadeType.ALL)
	private Collection<HistoricoCredencialProcesso> historicoCredencialProcessos;

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 */
	public CredencialProcesso() {

		super();
	}

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * 
	 * @param processo
	 * @param grupo
	 */
	public CredencialProcesso( Processo processo, Grupo grupo, Boolean permiteCredenciar ) {

		this.processo = processo;
		this.grupo = grupo;
		this.permiteCredenciar = permiteCredenciar;
	}

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * 
	 * @param processo
	 * @param usuario
	 */
	public CredencialProcesso( Processo processo, Usuario usuario ) {

		this.processo = processo;
		this.usuario = usuario;
	}

	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>grupo</code>
	 * 
	 * @return <code>Grupo</code>
	 */
	public Grupo getGrupo() {

		return grupo;
	}

	/**
	 * Define o valor do atributo <code>grupo</code>.
	 * 
	 * @param grupo
	 */
	public void setGrupo(Grupo grupo) {

		this.grupo = grupo;
	}

	/**
	 * Retorna o valor do atributo <code>usuario</code>
	 * 
	 * @return <code>Usuario</code>
	 */
	public Usuario getUsuario() {

		return usuario;
	}

	/**
	 * Define o valor do atributo <code>usuario</code>.
	 * 
	 * @param usuario
	 */
	public void setUsuario(Usuario usuario) {

		this.usuario = usuario;
	}

	/**
	 * Retorna o valor do atributo <code>permiteCredenciar</code>
	 * 
	 * @return <code>Boolean</code>
	 */
	public Boolean getPermiteCredenciar() {

		if (!UtilObjeto.isReferencia(permiteCredenciar)) {

			return Boolean.FALSE;

		}

		return permiteCredenciar;
	}

	/**
	 * Define o valor do atributo <code>permiteCredenciar</code>.
	 * 
	 * @param permiteCredenciar
	 */
	public void setPermiteCredenciar(Boolean permiteCredenciar) {

		this.permiteCredenciar = permiteCredenciar;
	}

	/**
	 * Retorna o valor do atributo <code>processo</code>
	 * 
	 * @return <code>Processo</code>
	 */
	public Processo getProcesso() {

		return processo;
	}

	/**
	 * Define o valor do atributo <code>processo</code>.
	 * 
	 * @param processo
	 */
	public void setProcesso(Processo processo) {

		this.processo = processo;
	}

	/**
	 * Retorna o valor do atributo <code>icon</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getIcon() {

		return icon;
	}

	/**
	 * Define o valor do atributo <code>icon</code>.
	 * 
	 * @param icon
	 */
	public void setIcon(String icon) {

		this.icon = icon;
	}

	/**
	 * Retorna o valor do atributo <code>processoRemocao</code>
	 * 
	 * @return <code>Processo</code>
	 */
	public Processo getProcessoRemocao() {

		return processoRemocao;
	}

	/**
	 * Define o valor do atributo <code>processoRemocao</code>.
	 * 
	 * @param processoRemocao
	 */
	public void setProcessoRemocao(Processo processoRemocao) {

		this.processoRemocao = processoRemocao;
	}

	/**
	 * Retorna o valor do atributo <code>historicoCredencialProcessos</code>
	 * 
	 * @return <code>Collection<HistoricoCredencialProcesso></code>
	 */
	public Collection<HistoricoCredencialProcesso> getHistoricoCredencialProcessos() {

		return historicoCredencialProcessos;
	}

	/**
	 * Define o valor do atributo <code>historicoCredencialProcessos</code>.
	 * 
	 * @param historicoCredencialProcessos
	 */
	public void setHistoricoCredencialProcessos(Collection<HistoricoCredencialProcesso> historicoCredencialProcessos) {

		this.historicoCredencialProcessos = historicoCredencialProcessos;
	}

	/**
	 * Retorna o valor do atributo <code>idTask</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getIdTask() {

		return idTask;
	}

	/**
	 * Define o valor do atributo <code>idTask</code>.
	 * 
	 * @param idTask
	 */
	public void setIdTask(Long idTask) {

		this.idTask = idTask;
	}

	/**
	 * Retorna o valor do atributo <code>permiteEdicao</code>
	 * 
	 * @return <code>Boolean</code>
	 */
	public Boolean getPermiteEdicao() {

		return permiteEdicao;
	}

	/**
	 * Define o valor do atributo <code>permiteEdicao</code>.
	 * 
	 * @param permiteEdicao
	 */
	public void setPermiteEdicao(Boolean permiteEdicao) {

		this.permiteEdicao = permiteEdicao;
	}

}
