package br.com.centralit.api.model;

import java.util.Collection;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;

import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.GrupoUnidade;
import br.com.centralit.framework.model.Unidade;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 14/12/2015 - 09:13:29
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Entity
@JsonIgnoreProperties({ "estruturaECM" })
public class EstruturaOrganizacionalECM extends Unidade {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = -1968991778443252720L;

	/** Atributo estruturaOrganizacional. */
	@OneToOne(fetch = FetchType.LAZY, optional = false)
	@JsonView({ Views.EstruturaOrganizacionalECMEditView.class, Views.ConfiguracaoUsuarioUnidadeListView.class, Views.UsuarioEditView.class })
	private EstruturaOrganizacional estruturaOrganizacional;

	/** Atributo codigoSiorg. */
	@JsonView({ Views.EstruturaOrganizacionalECMEditView.class })
	private String codigoSiorg;

	/** Atributo configuracaoUsuariosUnidade. */
	@OneToMany(fetch = FetchType.LAZY, mappedBy = "estruturaOrganizacionalECM", cascade = CascadeType.ALL)
	@JsonView({ Views.EstruturaOrganizacionalECMEditView.class })
	private Collection<ConfiguracaoUsuarioUnidade> configuracaoUsuariosUnidade;

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "unidade", cascade = CascadeType.ALL)
	@JsonView({ Views.EstruturaOrganizacionalECMEditView.class })
	private Collection<GrupoUnidade> gruposUnidade;

	/**
	 * Retorna o valor do atributo <code>estruturaOrganizacional</code>
	 * 
	 * @return <code>EstruturaOrganizacional</code>
	 */
	public EstruturaOrganizacional getEstruturaOrganizacional() {

		return estruturaOrganizacional;
	}

	/**
	 * Define o valor do atributo <code>estruturaOrganizacional</code>.
	 * 
	 * @param estruturaOrganizacional
	 */
	public void setEstruturaOrganizacional(EstruturaOrganizacional estruturaOrganizacional) {

		this.estruturaOrganizacional = estruturaOrganizacional;
	}

	/**
	 * Retorna o valor do atributo <code>codigoSiorg</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getCodigoSiorg() {

		return codigoSiorg;
	}

	/**
	 * Define o valor do atributo <code>codigoSiorg</code>.
	 * 
	 * @param codigoSiorg
	 */
	public void setCodigoSiorg(String codigoSiorg) {

		this.codigoSiorg = codigoSiorg;
	}

	/**
	 * Retorna o valor do atributo <code>configuracaoUsuariosUnidade</code>
	 * 
	 * @return <code>Collection<ConfiguracaoUsuarioUnidade></code>
	 */
	public Collection<ConfiguracaoUsuarioUnidade> getConfiguracaoUsuariosUnidade() {

		return configuracaoUsuariosUnidade;
	}

	/**
	 * Define o valor do atributo <code>configuracaoUsuariosUnidade</code>.
	 * 
	 * @param configuracaoUsuariosUnidade
	 */
	public void setConfiguracaoUsuariosUnidade(Collection<ConfiguracaoUsuarioUnidade> configuracaoUsuariosUnidade) {

		this.configuracaoUsuariosUnidade = configuracaoUsuariosUnidade;
	}

	/**
	 * Retorna o valor do atributo <code>gruposUnidade</code>
	 * 
	 * @return <code>Collection<GrupoUnidade></code>
	 */
	public Collection<GrupoUnidade> getGruposUnidade() {

		return gruposUnidade;
	}

	/**
	 * Define o valor do atributo <code>gruposUnidade</code>.
	 * 
	 * @param gruposUnidade
	 */
	public void setGruposUnidade(Collection<GrupoUnidade> gruposUnidade) {

		this.gruposUnidade = gruposUnidade;
	}

}
