package br.com.centralit.api.model;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Lob;
import javax.persistence.ManyToOne;

import org.hibernate.annotations.Type;

import br.com.centralit.api.framework.json.ViewsEcm;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.Dominio;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAudit;

import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>HipoteseLegal
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 20/10/2015 - 15:37:52
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Entity
public class HipoteseLegal extends PersistentObjectAudit {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = -6513085925652207921L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo descricao. */

	@Lob
	@Type(type = "org.hibernate.type.StringClobType")
	@JsonView({ ViewsEcm.HipoteseLegalList.class })
	private String descricao;

	/** Atributo nome. */
	@JsonView({ ViewsEcm.HipoteseLegalList.class, ViewsEcm.TipoProcessoList.class, ViewsEcm.TipoDocumentoEdit.class, ViewsEcm.NivelAcessoTipoDocumentoEdit.class, ViewsEcm.DocumentoGedEdit.class, ViewsEcm.ProcessoEdit.class, ViewsEcm.NivelAcessoTipoProcessoEdit.class, ViewsEcm.MetadadoProcessoView.class,
		Views.ProcessoVHView.class})
	private String nome;

	/** Atributo fundamentacaoLegal. */
	@JsonView({ ViewsEcm.HipoteseLegalEdit.class })
	private String fundamentacaoLegal;

	/** Atributo tipoAcesso. */
	@JsonView({ ViewsEcm.HipoteseLegalEdit.class, ViewsEcm.HipoteseLegalList.class })
	@ManyToOne(fetch = FetchType.LAZY)
	private Dominio nivelAcesso;

	/** Atributo sigilo. */
	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	@JsonView({ ViewsEcm.HipoteseLegalEdit.class })
	private Sigilo sigilo;

	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>descricao</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getDescricao() {

		return descricao;
	}

	/**
	 * Define o valor do atributo <code>descricao</code>.
	 * 
	 * @param descricao
	 */
	public void setDescricao(String descricao) {

		this.descricao = descricao;
	}

	/**
	 * Retorna o valor do atributo <code>nome</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getNome() {

		return nome;
	}

	/**
	 * Define o valor do atributo <code>nome</code>.
	 * 
	 * @param nome
	 */
	public void setNome(String nome) {

		this.nome = nome;
	}

	/**
	 * Retorna o valor do atributo <code>nivelAcesso</code>
	 * 
	 * @return <code>Dominio</code>
	 */
	public Dominio getNivelAcesso() {

		return nivelAcesso;
	}

	/**
	 * Define o valor do atributo <code>nivelAcesso</code>.
	 * 
	 * @param nivelAcesso
	 */
	public void setNivelAcesso(Dominio nivelAcesso) {

		this.nivelAcesso = nivelAcesso;
	}

	/**
	 * Retorna o valor do atributo <code>fundamentacaoLegal</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getFundamentacaoLegal() {

		return fundamentacaoLegal;
	}

	/**
	 * Define o valor do atributo <code>fundamentacaoLegal</code>.
	 * 
	 * @param fundamentacaoLegal
	 */
	public void setFundamentacaoLegal(String fundamentacaoLegal) {

		this.fundamentacaoLegal = fundamentacaoLegal;
	}

}
