package br.com.centralit.api.model;

import java.util.Calendar;
import java.util.Map;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Transient;

import br.com.centralit.api.framework.json.ViewsEcm;
import br.com.centralit.framework.json.JsonCalendarDeserializer;
import br.com.centralit.framework.json.JsonCalendarSerializer;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAudit;

import com.fasterxml.jackson.annotation.JsonView;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 20/10/2015 - 15:43:02
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Entity
public class HistoricoAlteracaoProcesso extends PersistentObjectAudit {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = -4015590999407159415L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo documento. */
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ ViewsEcm.HistoricoProcessoView.class })
	private Processo processo;

	/** Atributo dataRegistro. */
	@Temporal(TemporalType.TIMESTAMP)
	@JsonView({ ViewsEcm.HistoricoProcessoView.class })
	@JsonSerialize(using = JsonCalendarSerializer.class)
	@JsonDeserialize(using = JsonCalendarDeserializer.class)
	private Calendar dataRegistro;

	/** Atributo estruturaOrganizacional. */
	@JsonView({ ViewsEcm.HistoricoProcessoView.class })
	private String nomeUnidadeVigente;

	/** Atributo usuario. */
	@JsonView({ ViewsEcm.HistoricoProcessoView.class })
	private String nomeUsuario;

	private Long idTask;

	@JsonView({ ViewsEcm.HistoricoProcessoView.class })
	private String descricaoAcao;

	/** Atributo formaCriacao. */
	@JsonView({ ViewsEcm.HistoricoProcessoView.class })
	private String acaoAlteracao;

	@Transient
	private DocumentoGed documentoGed;

	@Transient
	private Map<String, String> mapaAtributos;
	
	public HistoricoAlteracaoProcesso(){
		super();
	}

	public HistoricoAlteracaoProcesso( Processo processo, Calendar dataRegistro, String nomeUnidadeVigente, String nomeUsuario, Long idTask, String descricaoAcao, String acaoAlteracao, DocumentoGed documentoGed, Map<String, String> mapaAtributos) {

		super();
		this.processo = processo;
		this.dataRegistro = dataRegistro;
		this.nomeUnidadeVigente = nomeUnidadeVigente;
		this.nomeUsuario = nomeUsuario;
		this.idTask = idTask;
		this.descricaoAcao = descricaoAcao;
		this.acaoAlteracao = acaoAlteracao;
		this.documentoGed = documentoGed;
		this.mapaAtributos = mapaAtributos;
	}

	public Calendar getDataRegistro() {

		return dataRegistro;
	}

	public void setDataRegistro(Calendar dataRegistro) {

		this.dataRegistro = dataRegistro;
	}

	public String getDescricaoAcao() {

		return descricaoAcao;
	}

	public void setDescricaoAcao(String descricaoAcao) {

		this.descricaoAcao = descricaoAcao;
	}

	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>processo</code>
	 * 
	 * @return <code>Processo</code>
	 */
	public Processo getProcesso() {

		return processo;
	}

	/**
	 * Define o valor do atributo <code>processo</code>.
	 * 
	 * @param processo
	 */
	public void setProcesso(Processo processo) {

		this.processo = processo;
	}

	/**
	 * Retorna o valor do atributo <code>idTask</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getIdTask() {

		return idTask;
	}

	/**
	 * Define o valor do atributo <code>idTask</code>.
	 * 
	 * @param idTask
	 */
	public void setIdTask(Long idTask) {

		this.idTask = idTask;
	}

	/**
	 * Retorna o valor do atributo <code>nomeUnidadeVigente</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getNomeUnidadeVigente() {

		return nomeUnidadeVigente;
	}

	/**
	 * Define o valor do atributo <code>nomeUnidadeVigente</code>.
	 * 
	 * @param nomeUnidadeVigente
	 */
	public void setNomeUnidadeVigente(String nomeUnidadeVigente) {

		this.nomeUnidadeVigente = nomeUnidadeVigente;
	}

	/**
	 * Retorna o valor do atributo <code>nomeUsuario</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getNomeUsuario() {

		return nomeUsuario;
	}

	/**
	 * Define o valor do atributo <code>nomeUsuario</code>.
	 * 
	 * @param nomeUsuario
	 */
	public void setNomeUsuario(String nomeUsuario) {

		this.nomeUsuario = nomeUsuario;
	}

	/**
	 * Retorna o valor do atributo <code>acaoAlteracao</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getAcaoAlteracao() {

		return acaoAlteracao;
	}

	/**
	 * Define o valor do atributo <code>acaoAlteracao</code>.
	 * 
	 * @param acaoAlteracao
	 */
	public void setAcaoAlteracao(String acaoAlteracao) {

		this.acaoAlteracao = acaoAlteracao;
	}

	/**
	 * Retorna o valor do atributo <code>documentoGed</code>
	 * 
	 * @return <code>DocumentoGed</code>
	 */
	public DocumentoGed getDocumentoGed() {

		return documentoGed;
	}

	/**
	 * Define o valor do atributo <code>documentoGed</code>.
	 * 
	 * @param documentoGed
	 */
	public void setDocumentoGed(DocumentoGed documentoGed) {

		this.documentoGed = documentoGed;
	}

	/**
	 * Retorna o valor do atributo <code>mapaAtributos</code>
	 * 
	 * @return <code>Map<String,String></code>
	 */
	public Map<String, String> getMapaAtributos() {

		return mapaAtributos;
	}

	/**
	 * Define o valor do atributo <code>mapaAtributos</code>.
	 * 
	 * @param mapaAtributos
	 */
	public void setMapaAtributos(Map<String, String> mapaAtributos) {

		this.mapaAtributos = mapaAtributos;
	}

}
