package br.com.centralit.api.model;

import java.util.Calendar;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import br.com.centralit.api.framework.json.ViewsEcm;
import br.com.centralit.framework.json.JsonCalendarSimpleDateDeserializer;
import br.com.centralit.framework.json.JsonCalendarSimpleDateSerializer;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAudit;

import com.fasterxml.jackson.annotation.JsonView;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 02/04/2016 - 10:11:50
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Entity
public class HistoricoAtribuicaoProcesso extends PersistentObjectAudit {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 7132743441754771336L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo nomeUsuarioAtribuido. */
	@JsonView({ ViewsEcm.HistoricoAtribuicaoProcessoView.class })
	private String nomeUsuarioAtribuido;

	/** Atributo nomeUsuarioRemocao. */
	@JsonView({ ViewsEcm.HistoricoAtribuicaoProcessoView.class })
	private String nomeUsuarioRemocao;

	/** Atributo dataAtribuicao. */
	@Temporal(TemporalType.TIMESTAMP)
	@JsonSerialize(using = JsonCalendarSimpleDateSerializer.class)
	@JsonDeserialize(using = JsonCalendarSimpleDateDeserializer.class)
	@JsonView({ ViewsEcm.HistoricoAtribuicaoProcessoView.class })
	private Calendar dataAtribuicao;

	/** Atributo dataRemocao. */
	@Temporal(TemporalType.TIMESTAMP)
	@JsonSerialize(using = JsonCalendarSimpleDateSerializer.class)
	@JsonDeserialize(using = JsonCalendarSimpleDateDeserializer.class)
	@JsonView({ ViewsEcm.HistoricoAtribuicaoProcessoView.class })
	private Calendar dataRemocao;

	/** Atributo unidadeProcesso. */
	@ManyToOne(fetch = FetchType.LAZY)
	private UnidadeProcesso unidadeProcesso;

	/**
	 * Retorna o valor do atributo <code>nomeUsuarioAtribuido</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getNomeUsuarioAtribuido() {

		return nomeUsuarioAtribuido;
	}

	/**
	 * Define o valor do atributo <code>nomeUsuarioAtribuido</code>.
	 * 
	 * @param nomeUsuarioAtribuido
	 */
	public void setNomeUsuarioAtribuido(String nomeUsuarioAtribuido) {

		this.nomeUsuarioAtribuido = nomeUsuarioAtribuido;
	}

	/**
	 * Retorna o valor do atributo <code>nomeUsuarioRemocao</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getNomeUsuarioRemocao() {

		return nomeUsuarioRemocao;
	}

	/**
	 * Define o valor do atributo <code>nomeUsuarioRemocao</code>.
	 * 
	 * @param nomeUsuarioRemocao
	 */
	public void setNomeUsuarioRemocao(String nomeUsuarioRemocao) {

		this.nomeUsuarioRemocao = nomeUsuarioRemocao;
	}

	/**
	 * Retorna o valor do atributo <code>dataAtribuicao</code>
	 * 
	 * @return <code>Calendar</code>
	 */
	public Calendar getDataAtribuicao() {

		return dataAtribuicao;
	}

	/**
	 * Define o valor do atributo <code>dataAtribuicao</code>.
	 * 
	 * @param dataAtribuicao
	 */
	public void setDataAtribuicao(Calendar dataAtribuicao) {

		this.dataAtribuicao = dataAtribuicao;
	}

	/**
	 * Retorna o valor do atributo <code>dataRemocao</code>
	 * 
	 * @return <code>Calendar</code>
	 */
	public Calendar getDataRemocao() {

		return dataRemocao;
	}

	/**
	 * Define o valor do atributo <code>dataRemocao</code>.
	 * 
	 * @param dataRemocao
	 */
	public void setDataRemocao(Calendar dataRemocao) {

		this.dataRemocao = dataRemocao;
	}

	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>unidadeProcesso</code>
	 * 
	 * @return <code>UnidadeProcesso</code>
	 */
	public UnidadeProcesso getUnidadeProcesso() {

		return unidadeProcesso;
	}

	/**
	 * Define o valor do atributo <code>unidadeProcesso</code>.
	 * 
	 * @param unidadeProcesso
	 */
	public void setUnidadeProcesso(UnidadeProcesso unidadeProcesso) {

		this.unidadeProcesso = unidadeProcesso;
	}

	@JsonView({ ViewsEcm.HistoricoAtribuicaoProcessoView.class })
	public String getAtribuidoPor() {

		return this.autor.getUsername();
	}

}
