package br.com.centralit.api.model;

import java.util.Calendar;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import br.com.centralit.framework.json.JsonCalendarSimpleDateDeserializer;
import br.com.centralit.framework.json.JsonCalendarSimpleDateSerializer;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.Grupo;
import br.com.centralit.framework.model.Usuario;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAudit;
import br.com.centralit.framework.util.UtilObjeto;

import com.fasterxml.jackson.annotation.JsonView;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 11/03/2016 - 15:38:20
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Entity
public class HistoricoCredencialProcesso extends PersistentObjectAudit {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 2781741080885327846L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo dataDescredenciado. */
	@Temporal(TemporalType.TIMESTAMP)
	@JsonSerialize(using = JsonCalendarSimpleDateSerializer.class)
	@JsonDeserialize(using = JsonCalendarSimpleDateDeserializer.class)
	@JsonView({ Views.HistoricoCredencialProcesso.class })
	private Calendar dataDescredenciado;

	/** Atributo dataDescredenciamento. */
	@Temporal(TemporalType.TIMESTAMP)
	@JsonSerialize(using = JsonCalendarSimpleDateSerializer.class)
	@JsonDeserialize(using = JsonCalendarSimpleDateDeserializer.class)
	@JsonView({ Views.HistoricoCredencialProcesso.class })
	private Calendar dataDescredenciamento;

	/** Atributo credencialProcesso. */
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ Views.HistoricoCredencialProcesso.class })
	private CredencialProcesso credencialProcesso;

	/** Atributo descredenciador. */
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ Views.HistoricoCredencialProcesso.class })
	private Usuario descredenciador;

	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ Views.HistoricoCredencialProcesso.class })
	private Grupo grupo;

	/** Atributo usuario. */
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ Views.HistoricoCredencialProcesso.class })
	private Usuario usuario;

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 */
	public HistoricoCredencialProcesso() {

		super();
	}

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * 
	 * @param dataDescredenciado
	 * @param credencialProcesso
	 * @param descredenciador
	 */
	public HistoricoCredencialProcesso( Calendar dataDescredenciado, CredencialProcesso credencialProcesso, Usuario descredenciador ) {

		this.dataDescredenciado = dataDescredenciado;
		this.credencialProcesso = credencialProcesso;
		this.descredenciador = descredenciador;

	}

	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>dataDescredenciado</code>
	 * 
	 * @return <code>Calendar</code>
	 */
	public Calendar getDataDescredenciado() {

		return dataDescredenciado;
	}

	/**
	 * Define o valor do atributo <code>dataDescredenciado</code>.
	 * 
	 * @param dataDescredenciado
	 */
	public void setDataDescredenciado(Calendar dataDescredenciado) {

		this.dataDescredenciado = dataDescredenciado;
	}

	/**
	 * Retorna o valor do atributo <code>credencialProcesso</code>
	 * 
	 * @return <code>CredencialProcesso</code>
	 */
	public CredencialProcesso getCredencialProcesso() {

		return credencialProcesso;
	}

	/**
	 * Define o valor do atributo <code>credencialProcesso</code>.
	 * 
	 * @param credencialProcesso
	 */
	public void setCredencialProcesso(CredencialProcesso credencialProcesso) {

		this.credencialProcesso = credencialProcesso;
	}

	/**
	 * Retorna o valor do atributo <code>descredenciador</code>
	 * 
	 * @return <code>Usuario</code>
	 */
	public Usuario getDescredenciador() {

		return descredenciador;
	}

	/**
	 * Define o valor do atributo <code>descredenciador</code>.
	 * 
	 * @param descredenciador
	 */
	public void setDescredenciador(Usuario descredenciador) {

		this.descredenciador = descredenciador;
	}

	/**
	 * Retorna o valor do atributo <code>dataDescredenciamento</code>
	 * 
	 * @return <code>Calendar</code>
	 */
	public Calendar getDataDescredenciamento() {

		return dataDescredenciamento;
	}

	/**
	 * Define o valor do atributo <code>dataDescredenciamento</code>.
	 * 
	 * @param dataDescredenciamento
	 */
	public void setDataDescredenciamento(Calendar dataDescredenciamento) {

		this.dataDescredenciamento = dataDescredenciamento;
	}

	/**
	 * Retorna o valor do atributo <code>grupo</code>
	 * 
	 * @return <code>Grupo</code>
	 */
	public Grupo getGrupo() {

		return grupo;
	}

	/**
	 * Define o valor do atributo <code>grupo</code>.
	 * 
	 * @param grupo
	 */
	public void setGrupo(Grupo grupo) {

		this.grupo = grupo;
	}

	/**
	 * Retorna o valor do atributo <code>usuario</code>
	 * 
	 * @return <code>Usuario</code>
	 */
	public Usuario getUsuario() {

		return usuario;
	}

	/**
	 * Define o valor do atributo <code>usuario</code>.
	 * 
	 * @param usuario
	 */
	public void setUsuario(Usuario usuario) {

		this.usuario = usuario;
	}

	@JsonView({ Views.HistoricoCredencialProcesso.class })
	public String getUnidadeUsuarioCredenciado() {

		return UtilObjeto.isReferencia(this.credencialProcesso.getUsuario()) && UtilObjeto.isReferencia(this.credencialProcesso.getUsuario().getUnidade()) ? this.credencialProcesso.getUsuario().getUnidade().getNome() : "-";

	}
}
