package br.com.centralit.api.model;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;

import br.com.centralit.api.framework.json.ViewsEcm;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAudit;

import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 20/10/2015 - 15:47:00
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Entity
public class InteressadoDocumento extends PersistentObjectAudit {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 5736038271420067849L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo documento. */
	@ManyToOne(fetch = FetchType.LAZY)
	private DocumentoGed documentoGed;

	/** Atributo documentoGedRemocao. */
	@ManyToOne(fetch = FetchType.LAZY)
	private DocumentoGed documentoGedRemocao;

	/** Atributo interessado. */
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ ViewsEcm.DocumentoGedEdit.class })
	private Pessoa interessado;


	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>documento</code>
	 * 
	 * @return <code>Documento</code>
	 */
	public DocumentoGed getDocumentoGed() {

		return documentoGed;
	}

	/**
	 * Define o valor do atributo <code>documento</code>.
	 * 
	 * @param documento
	 */
	public void setDocumentoGed(DocumentoGed documentoGed) {

		this.documentoGed = documentoGed;
	}

	/**
	 * Retorna o valor do atributo <code>interessado</code>
	 * 
	 * @return <code>Usuario</code>
	 */
	public Pessoa getInteressado() {

		return interessado;
	}

	/**
	 * Define o valor do atributo <code>interessado</code>.
	 * 
	 * @param interessado
	 */
	public void setInteressado(Pessoa interessado) {

		this.interessado = interessado;
	}

	/**
	 * Retorna o valor do atributo <code>documentoGedRemocao</code>
	 * 
	 * @return <code>DocumentoGed</code>
	 */
	public DocumentoGed getDocumentoGedRemocao() {

		return documentoGedRemocao;
	}

	/**
	 * Define o valor do atributo <code>documentoGedRemocao</code>.
	 * 
	 * @param documentoGedRemocao
	 */
	public void setDocumentoGedRemocao(DocumentoGed documentoGedRemocao) {

		this.documentoGedRemocao = documentoGedRemocao;
	}

}
