package br.com.centralit.api.model;

import java.util.Collection;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

import br.com.centralit.api.framework.json.ViewsEcm;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.Dominio;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAudit;

import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 20/10/2015 - 16:17:55
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Entity
public class NivelAcessoTipoDocumento extends PersistentObjectAudit {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = -1083656374238609224L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo tipoAcesso. */
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ ViewsEcm.TipoDocumentoEdit.class, ViewsEcm.NivelAcessoTipoDocumentoEdit.class, ViewsEcm.DocumentoGedEdit.class, Views.ProcessoEdit.class, Views.ProcessoVHView.class })
	private Dominio nivelAcesso;

	/** Atributo tipoDocumento. */
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ ViewsEcm.NivelAcessoTipoDocumentoEdit.class, ViewsEcm.DocumentoGedEdit.class})
	private TipoDocumento tipoDocumento;

	/** Atributo tipoDocumentoRemocao. */
	@ManyToOne(fetch = FetchType.LAZY)
	private TipoDocumento tipoDocumentoRemocao;

	/** Atributo sigilos. */
	@OneToMany(fetch = FetchType.LAZY, mappedBy = "nivelAcessoTipoDocumento", cascade = CascadeType.ALL)
	@JsonView({ ViewsEcm.TipoDocumentoEdit.class, ViewsEcm.NivelAcessoTipoDocumentoEdit.class, ViewsEcm.DocumentoGedEdit.class })
	private Collection<SigiloTipoDocumento> sigilos;

	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>tipoDocumento</code>
	 * 
	 * @return <code>TipoDocumento</code>
	 */
	public TipoDocumento getTipoDocumento() {

		return tipoDocumento;
	}

	/**
	 * Define o valor do atributo <code>tipoDocumento</code>.
	 * 
	 * @param tipoDocumento
	 */
	public void setTipoDocumento(TipoDocumento tipoDocumento) {

		this.tipoDocumento = tipoDocumento;
	}

	/**
	 * Retorna o valor do atributo <code>nivelAcesso</code>
	 * 
	 * @return <code>Dominio</code>
	 */
	public Dominio getNivelAcesso() {

		return nivelAcesso;
	}

	/**
	 * Define o valor do atributo <code>nivelAcesso</code>.
	 * 
	 * @param nivelAcesso
	 */
	public void setNivelAcesso(Dominio nivelAcesso) {

		this.nivelAcesso = nivelAcesso;
	}

	/**
	 * Retorna o valor do atributo <code>tipoDocumentoRemocao</code>
	 * 
	 * @return <code>TipoDocumento</code>
	 */
	public TipoDocumento getTipoDocumentoRemocao() {

		return tipoDocumentoRemocao;
	}

	/**
	 * Define o valor do atributo <code>tipoDocumentoRemocao</code>.
	 * 
	 * @param tipoDocumentoRemocao
	 */
	public void setTipoDocumentoRemocao(TipoDocumento tipoDocumentoRemocao) {

		this.tipoDocumentoRemocao = tipoDocumentoRemocao;
	}

	/**
	 * Retorna o valor do atributo <code>sigilos</code>
	 * 
	 * @return <code>Collection<SigiloTipoDocumento></code>
	 */
	public Collection<SigiloTipoDocumento> getSigilos() {

		return sigilos;
	}

	/**
	 * Define o valor do atributo <code>sigilos</code>.
	 * 
	 * @param sigilos
	 */
	public void setSigilos(Collection<SigiloTipoDocumento> sigilos) {

		this.sigilos = sigilos;
	}

}
