package br.com.centralit.api.model;

import java.util.Collection;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

import br.com.centralit.api.framework.json.ViewsEcm;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.Dominio;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAudit;

import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 20/10/2015 - 15:53:40
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Entity
public class NivelAcessoTipoProcesso extends PersistentObjectAudit {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 1836670032231445051L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo tipoProcesso. */
	@ManyToOne(fetch = FetchType.LAZY)
	private TipoProcesso tipoProcesso;

	/** Atributo tipoProcessoRemocao. */
	@ManyToOne(fetch = FetchType.LAZY)
	private TipoProcesso tipoProcessoRemocao;

	/** Atributo tipoAcesso. */
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ ViewsEcm.TipoProcessoEdit.class, ViewsEcm.NivelAcessoTipoProcessoEdit.class, Views.ProcessoList.class, Views.UnidadeProcessoListView.class, ViewsEcm.MetadadoProcessoView.class, Views.ProcessoVHView.class})
	private Dominio nivelAcesso;

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "nivelAcessoTipoProcesso", cascade = CascadeType.ALL)
	@JsonView({ ViewsEcm.TipoProcessoEdit.class, ViewsEcm.NivelAcessoTipoProcessoEdit.class, ViewsEcm.ProcessoEdit.class, ViewsEcm.MetadadoProcessoView.class })
	private Collection<SigiloTipoProcesso> sigilos;

	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	@Override
	public Long getId() {

		return this.id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>tipoProcesso</code>
	 * 
	 * @return <code>TipoProcesso</code>
	 */
	public TipoProcesso getTipoProcesso() {

		return this.tipoProcesso;
	}

	/**
	 * Define o valor do atributo <code>tipoProcesso</code>.
	 * 
	 * @param tipoProcesso
	 */
	public void setTipoProcesso(TipoProcesso tipoProcesso) {

		this.tipoProcesso = tipoProcesso;
	}

	/**
	 * Retorna o valor do atributo <code>nivelAcesso</code>
	 * 
	 * @return <code>Dominio</code>
	 */
	public Dominio getNivelAcesso() {

		return this.nivelAcesso;
	}

	/**
	 * Define o valor do atributo <code>nivelAcesso</code>.
	 * 
	 * @param nivelAcesso
	 */
	public void setNivelAcesso(Dominio nivelAcesso) {

		this.nivelAcesso = nivelAcesso;
	}

	/**
	 * Retorna o valor do atributo <code>tipoProcessoRemocao</code>
	 * 
	 * @return <code>TipoProcesso</code>
	 */
	public TipoProcesso getTipoProcessoRemocao() {

		return this.tipoProcessoRemocao;
	}

	/**
	 * Define o valor do atributo <code>tipoProcessoRemocao</code>.
	 * 
	 * @param tipoProcessoRemocao
	 */
	public void setTipoProcessoRemocao(TipoProcesso tipoProcessoRemocao) {

		this.tipoProcessoRemocao = tipoProcessoRemocao;
	}

	/**
	 * Retorna o valor do atributo <code>sigilos</code>
	 * 
	 * @return <code>Collection<SigiloTipoProcesso></code>
	 */
	public Collection<SigiloTipoProcesso> getSigilos() {

		return sigilos;
	}

	/**
	 * Define o valor do atributo <code>sigilos</code>.
	 * 
	 * @param sigilos
	 */
	public void setSigilos(Collection<SigiloTipoProcesso> sigilos) {

		this.sigilos = sigilos;
	}

}
