package br.com.centralit.api.model;

import java.util.Collection;
import java.util.LinkedList;

import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Lob;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Transient;

import org.hibernate.annotations.Type;

import br.com.centralit.api.framework.json.ViewsEcm;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.Dominio;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAuditOrganizacao;
import br.com.centralit.framework.util.UtilColecao;
import br.com.centralit.framework.util.UtilObjeto;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 20/10/2015 - 15:59:31
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Entity
@JsonIgnoreProperties({ "$selected" })
public class PlanoClassificacao extends PersistentObjectAuditOrganizacao implements Cloneable {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 5566628072491706190L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo codigo. */
	@JsonView({ ViewsEcm.PlanoClassificacaoListView.class, ViewsEcm.PlanoClassificacaoParent.class, ViewsEcm.PlanoClassificacaoAutocompleteRecursive.class, ViewsEcm.PlanoCLassificacaoAutoComplete.class, ViewsEcm.PlanoCLassificacaoAutoComplete.class, ViewsEcm.TipoDocumentoEdit.class, ViewsEcm.TipoProcessoEdit.class })
	private String codigo;

	/** Atributo nome. */
	@JsonView({ ViewsEcm.PlanoClassificacaoListView.class, ViewsEcm.PlanoClassificacaoParent.class, ViewsEcm.PlanoClassificacaoAutocompleteRecursive.class, ViewsEcm.PlanoCLassificacaoAutoComplete.class, ViewsEcm.TipoDocumentoEdit.class, ViewsEcm.PlanoCLassificacaoAutoComplete.class, ViewsEcm.TipoProcessoEdit.class, ViewsEcm.DocumentoGedEdit.class, ViewsEcm.ProcessoEdit.class, Views.ProcessoVHView.class })
	private String nome;

	/** Atributo observacao. */
	@Lob
	@JsonView({ ViewsEcm.PlanoClassificacaoListView.class })
	@Basic(fetch = FetchType.LAZY)
	@Type(type = "org.hibernate.type.StringClobType")
	private String observacao;

	/** Atributo faseCorrente. */
	@JsonView({ ViewsEcm.PlanoClassificacaoEditView.class })
	private Integer faseCorrente;

	/** Atributo faseIntermediaria. */
	@JsonView({ ViewsEcm.PlanoClassificacaoEditView.class })
	private Integer faseIntermediaria;

	/** Atributo permitirUsarComoClassificacao. */
	@JsonView({ ViewsEcm.PlanoClassificacaoEditView.class })
	private Boolean permitirUsarComoClassificacao;

	/** Atributo assunto. */
	@Transient
	@JsonView({ ViewsEcm.PlanoCLassificacaoAutoComplete.class, ViewsEcm.TipoDocumentoEdit.class, ViewsEcm.TipoProcessoEdit.class, Views.ProcessoList.class, Views.DocumentoGedEdit.class, ViewsEcm.TipoDocumentoPlanoClassificacaoAutoCompleteView.class, Views.UnidadeProcessoListView.class, ViewsEcm.MetadadoProcessoView.class, Views.ProcessoVHView.class })
	private String assunto;

	/** Atributo tipoDestinacao. */
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ ViewsEcm.PlanoClassificacaoEditView.class, Views.ProcessoList.class })
	private Dominio tipoDestinacao;

	/** Atributo planoClassificacaoParent. */
	@ManyToOne(fetch = FetchType.EAGER)
	@JsonView({ ViewsEcm.PlanoClassificacaoEditView.class })
	private PlanoClassificacao planoClassificacaoParent;

	@Transient
	/** Atributo planoClassificacoes. */
	@JsonView({ ViewsEcm.PlanoClassificacaoAutocompleteRecursive.class })
	private Collection<PlanoClassificacao> planoClassificacaoFilhas;

	/** Atributo planoClassificacaoFilhasMapeadas. */
	@OneToMany(fetch = FetchType.EAGER, cascade = CascadeType.ALL, mappedBy = "planoClassificacaoParent")
	private Collection<PlanoClassificacao> planoClassificacaoFilhasMapeadas;

	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>codigo</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getCodigo() {

		return codigo;
	}

	/**
	 * Define o valor do atributo <code>codigo</code>.
	 * 
	 * @param codigo
	 */
	public void setCodigo(String codigo) {

		this.codigo = codigo;
	}

	/**
	 * Retorna o valor do atributo <code>nome</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getNome() {

		return nome;
	}

	/**
	 * Define o valor do atributo <code>nome</code>.
	 * 
	 * @param nome
	 */
	public void setNome(String nome) {

		this.nome = nome;
	}

	/**
	 * Retorna o valor do atributo <code>observacao</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getObservacao() {

		return observacao;
	}

	/**
	 * Define o valor do atributo <code>observacao</code>.
	 * 
	 * @param observacao
	 */
	public void setObservacao(String observacao) {

		this.observacao = observacao;
	}

	/**
	 * Retorna o valor do atributo <code>planoClassificacaoParent</code>
	 * 
	 * @return <code>PlanoClassificacao</code>
	 */
	public PlanoClassificacao getPlanoClassificacaoParent() {

		return planoClassificacaoParent;
	}

	/**
	 * Define o valor do atributo <code>planoClassificacaoParent</code>.
	 * 
	 * @param planoClassificacaoParent
	 */
	public void setPlanoClassificacaoParent(PlanoClassificacao planoClassificacaoParent) {

		this.planoClassificacaoParent = planoClassificacaoParent;
	}

	/**
	 * Retorna o valor do atributo <code>faseCorrente</code>
	 * 
	 * @return <code>Integer</code>
	 */
	public Integer getFaseCorrente() {

		return faseCorrente;
	}

	/**
	 * Define o valor do atributo <code>faseCorrente</code>.
	 * 
	 * @param faseCorrente
	 */
	public void setFaseCorrente(Integer faseCorrente) {

		this.faseCorrente = faseCorrente;
	}

	/**
	 * Retorna o valor do atributo <code>faseIntermediaria</code>
	 * 
	 * @return <code>Integer</code>
	 */
	public Integer getFaseIntermediaria() {

		return faseIntermediaria;
	}

	/**
	 * Define o valor do atributo <code>faseIntermediaria</code>.
	 * 
	 * @param faseIntermediaria
	 */
	public void setFaseIntermediaria(Integer faseIntermediaria) {

		this.faseIntermediaria = faseIntermediaria;
	}

	/**
	 * Retorna o valor do atributo <code>tipoDestinacao</code>
	 * 
	 * @return <code>Dominio</code>
	 */
	public Dominio getTipoDestinacao() {

		return tipoDestinacao;
	}

	/**
	 * Define o valor do atributo <code>tipoDestinacao</code>.
	 * 
	 * @param tipoDestinacao
	 */
	public void setTipoDestinacao(Dominio tipoDestinacao) {

		this.tipoDestinacao = tipoDestinacao;
	}

	/**
	 * Retorna o valor do atributo <code>planoClassificacaoFilhas</code>
	 * 
	 * @return <code>Collection<PlanoClassificacao></code>
	 */
	public Collection<PlanoClassificacao> getPlanoClassificacaoFilhas() {

		if (UtilColecao.isVazio(planoClassificacaoFilhas)) {

			this.planoClassificacaoFilhas = new LinkedList<PlanoClassificacao>();
		}

		return planoClassificacaoFilhas;
	}

	/**
	 * Define o valor do atributo <code>planoClassificacaoFilhas</code>.
	 * 
	 * @param planoClassificacaoFilhas
	 */
	public void setPlanoClassificacaoFilhas(Collection<PlanoClassificacao> planoClassificacaoFilhas) {

		this.planoClassificacaoFilhas = planoClassificacaoFilhas;
	}

	/**
	 * Retorna o valor do atributo <code>contemFilhos</code>
	 * 
	 * @return <code>boolean</code>
	 */
	@JsonView({ ViewsEcm.PlanoClassificacaoParent.class, ViewsEcm.PlanoClassificacaoAutocompleteRecursive.class })
	public boolean isContemFilhos() {

		return !UtilColecao.isVazio(this.planoClassificacaoFilhas) && !this.planoClassificacaoFilhas.isEmpty();
	}

	/**
	 * Retorna o valor do atributo <code>permitirUsarComoClassificacao</code>
	 * 
	 * @return <code>Boolean</code>
	 */
	public Boolean getPermitirUsarComoClassificacao() {

		return permitirUsarComoClassificacao;
	}

	/**
	 * Define o valor do atributo <code>permitirUsarComoClassificacao</code>.
	 * 
	 * @param permitirUsarComoClassificacao
	 */
	public void setPermitirUsarComoClassificacao(Boolean permitirUsarComoClassificacao) {

		this.permitirUsarComoClassificacao = permitirUsarComoClassificacao;
	}

	/**
	 * Retorna o valor do atributo <code>planoClassificacaoFilhasMapeadas</code>
	 * 
	 * @return <code>Collection<PlanoClassificacao></code>
	 */
	public Collection<PlanoClassificacao> getPlanoClassificacaoFilhasMapeadas() {

		return planoClassificacaoFilhasMapeadas;
	}

	/**
	 * Define o valor do atributo <code>planoClassificacaoFilhasMapeadas</code>.
	 * 
	 * @param planoClassificacaoFilhasMapeadas
	 */
	public void setPlanoClassificacaoFilhasMapeadas(Collection<PlanoClassificacao> planoClassificacaoFilhasMapeadas) {

		this.planoClassificacaoFilhasMapeadas = planoClassificacaoFilhasMapeadas;
	}

	public String getAssunto() {

		StringBuilder sb = new StringBuilder();

		sb.append(this.getCodigo()).append(" - ");

		setAssunto(this, sb);

		assunto = sb.toString().substring(0, sb.toString().length() - 2);

		return this.assunto;
	}

	/**
	 * Define o valor do atributo <code>assunto</code>.
	 * 
	 * @param assunto
	 */
	public void setAssunto(PlanoClassificacao planoClassificacao, StringBuilder sb) {

		if (UtilObjeto.isReferencia(planoClassificacao.getPlanoClassificacaoParent())) {

			setAssunto(planoClassificacao.getPlanoClassificacaoParent(), sb);
		}

		sb.append(planoClassificacao.getNome()).append(" / ");
	}

	/**
	 * {@inheritDoc}
	 */
	public PlanoClassificacao clone() {

		try {

			return (PlanoClassificacao) super.clone();

		} catch (CloneNotSupportedException ex) {

			return null;
		}
	}

}
