package br.com.centralit.api.model;

import java.util.Collection;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToMany;
import javax.persistence.ManyToOne;

import br.com.centralit.framework.json.Views;

import com.fasterxml.jackson.annotation.JsonView;

@Entity
public class ProcessoRelacionado extends PersistentObjectUnidade {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = -3431851712318787243L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo processo. */
	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	@JsonView({ Views.GenericView.class })
	private Processo processoRelacionado;

	/** Atributo processo. */
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ Views.GenericView.class })
	private Processo processo;

	/** Atributo processo. */
	@JsonView({ Views.GenericView.class })
	private Processo processoRemocao;

	/** Atributo processos. */
	@ManyToMany(cascade = { CascadeType.PERSIST, CascadeType.MERGE }, mappedBy = "relacionados", targetEntity = Processo.class)
	private Collection<Processo> processos;

	/**
	 * Retorna o valor do atributo <code>processos</code>
	 * 
	 * @return <code>Collection<Processo></code>
	 */
	public Collection<Processo> getProcessos() {

		return processos;
	}

	/**
	 * Define o valor do atributo <code>processos</code>.
	 * 
	 * @param processos
	 */
	public void setProcessos(Collection<Processo> processos) {

		this.processos = processos;
	}

	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>processo</code>
	 * 
	 * @return <code>Processo</code>
	 */
	public Processo getProcesso() {

		return processo;
	}

	/**
	 * Define o valor do atributo <code>processo</code>.
	 * 
	 * @param processo
	 */
	public void setProcesso(Processo processo) {

		this.processo = processo;
	}

	/**
	 * Retorna o valor do atributo <code>processoRelacionado</code>
	 * 
	 * @return <code>Processo</code>
	 */
	public Processo getProcessoRelacionado() {

		return processoRelacionado;
	}

	/**
	 * Define o valor do atributo <code>processoRelacionado</code>.
	 * 
	 * @param processoRelacionado
	 */
	public void setProcessoRelacionado(Processo processoRelacionado) {

		this.processoRelacionado = processoRelacionado;
	}

	/**
	 * Retorna o valor do atributo <code>processoRemocao</code>
	 * 
	 * @return <code>Processo</code>
	 */
	public Processo getProcessoRemocao() {

		return processoRemocao;
	}

	/**
	 * Define o valor do atributo <code>processoRemocao</code>.
	 * 
	 * @param processoRemocao
	 */
	public void setProcessoRemocao(Processo processoRemocao) {

		this.processoRemocao = processoRemocao;
	}

}
