package br.com.centralit.api.model;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Transient;

import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.Dominio;

import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 01/04/2016 - 19:15:01
 * 
 * @version 1.0.0
 * 
 * @author maycon.silva
 * 
 */
@Entity
public class ReabrirProcesso extends PersistentObjectUnidade {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 4660153373227383621L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo justificativa. */
	@JsonView({ Views.ReabrirProcessoListView.class })
	private String justificativaSolicitacao;
	
	/** Atributo justificativa. */
	@JsonView({ Views.ReabrirProcessoListView.class })
	private String justificativaRejeicao;

	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	@JsonView({ Views.ReabrirProcessoListView.class })
	private Processo processo;
	
	/** Atributo status. */
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ Views.ReabrirProcessoListView.class})
	private Dominio status;
	
	@Transient
	@JsonView({ Views.ReabrirProcessoListView.class})
	private boolean validado;


	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	@Override
	public Long getId() {

		return this.id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}


	/**
	 * Retorna o valor do atributo <code>processo</code>
	 * 
	 * @return <code>Processo</code>
	 */
	public Processo getProcesso() {

		return processo;
	}

	/**
	 * Define o valor do atributo <code>processo</code>.
	 * 
	 * @param processo
	 */
	public void setProcesso(Processo processo) {

		this.processo = processo;
	}

	
	/**
	 * Retorna o valor do atributo <code>status</code>
	 *
	 * @return <code>Dominio</code>
	 */
	public Dominio getStatus() {
	
		return status;
	}

	
	/**
	 * Define o valor do atributo <code>status</code>.
	 *
	 * @param status 
	 */
	public void setStatus(Dominio status) {
	
		this.status = status;
	}

	
	/**
	 * Retorna o valor do atributo <code>justificativaSolicitacao</code>
	 *
	 * @return <code>String</code>
	 */
	public String getJustificativaSolicitacao() {
	
		return justificativaSolicitacao;
	}

	
	/**
	 * Define o valor do atributo <code>justificativaSolicitacao</code>.
	 *
	 * @param justificativaSolicitacao 
	 */
	public void setJustificativaSolicitacao(String justificativaSolicitacao) {
	
		this.justificativaSolicitacao = justificativaSolicitacao;
	}

	
	/**
	 * Retorna o valor do atributo <code>justificativaRejeicao</code>
	 *
	 * @return <code>String</code>
	 */
	public String getJustificativaRejeicao() {
	
		return justificativaRejeicao;
	}

	
	/**
	 * Define o valor do atributo <code>justificativaRejeicao</code>.
	 *
	 * @param justificativaRejeicao 
	 */
	public void setJustificativaRejeicao(String justificativaRejeicao) {
	
		this.justificativaRejeicao = justificativaRejeicao;
	}

	
	/**
	 * Retorna o valor do atributo <code>validado</code>
	 *
	 * @return <code>boolean</code>
	 */
	public boolean isValidado() {
	
		return validado;
	}

	
	/**
	 * Define o valor do atributo <code>validado</code>.
	 *
	 * @param validado 
	 */
	public void setValidado(boolean validado) {
	
		this.validado = validado;
	}

}
