package br.com.centralit.api.model;

import java.util.Collection;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.Dominio;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAudit;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 02/03/2016 - 16:39:02
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Entity
@JsonIgnoreProperties({ "checked" })
public class Sigilo extends PersistentObjectAudit {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = -3028368290157018483L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo tipoSigilo. */
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ Views.GenericView.class})
	private Dominio tipoSigilo;

	/** Atributo sigiloPrivilegios. */
	@OneToMany(fetch = FetchType.LAZY, mappedBy = "sigilo", cascade = CascadeType.ALL)
	private Collection<SigiloPrivilegio> sigiloPrivilegios;

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 */
	public Sigilo() {

		super();
	}

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * 
	 * @param tipoSigilo
	 */
	public Sigilo( Dominio tipoSigilo ) {

		this.tipoSigilo = tipoSigilo;

	}

	/**
	 * Retorna o valor do atributo <code>tipoSigilo</code>
	 * 
	 * @return <code>Dominio</code>
	 */
	public Dominio getTipoSigilo() {

		return tipoSigilo;
	}

	/**
	 * Define o valor do atributo <code>tipoSigilo</code>.
	 * 
	 * @param tipoSigilo
	 */
	public void setTipoSigilo(Dominio tipoSigilo) {

		this.tipoSigilo = tipoSigilo;
	}

	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>sigiloPrivilegios</code>
	 * 
	 * @return <code>Collection<SigiloPrivilegio></code>
	 */
	public Collection<SigiloPrivilegio> getSigiloPrivilegios() {

		return sigiloPrivilegios;
	}

	/**
	 * Define o valor do atributo <code>sigiloPrivilegios</code>.
	 * 
	 * @param sigiloPrivilegios
	 */
	public void setSigiloPrivilegios(Collection<SigiloPrivilegio> sigiloPrivilegios) {

		this.sigiloPrivilegios = sigiloPrivilegios;
	}

}
