package br.com.centralit.api.model;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;

import br.com.centralit.api.framework.json.ViewsEcm;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAudit;

import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 29/01/2016 - 14:44:14
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Entity
public class SigiloTipoDocumento extends PersistentObjectAudit {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = -7592687728432350533L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo tipoSigilo. */
	@ManyToOne(fetch = FetchType.LAZY)
	private NivelAcessoTipoDocumento nivelAcessoTipoDocumento;

	/** Atributo tipoSigilo. */
	@ManyToOne(fetch = FetchType.LAZY)
	private NivelAcessoTipoDocumento nivelAcessoTipoDocumentoRemocao;

	/** Atributo sigilo. */
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ ViewsEcm.TipoDocumentoEdit.class, ViewsEcm.NivelAcessoTipoDocumentoEdit.class, Views.DocumentoGedEdit.class })
	private Sigilo sigilo;

	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>nivelAcessoTipoDocumento</code>
	 * 
	 * @return <code>NivelAcessoTipoDocumento</code>
	 */
	public NivelAcessoTipoDocumento getNivelAcessoTipoDocumento() {

		return nivelAcessoTipoDocumento;
	}

	/**
	 * Define o valor do atributo <code>nivelAcessoTipoDocumento</code>.
	 * 
	 * @param nivelAcessoTipoDocumento
	 */
	public void setNivelAcessoTipoDocumento(NivelAcessoTipoDocumento nivelAcessoTipoDocumento) {

		this.nivelAcessoTipoDocumento = nivelAcessoTipoDocumento;
	}

	/**
	 * Retorna o valor do atributo <code>nivelAcessoTipoDocumentoRemocao</code>
	 * 
	 * @return <code>NivelAcessoTipoDocumento</code>
	 */
	public NivelAcessoTipoDocumento getNivelAcessoTipoDocumentoRemocao() {

		return nivelAcessoTipoDocumentoRemocao;
	}

	/**
	 * Define o valor do atributo <code>nivelAcessoTipoDocumentoRemocao</code>.
	 * 
	 * @param nivelAcessoTipoDocumentoRemocao
	 */
	public void setNivelAcessoTipoDocumentoRemocao(NivelAcessoTipoDocumento nivelAcessoTipoDocumentoRemocao) {

		this.nivelAcessoTipoDocumentoRemocao = nivelAcessoTipoDocumentoRemocao;
	}

	@JsonView({ ViewsEcm.NivelAcessoTipoDocumentoEdit.class})
	public String getTipoSigiloDescricao() {

		return this.sigilo.getTipoSigilo().getDescricao();
	}

}
