package br.com.centralit.api.model;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;

import br.com.centralit.api.framework.json.ViewsEcm;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAudit;

import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 27/01/2016 - 17:08:32
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Entity
public class SigiloTipoProcesso extends PersistentObjectAudit {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 3408711178357669906L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo nivelAcessoTipoProcesso. */
	@ManyToOne(fetch = FetchType.LAZY)
	private NivelAcessoTipoProcesso nivelAcessoTipoProcesso;

	@ManyToOne(fetch = FetchType.LAZY)
	private NivelAcessoTipoProcesso nivelAcessoTipoProcessoRemocao;

	/** Atributo sigilo. */
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ ViewsEcm.TipoProcessoEdit.class, ViewsEcm.NivelAcessoTipoProcessoEdit.class, ViewsEcm.ProcessoEdit.class, ViewsEcm.MetadadoProcessoView.class })
	private Sigilo sigilo;

	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>nivelAcessoTipoProcesso</code>
	 * 
	 * @return <code>NivelAcessoTipoProcesso</code>
	 */
	public NivelAcessoTipoProcesso getNivelAcessoTipoProcesso() {

		return nivelAcessoTipoProcesso;
	}

	/**
	 * Define o valor do atributo <code>nivelAcessoTipoProcesso</code>.
	 * 
	 * @param nivelAcessoTipoProcesso
	 */
	public void setNivelAcessoTipoProcesso(NivelAcessoTipoProcesso nivelAcessoTipoProcesso) {

		this.nivelAcessoTipoProcesso = nivelAcessoTipoProcesso;
	}

	/**
	 * Retorna o valor do atributo <code>nivelAcessoTipoProcessoRemocao</code>
	 * 
	 * @return <code>NivelAcessoTipoProcesso</code>
	 */
	public NivelAcessoTipoProcesso getNivelAcessoTipoProcessoRemocao() {

		return nivelAcessoTipoProcessoRemocao;
	}

	/**
	 * Define o valor do atributo <code>nivelAcessoTipoProcessoRemocao</code>.
	 * 
	 * @param nivelAcessoTipoProcessoRemocao
	 */
	public void setNivelAcessoTipoProcessoRemocao(NivelAcessoTipoProcesso nivelAcessoTipoProcessoRemocao) {

		this.nivelAcessoTipoProcessoRemocao = nivelAcessoTipoProcessoRemocao;
	}

	/**
	 * Retorna o valor do atributo <code>sigilo</code>
	 * 
	 * @return <code>Sigilo</code>
	 */
	public Sigilo getSigilo() {

		return sigilo;
	}

	/**
	 * Define o valor do atributo <code>sigilo</code>.
	 * 
	 * @param sigilo
	 */
	public void setSigilo(Sigilo sigilo) {

		this.sigilo = sigilo;
	}

}
