package br.com.centralit.api.model;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToOne;

import com.fasterxml.jackson.annotation.JsonView;

import br.com.centralit.api.framework.json.ViewsEcm;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.AnexoImagem;
import br.com.centralit.framework.model.Dominio;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAudit;

@Entity
public class TarjaAssinatura extends PersistentObjectAudit{

	private static final long serialVersionUID = -7187159662335439914L;

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	@JsonView({ ViewsEcm.TarjaAssinaturaEditview.class })
	@Column (length=100, nullable = false)
	private String descricao;

	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ ViewsEcm.TarjaAssinaturaEditview.class })
	private Dominio tipoAssinatura;

	/** Conte&uacute;do em HTML*/
	@JsonView({ ViewsEcm.TarjaAssinaturaEditview.class })
	@Column (length=1000, nullable = false)
	private String conteudo;

	@OneToOne
	@JsonView({ ViewsEcm.TarjaAssinaturaEditview.class })
	private AnexoImagem anexoImagem;
	
	public static String LOGO = "@logo@";
	public static String NOME_ASSINANTE = "@nome_assinante@";
	public static String FUNCAO_ASSINANTE = "@funcao_assinante@";
	public static String DATA_ASSINATURA = "@data_assinatura@";
	public static String HORA_ASSINATURA = "@hora_assinatura@";
	public static String CODIGO_ASSINATURA = "@codigo_assinatura@";

	public Long getId() {

		return id;
	}

	public void setId(Long id) {

		this.id = id;
	}

	public String getDescricao() {

		return descricao;
	}

	public void setDescricao(String descricao) {

		this.descricao = descricao;
	}

	public Dominio getTipoAssinatura() {

		return tipoAssinatura;
	}

	public void setTipoAssinatura(Dominio tipoAssinatura) {

		this.tipoAssinatura = tipoAssinatura;
	}

	public String getConteudo() {

		return conteudo;
	}

	public void setConteudo(String conteudo) {

		this.conteudo = conteudo;
	}

	public AnexoImagem getAnexoImagem() {

		return anexoImagem;
	}

	public void setAnexoImagem(AnexoImagem anexoImagem) {

		this.anexoImagem = anexoImagem;
	}
}
