package br.com.centralit.api.model;

import javax.persistence.Basic;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Lob;
import javax.persistence.ManyToOne;

import org.hibernate.annotations.Type;

import br.com.centralit.api.framework.json.ViewsEcm;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAudit;

import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 04/02/2016 - 11:31:00
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Entity
public class TemplatePadrao extends PersistentObjectAudit {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 4932115116434985520L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo nome. */
	@JsonView({ ViewsEcm.TemplatePadraoListView.class, ViewsEcm.TipoDocumentoEdit.class })
	private String nome;

	/** Atributo cabecalho. */
	@JsonView({ ViewsEcm.TemplatePadraoListView.class ,ViewsEcm.TipoDocumentoEdit.class })
	@ManyToOne(fetch = FetchType.LAZY)
	private Cabecalho cabecalho;

	/** Atributo rodape. */
	@JsonView({ ViewsEcm.TemplatePadraoListView.class ,ViewsEcm.TipoDocumentoEdit.class})
	@ManyToOne(fetch = FetchType.LAZY)
	private Rodape rodape;

	@Lob
	@JsonView({ ViewsEcm.TemplatePadraoEditView.class })
	@Basic(fetch = FetchType.LAZY)
	@Type(type = "org.hibernate.type.StringClobType")
	private String conteudo;

	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>cabecalho</code>
	 *
	 * @return <code>Cabecalho</code>
	 */
	public Cabecalho getCabecalho() {

		return cabecalho;
	}

	/**
	 * Define o valor do atributo <code>cabecalho</code>.
	 *
	 * @param cabecalho
	 */
	public void setCabecalho(Cabecalho cabecalho) {

		this.cabecalho = cabecalho;
	}

	/**
	 * Retorna o valor do atributo <code>rodape</code>
	 *
	 * @return <code>Rodape</code>
	 */
	public Rodape getRodape() {

		return rodape;
	}

	/**
	 * Define o valor do atributo <code>rodape</code>.
	 *
	 * @param rodape
	 */
	public void setRodape(Rodape rodape) {

		this.rodape = rodape;
	}

	/**
	 * Retorna o valor do atributo <code>nome</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getNome() {

		return nome;
	}

	/**
	 * Define o valor do atributo <code>nome</code>.
	 * 
	 * @param nome
	 */
	public void setNome(String nome) {

		this.nome = nome;
	}

	/**
	 * Retorna o valor do atributo <code>conteudo</code>
	 *
	 * @return <code>String</code>
	 */
	public String getConteudo() {

		return conteudo;
	}

	/**
	 * Define o valor do atributo <code>conteudo</code>.
	 *
	 * @param conteudo
	 */
	public void setConteudo(String conteudo) {

		this.conteudo = conteudo;
	}

}
