package br.com.centralit.api.model;

import java.util.Calendar;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToOne;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import br.com.centralit.framework.json.JsonCalendarSerializer;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.Dominio;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAudit;

import com.fasterxml.jackson.annotation.JsonView;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 16/02/2016 - 16:25:15
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Entity
public class Temporalidade extends PersistentObjectAudit {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 1389536103618860589L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo faseCorrente. */
	private Integer faseCorrente;

	/** Atributo faseIntermediaria. */
	private Integer faseIntermediaria;

	/** Atributo dataFimTemporalidade. */
	@Temporal(TemporalType.TIMESTAMP)
	@JsonView({ Views.ProcessoList.class })
	@JsonSerialize(using = JsonCalendarSerializer.class)
	private Calendar dataFimTemporalidade;

	/** Atributo tipoDestinacao. */
	@JsonView({ Views.ProcessoList.class })
	@ManyToOne(fetch = FetchType.LAZY)
	private Dominio tipoDestinacao;

	/** Atributo processo. */
	@OneToOne(mappedBy = "temporalidade", fetch = FetchType.LAZY)
	private Processo processo;

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * 
	 * @param faseCorrente
	 * @param faseIntermediaria
	 */
	public Temporalidade( Integer faseCorrente, Integer faseIntermediaria, Dominio tipoDestinacao ) {

		this.faseCorrente = faseCorrente;

		this.faseIntermediaria = faseIntermediaria;

		this.tipoDestinacao = tipoDestinacao;

	}

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 */
	public Temporalidade() {

		super();
	}

	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	@Override
	public Long getId() {

		return this.id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>faseCorrente</code>
	 * 
	 * @return <code>Integer</code>
	 */
	public Integer getFaseCorrente() {

		return this.faseCorrente;
	}

	/**
	 * Define o valor do atributo <code>faseCorrente</code>.
	 * 
	 * @param faseCorrente
	 */
	public void setFaseCorrente(Integer faseCorrente) {

		this.faseCorrente = faseCorrente;
	}

	/**
	 * Retorna o valor do atributo <code>faseIntermediaria</code>
	 * 
	 * @return <code>Integer</code>
	 */
	public Integer getFaseIntermediaria() {

		return this.faseIntermediaria;
	}

	/**
	 * Define o valor do atributo <code>faseIntermediaria</code>.
	 * 
	 * @param faseIntermediaria
	 */
	public void setFaseIntermediaria(Integer faseIntermediaria) {

		this.faseIntermediaria = faseIntermediaria;
	}

	/**
	 * Retorna o valor do atributo <code>dataFimTemporalidade</code>
	 * 
	 * @return <code>Calendar</code>
	 */
	public Calendar getDataFimTemporalidade() {

		return this.dataFimTemporalidade;
	}

	/**
	 * Define o valor do atributo <code>dataFimTemporalidade</code>.
	 * 
	 * @param dataFimTemporalidade
	 */
	public void setDataFimTemporalidade(Calendar dataFimTemporalidade) {

		this.dataFimTemporalidade = dataFimTemporalidade;
	}

	/**
	 * Retorna o valor do atributo <code>processo</code>
	 * 
	 * @return <code>Processo</code>
	 */
	public Processo getProcesso() {

		return processo;
	}

	/**
	 * Define o valor do atributo <code>processo</code>.
	 * 
	 * @param processo
	 */
	public void setProcesso(Processo processo) {

		this.processo = processo;
	}

	/**
	 * Retorna o valor do atributo <code>tipoDestinacao</code>
	 * 
	 * @return <code>Dominio</code>
	 */
	public Dominio getTipoDestinacao() {

		return tipoDestinacao;
	}

	/**
	 * Define o valor do atributo <code>tipoDestinacao</code>.
	 * 
	 * @param tipoDestinacao
	 */
	public void setTipoDestinacao(Dominio tipoDestinacao) {

		this.tipoDestinacao = tipoDestinacao;
	}

}
