package br.com.centralit.api.model;

import java.util.Collection;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

import br.com.centralit.api.framework.json.ViewsEcm;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.Dominio;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAudit;

import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 20/10/2015 - 16:15:28
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Entity
public class TipoDocumento extends PersistentObjectAudit {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 3628020005616387940L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo descricao. */
	@JsonView({ ViewsEcm.TipoDocumentoList.class })
	private String descricao;

	/** Atributo nome. */
	@JsonView({ ViewsEcm.TipoDocumentoList.class, ViewsEcm.DocumentoGedEdit.class, Views.ProcessoEdit.class, Views.ProcessoVHView.class })
	private String nome;

	/** Atributo formaCriacao. */
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ ViewsEcm.TipoDocumentoEdit.class, Views.DocumentoGedEdit.class })
	private Dominio formaCriacao;

	/** Atributo formaNumeracao. */
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ ViewsEcm.TipoDocumentoEdit.class, Views.DocumentoGedEdit.class })
	private Dominio formaNumeracao;

	/** Atributo hipoteseLegal. */
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ ViewsEcm.TipoDocumentoEdit.class, ViewsEcm.NivelAcessoTipoDocumentoEdit.class, ViewsEcm.DocumentoGedEdit.class })
	private HipoteseLegal hipoteseLegal;

	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ ViewsEcm.TipoDocumentoEdit.class, Views.DocumentoGedEdit.class })
	private TemplatePadrao templatePadrao;

	/** Atributo acessos. */
	@OneToMany(fetch = FetchType.LAZY, mappedBy = "tipoDocumento", cascade = CascadeType.ALL, orphanRemoval = true)
	@JsonView({ ViewsEcm.TipoDocumentoEdit.class })
	private Collection<NivelAcessoTipoDocumento> acessos;

	/** Atributo tipoDocumentoPlanoClassificacoes. */
	@OneToMany(fetch = FetchType.LAZY, mappedBy = "tipoDocumento", cascade = CascadeType.ALL, orphanRemoval = true)
	@JsonView({ ViewsEcm.TipoDocumentoEdit.class })
	private Collection<TipoDocumentoPlanoClassificacao> tipoDocumentoPlanoClassificacoes;

	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>descricao</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getDescricao() {

		return descricao;
	}

	/**
	 * Define o valor do atributo <code>descricao</code>.
	 * 
	 * @param descricao
	 */
	public void setDescricao(String descricao) {

		this.descricao = descricao;
	}

	/**
	 * Retorna o valor do atributo <code>formaCriacao</code>
	 * 
	 * @return <code>Dominio</code>
	 */
	public Dominio getFormaCriacao() {

		return formaCriacao;
	}

	/**
	 * Define o valor do atributo <code>formaCriacao</code>.
	 * 
	 * @param formaCriacao
	 */
	public void setFormaCriacao(Dominio formaCriacao) {

		this.formaCriacao = formaCriacao;
	}

	/**
	 * Retorna o valor do atributo <code>nome</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getNome() {

		return nome;
	}

	/**
	 * Define o valor do atributo <code>nome</code>.
	 * 
	 * @param nome
	 */
	public void setNome(String nome) {

		this.nome = nome;
	}

	/**
	 * Retorna o valor do atributo <code>acessos</code>
	 * 
	 * @return <code>Collection<NivelAcessoTipoDocumento></code>
	 */
	public Collection<NivelAcessoTipoDocumento> getAcessos() {

		return acessos;
	}

	/**
	 * Define o valor do atributo <code>acessos</code>.
	 * 
	 * @param acessos
	 */
	public void setAcessos(Collection<NivelAcessoTipoDocumento> acessos) {

		this.acessos = acessos;
	}

	/**
	 * Retorna o valor do atributo <code>tipoDocumentoPlanoClassificacoes</code>
	 * 
	 * @return <code>Collection<TipoDocumentoPlanoClassificacao></code>
	 */
	public Collection<TipoDocumentoPlanoClassificacao> getTipoDocumentoPlanoClassificacoes() {

		return tipoDocumentoPlanoClassificacoes;
	}

	/**
	 * Define o valor do atributo <code>tipoDocumentoPlanoClassificacoes</code>.
	 * 
	 * @param tipoDocumentoPlanoClassificacoes
	 */
	public void setTipoDocumentoPlanoClassificacoes(Collection<TipoDocumentoPlanoClassificacao> tipoDocumentoPlanoClassificacoes) {

		this.tipoDocumentoPlanoClassificacoes = tipoDocumentoPlanoClassificacoes;
	}

	/**
	 * Retorna o valor do atributo <code>hipoteseLegal</code>
	 * 
	 * @return <code>HipoteseLegal</code>
	 */
	public HipoteseLegal getHipoteseLegal() {

		return hipoteseLegal;
	}

	/**
	 * Define o valor do atributo <code>hipoteseLegal</code>.
	 * 
	 * @param hipoteseLegal
	 */
	public void setHipoteseLegal(HipoteseLegal hipoteseLegal) {

		this.hipoteseLegal = hipoteseLegal;
	}

	/**
	 * Retorna o valor do atributo <code>formaNumeracao</code>
	 * 
	 * @return <code>Dominio</code>
	 */
	public Dominio getFormaNumeracao() {

		return formaNumeracao;
	}

	/**
	 * Define o valor do atributo <code>formaNumeracao</code>.
	 * 
	 * @param formaNumeracao
	 */
	public void setFormaNumeracao(Dominio formaNumeracao) {

		this.formaNumeracao = formaNumeracao;
	}

	/**
	 * Retorna o valor do atributo <code>templatePadrao</code>
	 * 
	 * @return <code>TemplatePadrao</code>
	 */
	public TemplatePadrao getTemplatePadrao() {

		return templatePadrao;
	}

	/**
	 * Define o valor do atributo <code>templatePadrao</code>.
	 * 
	 * @param templatePadrao
	 */
	public void setTemplatePadrao(TemplatePadrao templatePadrao) {

		this.templatePadrao = templatePadrao;
	}

}
