package br.com.centralit.api.model;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;

import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAudit;

import com.fasterxml.jackson.annotation.JsonView;


/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title:  </b></p>
 *
 * <p><b>Description:Entidade Responsável por vincular tipoDocumento a Caracteristica do Documento </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio: História de Usuário Manter Tipo Documento</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 29/10/2015 - 17:29:22
 *
 * @version 1.0.0
 *
 * @author maycon.silva
 *	
 */
@Entity
public class TipoDocumentoCaracteristica extends PersistentObjectAudit {

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo obrigatorio. */
	@JsonView({ Views.MaterialAutoCompleteView.class, Views.MaterialEditView.class, Views.EntradaEditView.class, Views.BemPatrimonialEditView.class })
	private Boolean obrigatorio;

	/** Atributo sequencia. */
	@JsonView({ Views.MaterialAutoCompleteView.class, Views.MaterialEditView.class })
	private Long sequencia;

	/** Atributo caracteristica. */
	@ManyToOne(fetch = FetchType.LAZY, optional = false)
	@JsonView({ Views.MaterialAutoCompleteView.class, Views.MaterialEditView.class, Views.EntradaEditView.class, Views.BemPatrimonialEditView.class })
	public Caracteristica caracteristica;

	/** Atributo material. */
	@ManyToOne(fetch = FetchType.LAZY)
	private TipoDocumento tipoDocumento;

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 6457940093834583996L;

	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>obrigatorio</code>
	 * 
	 * @return <code>Boolean</code>
	 */
	public Boolean getObrigatorio() {

		return obrigatorio;
	}

	/**
	 * Define o valor do atributo <code>obrigatorio</code>.
	 * 
	 * @param obrigatorio
	 */
	public void setObrigatorio(Boolean obrigatorio) {

		this.obrigatorio = obrigatorio;
	}

	/**
	 * Retorna o valor do atributo <code>sequencia</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getSequencia() {

		return sequencia;
	}

	/**
	 * Define o valor do atributo <code>sequencia</code>.
	 * 
	 * @param sequencia
	 */
	public void setSequencia(Long sequencia) {

		this.sequencia = sequencia;
	}

	/**
	 * Retorna o valor do atributo <code>caracteristica</code>
	 * 
	 * @return <code>Caracteristica</code>
	 */
	public Caracteristica getCaracteristica() {

		return caracteristica;
	}

	/**
	 * Define o valor do atributo <code>caracteristica</code>.
	 * 
	 * @param caracteristica
	 */
	public void setCaracteristica(Caracteristica caracteristica) {

		this.caracteristica = caracteristica;
	}

	/**
	 * Retorna o valor do atributo <code>tipoDocumento</code>
	 * 
	 * @return <code>TipoDocumento</code>
	 */
	public TipoDocumento getTipoDocumento() {

		return tipoDocumento;
	}

	/**
	 * Define o valor do atributo <code>tipoDocumento</code>.
	 * 
	 * @param tipoDocumento
	 */
	public void setTipoDocumento(TipoDocumento tipoDocumento) {

		this.tipoDocumento = tipoDocumento;
	}

}
