package br.com.centralit.api.model;

import java.util.Collection;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;

import org.apache.solr.client.solrj.beans.Field;

import com.fasterxml.jackson.annotation.JsonView;

import br.com.centralit.api.framework.json.ViewsEcm;
import br.com.centralit.framework.json.Views;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 20/10/2015 - 16:39:58
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Entity
public class TipoProcesso extends PersistentObjectUnidade {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = -1253293648291624602L;

	/** Atributo id. */
	@Id
	@Field
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo descricao. */
	@JsonView({ ViewsEcm.TipoProcessoList.class, Views.UnidadeProcessoListView.class})
	private String descricao;

	/** Atributo nome. */
	@JsonView({ ViewsEcm.TipoProcessoList.class, Views.ProcessoList.class, Views.ProcessoRelacionadoList.class, ViewsEcm.MetadadoProcessoView.class, Views.ProcessoVHView.class})
	private String nome;

	/** Atributo nome. */
	@JsonView({ ViewsEcm.TipoProcessoList.class, Views.ProcessoEdit.class })
	private String processoNegocio;

	/** Atributo acessos. */
	@OneToMany(fetch = FetchType.LAZY, mappedBy = "tipoProcesso", cascade = CascadeType.ALL)
	@JsonView({ ViewsEcm.TipoProcessoEdit.class, ViewsEcm.ProcessoEdit.class })
	private Collection<NivelAcessoTipoProcesso> acessos;

	/** Atributo tipoProcessoPlanoClassificacoes. */
	@OneToMany(fetch = FetchType.LAZY, mappedBy = "tipoProcesso", cascade = CascadeType.ALL, orphanRemoval = true)
	@JsonView({ ViewsEcm.TipoProcessoEdit.class })
	private Collection<TipoProcessoPlanoClassificacao> tipoProcessoPlanoClassificacoes;

	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>descricao</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getDescricao() {

		return descricao;
	}

	/**
	 * Define o valor do atributo <code>descricao</code>.
	 * 
	 * @param descricao
	 */
	public void setDescricao(String descricao) {

		this.descricao = descricao;
	}

	/**
	 * Retorna o valor do atributo <code>nome</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getNome() {

		return nome;
	}

	/**
	 * Define o valor do atributo <code>nome</code>.
	 * 
	 * @param nome
	 */
	public void setNome(String nome) {

		this.nome = nome;
	}

	/**
	 * Retorna o valor do atributo <code>acessos</code>
	 * 
	 * @return <code>Collection<NivelAcessoTipoProcesso></code>
	 */
	public Collection<NivelAcessoTipoProcesso> getAcessos() {

		return acessos;
	}

	/**
	 * Define o valor do atributo <code>acessos</code>.
	 * 
	 * @param acessos
	 */
	public void setAcessos(Collection<NivelAcessoTipoProcesso> acessos) {

		this.acessos = acessos;
	}

	/**
	 * Retorna o valor do atributo <code>tipoProcessoPlanoClassificacoes</code>
	 * 
	 * @return <code>Collection<TipoProcessoPlanoClassificacao></code>
	 */
	public Collection<TipoProcessoPlanoClassificacao> getTipoProcessoPlanoClassificacoes() {

		return tipoProcessoPlanoClassificacoes;
	}

	/**
	 * Define o valor do atributo <code>tipoProcessoPlanoClassificacoes</code>.
	 * 
	 * @param tipoProcessoPlanoClassificacoes
	 */
	public void setTipoProcessoPlanoClassificacoes(Collection<TipoProcessoPlanoClassificacao> tipoProcessoPlanoClassificacoes) {

		this.tipoProcessoPlanoClassificacoes = tipoProcessoPlanoClassificacoes;
	}

	/**
	 * Retorna o valor do atributo <code>processoNegocio</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getProcessoNegocio() {

		return processoNegocio;
	}

	/**
	 * Define o valor do atributo <code>processoNegocio</code>.
	 * 
	 * @param processoNegocio
	 */
	public void setProcessoNegocio(String processoNegocio) {

		this.processoNegocio = processoNegocio;
	}

}
