package br.com.centralit.api.model;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;

import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.Unidade;
import br.com.centralit.framework.model.Usuario;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAudit;

import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 05/01/2016 - 14:33:52
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Entity
public class UnidadeProcesso extends PersistentObjectAudit {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 6951829979764291861L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo eviarEmail. */
	@JsonView({ Views.EnviarProcessoView.class })
	private Boolean enviarEmail;

	/** Atributo concluido. */
	@JsonView({ Views.EnviarProcessoView.class })
	private Boolean concluido;

	/** Atributo primeiroAcesso. */
	@JsonView({ Views.EnviarProcessoView.class })
	private Boolean primeiroAcesso;

	/** Atributo processo. */
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ Views.EnviarProcessoView.class, Views.UnidadeProcessoListView.class })
	private Processo processo;

	/** Atributo grupo. */
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ Views.EnviarProcessoView.class, Views.ProcessoVHView.class})
	private Unidade unidade;

	/** Atributo usuarioResponsavel. */
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ Views.EnviarProcessoView.class, Views.UnidadeProcessoListView.class, Views.ProcessoVHView.class})
	private Usuario usuarioResponsavel;

	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>processo</code>
	 * 
	 * @return <code>Processo</code>
	 */
	public Processo getProcesso() {

		return processo;
	}

	/**
	 * Define o valor do atributo <code>processo</code>.
	 * 
	 * @param processo
	 */
	public void setProcesso(Processo processo) {

		this.processo = processo;
	}

	/**
	 * Retorna o valor do atributo <code>unidade</code>
	 * 
	 * @return <code>Unidade</code>
	 */
	public Unidade getUnidade() {

		return unidade;
	}

	/**
	 * Define o valor do atributo <code>unidade</code>.
	 * 
	 * @param unidade
	 */
	public void setUnidade(Unidade unidade) {

		this.unidade = unidade;
	}

	/**
	 * Retorna o valor do atributo <code>enviarEmail</code>
	 * 
	 * @return <code>Boolean</code>
	 */
	public Boolean getEnviarEmail() {

		return enviarEmail;
	}

	/**
	 * Define o valor do atributo <code>enviarEmail</code>.
	 * 
	 * @param enviarEmail
	 */
	public void setEnviarEmail(Boolean enviarEmail) {

		this.enviarEmail = enviarEmail;
	}

	/**
	 * Retorna o valor do atributo <code>concluido</code>
	 * 
	 * @return <code>Boolean</code>
	 */
	public Boolean getConcluido() {

		return concluido;
	}

	/**
	 * Define o valor do atributo <code>concluido</code>.
	 * 
	 * @param concluido
	 */
	public void setConcluido(Boolean concluido) {

		this.concluido = concluido;
	}

	/**
	 * Retorna o valor do atributo <code>primeiroAcesso</code>
	 * 
	 * @return <code>Boolean</code>
	 */
	public Boolean getPrimeiroAcesso() {

		return primeiroAcesso;
	}

	/**
	 * Define o valor do atributo <code>primeiroAcesso</code>.
	 * 
	 * @param primeiroAcesso
	 */
	public void setPrimeiroAcesso(Boolean primeiroAcesso) {

		this.primeiroAcesso = primeiroAcesso;
	}

	/**
	 * Retorna o valor do atributo <code>usuarioResponsavel</code>
	 * 
	 * @return <code>Usuario</code>
	 */
	public Usuario getUsuarioResponsavel() {

		return usuarioResponsavel;
	}

	/**
	 * Define o valor do atributo <code>usuarioResponsavel</code>.
	 * 
	 * @param usuarioResponsavel
	 */
	public void setUsuarioResponsavel(Usuario usuarioResponsavel) {

		this.usuarioResponsavel = usuarioResponsavel;
	}

}
