package br.com.centralit.api.security;

import org.springframework.security.core.Authentication;
import org.springframework.security.web.FilterInvocation;
import org.springframework.security.web.access.expression.WebSecurityExpressionRoot;

import br.com.centralit.api.service.CredencialProcessoService;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 30/03/2016 - 10:43:40
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
public class CustomWebSecurityExpresssionRoot extends WebSecurityExpressionRoot {

	/** Atributo credencialProcessoService. */
	private CredencialProcessoService credencialProcessoService;

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * 
	 * @param authentication
	 * @param filterInvocation
	 * @param credencialProcessoService
	 */
	public CustomWebSecurityExpresssionRoot( Authentication authentication, FilterInvocation filterInvocation, CredencialProcessoService credencialProcessoService ) {

		super(authentication, filterInvocation);

		this.credencialProcessoService = credencialProcessoService;
	}

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por verificar se o usuario tem permissão para credenciar
	 * 
	 * @author rogerio.costa
	 * 
	 * @return boolean
	 */
	public boolean permiteCredenciar() {

		Long idProcesso = (Long) this.request.getSession().getAttribute("idProcesso");

		return this.credencialProcessoService.permiteCredenciar(idProcesso);
	}

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por verificar se o usuario logado não é o criador do processo, e se contem uma credencial para o mesmo
	 * 
	 * @author rogerio.costa
	 * 
	 * @return boolean
	 */
	public boolean permiteRenunciar() {

		Long idProcesso = (Long) this.request.getSession().getAttribute("idProcesso");

		return this.credencialProcessoService.permiteRenunciar(idProcesso);
	}
	
	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por verificar se o usuario tem permissão para executar o processo
	 * 
	 * @author rogerio.costa
	 * 
	 * @return boolean
	 */
	public boolean permiteExecutar() {

		Long idProcesso = (Long) this.request.getSession().getAttribute("idProcesso");

 		return this.credencialProcessoService.permiteExecutar(idProcesso);
	}

}
