package br.com.centralit.api.service;

import java.util.Collection;

import br.com.centralit.api.model.CredencialProcesso;
import br.com.centralit.api.model.Processo;
import br.com.centralit.api.model.Sigilo;
import br.com.centralit.api.viewHelper.GrupoUsuarioVH;
import br.com.centralit.api.viewHelper.HerancaSistemaVH;
import br.com.centralit.framework.model.Grupo;
import br.com.centralit.framework.service.arquitetura.GenericService;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 08/03/2016 - 16:47:15
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
public interface CredencialProcessoService extends GenericService<CredencialProcesso, Long> {

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por listar grupos e usuarios do sistema
	 * 
	 * @author rogerio.costa
	 * 
	 * @return Collection<GrupoUsuarioVH>
	 */
	Collection<GrupoUsuarioVH> findGrupoUsuarioByName(String nome);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por salvar credenciais
	 * 
	 * @author rogerio.costa
	 * 
	 * @param credenciais
	 * @return
	 */
	Collection<CredencialProcesso> save(Collection<CredencialProcesso> credenciais);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por salvar credenciais iniciais do processo/ Grupos que contem permissão para acessar o processo e Usuário que criou o processo.
	 * 
	 * @author rogerio.costa
	 * 
	 * @param processo
	 */
	void saveCredenciais(Processo processo);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por listar grupo e usuarios que tem credenciais herdadas do sistema.
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idProcesso
	 * 
	 * @return Collection<HerancaSistemaVH>
	 */
	Collection<HerancaSistemaVH> findCredenciaisHerdadas(Long idProcesso);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por verificar se o usuario tem permissão para credenciar
	 * 
	 * @author rogerio.costa
	 * 
	 */
	Boolean permiteCredenciar(Long idProcesso);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por verificar se o usuario logado não é o criador do processo, e se contem uma credencial para o mesmo
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idProcesso
	 * @return boolean
	 */
	Boolean permiteRenunciar(Long idProcesso);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por renunciar credencial.
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idProcesso
	 */
	Boolean renunciar(Long idProcesso);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por listar através do id do processo
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idProcesso
	 * @return Collection<CredencialProcesso>
	 */
	Collection<CredencialProcesso> findByIdProcesso(Long id);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por verificar se o usuarioLogado tem permissão no processo
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idProcesso
	 * @return boolean
	 */
	boolean contemPermissaoProcesso(Long idProcesso);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por obter grupos através do sigilo
	 * 
	 * @author rogerio.costa
	 * 
	 * @param sigilo
	 * 
	 * @return Collection<Grupo>
	 */
	Collection<Grupo> findGrupoPorSigilo(Sigilo sigilo);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por validar acesso para o processo
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idProcessInstance
	 */
	void validarAcessoPesquisa(Long idProcessInstance);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por verificar se o usuario tem permissão para executar o processo
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idProcesso
	 * 
	 * @return Boolean
	 */
	Boolean permiteExecutar(Long idProcesso);

}
