package br.com.centralit.api.service;

import java.util.Collection;

import br.com.centralit.api.model.DocumentoGed;
import br.com.centralit.api.model.Processo;
import br.com.centralit.framework.model.Dominio;
import br.com.centralit.framework.service.arquitetura.GenericService;

public interface DocumentoGedService extends GenericService<DocumentoGed, Long> {

	Collection<DocumentoGed> findByProcesso(Long id);

	Collection<DocumentoGed> findByIdProcessoUltimaVersao(Long id);

	Collection<DocumentoGed> findByIdDocumentoTodasVersoes(Long id);

	boolean removerDocumento(Long id);

	boolean validaQuantidadeVersoes(Long id);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de neg�cio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por salvar o icone do documento
	 * 
	 * @author rogerio.costa
	 * 
	 * @param documentoGed
	 * @param tipoAnexo
	 */
	void saveIconeDocumento(DocumentoGed documentoGed, Dominio tipoAnexo);

	void anexarDocumento(Processo processoDestinoAnexo, Processo processoOrigem);

	Collection<DocumentoGed> findByProcessoSigilo(Long idProcesso);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por obter através do id do PlanoClassificacao
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idPlanoClassificacao
	 * 
	 * @return Collection<Processo>
	 */
	Collection<DocumentoGed> findPorPlanoClassificacao(Long idPlanoClassificacao);

	/**
	 * 
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por
	 * 
	 * @author andre.silva
	 * 
	 * @param listaDocumentos
	 */
	Collection<DocumentoGed> atualizarSigiloDocumentos(Collection<DocumentoGed> listaDocumentos);

	/**
	 * Método responsável por montar as três primeiras assinaturas por documento para apresentação no tooltip da tela de execução de tarefa
	 * @author rogerio.cassimiro
	 * @param documentos
	 */
	void montarTresAssinantesPorDocumento(Collection<DocumentoGed> documentos);
}
