package br.com.centralit.api.service;

import java.util.Collection;

import br.com.centralit.api.model.Assinatura;
import br.com.centralit.api.model.HistoricoAlteracaoProcesso;
import br.com.centralit.api.model.Processo;
import br.com.centralit.api.model.UnidadeProcesso;
import br.com.centralit.framework.model.Unidade;
import br.com.centralit.framework.service.arquitetura.GenericService;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 04/01/2016 - 17:23:47
 * 
 * @version 1.0.0
 * 
 * @author halan.lima
 * 
 */
public interface HistoricoAlteracaoProcessoService extends GenericService<HistoricoAlteracaoProcesso, Long> {

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por retornar o numero de historicos de um determinado processo
	 * 
	 * @author halan.lima
	 * 
	 * @param idProcesso
	 * @return
	 */
	Integer countByProcesso(Long idProcesso);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por buscar historicos por processo e paginacao
	 * 
	 * @author halan.lima
	 * 
	 * @param idProcesso
	 * @param inicio
	 * @param max
	 * @return
	 */
	Collection<HistoricoAlteracaoProcesso> findByProcessoPaginado(Long idProcesso, Integer inicio, Integer max);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por salvar o historico com os parametros vindo da view
	 * 
	 * @author halan.lima
	 * 
	 * @param historicoView
	 * @return
	 */
	boolean saveWithParams(HistoricoAlteracaoProcesso historicoView);

	/**
	 * Método responsável por gerar histórico de alteração do processo por assinatura de documento
	 * @author rogerio.cassimiro
	 * @param assinatura
	 */
	void gerarHistoricoAssinatura(Assinatura assinatura);
	
	/**
	 * Método responsável por gerar Histórico de alteracao do precesso atribuição
	 *
	 * @author maycon.silva
	 *
	 * @param unidadeProcesso
	 */
	void gerarHistoricoAtribuicao(UnidadeProcesso unidadeProcesso);
	
	/**
	 *
	 * Método responsável por
	 *
	 * @author maycon.silva
	 *
	 * @param processo
	 */
	void gerarHistoricoIniciacaoProcesso(Processo processo);
	
	
	/**
	 * Método responsável por
	 *
	 * @author maycon.silva
	 *
	 * @param unidadeProcesso
	 */
	void gerarHistoricoCapturaDeProcesso(UnidadeProcesso unidadeProcesso);

	/**	 *
	 * Método responsável por gerar historico de reabertura do processo
	 *
	 * @author maycon.silva
	 *
	 * @param processo
	 */
	void gerarHistoricoReaberturProcesso(Processo processo, Unidade unidade);
}
