package br.com.centralit.api.service;

import java.util.Collection;

import br.com.centralit.api.model.PlanoClassificacao;
import br.com.centralit.framework.service.arquitetura.GenericService;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 21/10/2015 - 16:03:15
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
public interface PlanoClassificacaoService extends GenericService<PlanoClassificacao, Long> {

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por listar a entidade<code>PlanoClassificacao</code> que não contem parent, ou sejá o primeiro nó da arvore
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idOrganizacao
	 * 
	 * @return Collection<PlanoClassificacao>
	 */
	Collection<PlanoClassificacao> findParent(Long idOrganizacao);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por buscar PlanoClassificacao filhas através do id do parent
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idPlanoClassificacao
	 * 
	 * @return Collection<PlanoClassificacao>
	 */
	Collection<PlanoClassificacao> findChildrens(Long idPlanoClassificacao);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por listar recursivo
	 * 
	 * @author rogerio.costa
	 * 
	 * @param nome
	 * @return Collection<PlanoClassificacao>
	 */
	Collection<PlanoClassificacao> findTree(String nome);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por listar ultimo nivel ou que possua a opção "permitirUsarComoClassificacao"
	 * 
	 * @author rogerio.costa
	 * 
	 * @param codigoNome
	 * 
	 * @return Collection<PlanoClassificacao>
	 */
	Collection<PlanoClassificacao> findAssuntoAutoComplete(String codigoNome);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por atualizar a temporalidade e destinação dos processos e documentos
	 * 
	 * @author rogerio.costa
	 * 
	 * @param planoClassificacao
	 */
	void atualizarTemporalidadeDestinacao();

}
