package br.com.centralit.api.service;

import java.util.Collection;

import br.com.centralit.api.model.PlanoClassificacao;
import br.com.centralit.api.model.Processo;
import br.com.centralit.api.viewHelper.ProcessoVH;
import br.com.centralit.framework.model.Unidade;
import br.com.centralit.framework.service.arquitetura.GenericService;

import com.googlecode.genericdao.search.ISearch;
import com.googlecode.genericdao.search.SearchResult;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 28/03/2016 - 09:15:34
 * 
 * @version 1.0.0
 * 
 * @author maycon.silva
 * 
 */
public interface ProcessoService extends GenericService<Processo, Long> {

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por concluir o processo
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idProcesso
	 *            , Long idTask
	 * @paramidTask
	 * 
	 * @return Processo
	 */
	Boolean concluir(Long idProcesso, Long idTask);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por atualizar a temporalidade e destinação dos processos e documentos
	 * 
	 * @author rogerio.costa
	 * 
	 * @param planoClassificacao
	 */
	void atualizarTemporalidadeDestinacao(PlanoClassificacao planoClassificacao);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por verificar a temporalidade do processo. História de usuário #2182
	 * 
	 * @author rogerio.costa
	 * 
	 * @param entity
	 */
	void verificaTemporalidadeProcessoAtravesDoPlanoClassificacacao(PlanoClassificacao planoClassificacao, Processo processo);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por atualizar a temporalidade do processo através do processo anexado. História de usuário #2182
	 * 
	 * @author rogerio.costa
	 * 
	 * @param processo
	 * @param processoAnexo
	 */
	void atualizarTemporalidadeProcessoAnexado(Processo processo, Processo processoAnexo);

	/**
	 * 
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por
	 * 
	 * @author andre.silva
	 * 
	 * @param entity
	 * @return Processo
	 */
	Processo atualizarSigiloProcesso(Processo entity);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por devolver o processoSigad passando como parametro o id da instancia do BPE
	 * 
	 * @author maycon.silva
	 * 
	 * @param idProcessInstance
	 * @return
	 */
	Processo getProcessoByIdProcessInstance(Long idProcessInstance);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por
	 * 
	 * @author maycon.silva
	 * 
	 * @param nup
	 * @return
	 */
	Processo getProcessoByProtocolo(String nup);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por iniciar o gerenciamento do processo
	 * 
	 * @author rogerio.costa
	 * 
	 * @return Processo
	 */
	Processo getProcessoGerenciamento(Long id);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por atribuir processo para o usuario logado no primeiro acesso
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idProcesso
	 */
	Boolean verificarAtribuicaoProcessoPrimeiroAcesso(Long idProcesso);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por listar através da permissão que o usuario tem
	 * 
	 * @author rogerio.costa
	 * 
	 * @param search
	 * 
	 * @return <RT> SearchResult<RT>
	 */
	<RT> SearchResult<RT> searchAndCountPorSigilo(ISearch search);
	
	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por
	 *
	 * @author maycon.silva
	 *
	 * @param nup
	 * @return
	 */
	Collection<Processo> autoCompleteProcessoEmAndametoByNup(String nup);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por obter o processo.
	 * 
	 * @author rogerio.costa
	 * 
	 * @param id
	 * @return
	 */
	ProcessoVH getProcessoView(Long id);
	
	/**
	 * Método responsável por Reabrir processo  BPE para uma unidade
	 *
	 *O processo será aberto no ponto que final da execução do fluxo
	 *
	 * @author maycon.silva
	 *
	 * @param processo
	 * @param unidade
	 */
	 void reopenProcessIntance(Processo processo, Unidade unidade);
	 

	Collection<Processo> autoCompleteProcessoConcluidoByNup(String nup);

}
