package br.com.centralit.api.service;

import java.io.IOException;

import org.apache.solr.client.solrj.SolrServerException;

import br.com.centralit.api.model.DocumentoGed;
import br.com.centralit.api.model.Processo;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 *
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 *
 * <p>
 * <b>Title: DefaultFileServiceImpl</b>
 * </p>
 *
 * <p>
 * <b>Description: Para o funcionamento correto da solução é necessario configurar as 3 propriedades no arquivo property: 
 *    ecm.dir.output : Diretorio base onde os arquivos seram gravados.
 *    ecm.dir.privateKeyFile : Caminho da privateKey
 *    ecm.dir.encryptedKeyFile : Caminho da encriptedKey File		
 * </b>
 * </p>
 * 
 * <p>
 * <b>Orientações de como gerar as chaves:</b> 
 * 
 * To use the code, you need corresponding public and private RSA keys. RSA keys can be generated using the open source tool OpenSSL. However, you have to be careful to generate them in the format required by the Java encryption libraries. To generate a private key of length 2048 bits:
 *  1. openssl genrsa -out private.pem 2048
 * 
 * To get it into the required (PKCS#8, DER) format:
 *	2. openssl pkcs8 -topk8 -in private.pem -outform DER -out private.der -nocrypt 
 * 
 * To generate a public key from the private key:
 *	3. openssl rsa -in private.pem -pubout -outform DER -out public.der	 
 * 
 * 
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 *
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 *
 * @since 16/12/2015 - 10:30:24
 *
 * @version 1.0.0
 *
 * @author ally.barra
 *
 */

public interface SolrService {	
	public boolean addProcesso(Processo processo) throws SolrServerException, IOException;
	public boolean addDocumento(DocumentoGed documentoGed) throws SolrServerException, IOException;
}
