package br.com.centralit.api.service.impl;

import java.util.Collection;
import java.util.Collections;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import br.com.centralit.api.dao.ConfiguracaoUsuarioUnidadeDao;
import br.com.centralit.api.model.ConfiguracaoUsuarioUnidade;
import br.com.centralit.api.model.EstruturaOrganizacionalECM;
import br.com.centralit.api.service.ConfiguracaoUsuarioUnidadeService;
import br.com.centralit.api.service.UsuarioService;
import br.com.centralit.api.viewHelper.ConfiguracaoUnidadeUsuarioVH;
import br.com.centralit.framework.model.Usuario;
import br.com.centralit.framework.service.arquitetura.GenericServiceImpl;
import br.com.centralit.framework.util.UtilColecao;
import br.com.centralit.framework.util.UtilObjeto;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 08/12/2015 - 09:53:20
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Service("configuracaoUsuarioUnidadeService")
public class ConfiguracaoUsuarioUnidadeServiceImpl extends GenericServiceImpl<ConfiguracaoUsuarioUnidade, Long> implements ConfiguracaoUsuarioUnidadeService {

	/** Atributo configuracaoUsuarioUnidadeDao. */
	private ConfiguracaoUsuarioUnidadeDao configuracaoUsuarioUnidadeDao;

	@Autowired
	private UsuarioService usuarioService;

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * 
	 * @param configuracaoUsuarioUnidadeDao
	 */
	@Autowired
	public ConfiguracaoUsuarioUnidadeServiceImpl( ConfiguracaoUsuarioUnidadeDao configuracaoUsuarioUnidadeDao ) {

		this.dao = configuracaoUsuarioUnidadeDao;

		this.configuracaoUsuarioUnidadeDao = configuracaoUsuarioUnidadeDao;
	}

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por
	 * 
	 * @author rogerio.costa
	 * 
	 * @param listaConfiguracaoUsuarioUnidade
	 * @return
	 */
	@SuppressWarnings("unchecked")
	public Collection<ConfiguracaoUsuarioUnidade> salvarConfiguracao(ConfiguracaoUnidadeUsuarioVH configuracaoUnidadeUsuarioVH) {

		if (!UtilColecao.isVazio(configuracaoUnidadeUsuarioVH.getListaConfiguracaoUsuarioUnidade())) {

			List<ConfiguracaoUsuarioUnidade> listConfiguracao = (List<ConfiguracaoUsuarioUnidade>) configuracaoUnidadeUsuarioVH.getListaConfiguracaoUsuarioUnidade();

			Usuario usuario = this.atualizarUnidadePrincipalUsuario(configuracaoUnidadeUsuarioVH, listConfiguracao);

			if (!UtilColecao.isVazio(listConfiguracao)) {

				for (ConfiguracaoUsuarioUnidade configuracaoUsuarioUnidade : listConfiguracao) {

					configuracaoUsuarioUnidade.setOrganizacaoUsuario(this.getUsuario().getOrganizacao());
					configuracaoUsuarioUnidade.setUsuario(usuario);

				}

				listConfiguracao = this.saveList((List<ConfiguracaoUsuarioUnidade>) configuracaoUnidadeUsuarioVH.getListaConfiguracaoUsuarioUnidade());

			}

			return listConfiguracao;

		}

		return Collections.EMPTY_LIST;

	}

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por atualizar a entidade Usuario setando a unidadePrincipal
	 * 
	 * @author rogerio.costa
	 * 
	 * @param configuracaoUnidadeUsuarioVH
	 * @param listConfiguracao
	 * @return Usuario
	 */
	private Usuario atualizarUnidadePrincipalUsuario(ConfiguracaoUnidadeUsuarioVH configuracaoUnidadeUsuarioVH, List<ConfiguracaoUsuarioUnidade> listConfiguracao) {

		Usuario usuario = this.usuarioService.getReference(this.getUsuario().getId());

		if (!UtilObjeto.isReferencia(configuracaoUnidadeUsuarioVH.getEstruturaOrganizacionalECM())) {

			usuario.setUnidade(listConfiguracao.get(0).getEstruturaOrganizacionalECM());

			this.getUsuario().setUnidade(listConfiguracao.get(0).getEstruturaOrganizacionalECM());

		} else {

			usuario.setUnidade(configuracaoUnidadeUsuarioVH.getEstruturaOrganizacionalECM());

			this.getUsuario().setUnidade(configuracaoUnidadeUsuarioVH.getEstruturaOrganizacionalECM());
		}

		return usuario;
	}

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por
	 * 
	 * @author rogerio.costa
	 * 
	 * @param entity
	 */
	public void verificarRemocaoConfiguracaoUsuarioUnidade(EstruturaOrganizacionalECM entity) {

		Collection<ConfiguracaoUsuarioUnidade> listVinculados = this.configuracaoUsuarioUnidadeDao.findPorIdEstruturaOrganizacionalECM(entity.getId());

		if (!UtilColecao.isVazio(listVinculados)) {

			for (ConfiguracaoUsuarioUnidade configuracaoUsuarioUnidade : listVinculados) {

				if (!entity.getConfiguracaoUsuariosUnidade().contains(configuracaoUsuarioUnidade)) {

					configuracaoUsuarioUnidade.setEstruturaOrganizacionalECMRemocao(entity);

					configuracaoUsuarioUnidade.setEstruturaOrganizacionalECM(null);

				}
			}

		}
	}

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por listar configuracaoUnidade através do usuario logado e organização ativa
	 * 
	 * @author rogerio.costa
	 * 
	 * @param usuario
	 * @return Collection<ConfiguracaoUsuarioUnidade>
	 */
	public Collection<ConfiguracaoUsuarioUnidade> findPorUsuarioOrganizacao() {

		return this.configuracaoUsuarioUnidadeDao.findPorUsuarioOrganizacao(this.getUsuario());
	}

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idEstruturaECM
	 * @return
	 */
	public Collection<ConfiguracaoUsuarioUnidade> findPorIdEstruturaOrganizacionalECM(Long idEstruturaECM) {

		return this.configuracaoUsuarioUnidadeDao.findPorIdEstruturaOrganizacionalECM(idEstruturaECM);
	}

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por listar usuarios através da unidade e username
	 * 
	 * @author rogerio.costa
	 * 
	 * @param username
	 * @param idUnidade
	 * @return Collection<Usuario>
	 */
	public Collection<ConfiguracaoUsuarioUnidade> findPorUsernameUsuarioAndUnidade(String username, Long idUnidade) {

		return this.configuracaoUsuarioUnidadeDao.findPorUsernameUsuarioAndUnidade(username, idUnidade);
	}

}
