package br.com.centralit.api.service.impl;

import java.util.Calendar;
import java.util.Collection;
import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;

import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.stereotype.Service;

import br.com.centralit.api.dao.HistoricoAlteracaoProcessoDao;
import br.com.centralit.api.model.AcaoHistoricoAlteracaoProcesso;
import br.com.centralit.api.model.Assinatura;
import br.com.centralit.api.model.HistoricoAlteracaoProcesso;
import br.com.centralit.api.model.Processo;
import br.com.centralit.api.model.UnidadeProcesso;
import br.com.centralit.api.service.AcaoHistoricoAlteracaoProcessoService;
import br.com.centralit.api.service.HistoricoAlteracaoProcessoService;
import br.com.centralit.api.service.ProcessoService;
import br.com.centralit.framework.model.Unidade;
import br.com.centralit.framework.model.Usuario;
import br.com.centralit.framework.service.arquitetura.GenericServiceImpl;
import br.com.centralit.framework.util.UtilObjeto;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 16/12/2015 - 15:40:28
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 28/04/2016 - 21:53:16
 *
 * @version 1.0.0
 *
 * @author maycon.silva
 *	
 */
@Service("historicoAlteracaoProcessoService")
public class HistoricoAlteracaoProcessoServiceImpl extends GenericServiceImpl<HistoricoAlteracaoProcesso, Long> implements HistoricoAlteracaoProcessoService {

	HistoricoAlteracaoProcessoDao historicoAlteracaoProcessoDao;

	@Autowired
	private ProcessoService processoService;

	@Autowired
	private AcaoHistoricoAlteracaoProcessoService acaoHistoricoAlteracaoProcessoService;

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * 
	 * @param historicoAlteracaoProcessoDao
	 */
	@Autowired
	private HistoricoAlteracaoProcessoServiceImpl( HistoricoAlteracaoProcessoDao historicoAlteracaoProcessoDao ) {

		this.dao = historicoAlteracaoProcessoDao;
		this.historicoAlteracaoProcessoDao = historicoAlteracaoProcessoDao;

	}

	@Override
	public Integer countByProcesso(Long idProcesso) {

		return historicoAlteracaoProcessoDao.countByProcesso(idProcesso);
	}

	@Override
	public Collection<HistoricoAlteracaoProcesso> findByProcessoPaginado(Long idProcesso, Integer inicio, Integer max) {

		return historicoAlteracaoProcessoDao.findByProcessoPaginado(idProcesso, inicio, max);
	}

	@Override
	public boolean saveWithParams(HistoricoAlteracaoProcesso historicoView) {

		HistoricoAlteracaoProcesso toSave = new HistoricoAlteracaoProcesso();

		AcaoHistoricoAlteracaoProcesso acao = acaoHistoricoAlteracaoProcessoService.findByChave(historicoView.getAcaoAlteracao());

		toSave.setNomeUsuario(historicoView.getAutor().getUsername());

		if (UtilObjeto.isReferencia(historicoView.getAutor().getUnidade())) {

			toSave.setNomeUnidadeVigente(historicoView.getAutor().getUnidade().getSigla());
		}
		toSave.setDescricaoAcao(historicoView.getDescricaoAcao());
		toSave.setProcesso(processoService.find(historicoView.getProcesso().getId()));
		toSave.setIdTask(historicoView.getIdTask());
		toSave.setAcaoAlteracao(acao.getAcao());
		toSave.setDataRegistro(Calendar.getInstance());
		toSave.setDocumentoGed(historicoView.getDocumentoGed());

		toSave = (HistoricoAlteracaoProcesso) historicoAlteracaoProcessoDao.save(toSave);

		try {
			produceViewParams(historicoView, toSave);

			populateViewParams(toSave, acao, historicoView.getMapaAtributos());
		} catch (Exception e) {
			e.printStackTrace();
		}

		return ( (HistoricoAlteracaoProcesso) historicoAlteracaoProcessoDao.save(toSave) ) != null ? true : false;
	}
	
	private void produceViewParams(HistoricoAlteracaoProcesso historico, HistoricoAlteracaoProcesso toSave) {

		Map<String, String> mapaAtributos;
		if (historico.getMapaAtributos() != null) {
			mapaAtributos = historico.getMapaAtributos();
		} else {
			mapaAtributos = new HashMap<String, String>();
		}

		if (toSave.getProcesso() != null) {
			if (null == mapaAtributos.get("protocolo")) {
				mapaAtributos.put("protocolo", toSave.getProcesso().getNup());
			}
			if (null == mapaAtributos.get("situacao") && null != toSave.getProcesso().getStatus()) {
				mapaAtributos.put("situacao", toSave.getProcesso().getStatus().getDescricao());
			}
		}

		if (toSave.getDocumentoGed() != null) {
			if (null == mapaAtributos.get("tipo_documento") && null != toSave.getDocumentoGed().getTipoDocumento()) {
				mapaAtributos.put("tipo_documento", toSave.getDocumentoGed().getTipoDocumento().getNome());
			}
			if (null == mapaAtributos.get("numero_documento")) {
				mapaAtributos.put("numero_documento", toSave.getDocumentoGed().getNumero());
			}
			if (null == mapaAtributos.get("numero_versao") && null != toSave.getDocumentoGed().getVersaoDocumento()) {
				mapaAtributos.put("numero_versao", toSave.getDocumentoGed().getVersaoDocumento().toString());
			}
		}

		if (!StringUtils.isEmpty(toSave.getNomeUnidadeVigente())) {
			if (null == mapaAtributos.get("unidade")) {
				mapaAtributos.put("unidade", toSave.getNomeUnidadeVigente());
			}
		}

		if (toSave.getAutor() != null) {
			if (null == mapaAtributos.get("usuario")) {
				mapaAtributos.put("usuario", toSave.getAutor().getUsername());
			}
		}

		historico.setMapaAtributos(mapaAtributos);
	}

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por percorrer os parametros enviados da tela substituindo pelos tokens pre cadastrados na descricao da acao
	 * 
	 * @author halan.lima
	 * 
	 * @param historico
	 * @param acao
	 * @param mapParams
	 */
	private void populateViewParams(HistoricoAlteracaoProcesso historico, AcaoHistoricoAlteracaoProcesso acao, Map<String, String> mapParams) {

		String descricaoAcao = acao.getDescricao();
		// iterando os parametros enviados da view
		for (Entry<String, String> entry : mapParams.entrySet()) {
			// padronizando o parametro
			String subKey = "<<" + entry.getKey() + ">>";
			if (descricaoAcao.contains(subKey)) {
				// substituindo parametro padronizado para
				descricaoAcao = descricaoAcao.replace(subKey, entry.getValue());
			}
		}
		historico.setDescricaoAcao(descricaoAcao);
	}
	
	/**
	 * Método responsável por gerar histórico de alteração do processo por assinatura de documento
	 * @author rogerio.cassimiro
	 * @param assinatura
	 */
	@Override
	public void gerarHistoricoAssinatura(Assinatura assinatura) {
		
		Usuario usuario = (Usuario) SecurityContextHolder.getContext().getAuthentication().getPrincipal();
		Map<String, String> mapaAtributos = new HashMap<String, String>();
		mapaAtributos.put("tipo_documento", null);
		mapaAtributos.put("numero_documento", null);
		HistoricoAlteracaoProcesso hap = new HistoricoAlteracaoProcesso(assinatura.getDocumentoGed().getProcesso(), Calendar.getInstance(),
				UtilObjeto.isReferencia(usuario.getUnidade()) ? usuario.getUnidade().getNome() : null, usuario.getUsername(), assinatura.getIdTask(), AcaoHistoricoAlteracaoProcesso.ASSINAR_DOCUMENTO_DESCRICAO, 
				AcaoHistoricoAlteracaoProcesso.ASSINAR_DOCUMENTO_CHAVE, assinatura.getDocumentoGed(), mapaAtributos);
		hap.setAutor(usuario);
		this.saveWithParams(hap);
	}
	
	/**
	 * Método responsável por gerar Histórico de alteracao do processo atribuição
	 *
	 * @author maycon.silva
	 *
	 * @param unidadeProcesso
	 */
	public void gerarHistoricoAtribuicao(UnidadeProcesso unidadeProcesso) {
		
		Usuario usuario = (Usuario) SecurityContextHolder.getContext().getAuthentication().getPrincipal();
		Map<String, String> mapaAtributos = new HashMap<String, String>();
		mapaAtributos.put("usuario", null);
		
		HistoricoAlteracaoProcesso hap = new HistoricoAlteracaoProcesso(
				unidadeProcesso.getProcesso(), 
				Calendar.getInstance(),	
				usuario.getUnidade().getNome(), 
				usuario.getUsername(),
				null,
				AcaoHistoricoAlteracaoProcesso.INICIAR_ATRIBUICAO_PROCESSO_DESCRICAO, 
				AcaoHistoricoAlteracaoProcesso.INICIAR_ATRIBUICAO_PROCESSO_CHAVE, null, mapaAtributos);
		hap.setAutor(usuario);
		
		this.saveWithParams(hap);
	}

	/**
	 * Método responsável por gerar Histórico de alteração do processo Iniciação processo
	 *
	 * @author maycon.silva
	 *
	 * @param processo
	 */
	public void gerarHistoricoIniciacaoProcesso(Processo processo) {
		
		Usuario usuario = (Usuario) SecurityContextHolder.getContext().getAuthentication().getPrincipal();
		Map<String, String> mapaAtributos = new HashMap<String, String>();
		mapaAtributos.put("usuario", null);
		mapaAtributos.put("protocolo", processo.getNup());
		
		HistoricoAlteracaoProcesso hap = new HistoricoAlteracaoProcesso(
				processo, 
				Calendar.getInstance(),	
				usuario.getUnidade().getNome(), 
				usuario.getUsername(),
				null,
				AcaoHistoricoAlteracaoProcesso.INCLUSAO_PROCESSO_DESCRICAO, 
				AcaoHistoricoAlteracaoProcesso.INCLUSAO_PROCESSO_CHAVE, null, mapaAtributos);
		hap.setAutor(usuario);
		
		this.saveWithParams(hap);
	}	
	
	public void gerarHistoricoCapturaDeProcesso(UnidadeProcesso unidadeProcesso){
		
		Usuario usuario = (Usuario) SecurityContextHolder.getContext().getAuthentication().getPrincipal();
		Map<String, String> mapaAtributos = new HashMap<String, String>();
		mapaAtributos.put("usuario", null);
		
		HistoricoAlteracaoProcesso hap = new HistoricoAlteracaoProcesso(
				unidadeProcesso.getProcesso(), 
				Calendar.getInstance(),	
				usuario.getUnidade().getNome(), 
				usuario.getUsername(),
				null,
				AcaoHistoricoAlteracaoProcesso.ALTERAR_ATRIBUICAO_PROCESSO_DESCRICAO, 
				AcaoHistoricoAlteracaoProcesso.ALTERAR_ATRIBUICAO_PROCESSO_CHAVE, null, mapaAtributos);
		hap.setAutor(usuario);
		
		this.saveWithParams(hap);
	}
	
	public void gerarHistoricoReaberturProcesso(Processo processo, Unidade unidade){
		
		Usuario usuario = (Usuario) SecurityContextHolder.getContext().getAuthentication().getPrincipal();
		Map<String, String> mapaAtributos = new HashMap<String, String>();
		mapaAtributos.put("protocolo", processo.getNup());
		mapaAtributos.put("unidade", unidade.getSigla());
		
		HistoricoAlteracaoProcesso hap = new HistoricoAlteracaoProcesso(
				processo, 
				Calendar.getInstance(),	
				usuario.getUnidade().getNome(), 
				usuario.getUsername(),
				null,
				AcaoHistoricoAlteracaoProcesso.REABERTURA_DE_PROCESSO_DESCRICAO, 
				AcaoHistoricoAlteracaoProcesso.REABERTURA_DE_PROCESSO_CHAVE, null, mapaAtributos);
		hap.setAutor(usuario);
		
		this.saveWithParams(hap);
		
	}
}
