package br.com.centralit.api.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import br.com.centralit.api.dao.HistoricoAtribuicaoProcessoDao;
import br.com.centralit.api.model.HistoricoAtribuicaoProcesso;
import br.com.centralit.api.model.UnidadeProcesso;
import br.com.centralit.api.service.HistoricoAtribuicaoProcessoService;
import br.com.centralit.framework.service.arquitetura.GenericServiceImpl;
import br.com.centralit.framework.util.UtilDate;
import br.com.centralit.framework.util.UtilObjeto;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 02/04/2016 - 10:45:13
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Service("historicoAtribuicaoProcessoService")
public class HistoricoAtribuicaoProcessoServiceImpl extends GenericServiceImpl<HistoricoAtribuicaoProcesso, Long> implements HistoricoAtribuicaoProcessoService {

	/** Atributo historicoAtribuicaoProcessoDao. */
	private HistoricoAtribuicaoProcessoDao historicoAtribuicaoProcessoDao;

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * 
	 * @param historicoAlteracaoProcessoDao
	 */
	@Autowired
	public HistoricoAtribuicaoProcessoServiceImpl( HistoricoAtribuicaoProcessoDao historicoAtribuicaoProcessoDao ) {

		this.dao = historicoAtribuicaoProcessoDao;
		this.historicoAtribuicaoProcessoDao = historicoAtribuicaoProcessoDao;

	}

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por salvar o historico de atribuição
	 * 
	 * @author rogerio.costa
	 * 
	 * @param entity
	 */
	public void saveHistorico(UnidadeProcesso entity) {

		HistoricoAtribuicaoProcesso historicoAtual = this.historicoAtribuicaoProcessoDao.obterAtualPorUnidadeProcesso(entity.getId());

		if (UtilObjeto.isReferencia(historicoAtual)) {

			historicoAtual.setNomeUsuarioRemocao(this.getUsuario().getUsername());
			historicoAtual.setDataRemocao(UtilDate.getDataAtualCalendar());

		}

		HistoricoAtribuicaoProcesso historicoAtribuicaoProcesso = new HistoricoAtribuicaoProcesso();
		historicoAtribuicaoProcesso.setNomeUsuarioAtribuido(entity.getUsuarioResponsavel().getUsername());
		historicoAtribuicaoProcesso.setUnidadeProcesso(entity);
		historicoAtribuicaoProcesso.setDataAtribuicao(UtilDate.getCalendarDaDataAtual());
		this.historicoAtribuicaoProcessoDao.save(historicoAtribuicaoProcesso);
	}
}
