package br.com.centralit.api.service.impl;

import java.util.Collection;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import br.com.centralit.api.dao.HistoricoCredencialProcessoDao;
import br.com.centralit.api.model.CredencialProcesso;
import br.com.centralit.api.model.HistoricoCredencialProcesso;
import br.com.centralit.api.service.HistoricoCredencialProcessoService;
import br.com.centralit.framework.service.arquitetura.GenericServiceImpl;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 11/03/2016 - 15:49:39
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Service("historicoCredencialProcessoService")
public class HistoricoCredencialProcessoServiceImpl extends GenericServiceImpl<HistoricoCredencialProcesso, Long> implements HistoricoCredencialProcessoService {

	/** Atributo historicoCredencialProcessoDao. */
	private HistoricoCredencialProcessoDao historicoCredencialProcessoDao;

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 */
	@Autowired
	public HistoricoCredencialProcessoServiceImpl( HistoricoCredencialProcessoDao historicoCredencialProcessoDao ) {

		this.dao = historicoCredencialProcessoDao;
		this.historicoCredencialProcessoDao = historicoCredencialProcessoDao;

	}
	
	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por listar através do id do processo e processoRemocao
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idProcesso
	 * 
	 * @return Collection<HistoricoCredencialProcesso>
	 */
	public Collection<HistoricoCredencialProcesso> findByIdProcessoAndIdProcessoRemocao(Long idProcesso) {

		return this.historicoCredencialProcessoDao.findByIdProcessoAndIdProcessoRemocao(idProcesso);
	}

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por listar através da credencial e credenciado
	 * 
	 * @author rogerio.costa
	 * 
	 * @param credencialProcesso
	 * 
	 * @return HistoricoCredencialProcesso
	 */
	public HistoricoCredencialProcesso findByCredencialAndCredenciado(CredencialProcesso credencialProcesso) {

		return this.historicoCredencialProcessoDao.findByCredencialAndCredenciado(credencialProcesso);
	}

}
