package br.com.centralit.api.service.impl;

import java.util.ArrayList;
import java.util.List;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import br.com.centralit.api.service.DominioService;
import br.com.centralit.api.service.MenuService;
import br.com.centralit.api.service.ModuloService;
import br.com.centralit.api.service.PaginaService;
import br.com.centralit.framework.model.Menu;
import br.com.centralit.framework.model.MenuFile;
import br.com.centralit.framework.model.Modulo;
import br.com.centralit.framework.model.Pagina;
import br.com.centralit.framework.model.UtilStartup;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 22/10/2015 - 08:54:55
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Service("inicializarEcmService")
public class InicializarEcmServiceImpl extends UtilStartup {

	/** Atributo dominioService. */
	@Autowired
	private DominioService dominioService;

	/** Atributo menuAdmMaterial. */
	private Menu menuECM;

	/** Atributo menuService. */
	@Autowired
	private MenuService menuService;

	/** Atributo paginaService. */
	@Autowired
	private PaginaService paginaService;

	@Autowired
	private ModuloService moduloService;

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 *
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 *
	 * Método responsável por gerar a carga inicial
	 *
	 * @author rogerio.costa
	 *
	 */
	public void gerarCarga() {

		this.criarPaginasMenus();
		this.menuService.adicionarGrupoMasterMenu(this.menuECM);
	}

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por
	 * 
	 * @author rogerio.costa
	 * 
	 * @param modulo
	 */
	private void criarPaginasMenus() {

		this.dominioJS = this.dominioService.findByChaveAndNome(UtilStartup.TIPO_FILE, UtilStartup.TIPO_FILE_JS);
		this.moduloSelecionado = this.moduloService.getModuloPorBaseUrl(UtilStartup.BASE_URL_ECM, null);

		// Menu pai ECM
		this.menuECM = new Menu("IDGS", null, null, null, 4, this.corEcm, this.cssMenuEcm, this.opacidadeMenuEcm, this.classeEcm, this.ICONE_MENU_ECM, this.moduloSelecionado);

		this.menuECM = this.menuService.mergeIfNotExist(this.menuECM);

		this.iniciarMenuCadastroBasico(this.moduloSelecionado);

		this.iniciarMenuCadastroProcesso(this.moduloSelecionado);

		Logger.getLogger(InicializarEcmServiceImpl.class).info("Menu executado - InicializarEcmServiceImpl!");

	}

	private void iniciarMenuCadastroProcesso(Modulo modulo) {

		// Submenu Processo
		Menu menuProcesso = new Menu("Gerenciar Processos", null, this.menuECM, 2, 1, null, null, null, null, modulo);
		menuProcesso = this.menuService.mergeIfNotExist(menuProcesso);

		// Submenu Cadastro de Processo #INICIO
		Pagina pgProcesso = new Pagina("Novo Processo", "/cit-ecm-web/html/processo/processoNew.html");
		pgProcesso = this.paginaService.saveIfNotExist(pgProcesso);

		Menu menuCadastroProcesso = new Menu("Novo Processo", pgProcesso, menuProcesso, 2, 1, null, null, null, null, modulo, "NOVO_PROCESSO");
		List<MenuFile> filesProcesso = this.gerarArquivosMenu(menuCadastroProcesso, this.CIT_ECM_WEB_ANGULAR, "Processo", true, true, true);

		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/NivelAcessoTipoProcessoRepository.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/NivelAcessoTipoProcessoRepository.min.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/ConfiguracaoUsuarioUnidadeRepository.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/EstruturaOrganizacionalECMRepository.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/ConfiguracaoUsuarioUnidadeRepository.min.js", this.dominioJS, menuCadastroProcesso));

		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/controller/AssinarDocumentoController.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/AssinaturaRepository.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/DocumentoGedRepository.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/DocumentoGedRepository.min.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/controller/GerenciarProcessoController.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/controller/GerenciarProcessoController.min.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/controller/AnexoGedController.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/controller/AnexoGedController.min.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/AnexoGedRepository.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/AnexoGedRepository.min.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/controller/DocumentoGedController.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/controller/DocumentoGedController.min.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/GerenciarProcessoRepository.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/GerenciarProcessoRepository.min.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/controller/UnidadeProcessoController.min.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/controller/UnidadeProcessoController.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/UnidadeProcessoRepository.min.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/UnidadeProcessoRepository.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/controller/ProcessoRelacionadoController.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/controller/ProcessoRelacionadoController.min.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/ProcessoRelacionadoRepository.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/ProcessoRelacionadoRepository.min.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/controller/GerenciarProcessoViewController.min.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/controller/GerenciarProcessoViewController.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/InteressadoDocumentoRepository.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/InteressadoDocumentoRepository.min.js", this.dominioJS, menuCadastroProcesso));

		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/TipoProcessoPlanoClassificacaoRepository.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/TipoProcessoPlanoClassificacaoRepository.min.js", this.dominioJS, menuCadastroProcesso));

		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/InteressadoProcessoRepository.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/InteressadoProcessoRepository.min.js", this.dominioJS, menuCadastroProcesso));

		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/NivelAcessoTipoDocumentoRepository.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/NivelAcessoTipoDocumentoRepository.min.js", this.dominioJS, menuCadastroProcesso));

		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/HistoricoAlteracaoProcessoRepository.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/HistoricoAlteracaoProcessoRepository.min.js", this.dominioJS, menuCadastroProcesso));

		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/controller/HistoricoAlteracaoProcessoController.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/controller/HistoricoAlteracaoProcessoController.min.js", this.dominioJS, menuCadastroProcesso));

		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/JustificativaAcaoProcessoRepository.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/JustificativaAcaoProcessoRepository.min.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/controller/JustificativaAcaoProcessoController.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/controller/JustificativaAcaoProcessoController.min.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/controller/JustificativaAcaoProcessoListController.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/controller/JustificativaAcaoProcessoListController.min.js", this.dominioJS, menuCadastroProcesso));

		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/AnexarProcessoRepository.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/AnexarProcessoRepository.min.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/controller/AnexarProcessoController.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/controller/AnexarProcessoController.min.js", this.dominioJS, menuCadastroProcesso));

		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/CancelamentoDocumentoGedRepository.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/CancelamentoDocumentoGedRepository.min.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/controller/CancelamentoDocumentoGedController.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/controller/CancelamentoDocumentoGedController.min.js", this.dominioJS, menuCadastroProcesso));

		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/controller/CredencialDocumentoController.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/controller/CredencialDocumentoController.min.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/CredencialDocumentoRepository.min.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/CredencialDocumentoRepository.js", this.dominioJS, menuCadastroProcesso));

		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/controller/CredencialProcessoController.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/controller/CredencialProcessoController.min.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/CredencialProcessoRepository.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/CredencialProcessoRepository.min.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/HistoricoCredencialProcessoRepository.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/HistoricoCredencialProcessoRepository.min.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/SigiloRepository.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/SigiloRepository.min.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/controller/AtribuirProcessoController.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/controller/AtribuirProcessoController.min.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/HistoricoAtribuicaoProcessoRepository.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/HistoricoAtribuicaoProcessoRepository.min.js", this.dominioJS, menuCadastroProcesso));
		
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/controller/MetadadoProcessoViewController.js", this.dominioJS, menuCadastroProcesso));
		filesProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/controller/MetadadoProcessoViewController.min.js", this.dominioJS, menuCadastroProcesso));
		
		menuCadastroProcesso.setIncludes(filesProcesso);
		this.menuService.mergeIfNotExist(menuCadastroProcesso);

		// Submenu Cadastro de Processo #INICIO
		Pagina pgPesquisaProcesso = new Pagina("Pesquisa ECM", "/cit-ecm-web/html/pesquisa/pesquisa.html");
		pgPesquisaProcesso = this.paginaService.saveIfNotExist(pgPesquisaProcesso);

		Menu menuPesquisaProcesso = new Menu("Pesquisa ECM", pgPesquisaProcesso, menuProcesso, 2, 2, null, null, null, null, modulo, "PESQUISA_PROCESSO");
		List<MenuFile> filesPesquisaProcesso = new ArrayList<MenuFile>();

		filesPesquisaProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/controller/SolrSearchController.js", this.dominioJS, menuPesquisaProcesso));
		filesPesquisaProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/directive/autocomplete.js", this.dominioJS, menuPesquisaProcesso));

		filesPesquisaProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/service/solr.js", this.dominioJS, menuPesquisaProcesso));
		filesPesquisaProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/service/utils.js", this.dominioJS, menuPesquisaProcesso));

		menuPesquisaProcesso.setIncludes(filesPesquisaProcesso);
		this.menuService.mergeIfNotExist(menuPesquisaProcesso);

		Pagina pgProcessoFinalizado = new Pagina("Processos Arquivados", "/cit-ecm-web/html/processoFinalizado/processoFinalizadoList.html");
		pgProcessoFinalizado = this.paginaService.saveIfNotExist(pgProcessoFinalizado);

		Menu menuProcessoFinalizado = new Menu("Processos Arquivados", pgProcessoFinalizado, menuProcesso, 2, 4, null, null, null, null, modulo, "PROCESSO_FINALIZADO");
		menuProcessoFinalizado.setIncludes(this.gerarArquivosMenu(menuProcessoFinalizado, this.CIT_ECM_WEB_ANGULAR, "ProcessoFinalizado", false, true, false));
		this.menuService.mergeIfNotExist(menuProcessoFinalizado);

		Pagina pgProcessoDocumentoSigiloso = new Pagina("Processos e Documentos Sigilosos", "/cit-ecm-web/html/classificarProcessoDocumento/classificarProcessoDocumentoList.html");
		pgProcessoDocumentoSigiloso = this.paginaService.saveIfNotExist(pgProcessoDocumentoSigiloso);

		Menu menuProcessoDocumentoSigiloso = new Menu("Processos e Documentos Sigilosos", pgProcessoDocumentoSigiloso, menuProcesso, 2, 5, null, null, null, null, modulo, "CLASSIFICAR_PROCESSO_DOCUMENTO");
		menuProcessoDocumentoSigiloso.setIncludes(this.gerarArquivosMenu(menuProcessoDocumentoSigiloso, this.CIT_ECM_WEB_ANGULAR, "ClassificarDocumentoProcesso", true, true, false));
		this.menuService.mergeIfNotExist(menuProcessoDocumentoSigiloso);
		
		Pagina pgGerenciarProcessoListUnidade = new Pagina("Processos Abertos na Unidade", "/cit-ecm-web/html/gerenciarProcesso/gerenciarProcessoListUnidade.html");
		pgGerenciarProcessoListUnidade = this.paginaService.saveIfNotExist(pgGerenciarProcessoListUnidade);

		Menu menuGerenciarProcessoListUnidade = new Menu("Processos Abertos na Unidade", pgGerenciarProcessoListUnidade, menuProcesso, 2, 6, null, null, null, null, modulo, "PROCESSO_ABERTO_UNIDADE");
		List<MenuFile> filesGerenciarProcessoListUnidade = new ArrayList<MenuFile>();

		filesGerenciarProcessoListUnidade.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/controller/GerenciarProcessoListUnidadeController.js", this.dominioJS, menuGerenciarProcessoListUnidade));
		menuGerenciarProcessoListUnidade.setIncludes(filesGerenciarProcessoListUnidade);
		this.menuService.mergeIfNotExist(menuGerenciarProcessoListUnidade);
		
		Pagina pgReabrirProcesso = new Pagina("Reabrir Processo", "/cit-ecm-web/html/reabrirProcesso/reabrirProcesso.html");
		pgReabrirProcesso = this.paginaService.saveIfNotExist(pgReabrirProcesso);

		Menu menuReabrirProcesso = new Menu("Reabrir Processo", pgReabrirProcesso, menuProcesso, 2, 7, null, null, null, null, modulo, "REABRIR_PROCESSO");
		menuReabrirProcesso.setIncludes(this.gerarArquivosMenu(menuReabrirProcesso, this.CIT_ECM_WEB_ANGULAR, "ReabrirProcesso", true, true, true));
		this.menuService.mergeIfNotExist(menuReabrirProcesso);

		
		Pagina pgSolicitarReaberturaProcesso = new Pagina("Solicitação de Reabertura de Processo", "/cit-ecm-web/html/solicitacaoReaberturaProcesso/solicitacaoReaberturaProcesso.html");
		pgSolicitarReaberturaProcesso = this.paginaService.saveIfNotExist(pgSolicitarReaberturaProcesso);

		Menu menuSolicitarReaberturaProcesso = new Menu("Solicitação de Reabertura de Processo", pgSolicitarReaberturaProcesso, menuProcesso, 2, 8, null, null, null, null, modulo, "SOLICITACAO_REABERTURA_PROCESSO");
		
		menuSolicitarReaberturaProcesso.setIncludes(this.gerarArquivosMenu(menuSolicitarReaberturaProcesso, this.CIT_ECM_WEB_ANGULAR, "SolicitacaoReaberturaProcesso", true, true, false));
		this.menuService.mergeIfNotExist(menuSolicitarReaberturaProcesso);
		
	}

	private void iniciarMenuCadastroBasico(Modulo modulo) {

		// Submenu Cadastros Básico #INICIO
		Menu menuCadastroBasico = new Menu("Gerenciar IDGS", null, this.menuECM, 0, 1, null, null, null, null, modulo);
		menuCadastroBasico = this.menuService.mergeIfNotExist(menuCadastroBasico);

		// Submenu Cadastro Plano de classificação, temporalidade e destinação #INICIO
		Pagina pgPlanoClassificacao = new Pagina("Plano de Classificação, Temporalidade e Destinação", "/cit-ecm-web/html/planoClassificacao/planoClassificacao.html");
		pgPlanoClassificacao = this.paginaService.saveIfNotExist(pgPlanoClassificacao);

		Menu menuPlanoClassificacao = new Menu("Plano de Classificação, Temporalidade e Destinação", pgPlanoClassificacao, menuCadastroBasico, 0, 1, null, null, null, null, modulo);
		menuPlanoClassificacao.setIncludes(this.gerarArquivosMenu(menuPlanoClassificacao, this.CIT_ECM_WEB_ANGULAR, "PlanoClassificacao", true, true, true));
		this.menuService.mergeIfNotExist(menuPlanoClassificacao);

		// Submenu Tabela de Hipóteses Legais #INICIO
		Pagina pgHipoteseLegal = new Pagina("Hipóteses Legais", "/cit-ecm-web/html/hipoteseLegal/hipoteseLegal.html");
		pgHipoteseLegal = this.paginaService.saveIfNotExist(pgHipoteseLegal);

		Menu menuHipoteseLegal = new Menu("Hipóteses Legais", pgHipoteseLegal, menuCadastroBasico, 0, 2, null, null, null, null, modulo);
		menuHipoteseLegal.setIncludes(this.gerarArquivosMenu(menuHipoteseLegal, this.CIT_ECM_WEB_ANGULAR, "HipoteseLegal", true, true, true));
		this.menuService.mergeIfNotExist(menuHipoteseLegal);

		// Submenu Tipos de Documento #INICIO
		Pagina pgTipoDocumento = new Pagina("Tipo de Documentos", "/cit-ecm-web/html/tipoDocumento/tipoDocumento.html");
		pgTipoDocumento = this.paginaService.saveIfNotExist(pgTipoDocumento);

		Menu menuTipoDocumento = new Menu("Tipo de Documentos", pgTipoDocumento, menuCadastroBasico, 0, 3, null, null, null, null, modulo);
		List<MenuFile> files = this.gerarArquivosMenu(menuTipoDocumento, this.CIT_ECM_WEB_ANGULAR, "TipoDocumento", true, true, true);
		files.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/TipoDocumentoPlanoClassificacaoRepository.js", this.dominioJS, menuTipoDocumento));
		files.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/TipoDocumentoPlanoClassificacaoRepository.min.js", this.dominioJS, menuTipoDocumento));
		files.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/SigiloRepository.js", this.dominioJS, menuTipoDocumento));
		files.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/SigiloRepository.min.js", this.dominioJS, menuTipoDocumento));
		menuTipoDocumento.setIncludes(files);
		this.menuService.mergeIfNotExist(menuTipoDocumento);

		// Submenu Tipos de Processo #INICIO
		Pagina pgTipoProcesso = new Pagina("Tipo de Processos", "/cit-ecm-web/html/tipoProcesso/tipoProcesso.html");
		pgTipoProcesso = this.paginaService.saveIfNotExist(pgTipoProcesso);

		Menu menuTipoProcesso = new Menu("Tipo de Processos", pgTipoProcesso, menuCadastroBasico, 0, 4, null, null, null, null, modulo);
		List<MenuFile> filesTipoProcesso = this.gerarArquivosMenu(menuTipoProcesso, this.CIT_ECM_WEB_ANGULAR, "TipoProcesso", true, true, true);
		filesTipoProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/TipoProcessoPlanoClassificacaoRepository.js", this.dominioJS, menuTipoProcesso));
		filesTipoProcesso.add(new MenuFile("/cit-ecm-web/assets/js/angular/custom/repository/TipoProcessoPlanoClassificacaoRepository.min.js", this.dominioJS, menuTipoProcesso));
		menuTipoProcesso.setIncludes(filesTipoProcesso);
		this.menuService.mergeIfNotExist(menuTipoProcesso);

		// Submenu Template padrão
		Pagina pgTipoTemplatePadrao = new Pagina("Modelo de documento", "/cit-ecm-web/html/templatePadrao/templatePadrao.html");
		pgTipoTemplatePadrao = this.paginaService.saveIfNotExist(pgTipoTemplatePadrao);

		Menu menuTemplatePadrao = new Menu("Modelo de documento", pgTipoTemplatePadrao, menuCadastroBasico, 0, 5, null, null, null, null, modulo);
		menuTemplatePadrao.setIncludes(this.gerarArquivosMenu(menuTemplatePadrao, this.CIT_ECM_WEB_ANGULAR, "TemplatePadrao", true, true, true));
		this.menuService.mergeIfNotExist(menuTemplatePadrao);

		// Submenu Rodapé
		Pagina pgRodape = new Pagina("Rodapé", "/cit-ecm-web/html/rodape/rodape.html");
		pgRodape = this.paginaService.saveIfNotExist(pgRodape);

		Menu menuRodape = new Menu("Rodapé", pgRodape, menuCadastroBasico, 0, 6, null, null, null, null, modulo);
		menuRodape.setIncludes(this.gerarArquivosMenu(menuRodape, this.CIT_ECM_WEB_ANGULAR, "Rodape", true, true, true));
		this.menuService.mergeIfNotExist(menuRodape);

		// Submenu cabeçalho
		Pagina pgCabecalho = new Pagina("Cabeçalho", "/cit-ecm-web/html/cabecalho/cabecalho.html");
		pgCabecalho = this.paginaService.saveIfNotExist(pgCabecalho);

		Menu menuCabecalho = new Menu("Cabeçalho", pgCabecalho, menuCadastroBasico, 0, 7, null, null, null, null, modulo);
		menuCabecalho.setIncludes(this.gerarArquivosMenu(menuCabecalho, this.CIT_ECM_WEB_ANGULAR, "Cabecalho", true, true, true));
		this.menuService.mergeIfNotExist(menuCabecalho);

		// Submenu tipoSuporteDocumento
		Pagina pgTipoSuporteDocumento = new Pagina("Tipo suporte de documento", "/cit-ecm-web/html/tipoSuporteDocumento/tipoSuporteDocumento.html");
		pgTipoSuporteDocumento = this.paginaService.saveIfNotExist(pgTipoSuporteDocumento);

		Menu menuSuporteDocumento = new Menu("Tipo suporte de documento", pgTipoSuporteDocumento, menuCadastroBasico, 0, 8, null, null, null, null, modulo);
		menuSuporteDocumento.setIncludes(this.gerarArquivosMenu(menuSuporteDocumento, this.CIT_ECM_WEB_ANGULAR, "TipoSuporteDocumento", true, true, true));
		this.menuService.mergeIfNotExist(menuSuporteDocumento);

		// Submenu Tarja de assinatura
		Pagina pgTarjaAssinatura = new Pagina("Tarja de Assinatura", "/cit-ecm-web/html/tarjaAssinatura/tarjaAssinatura.html");
		pgTarjaAssinatura = this.paginaService.saveIfNotExist(pgTarjaAssinatura);

		Menu menuTarjaAssinatura = new Menu("Tarja de Assinatura", pgTarjaAssinatura, menuCadastroBasico, 0, 9, null, null, null, null, modulo);
		menuTarjaAssinatura.setIncludes(this.gerarArquivosMenu(menuTarjaAssinatura, this.CIT_ECM_WEB_ANGULAR, "TarjaAssinatura", true, true, true));
		this.menuService.mergeIfNotExist(menuTarjaAssinatura);
	}

}
