package br.com.centralit.api.service.impl;

import java.util.Collection;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import br.com.centralit.api.dao.JustificativaAcaoProcessoDao;
import br.com.centralit.api.model.JustificativaAcaoProcesso;
import br.com.centralit.api.service.JustificativaAcaoProcessoService;
import br.com.centralit.api.service.ProcessoService;
import br.com.centralit.framework.service.arquitetura.GenericServiceImpl;


/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 06/02/2016 - 19:53:35
 *
 * @version 1.0.0
 *
 * @author Maycon
 *	
 */
@Service("justificativaAcaoProcessoService")
public class JustificativaAcaoProcessoServiceImpl extends GenericServiceImpl<JustificativaAcaoProcesso, Long> implements JustificativaAcaoProcessoService {

	/** Atributo justificativaAcaoProcessoDao. */
	private JustificativaAcaoProcessoDao justificativaAcaoProcessoDao;

	/** Atributo processoService. */
	@Autowired
	private ProcessoService processoService;

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * 
	 * @param justificativaAcaoProcessoDao
	 */
	@Autowired
	public JustificativaAcaoProcessoServiceImpl( JustificativaAcaoProcessoDao justificativaAcaoProcessoDao ) {
		
		this.dao = justificativaAcaoProcessoDao;

		this.justificativaAcaoProcessoDao = justificativaAcaoProcessoDao;

	}

	@Override
	public JustificativaAcaoProcesso save(JustificativaAcaoProcesso entity) {

		entity.setProcesso(this.processoService.getReference(entity.getProcesso().getId()));
		
		return super.save(entity);
	}

	@Override
	public Collection<JustificativaAcaoProcesso> listByIdProcesso(Long idProcesso) {

		// TODO Auto-generated method stub
		return justificativaAcaoProcessoDao.listByIdProcesso(idProcesso);
	}
	
	
}
