package br.com.centralit.api.service.impl;

import java.util.Collection;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import br.com.centralit.api.dao.NivelAcessoTipoDocumentoDao;
import br.com.centralit.api.model.NivelAcessoTipoDocumento;
import br.com.centralit.api.model.TipoDocumento;
import br.com.centralit.api.service.NivelAcessoTipoDocumentoService;
import br.com.centralit.api.service.SigiloTipoDocumentoService;
import br.com.centralit.framework.service.arquitetura.GenericServiceImpl;
import br.com.centralit.framework.util.UtilColecao;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 10/11/2015 - 08:51:52
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Service("nivelAcessoTipoDocumentoService")
public class NivelAcessoTipoDocumentoServiceImpl extends GenericServiceImpl<NivelAcessoTipoDocumento, Long> implements NivelAcessoTipoDocumentoService {

	/** Atributo nivelAcessoTipoDocumentoDao. */
	private NivelAcessoTipoDocumentoDao nivelAcessoTipoDocumentoDao;

	/** Atributo sigiloTipoDocumentoService. */
	@Autowired
	private SigiloTipoDocumentoService sigiloTipoDocumentoService;

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * 
	 * @param nivelAcessoTipoDocumentoDao
	 */
	@Autowired
	public NivelAcessoTipoDocumentoServiceImpl( NivelAcessoTipoDocumentoDao nivelAcessoTipoDocumentoDao ) {

		this.dao = nivelAcessoTipoDocumentoDao;

		this.nivelAcessoTipoDocumentoDao = nivelAcessoTipoDocumentoDao;

	}

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por remover entidade
	 * 
	 * @author rogerio.costa
	 * 
	 * @param tipoDocumento
	 */
	public void removeNivelAcesso(TipoDocumento tipoDocumento) {

		Collection<NivelAcessoTipoDocumento> niveisPersistido = this.nivelAcessoTipoDocumentoDao.findPorIdTipoDocumento(tipoDocumento.getId());

		if (!UtilColecao.isVazio(niveisPersistido)) {

			for (NivelAcessoTipoDocumento nivelAcessoTipoDocumento : niveisPersistido) {

				if (!tipoDocumento.getAcessos().contains(nivelAcessoTipoDocumento)) {

					nivelAcessoTipoDocumento.setTipoDocumentoRemocao(tipoDocumento);

					nivelAcessoTipoDocumento.setTipoDocumento(null);

				}else if (nivelAcessoTipoDocumento.getNivelAcesso().getCodigo().equals(0L)) {

					this.sigiloTipoDocumentoService.removeSigilo(this.obterNivelSigiloso(tipoDocumento.getAcessos()));
				}

			}

		}
	}

	public NivelAcessoTipoDocumento obterNivelSigiloso(Collection<NivelAcessoTipoDocumento> acessos) {

		for (NivelAcessoTipoDocumento nivelAcessoTipoDocumento : acessos) {

			if (nivelAcessoTipoDocumento.getNivelAcesso().getCodigo().equals(0L)) {

				return nivelAcessoTipoDocumento;
			}
		}

		return new NivelAcessoTipoDocumento();
	}

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por listar por id do tipoDocumento
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idTipoProcesso
	 * 
	 * @return Collection<NivelAcessoTipoProcesso>
	 */
	public Collection<NivelAcessoTipoDocumento> findPorIdTipoDocumento(Long idTipoDocumento) {

		return this.nivelAcessoTipoDocumentoDao.findPorIdTipoDocumento(idTipoDocumento);
	}

}
