package br.com.centralit.api.service.impl;

import java.util.Collection;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import br.com.centralit.api.dao.NivelAcessoTipoProcessoDao;
import br.com.centralit.api.model.NivelAcessoTipoProcesso;
import br.com.centralit.api.model.TipoProcesso;
import br.com.centralit.api.service.NivelAcessoTipoProcessoService;
import br.com.centralit.api.service.SigiloTipoProcessoService;
import br.com.centralit.framework.service.arquitetura.GenericServiceImpl;
import br.com.centralit.framework.util.UtilColecao;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 09/11/2015 - 17:22:51
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Service("nivelAcessoTipoProcessoService")
public class NivelAcessoTipoProcessoServiceImpl extends GenericServiceImpl<NivelAcessoTipoProcesso, Long> implements NivelAcessoTipoProcessoService {

	/** Atributo nivelAcessoTipoProcessoDao. */
	private NivelAcessoTipoProcessoDao nivelAcessoTipoProcessoDao;

	/** Atributo sigiloService. */
	@Autowired
	private SigiloTipoProcessoService sigiloTipoProcessoService;

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * 
	 * @param nivelAcessoTipoProcessoDao
	 */
	@Autowired
	private NivelAcessoTipoProcessoServiceImpl( NivelAcessoTipoProcessoDao nivelAcessoTipoProcessoDao ) {

		this.dao = nivelAcessoTipoProcessoDao;

		this.nivelAcessoTipoProcessoDao = nivelAcessoTipoProcessoDao;
	}

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por remover
	 * 
	 * @author rogerio.costa
	 * 
	 * @param tipoProcesso
	 */
	public void removeNivelAcesso(TipoProcesso tipoProcesso) {

		Collection<NivelAcessoTipoProcesso> niveisPersistido = this.nivelAcessoTipoProcessoDao.findPorIdTipoProcesso(tipoProcesso.getId());

		if (!UtilColecao.isVazio(niveisPersistido)) {

			for (NivelAcessoTipoProcesso nivelAcessoTipoProcesso : niveisPersistido) {

				if (!tipoProcesso.getAcessos().contains(nivelAcessoTipoProcesso)) {

					nivelAcessoTipoProcesso.setTipoProcessoRemocao(tipoProcesso);

					nivelAcessoTipoProcesso.setTipoProcesso(null);

				} else if (nivelAcessoTipoProcesso.getNivelAcesso().getCodigo().equals(0L)) {

					this.sigiloTipoProcessoService.removeSigilo(this.obterNivelSigiloso(tipoProcesso.getAcessos()));
				}

			}

		}
	}

	public NivelAcessoTipoProcesso obterNivelSigiloso(Collection<NivelAcessoTipoProcesso> acessos) {

		for (NivelAcessoTipoProcesso nivelAcessoTipoProcesso : acessos) {

			if (nivelAcessoTipoProcesso.getNivelAcesso().getCodigo().equals(0L)) {

				return nivelAcessoTipoProcesso;
			}
		}

		return new NivelAcessoTipoProcesso();
	}

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por listar por id do tipoProcesso
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idTipoProcesso
	 * @return
	 */
	public Collection<NivelAcessoTipoProcesso> findPorIdTipoProcesso(Long idTipoProcesso) {

		return this.nivelAcessoTipoProcessoDao.findPorIdTipoProcesso(idTipoProcesso);
	}

}
