package br.com.centralit.api.service.impl;

import java.util.Collection;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import br.com.centralit.api.dao.SigiloTipoDocumentoDao;
import br.com.centralit.api.model.NivelAcessoTipoDocumento;
import br.com.centralit.api.model.SigiloTipoDocumento;
import br.com.centralit.api.service.SigiloTipoDocumentoService;
import br.com.centralit.framework.service.arquitetura.GenericServiceImpl;
import br.com.centralit.framework.util.UtilColecao;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 29/01/2016 - 15:29:33
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Service("sigiloTipoDocumentoService")
public class SigiloTipoDocumentoServiceImpl extends GenericServiceImpl<SigiloTipoDocumento, Long> implements SigiloTipoDocumentoService {

	/** Atributo sigiloTipoDocumentoDao. */
	private SigiloTipoDocumentoDao sigiloTipoDocumentoDao;

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * 
	 * @param sigiloTipoDocumentoDao
	 */
	@Autowired
	public SigiloTipoDocumentoServiceImpl( SigiloTipoDocumentoDao sigiloTipoDocumentoDao ) {

		this.dao = sigiloTipoDocumentoDao;

		this.sigiloTipoDocumentoDao = sigiloTipoDocumentoDao;
	}

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por remover
	 * 
	 * @author rogerio.costa
	 * 
	 * @param tipoProcesso
	 */
	public void removeSigilo(NivelAcessoTipoDocumento nivelAcessoTipoDocumento) {

		Collection<SigiloTipoDocumento> sigilos = this.sigiloTipoDocumentoDao.findPorIdNivelAcessoTipoDocumento(nivelAcessoTipoDocumento.getId());

		if (!UtilColecao.isVazio(sigilos)) {

			for (SigiloTipoDocumento sigilo : sigilos) {

				if (!nivelAcessoTipoDocumento.getSigilos().contains(sigilo)) {

					sigilo.setNivelAcessoTipoDocumentoRemocao(nivelAcessoTipoDocumento);
					sigilo.setNivelAcessoTipoDocumento(null);

				}

			}

		}
	}

}
