package br.com.centralit.api.service.impl;

import java.util.Collection;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import br.com.centralit.api.dao.SigiloTipoProcessoDao;
import br.com.centralit.api.model.NivelAcessoTipoProcesso;
import br.com.centralit.api.model.SigiloTipoProcesso;
import br.com.centralit.api.service.SigiloTipoProcessoService;
import br.com.centralit.framework.service.arquitetura.GenericServiceImpl;
import br.com.centralit.framework.util.UtilColecao;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 28/01/2016 - 17:38:14
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Service("sigiloTipoProcessoService")
public class SigiloTipoProcessoServiceImpl extends GenericServiceImpl<SigiloTipoProcesso, Long> implements SigiloTipoProcessoService {

	/** Atributo sigiloTipoProcessoDao. */
	private SigiloTipoProcessoDao sigiloTipoProcessoDao;

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * 
	 * @param sigiloDao
	 */
	@Autowired
	private SigiloTipoProcessoServiceImpl( SigiloTipoProcessoDao sigiloDao ) {

		this.dao = sigiloDao;

		this.sigiloTipoProcessoDao = sigiloDao;

	}

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por remover
	 * 
	 * @author rogerio.costa
	 * 
	 * @param tipoProcesso
	 */
	public void removeSigilo(NivelAcessoTipoProcesso nivelAcessoTipoProcesso) {

		Collection<SigiloTipoProcesso> sigilos = this.sigiloTipoProcessoDao.findPorIdNivelAcessoTipoProcesso(nivelAcessoTipoProcesso.getId());

		if (!UtilColecao.isVazio(sigilos)) {

			for (SigiloTipoProcesso sigilo : sigilos) {

				if (!nivelAcessoTipoProcesso.getSigilos().contains(sigilo)) {

					sigilo.setNivelAcessoTipoProcessoRemocao(nivelAcessoTipoProcesso);
					sigilo.setNivelAcessoTipoProcesso(null);

				}

			}

		}
	}

}
