package br.com.centralit.api.service.impl;

import java.util.Collection;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Service;
import org.springframework.validation.Validator;

import br.com.centralit.api.dao.TipoProcessoPlanoClassificacaoDao;
import br.com.centralit.api.model.TipoProcessoPlanoClassificacao;
import br.com.centralit.api.service.TipoProcessoPlanoClassificacaoService;
import br.com.centralit.framework.service.arquitetura.GenericServiceImpl;

@Service("tipoProcessoPlanoClassificacaoService")
public class TipoProcessoPlanoClassificacaoServiceImpl extends GenericServiceImpl<TipoProcessoPlanoClassificacao, Long> implements TipoProcessoPlanoClassificacaoService {

	private TipoProcessoPlanoClassificacaoDao tipoProcessoPlanoClassificacaoDao;

	@Autowired
	public TipoProcessoPlanoClassificacaoServiceImpl( TipoProcessoPlanoClassificacaoDao tipoProcessoPlanoClassificacaoDao, @Qualifier("tipoProcessoPlanoClassificacaoValidator") Validator validator ) {

		this.dao = tipoProcessoPlanoClassificacaoDao;
		this.tipoProcessoPlanoClassificacaoDao = tipoProcessoPlanoClassificacaoDao;
		this.validator = validator;
	}

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por listar através do id do tipoProcesso
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idTipoProcesso
	 * @return Collection<TipoProcessoPlanoClassificacao>
	 */
	public Collection<TipoProcessoPlanoClassificacao> findPorIdTipoProcesso(Long idTipoProcesso) {

		return this.tipoProcessoPlanoClassificacaoDao.findPorIdTipoProcesso(idTipoProcesso);
	}

}
