package br.com.centralit.api.service.validation;

import br.com.centralit.api.model.DocumentoGed;
import org.springframework.stereotype.Component;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import org.springframework.validation.Validator;

import br.com.centralit.framework.exception.CodigoErro;

@Component("documentoGedValidator")
public class DocumentoGedValidator implements Validator {

    @Override
	public boolean supports(Class<?> clazz) {

		return DocumentoGed.class.isAssignableFrom(clazz);
	}

	@Override
	public void validate(Object target, Errors errors) {
        
        ValidationUtils.rejectIfEmpty(errors, "tipoDocumento", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "ECM.LABEL.TIPODOCUMENTO");
                   
        ValidationUtils.rejectIfEmpty(errors, "planoClassificacao", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "ECM.LABEL.ASSUNTO");
                   
        ValidationUtils.rejectIfEmpty(errors, "destinatario", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "ECM.LABEL.DESTINATARIO");
        
        ValidationUtils.rejectIfEmpty(errors, "formaCriacao.codigo", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "ECM.LABEL.FORMADECRIACAO");
                   
	}
}

