package br.com.centralit.api.service.validation;

import org.springframework.stereotype.Component;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import org.springframework.validation.Validator;

import br.com.centralit.api.model.EstruturaOrganizacionalECM;
import br.com.centralit.framework.exception.CodigoErro;

@Component("estruturaOrganizacionalECMValidator")
public class EstruturaOrganizacionalECMValidator implements Validator {

	@Override
	public boolean supports(Class<?> clazz) {

		return EstruturaOrganizacionalECM.class.isAssignableFrom(clazz);
	}

	@Override
	public void validate(Object target, Errors errors) {

		ValidationUtils.rejectIfEmpty(errors, "codigoSiorg", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "ECM.LABEL.CODIGO_SIORG");

	}
}
