package br.com.centralit.api.service.validation;

import org.springframework.stereotype.Component;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import org.springframework.validation.Validator;

import br.com.centralit.api.model.HistoricoAlteracaoProcesso;
import br.com.centralit.framework.exception.CodigoErro;

@Component("historicoAlteracaoProcessoValidator")
public class HistoricoAlteracaoProcessoValidator implements Validator {

	@Override
	public boolean supports(Class<?> clazz) {

		return HistoricoAlteracaoProcesso.class.isAssignableFrom(clazz);
	}

	@Override
	public void validate(Object target, Errors errors) {

		ValidationUtils.rejectIfEmpty(errors, "processo", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "ECM.LABEL.PROCESSO");

		ValidationUtils.rejectIfEmpty(errors, "usuario", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.USUARIO");

		ValidationUtils.rejectIfEmpty(errors, "unidadeVigente", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.UNIDADE");

		ValidationUtils.rejectIfEmpty(errors, "descricaoAcao", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.DESCRICAO");

	}
}
