package br.com.centralit.api.service.validation;

import org.springframework.stereotype.Component;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import org.springframework.validation.Validator;

import br.com.centralit.api.model.PlanoClassificacao;
import br.com.centralit.framework.exception.CodigoErro;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 21/10/2015 - 16:05:56
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Component("planoClassificacaoValidator")
public class PlanoClassificacaoValidator implements Validator {

	@Override
	public boolean supports(Class<?> clazz) {

		return PlanoClassificacao.class.isAssignableFrom(clazz);
	}

	@Override
	public void validate(Object target, Errors errors) {
		
		if(((PlanoClassificacao)target).getPermitirUsarComoClassificacao() != null && ((PlanoClassificacao)target).getPermitirUsarComoClassificacao()){
			
			ValidationUtils.rejectIfEmpty(errors, "nome", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.NOME");

			ValidationUtils.rejectIfEmpty(errors, "tipoDestinacao", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "ECM.LABEL.DESTINACAO");

			ValidationUtils.rejectIfEmpty(errors, "faseCorrente", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "ECM.LABEL.FASE_CORRENTE_ANO");
			
			ValidationUtils.rejectIfEmpty(errors, "faseIntermediaria", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "ECM.LABEL.FASE_INTERMEDIARIA_ANO");
		}

	}
}
