package br.com.centralit.api.service.validation;

import br.com.centralit.api.model.Processo;
import org.springframework.stereotype.Component;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import org.springframework.validation.Validator;

import br.com.centralit.framework.exception.CodigoErro;

@Component("processoValidator")
public class ProcessoValidator implements Validator {

    @Override
	public boolean supports(Class<?> clazz) {

		return Processo.class.isAssignableFrom(clazz);
	}

	@Override
	public void validate(Object target, Errors errors) {
        
                   
        ValidationUtils.rejectIfEmpty(errors, "tipoProcesso", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "ECM.LABEL.TIPOPROCESSO");
                   
                   
        ValidationUtils.rejectIfEmpty(errors, "nivelAcesso", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "ECM.LABEL.NIVELACESSO");
                                    
	}
}

