package br.com.centralit.api.service.validation;

import br.com.centralit.api.model.TipoDocumento;
import org.springframework.stereotype.Component;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import org.springframework.validation.Validator;

import br.com.centralit.framework.exception.CodigoErro;

@Component("tipoDocumentoValidator")
public class TipoDocumentoValidator implements Validator {

    @Override
	public boolean supports(Class<?> clazz) {

		return TipoDocumento.class.isAssignableFrom(clazz);
	}

	@Override
	public void validate(Object target, Errors errors) {
        
        ValidationUtils.rejectIfEmpty(errors, "nome", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.NOME");
                   
                   
        ValidationUtils.rejectIfEmpty(errors, "formaCriacao", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.FORMADECRIACAO");
                   
	}
}

