	
	CREATE TABLE acessoexterno (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    chaveacesso character varying(255),
	    datafimacesso timestamp without time zone,
	    emaildestinatario character varying(255),
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint,
	    documento_id bigint,
	    processo_id bigint
	);
	
	
	ALTER TABLE public.acessoexterno OWNER TO postgres;
	
	--
	-- Name: acessoexterno_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE acessoexterno_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.acessoexterno_id_seq OWNER TO postgres;
	
	--
	-- Name: acessoexterno_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE acessoexterno_id_seq OWNED BY acessoexterno.id;
	
	
	--
	-- Name: acompanhamento; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
	--
	
	CREATE TABLE acompanhamento (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint,
	    processo_id bigint,
	    usuario_id bigint
	);
	
	
	ALTER TABLE public.acompanhamento OWNER TO postgres;
	
	--
	-- Name: acompanhamento_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE acompanhamento_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.acompanhamento_id_seq OWNER TO postgres;
	
	--
	-- Name: acompanhamento_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE acompanhamento_id_seq OWNED BY acompanhamento.id;
	
	
	--
	-- Name: anexoprocesso; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
	--
	
	CREATE TABLE anexoprocesso (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint
	);
	
	
	ALTER TABLE public.anexoprocesso OWNER TO postgres;
	
	--
	-- Name: anexoprocesso_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE anexoprocesso_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.anexoprocesso_id_seq OWNER TO postgres;
	
	--
	-- Name: anexoprocesso_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE anexoprocesso_id_seq OWNED BY anexoprocesso.id;
	
	
	--
	-- Name: assinatura; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
	--
	
	CREATE TABLE assinatura (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint,
	    documento_id bigint,
	    usuario_id bigint
	);
	
	
	ALTER TABLE public.assinatura OWNER TO postgres;
	
	--
	-- Name: assinatura_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE assinatura_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.assinatura_id_seq OWNER TO postgres;
	
	--
	-- Name: assinatura_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE assinatura_id_seq OWNED BY assinatura.id;
	
	
	--
	-- Name: assunto; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
	--
	
	CREATE TABLE assunto (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint,
	    planoclassificacao_id bigint
	);
	
	
	ALTER TABLE public.assunto OWNER TO postgres;
	
	--
	-- Name: assunto_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE assunto_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.assunto_id_seq OWNER TO postgres;
	
	--
	-- Name: assunto_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE assunto_id_seq OWNED BY assunto.id;
	
	
	--
	-- Name: blocoreuniao; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
	--
	
	CREATE TABLE blocoreuniao (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint
	);
	
	
	ALTER TABLE public.blocoreuniao OWNER TO postgres;
	
	--
	-- Name: blocoreuniao_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE blocoreuniao_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.blocoreuniao_id_seq OWNER TO postgres;
	
	--
	-- Name: blocoreuniao_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE blocoreuniao_id_seq OWNED BY blocoreuniao.id;
	
	
	--
	-- Name: cienciadocumento; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
	--
	
	CREATE TABLE cienciadocumento (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint,
	    documento_id bigint,
	    usuario_id bigint
	);
	
	
	ALTER TABLE public.cienciadocumento OWNER TO postgres;
	
	--
	-- Name: cienciadocumento_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE cienciadocumento_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.cienciadocumento_id_seq OWNER TO postgres;
	
	--
	-- Name: cienciadocumento_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE cienciadocumento_id_seq OWNED BY cienciadocumento.id;
	
	
	--
	-- Name: cienciaprocesso; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
	--
	
	CREATE TABLE cienciaprocesso (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint,
	    processo_id bigint,
	    usuario_id bigint
	);
	
	
	ALTER TABLE public.cienciaprocesso OWNER TO postgres;
	
	--
	-- Name: cienciaprocesso_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE cienciaprocesso_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.cienciaprocesso_id_seq OWNER TO postgres;
	
	--
	-- Name: cienciaprocesso_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE cienciaprocesso_id_seq OWNED BY cienciaprocesso.id;
	
	
	--
	-- Name: configuracaoplanoclassificacao; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
	--
	
	CREATE TABLE configuracaoplanoclassificacao (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    fasecorrente integer,
	    faseintermediaria integer,
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint,
	    planoclassificacao_id bigint,
	    tipodestinacao_id bigint,
	    tipotemporalidade_id bigint
	);
	
	
	ALTER TABLE public.configuracaoplanoclassificacao OWNER TO postgres;
	
	--
	-- Name: configuracaoplanoclassificacao_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE configuracaoplanoclassificacao_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.configuracaoplanoclassificacao_id_seq OWNER TO postgres;
	
	--
	-- Name: configuracaoplanoclassificacao_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE configuracaoplanoclassificacao_id_seq OWNED BY configuracaoplanoclassificacao.id;
	
	
	--
	-- Name: configuracaosistemasigad; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
	--
	
	CREATE TABLE configuracaosistemasigad (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint
	);
	
	
	ALTER TABLE public.configuracaosistemasigad OWNER TO postgres;
	
	--
	-- Name: configuracaosistemasigad_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE configuracaosistemasigad_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.configuracaosistemasigad_id_seq OWNER TO postgres;
	
	--
	-- Name: configuracaosistemasigad_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE configuracaosistemasigad_id_seq OWNED BY configuracaosistemasigad.id;
	
	
	--
	-- Name: configuracaousuario; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
	--
	
	CREATE TABLE configuracaousuario (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint,
	    configuracaosistemasigad_id bigint,
	    unidade_id bigint,
	    usuario_id bigint
	);
	
	
	ALTER TABLE public.configuracaousuario OWNER TO postgres;
	
	--
	-- Name: configuracaousuario_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE configuracaousuario_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.configuracaousuario_id_seq OWNER TO postgres;
	
	--
	-- Name: configuracaousuario_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE configuracaousuario_id_seq OWNED BY configuracaousuario.id;
	
	
	--
	-- Name: destinatario; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
	--
	
	CREATE TABLE destinatario (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint,
	    documento_id bigint,
	    pessoa_id bigint
	);
	
	
	ALTER TABLE public.destinatario OWNER TO postgres;
	
	--
	-- Name: destinatario_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE destinatario_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.destinatario_id_seq OWNER TO postgres;
	
	--
	-- Name: destinatario_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE destinatario_id_seq OWNED BY destinatario.id;
	
	
	--
	-- Name: documentoecm; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
	--
	
	CREATE TABLE documentoecm (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    assuntocomplementar character varying(255),
	    numero character varying(255),
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint,
	    anexo_id bigint,
	    hipoteselegal_id bigint,
	    nivelacesso_id bigint,
	    permissao_id bigint,
	    processo_id bigint NOT NULL,
	    status_id bigint,
	    tipodocumento_id bigint,
	    tramitardocumento_id bigint
	);
	
	
	ALTER TABLE public.documentoecm OWNER TO postgres;
	
	--
	-- Name: documentoecm_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE documentoecm_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.documentoecm_id_seq OWNER TO postgres;
	
	--
	-- Name: documentoecm_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE documentoecm_id_seq OWNED BY documentoecm.id;
	
	
	--
	-- Name: documentofavorito; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
	--
	
	CREATE TABLE documentofavorito (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint,
	    documento_id bigint
	);
	
	
	ALTER TABLE public.documentofavorito OWNER TO postgres;
	
	--
	-- Name: documentofavorito_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE documentofavorito_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.documentofavorito_id_seq OWNER TO postgres;
	
	--
	-- Name: documentofavorito_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE documentofavorito_id_seq OWNED BY documentofavorito.id;
	
	
	--
	-- Name: enviodocumento; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
	--
	
	CREATE TABLE enviodocumento (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint,
	    documento_id bigint
	);
	
	
	ALTER TABLE public.enviodocumento OWNER TO postgres;
	
	--
	-- Name: enviodocumento_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE enviodocumento_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.enviodocumento_id_seq OWNER TO postgres;
	
	--
	-- Name: enviodocumento_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE enviodocumento_id_seq OWNED BY enviodocumento.id;
	
	CREATE TABLE hipoteselegal (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    descricao character varying(255),
	    nome character varying(255),
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint
	);
	
	
	ALTER TABLE public.hipoteselegal OWNER TO postgres;
	
	--
	-- Name: hipoteselegal_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE hipoteselegal_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.hipoteselegal_id_seq OWNER TO postgres;
	
	--
	-- Name: hipoteselegal_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE hipoteselegal_id_seq OWNED BY hipoteselegal.id;
	
	
	--
	-- Name: historicoalteracaodocumento; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
	--
	
	CREATE TABLE historicoalteracaodocumento (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint,
	    documento_id bigint
	);
	
	
	ALTER TABLE public.historicoalteracaodocumento OWNER TO postgres;
	
	--
	-- Name: historicoalteracaodocumento_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE historicoalteracaodocumento_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.historicoalteracaodocumento_id_seq OWNER TO postgres;
	
	--
	-- Name: historicoalteracaodocumento_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE historicoalteracaodocumento_id_seq OWNED BY historicoalteracaodocumento.id;
	
	
	--
	-- Name: historicoalteracaoprocesso; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
	--
	
	CREATE TABLE historicoalteracaoprocesso (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint,
	    processo_id bigint
	);
	
	
	ALTER TABLE public.historicoalteracaoprocesso OWNER TO postgres;
	
	--
	-- Name: historicoalteracaoprocesso_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE historicoalteracaoprocesso_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.historicoalteracaoprocesso_id_seq OWNER TO postgres;
	
	--
	-- Name: historicoalteracaoprocesso_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE historicoalteracaoprocesso_id_seq OWNED BY historicoalteracaoprocesso.id;
	
	
	--
	-- Name: interessadodocumento; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
	--
	
	CREATE TABLE interessadodocumento (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint,
	    documento_id bigint,
	    interessado_id bigint
	);
	
	
	ALTER TABLE public.interessadodocumento OWNER TO postgres;
	
	--
	-- Name: interessadodocumento_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE interessadodocumento_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.interessadodocumento_id_seq OWNER TO postgres;
	
	--
	-- Name: interessadodocumento_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE interessadodocumento_id_seq OWNED BY interessadodocumento.id;
	
	
	--
	-- Name: interessadoprocesso; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
	--
	
	CREATE TABLE interessadoprocesso (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint,
	    interessado_id bigint,
	    processo_id bigint
	);
	
	
	ALTER TABLE public.interessadoprocesso OWNER TO postgres;
	
	--
	-- Name: interessadoprocesso_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE interessadoprocesso_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.interessadoprocesso_id_seq OWNER TO postgres;
	
	--
	-- Name: interessadoprocesso_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE interessadoprocesso_id_seq OWNED BY interessadoprocesso.id;
	
	
	--
	-- Name: nivelacessotipodocumento; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
	--
	
	CREATE TABLE nivelacessotipodocumento (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint,
	    nivelacesso_id bigint,
	    tipodocumento_id bigint,
	    tipodocumentoremocao_id bigint,
	    tiposigilo_id bigint
	);
	
	
	ALTER TABLE public.nivelacessotipodocumento OWNER TO postgres;
	
	--
	-- Name: nivelacessotipodocumento_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE nivelacessotipodocumento_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.nivelacessotipodocumento_id_seq OWNER TO postgres;
	
	--
	-- Name: nivelacessotipodocumento_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE nivelacessotipodocumento_id_seq OWNED BY nivelacessotipodocumento.id;
	
	
	--
	-- Name: nivelacessotipoprocesso; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
	--
	
	CREATE TABLE nivelacessotipoprocesso (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint,
	    nivelacesso_id bigint,
	    tipoprocesso_id bigint,
	    tipoprocessoremocao_id bigint,
	    tiposigilo_id bigint
	);
	
	
	ALTER TABLE public.nivelacessotipoprocesso OWNER TO postgres;
	
	--
	-- Name: nivelacessotipoprocesso_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE nivelacessotipoprocesso_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.nivelacessotipoprocesso_id_seq OWNER TO postgres;
	
	--
	-- Name: nivelacessotipoprocesso_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE nivelacessotipoprocesso_id_seq OWNED BY nivelacessotipoprocesso.id;
	
	
	--
	-- Name: nivelacessotiposigilo; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
	--
	
	CREATE TABLE nivelacessotiposigilo (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint,
	    nivelacessotipoprocesso_id bigint,
	    tiposigilo_id bigint
	);
	
	
	ALTER TABLE public.nivelacessotiposigilo OWNER TO postgres;
	
	--
	-- Name: nivelacessotiposigilo_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE nivelacessotiposigilo_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.nivelacessotiposigilo_id_seq OWNER TO postgres;
	
	--
	-- Name: nivelacessotiposigilo_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE nivelacessotiposigilo_id_seq OWNED BY nivelacessotiposigilo.id;
	
	
	--
	-- Name: permissao; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
	--
	
	CREATE TABLE permissao (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint,
	    documento_id bigint,
	    tipopermissao_id bigint,
	    usuario_id bigint
	);
	
	
	ALTER TABLE public.permissao OWNER TO postgres;
	
	--
	-- Name: permissao_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE permissao_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.permissao_id_seq OWNER TO postgres;
	
	--
	-- Name: permissao_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE permissao_id_seq OWNED BY permissao.id;
	
	
	--
	-- Name: planoclassificacao; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
	--
	
	CREATE TABLE planoclassificacao (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    codigo character varying(255),
	    fasecorrente integer,
	    faseintermediaria integer,
	    nome character varying(255),
	    observacao character varying(255),
	    permitirusarcomoclassificacao boolean,
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint,
	    organizacao_id bigint,
	    planoclassificacaoparent_id bigint,
	    tipodestinacao_id bigint
	);
	
	
	ALTER TABLE public.planoclassificacao OWNER TO postgres;
	
	--
	-- Name: planoclassificacao_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE planoclassificacao_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.planoclassificacao_id_seq OWNER TO postgres;
	
	--
	-- Name: planoclassificacao_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE planoclassificacao_id_seq OWNED BY planoclassificacao.id;
	
	
	--
	-- Name: processo; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
	--
	
	CREATE TABLE processo (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    assuntocomplementar character varying(255),
	    datareferencia timestamp without time zone,
	    nup character varying(255),
	    observacaogeral character varying(255),
	    protocolo character varying(255),
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint,
	    anexoprocesso_id bigint,
	    assunto_id bigint,
	    cienciaprocesso_id bigint,
	    hipoteselegal_id bigint,
	    nivelacesso_id bigint,
	    status_id bigint,
	    tipoprocesso_id bigint,
	    tramitardocumento_id bigint,
	    unidade_id bigint
	);
	
	
	ALTER TABLE public.processo OWNER TO postgres;
	
	--
	-- Name: processo_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE processo_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.processo_id_seq OWNER TO postgres;
	
	--
	-- Name: processo_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE processo_id_seq OWNED BY processo.id;
	
	
	--
	-- Name: sobrestar; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
	--
	
	CREATE TABLE sobrestar (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint
	);
	
	
	ALTER TABLE public.sobrestar OWNER TO postgres;
	
	--
	-- Name: sobrestar_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE sobrestar_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.sobrestar_id_seq OWNER TO postgres;
	
	--
	-- Name: sobrestar_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE sobrestar_id_seq OWNED BY sobrestar.id;
	
	
	--
	-- Name: templatedocumento; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
	--
	
	CREATE TABLE templatedocumento (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint,
	    tipodocumento_id bigint
	);
	
	
	ALTER TABLE public.templatedocumento OWNER TO postgres;
	
	--
	-- Name: templatedocumento_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE templatedocumento_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.templatedocumento_id_seq OWNER TO postgres;
	
	--
	-- Name: templatedocumento_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE templatedocumento_id_seq OWNED BY templatedocumento.id;
	
	
	--
	-- Name: templateemail; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
	--
	
	CREATE TABLE templateemail (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint
	);
	
	
	ALTER TABLE public.templateemail OWNER TO postgres;
	
	--
	-- Name: templateemail_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE templateemail_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.templateemail_id_seq OWNER TO postgres;
	
	--
	-- Name: templateemail_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE templateemail_id_seq OWNED BY templateemail.id;
	
	
	--
	-- Name: tipodocumento; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
	--
	
	CREATE TABLE tipodocumento (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    descricao character varying(255),
	    nome character varying(255),
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint,
	    formacriacao_id bigint,
	    hipoteselegal_id bigint
	);
	
	
	ALTER TABLE public.tipodocumento OWNER TO postgres;
	
	--
	-- Name: tipodocumento_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE tipodocumento_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.tipodocumento_id_seq OWNER TO postgres;
	
	--
	-- Name: tipodocumento_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE tipodocumento_id_seq OWNED BY tipodocumento.id;
	
	
	--
	-- Name: tipodocumentocaracteristica; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
	--
	
	CREATE TABLE tipodocumentocaracteristica (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    obrigatorio boolean,
	    sequencia bigint,
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint,
	    caracteristica_id bigint NOT NULL,
	    tipodocumento_id bigint
	);
	
	
	ALTER TABLE public.tipodocumentocaracteristica OWNER TO postgres;
	
	--
	-- Name: tipodocumentocaracteristica_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE tipodocumentocaracteristica_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.tipodocumentocaracteristica_id_seq OWNER TO postgres;
	
	--
	-- Name: tipodocumentocaracteristica_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE tipodocumentocaracteristica_id_seq OWNED BY tipodocumentocaracteristica.id;
	
	
	--
	-- Name: tipodocumentoplanoclassificacao; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
	--
	
	CREATE TABLE tipodocumentoplanoclassificacao (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint,
	    planoclassificacao_id bigint,
	    tipodocumento_id bigint
	);
	
	
	ALTER TABLE public.tipodocumentoplanoclassificacao OWNER TO postgres;
	
	--
	-- Name: tipodocumentoplanoclassificacao_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE tipodocumentoplanoclassificacao_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.tipodocumentoplanoclassificacao_id_seq OWNER TO postgres;
	
	--
	-- Name: tipodocumentoplanoclassificacao_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE tipodocumentoplanoclassificacao_id_seq OWNED BY tipodocumentoplanoclassificacao.id;
	
	
	--
	-- Name: tipoprocesso; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
	--
	
	CREATE TABLE tipoprocesso (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    descricao character varying(255),
	    nome character varying(255),
	    processonegocio character varying(255),
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint,
	    hipoteselegal_id bigint
	);
	
	
	ALTER TABLE public.tipoprocesso OWNER TO postgres;
	
	--
	-- Name: tipoprocesso_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE tipoprocesso_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.tipoprocesso_id_seq OWNER TO postgres;
	
	--
	-- Name: tipoprocesso_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE tipoprocesso_id_seq OWNED BY tipoprocesso.id;
	
	
	--
	-- Name: tipoprocessoplanoclassificacao; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
	--
	
	CREATE TABLE tipoprocessoplanoclassificacao (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint,
	    planoclassificacao_id bigint,
	    tipoprocesso_id bigint
	);
	
	
	ALTER TABLE public.tipoprocessoplanoclassificacao OWNER TO postgres;
	
	--
	-- Name: tipoprocessoplanoclassificacao_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE tipoprocessoplanoclassificacao_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.tipoprocessoplanoclassificacao_id_seq OWNER TO postgres;
	
	--
	-- Name: tipoprocessoplanoclassificacao_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE tipoprocessoplanoclassificacao_id_seq OWNED BY tipoprocessoplanoclassificacao.id;
	
	
	--
	-- Name: tramitardocumento; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
	--
	
	CREATE TABLE tramitardocumento (
	    id bigint NOT NULL,
	    databloqueio date,
	    datainativo date,
	    datacriacao timestamp without time zone NOT NULL,
	    dataedicao timestamp without time zone NOT NULL,
	    version bigint,
	    inativador_id bigint,
	    autor_id bigint,
	    editor_id bigint,
	    documento_id bigint,
	    unidade_id bigint,
	    usuario_id bigint
	);
	
	
	ALTER TABLE public.tramitardocumento OWNER TO postgres;
	
	--
	-- Name: tramitardocumento_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
	--
	
	CREATE SEQUENCE tramitardocumento_id_seq
	    START WITH 1
	    INCREMENT BY 1
	    NO MINVALUE
	    NO MAXVALUE
	    CACHE 1;
	
	
	ALTER TABLE public.tramitardocumento_id_seq OWNER TO postgres;
	
	--
	-- Name: tramitardocumento_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
	--
	
	ALTER SEQUENCE tramitardocumento_id_seq OWNED BY tramitardocumento.id;
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY acessoexterno ALTER COLUMN id SET DEFAULT nextval('acessoexterno_id_seq'::regclass);
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY acompanhamento ALTER COLUMN id SET DEFAULT nextval('acompanhamento_id_seq'::regclass);
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY anexoprocesso ALTER COLUMN id SET DEFAULT nextval('anexoprocesso_id_seq'::regclass);
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY assinatura ALTER COLUMN id SET DEFAULT nextval('assinatura_id_seq'::regclass);
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY assunto ALTER COLUMN id SET DEFAULT nextval('assunto_id_seq'::regclass);
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY blocoreuniao ALTER COLUMN id SET DEFAULT nextval('blocoreuniao_id_seq'::regclass);
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY cienciadocumento ALTER COLUMN id SET DEFAULT nextval('cienciadocumento_id_seq'::regclass);
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY cienciaprocesso ALTER COLUMN id SET DEFAULT nextval('cienciaprocesso_id_seq'::regclass);
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY configuracaoplanoclassificacao ALTER COLUMN id SET DEFAULT nextval('configuracaoplanoclassificacao_id_seq'::regclass);
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY configuracaosistemasigad ALTER COLUMN id SET DEFAULT nextval('configuracaosistemasigad_id_seq'::regclass);
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY configuracaousuario ALTER COLUMN id SET DEFAULT nextval('configuracaousuario_id_seq'::regclass);
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY destinatario ALTER COLUMN id SET DEFAULT nextval('destinatario_id_seq'::regclass);
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY documentoecm ALTER COLUMN id SET DEFAULT nextval('documentoecm_id_seq'::regclass);
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY documentofavorito ALTER COLUMN id SET DEFAULT nextval('documentofavorito_id_seq'::regclass);
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY enviodocumento ALTER COLUMN id SET DEFAULT nextval('enviodocumento_id_seq'::regclass);
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	ALTER TABLE ONLY hipoteselegal ALTER COLUMN id SET DEFAULT nextval('hipoteselegal_id_seq'::regclass);
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY historicoalteracaodocumento ALTER COLUMN id SET DEFAULT nextval('historicoalteracaodocumento_id_seq'::regclass);
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY historicoalteracaoprocesso ALTER COLUMN id SET DEFAULT nextval('historicoalteracaoprocesso_id_seq'::regclass);
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY interessadodocumento ALTER COLUMN id SET DEFAULT nextval('interessadodocumento_id_seq'::regclass);
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY interessadoprocesso ALTER COLUMN id SET DEFAULT nextval('interessadoprocesso_id_seq'::regclass);
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY nivelacessotipodocumento ALTER COLUMN id SET DEFAULT nextval('nivelacessotipodocumento_id_seq'::regclass);
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY nivelacessotipoprocesso ALTER COLUMN id SET DEFAULT nextval('nivelacessotipoprocesso_id_seq'::regclass);
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY nivelacessotiposigilo ALTER COLUMN id SET DEFAULT nextval('nivelacessotiposigilo_id_seq'::regclass);
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY permissao ALTER COLUMN id SET DEFAULT nextval('permissao_id_seq'::regclass);
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY planoclassificacao ALTER COLUMN id SET DEFAULT nextval('planoclassificacao_id_seq'::regclass);
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY processo ALTER COLUMN id SET DEFAULT nextval('processo_id_seq'::regclass);
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY sobrestar ALTER COLUMN id SET DEFAULT nextval('sobrestar_id_seq'::regclass);
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY templatedocumento ALTER COLUMN id SET DEFAULT nextval('templatedocumento_id_seq'::regclass);
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY templateemail ALTER COLUMN id SET DEFAULT nextval('templateemail_id_seq'::regclass);
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY tipodocumento ALTER COLUMN id SET DEFAULT nextval('tipodocumento_id_seq'::regclass);
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY tipodocumentocaracteristica ALTER COLUMN id SET DEFAULT nextval('tipodocumentocaracteristica_id_seq'::regclass);
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY tipodocumentoplanoclassificacao ALTER COLUMN id SET DEFAULT nextval('tipodocumentoplanoclassificacao_id_seq'::regclass);
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY tipoprocesso ALTER COLUMN id SET DEFAULT nextval('tipoprocesso_id_seq'::regclass);
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY tipoprocessoplanoclassificacao ALTER COLUMN id SET DEFAULT nextval('tipoprocessoplanoclassificacao_id_seq'::regclass);
	
	
	--
	-- Name: id; Type: DEFAULT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY tramitardocumento ALTER COLUMN id SET DEFAULT nextval('tramitardocumento_id_seq'::regclass);
	
	--
	-- Name: acessoexterno_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('acessoexterno_id_seq', 1, false);
	
	
	--
	-- Name: acompanhamento_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('acompanhamento_id_seq', 1, false);
	
	
	--
	-- Name: anexoprocesso_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('anexoprocesso_id_seq', 1, false);
	
	
	--
	-- Name: assinatura_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('assinatura_id_seq', 1, false);
	
	--
	-- Name: assunto_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('assunto_id_seq', 1, false);
	
	--
	-- Name: blocoreuniao_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('blocoreuniao_id_seq', 1, false);
	
	
	
	--
	-- Name: cienciadocumento_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('cienciadocumento_id_seq', 1, false);
	
	
	--
	-- Name: cienciaprocesso_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('cienciaprocesso_id_seq', 1, false);
	
	--
	-- Name: configuracaoplanoclassificacao_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('configuracaoplanoclassificacao_id_seq', 1, false);
	
	
	--
	-- Name: configuracaosistemasigad_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('configuracaosistemasigad_id_seq', 1, false);
	
	
	--
	-- Name: configuracaousuario_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('configuracaousuario_id_seq', 1, false);
	
	
	--
	-- Name: destinatario_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('destinatario_id_seq', 1, false);
	
	--
	-- Name: documentoecm_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('documentoecm_id_seq', 1, false);
	
	
	--
	-- Name: documentofavorito_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('documentofavorito_id_seq', 1, false);
	
	
	--
	-- Name: enviodocumento_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('enviodocumento_id_seq', 1, false);
	
	--
	-- Name: hipoteselegal_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('hipoteselegal_id_seq', 1, false);
	
	
	--
	-- Name: historicoalteracaodocumento_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('historicoalteracaodocumento_id_seq', 1, false);
	
	
	--
	-- Name: historicoalteracaoprocesso_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('historicoalteracaoprocesso_id_seq', 1, false);
	
	
	--
	-- Name: interessadodocumento_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('interessadodocumento_id_seq', 1, false);
	
	
	--
	-- Name: interessadoprocesso_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('interessadoprocesso_id_seq', 1, false);
	
	--
	-- Name: nivelacessotipodocumento_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('nivelacessotipodocumento_id_seq', 1, false);
	
	
	--
	-- Name: nivelacessotipoprocesso_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('nivelacessotipoprocesso_id_seq', 1, false);
	
	--
	-- Name: nivelacessotiposigilo_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('nivelacessotiposigilo_id_seq', 1, false);
	
	
	--
	-- Name: permissao_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('permissao_id_seq', 1, false);
	
	
	--
	-- Name: planoclassificacao_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('planoclassificacao_id_seq', 1, false);
	
	
	--
	-- Name: processo_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('processo_id_seq', 1, false);
	
	
	--
	-- Name: sobrestar_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('sobrestar_id_seq', 1, false);
	
	
	--
	-- Name: templatedocumento_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('templatedocumento_id_seq', 1, false);
	
	
	--
	-- Name: templateemail_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('templateemail_id_seq', 1, false);
	
	
	--
	-- Name: tipodocumento_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('tipodocumento_id_seq', 1, false);
	
	
	--
	-- Name: tipodocumentocaracteristica_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('tipodocumentocaracteristica_id_seq', 1, false);
	
	--
	-- Name: tipodocumentoplanoclassificacao_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('tipodocumentoplanoclassificacao_id_seq', 1, false);
	
	
	
	--
	-- Name: tipoprocesso_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('tipoprocesso_id_seq', 1, false);
	
	
	--
	-- Name: tipoprocessoplanoclassificacao_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('tipoprocessoplanoclassificacao_id_seq', 1, false);
	
	
	--
	-- Name: tramitardocumento_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
	--
	
	SELECT pg_catalog.setval('tramitardocumento_id_seq', 1, false);
	
	
	--
	-- Name: acessoexterno_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY acessoexterno
	    ADD CONSTRAINT acessoexterno_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: acompanhamento_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY acompanhamento
	    ADD CONSTRAINT acompanhamento_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: anexoprocesso_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY anexoprocesso
	    ADD CONSTRAINT anexoprocesso_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: assinatura_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY assinatura
	    ADD CONSTRAINT assinatura_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: assunto_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY assunto
	    ADD CONSTRAINT assunto_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: blocoreuniao_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY blocoreuniao
	    ADD CONSTRAINT blocoreuniao_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: cienciadocumento_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY cienciadocumento
	    ADD CONSTRAINT cienciadocumento_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: cienciaprocesso_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY cienciaprocesso
	    ADD CONSTRAINT cienciaprocesso_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: configuracaoplanoclassificacao_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY configuracaoplanoclassificacao
	    ADD CONSTRAINT configuracaoplanoclassificacao_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: configuracaosistemasigad_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY configuracaosistemasigad
	    ADD CONSTRAINT configuracaosistemasigad_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: configuracaousuario_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY configuracaousuario
	    ADD CONSTRAINT configuracaousuario_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: destinatario_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY destinatario
	    ADD CONSTRAINT destinatario_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: documentoecm_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY documentoecm
	    ADD CONSTRAINT documentoecm_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: documentofavorito_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY documentofavorito
	    ADD CONSTRAINT documentofavorito_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: enviodocumento_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY enviodocumento
	    ADD CONSTRAINT enviodocumento_pkey PRIMARY KEY (id);
	
	--
	-- Name: hipoteselegal_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY hipoteselegal
	    ADD CONSTRAINT hipoteselegal_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: historicoalteracaodocumento_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY historicoalteracaodocumento
	    ADD CONSTRAINT historicoalteracaodocumento_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: historicoalteracaoprocesso_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY historicoalteracaoprocesso
	    ADD CONSTRAINT historicoalteracaoprocesso_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: interessadodocumento_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY interessadodocumento
	    ADD CONSTRAINT interessadodocumento_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: interessadoprocesso_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY interessadoprocesso
	    ADD CONSTRAINT interessadoprocesso_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: nivelacessotipodocumento_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY nivelacessotipodocumento
	    ADD CONSTRAINT nivelacessotipodocumento_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: nivelacessotipoprocesso_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY nivelacessotipoprocesso
	    ADD CONSTRAINT nivelacessotipoprocesso_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: nivelacessotiposigilo_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY nivelacessotiposigilo
	    ADD CONSTRAINT nivelacessotiposigilo_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: permissao_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY permissao
	    ADD CONSTRAINT permissao_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: planoclassificacao_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY planoclassificacao
	    ADD CONSTRAINT planoclassificacao_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: processo_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY processo
	    ADD CONSTRAINT processo_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: sobrestar_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY sobrestar
	    ADD CONSTRAINT sobrestar_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: templatedocumento_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY templatedocumento
	    ADD CONSTRAINT templatedocumento_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: templateemail_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY templateemail
	    ADD CONSTRAINT templateemail_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: tipodocumento_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY tipodocumento
	    ADD CONSTRAINT tipodocumento_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: tipodocumentocaracteristica_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY tipodocumentocaracteristica
	    ADD CONSTRAINT tipodocumentocaracteristica_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: tipodocumentoplanoclassificacao_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY tipodocumentoplanoclassificacao
	    ADD CONSTRAINT tipodocumentoplanoclassificacao_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: tipoprocesso_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY tipoprocesso
	    ADD CONSTRAINT tipoprocesso_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: tipoprocessoplanoclassificacao_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY tipoprocessoplanoclassificacao
	    ADD CONSTRAINT tipoprocessoplanoclassificacao_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: tramitardocumento_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
	--
	
	ALTER TABLE ONLY tramitardocumento
	    ADD CONSTRAINT tramitardocumento_pkey PRIMARY KEY (id);
	
	
	--
	-- Name: fk_11q6ibxpggcuu4p3w7vi1bd8s; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY processo
	    ADD CONSTRAINT fk_11q6ibxpggcuu4p3w7vi1bd8s FOREIGN KEY (assunto_id) REFERENCES assunto(id);
	
	
	--
	-- Name: fk_14gbsokde0li8macynbk3cxq7; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY templatedocumento
	    ADD CONSTRAINT fk_14gbsokde0li8macynbk3cxq7 FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_18b0rbqqhe3h9xy4gx0qjdns; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY tramitardocumento
	    ADD CONSTRAINT fk_18b0rbqqhe3h9xy4gx0qjdns FOREIGN KEY (documento_id) REFERENCES documentoecm(id);
	
	
	--
	-- Name: fk_19lhwc661vfqg4dedhtmgbruw; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY tipodocumentocaracteristica
	    ADD CONSTRAINT fk_19lhwc661vfqg4dedhtmgbruw FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_1aagv8ymq0cl6qbl90j3y3t2u; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY tipodocumento
	    ADD CONSTRAINT fk_1aagv8ymq0cl6qbl90j3y3t2u FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_1b1yik2d9nixr794rby4nbasw; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY templatedocumento
	    ADD CONSTRAINT fk_1b1yik2d9nixr794rby4nbasw FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_1c6focyxlluwk972lerekjkof; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY interessadoprocesso
	    ADD CONSTRAINT fk_1c6focyxlluwk972lerekjkof FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	--
	-- Name: fk_1gfqrjcot4wrslhcps1qsv4ph; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY configuracaousuario
	    ADD CONSTRAINT fk_1gfqrjcot4wrslhcps1qsv4ph FOREIGN KEY (configuracaosistemasigad_id) REFERENCES configuracaosistemasigad(id);
	
	
	--
	-- Name: fk_1nr90vd04es3opu4otc6da0u9; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY processo
	    ADD CONSTRAINT fk_1nr90vd04es3opu4otc6da0u9 FOREIGN KEY (nivelacesso_id) REFERENCES nivelacessotipoprocesso(id);
	
	
	--
	-- Name: fk_1ok8kn8gfsmx2fqf52uqdsqf3; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY documentoecm
	    ADD CONSTRAINT fk_1ok8kn8gfsmx2fqf52uqdsqf3 FOREIGN KEY (permissao_id) REFERENCES permissao(id);
	
	
	--
	-- Name: fk_1s7jkgn6innbmlxf3rjytckoh; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY documentofavorito
	    ADD CONSTRAINT fk_1s7jkgn6innbmlxf3rjytckoh FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_1werp3ad7vtj41ef84bu0fnw6; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY cienciadocumento
	    ADD CONSTRAINT fk_1werp3ad7vtj41ef84bu0fnw6 FOREIGN KEY (usuario_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_1xkft5vhki4i3nllg8s2vow4d; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY nivelacessotiposigilo
	    ADD CONSTRAINT fk_1xkft5vhki4i3nllg8s2vow4d FOREIGN KEY (nivelacessotipoprocesso_id) REFERENCES nivelacessotipoprocesso(id);
	
	
	--
	-- Name: fk_21vx58f35r7w1q1k7k129j69w; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY cienciaprocesso
	    ADD CONSTRAINT fk_21vx58f35r7w1q1k7k129j69w FOREIGN KEY (processo_id) REFERENCES processo(id);
	
	
	--
	-- Name: fk_22fl3cncs97uah8n4k0pqiau3; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY configuracaoplanoclassificacao
	    ADD CONSTRAINT fk_22fl3cncs97uah8n4k0pqiau3 FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_253cdebydo6tpaaslvnal6awt; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY blocoreuniao
	    ADD CONSTRAINT fk_253cdebydo6tpaaslvnal6awt FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_288fhq8ry3l1o3nx6m94xfct4; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY tipodocumentoplanoclassificacao
	    ADD CONSTRAINT fk_288fhq8ry3l1o3nx6m94xfct4 FOREIGN KEY (tipodocumento_id) REFERENCES tipodocumento(id);
	
	
	--
	-- Name: fk_2aylbba0alukvj2j6723i3mue; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY tramitardocumento
	    ADD CONSTRAINT fk_2aylbba0alukvj2j6723i3mue FOREIGN KEY (usuario_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_2j2k2mi3fxyryni6kv278yef9; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY nivelacessotipoprocesso
	    ADD CONSTRAINT fk_2j2k2mi3fxyryni6kv278yef9 FOREIGN KEY (tiposigilo_id) REFERENCES dominio(id);
	
	
	--
	-- Name: fk_2otqgyaa4gs9iv0vasyh32i6j; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY acessoexterno
	    ADD CONSTRAINT fk_2otqgyaa4gs9iv0vasyh32i6j FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_32hllv4ueil77uhhumfbvw5ql; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY configuracaosistemasigad
	    ADD CONSTRAINT fk_32hllv4ueil77uhhumfbvw5ql FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_38f61flfgiaxtnr0owkd69yq5; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY anexoprocesso
	    ADD CONSTRAINT fk_38f61flfgiaxtnr0owkd69yq5 FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_3odor9rpiotusyoyfhbymov40; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY destinatario
	    ADD CONSTRAINT fk_3odor9rpiotusyoyfhbymov40 FOREIGN KEY (documento_id) REFERENCES documentoecm(id);
	
	
	--
	-- Name: fk_3wlhfja32sxpvdvpr4cw8g8n5; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY nivelacessotipodocumento
	    ADD CONSTRAINT fk_3wlhfja32sxpvdvpr4cw8g8n5 FOREIGN KEY (tipodocumentoremocao_id) REFERENCES tipodocumento(id);
	
	
	--
	-- Name: fk_49pf48nb9h2srw4wovcgwhfo6; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY documentoecm
	    ADD CONSTRAINT fk_49pf48nb9h2srw4wovcgwhfo6 FOREIGN KEY (nivelacesso_id) REFERENCES dominio(id);
	
	
	--
	-- Name: fk_4htdg1pgx4yg0vguc4c5cktjq; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY hipoteselegal
	    ADD CONSTRAINT fk_4htdg1pgx4yg0vguc4c5cktjq FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_4uyy6pwvd452b60tygcr7s2qt; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY blocoreuniao
	    ADD CONSTRAINT fk_4uyy6pwvd452b60tygcr7s2qt FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_50p6yffuyqcupf6jgel7isg4p; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY nivelacessotipodocumento
	    ADD CONSTRAINT fk_50p6yffuyqcupf6jgel7isg4p FOREIGN KEY (nivelacesso_id) REFERENCES dominio(id);
	
	
	--
	-- Name: fk_54ikccosu61msf4os56l9fgh7; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY documentofavorito
	    ADD CONSTRAINT fk_54ikccosu61msf4os56l9fgh7 FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_5jfls01h162wrx5wu7n1alog8; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY tipodocumentocaracteristica
	    ADD CONSTRAINT fk_5jfls01h162wrx5wu7n1alog8 FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_5my3c3ampif4kgclr3nw4muou; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY nivelacessotipoprocesso
	    ADD CONSTRAINT fk_5my3c3ampif4kgclr3nw4muou FOREIGN KEY (tipoprocessoremocao_id) REFERENCES tipoprocesso(id);
	
	
	--
	-- Name: fk_61g9wo0ryg3fridqa90akave2; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY enviodocumento
	    ADD CONSTRAINT fk_61g9wo0ryg3fridqa90akave2 FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_6joqeygi6x883bhx3v572xte4; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY documentoecm
	    ADD CONSTRAINT fk_6joqeygi6x883bhx3v572xte4 FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_6ohhtpo40t2k3yk2kv1jqqg61; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY planoclassificacao
	    ADD CONSTRAINT fk_6ohhtpo40t2k3yk2kv1jqqg61 FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_6peuik9skdwqy4yb4opulrt16; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY acompanhamento
	    ADD CONSTRAINT fk_6peuik9skdwqy4yb4opulrt16 FOREIGN KEY (usuario_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_6rrrcjjdycfqu1bgnlty3nhha; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY configuracaoplanoclassificacao
	    ADD CONSTRAINT fk_6rrrcjjdycfqu1bgnlty3nhha FOREIGN KEY (tipotemporalidade_id) REFERENCES dominio(id);
	
	
	--
	-- Name: fk_6rtp4wvn6c9uea8wtx7dwyphx; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY sobrestar
	    ADD CONSTRAINT fk_6rtp4wvn6c9uea8wtx7dwyphx FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_6uu09ngf0jaoknq2wmchaxgdi; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY configuracaousuario
	    ADD CONSTRAINT fk_6uu09ngf0jaoknq2wmchaxgdi FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_6ytccmwvevj6rpl5ib0kuvh52; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY tramitardocumento
	    ADD CONSTRAINT fk_6ytccmwvevj6rpl5ib0kuvh52 FOREIGN KEY (unidade_id) REFERENCES estruturaorganizacional(id);
	
	
	--
	-- Name: fk_727tt9euqkqwy60yyml4mwes9; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY nivelacessotipodocumento
	    ADD CONSTRAINT fk_727tt9euqkqwy60yyml4mwes9 FOREIGN KEY (tiposigilo_id) REFERENCES dominio(id);
	
	
	--
	-- Name: fk_770cuyyolwdmg7nbl6oroiky6; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY nivelacessotipodocumento
	    ADD CONSTRAINT fk_770cuyyolwdmg7nbl6oroiky6 FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_7bhmyddir211bwhkdxs2dy2d3; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY planoclassificacao
	    ADD CONSTRAINT fk_7bhmyddir211bwhkdxs2dy2d3 FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_7ljtujdsi7emxhym9shsketu; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY processo
	    ADD CONSTRAINT fk_7ljtujdsi7emxhym9shsketu FOREIGN KEY (anexoprocesso_id) REFERENCES anexoprocesso(id);
	
	
	--
	-- Name: fk_7ndyk1vgeheb9x15bnfd656kb; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY processo
	    ADD CONSTRAINT fk_7ndyk1vgeheb9x15bnfd656kb FOREIGN KEY (cienciaprocesso_id) REFERENCES cienciaprocesso(id);
	
	
	--
	-- Name: fk_7yecychvupf085jtp46p14cdc; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY anexoprocesso
	    ADD CONSTRAINT fk_7yecychvupf085jtp46p14cdc FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_80a43wipkf8ktuik855jcuf1g; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY tramitardocumento
	    ADD CONSTRAINT fk_80a43wipkf8ktuik855jcuf1g FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_83m8s7jo835txv7vi5nuj7h0r; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY permissao
	    ADD CONSTRAINT fk_83m8s7jo835txv7vi5nuj7h0r FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_85itvajuplm4qr459hj2aama4; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY templatedocumento
	    ADD CONSTRAINT fk_85itvajuplm4qr459hj2aama4 FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_85nqm6bicdo9lv3pc3lwmtbf; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY interessadoprocesso
	    ADD CONSTRAINT fk_85nqm6bicdo9lv3pc3lwmtbf FOREIGN KEY (interessado_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_8pko4l5pifgk49jdphspkoy8j; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY historicoalteracaodocumento
	    ADD CONSTRAINT fk_8pko4l5pifgk49jdphspkoy8j FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_8qg35u71yvldoldk7d346gfk2; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY assinatura
	    ADD CONSTRAINT fk_8qg35u71yvldoldk7d346gfk2 FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_8t9dmm2fxd6inghx9b8l7x8bd; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY nivelacessotiposigilo
	    ADD CONSTRAINT fk_8t9dmm2fxd6inghx9b8l7x8bd FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_8u1bncwyo4mj8dtj2d431bo8w; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY tipodocumentoplanoclassificacao
	    ADD CONSTRAINT fk_8u1bncwyo4mj8dtj2d431bo8w FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_926dg5aorg94f67mry756w2du; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY tipodocumentoplanoclassificacao
	    ADD CONSTRAINT fk_926dg5aorg94f67mry756w2du FOREIGN KEY (planoclassificacao_id) REFERENCES planoclassificacao(id);
	
	
	--
	-- Name: fk_95reld3lyym0yfn1lk3kkii4c; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY interessadodocumento
	    ADD CONSTRAINT fk_95reld3lyym0yfn1lk3kkii4c FOREIGN KEY (interessado_id) REFERENCES seguranca_usuario(id);
	
	
	--
	-- Name: fk_9e2s0huditm90ntuhbyls3efp; Type: FK CONSTRAINT; Schema: public; Owner: postgres
	--
	
	ALTER TABLE ONLY anexoprocesso
	    ADD CONSTRAINT fk_9e2s0huditm90ntuhbyls3efp FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	
	ALTER TABLE ONLY cienciaprocesso
	    ADD CONSTRAINT fk_9fy50b641s85bvhkje5tsqkjk FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY documentoecm
	    ADD CONSTRAINT fk_9kvt9c190sl2s2jlhelue07k3 FOREIGN KEY (anexo_id) REFERENCES anexo(id);
	
	ALTER TABLE ONLY enviodocumento
	    ADD CONSTRAINT fk_9oapa40n04sud9q0vi02jo7u0 FOREIGN KEY (documento_id) REFERENCES documentoecm(id);
	
	ALTER TABLE ONLY acessoexterno
	    ADD CONSTRAINT fk_9psy22lxvdticmsulroqybr3c FOREIGN KEY (processo_id) REFERENCES processo(id);
	
	
	ALTER TABLE ONLY destinatario
	    ADD CONSTRAINT fk_9vx0mvqlrkj3ec8956jir3yqt FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY interessadodocumento
	    ADD CONSTRAINT fk_9xyqhq8xyb6tys2v7t2csubi6 FOREIGN KEY (documento_id) REFERENCES documentoecm(id);
	
	
	ALTER TABLE ONLY enviodocumento
	    ADD CONSTRAINT fk_a0itm3w45v819rbrshipdnhkg FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY sobrestar
	    ADD CONSTRAINT fk_a9es6jyj0qavet8smbqyhg6ew FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	
	ALTER TABLE ONLY cienciaprocesso
	    ADD CONSTRAINT fk_acda7b9ug4d0plr7www0rdg1u FOREIGN KEY (usuario_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY configuracaousuario
	    ADD CONSTRAINT fk_b2ni7vxdrlhiuwse2bkjngy0x FOREIGN KEY (unidade_id) REFERENCES estruturaorganizacional(id);
	
	ALTER TABLE ONLY nivelacessotipoprocesso
	    ADD CONSTRAINT fk_bejee2c370w4xg8tdgkokanna FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY templateemail
	    ADD CONSTRAINT fk_bt5l3qqj4q5imuxkerdtnobge FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	
	ALTER TABLE ONLY configuracaousuario
	    ADD CONSTRAINT fk_c0903p0w5n8i8vyh8s7diohi2 FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY enviodocumento
	    ADD CONSTRAINT fk_cbxwl3nmyimmo2xa8c3m5d2rg FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY assinatura
	    ADD CONSTRAINT fk_cgnnc42albuejj6cs99b8k2g6 FOREIGN KEY (usuario_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY cienciadocumento
	    ADD CONSTRAINT fk_cgonm9w723i52cvs7i6pxb1yy FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY processo
	    ADD CONSTRAINT fk_cjalmdbntj46pjxpyti02gfcp FOREIGN KEY (unidade_id) REFERENCES estruturaorganizacional(id);
	
	
	ALTER TABLE ONLY acessoexterno
	    ADD CONSTRAINT fk_ckd592ypbh7mq0u3g2u8a7dsl FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	
	ALTER TABLE ONLY historicoalteracaodocumento
	    ADD CONSTRAINT fk_con6lk9ssbjv11uvt2wqdsvp6 FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	
	ALTER TABLE ONLY interessadodocumento
	    ADD CONSTRAINT fk_ct22o0ssf2wrfls71kv63rg75 FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY assunto
	    ADD CONSTRAINT fk_cv9xwwbdb7at06sww1wa0y7qf FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY acompanhamento
	    ADD CONSTRAINT fk_d0iajr6um3ca1ly4yq0y87881 FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY assunto
	    ADD CONSTRAINT fk_d32bagtmhsw1hneq1dtxuqk8t FOREIGN KEY (planoclassificacao_id) REFERENCES planoclassificacao(id);
	
	ALTER TABLE ONLY nivelacessotipoprocesso
	    ADD CONSTRAINT fk_d81drbe5na3crob6y9lqoqx4n FOREIGN KEY (tipoprocesso_id) REFERENCES tipoprocesso(id);
	
	ALTER TABLE ONLY cienciaprocesso
	    ADD CONSTRAINT fk_d9fwhfvnbeycnkye77hpj6tp9 FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY tipodocumentoplanoclassificacao
	    ADD CONSTRAINT fk_ddunxrw7tyx56hay1wy4fqkij FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	
	ALTER TABLE ONLY permissao
	    ADD CONSTRAINT fk_dow5qygjxorcwbx6rd84bqioa FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY destinatario
	    ADD CONSTRAINT fk_doye4ep4cakyqxnnwcy2d0tiv FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY tipodocumento
	    ADD CONSTRAINT fk_dumro1mutn3igd3ddo6yw2lq2 FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY nivelacessotipoprocesso
	    ADD CONSTRAINT fk_duvd3ec3tagg1f59hk5k43h8m FOREIGN KEY (nivelacesso_id) REFERENCES dominio(id);
	
	ALTER TABLE ONLY tipoprocessoplanoclassificacao
	    ADD CONSTRAINT fk_e1py8wt3hrdn9lw8qmqn6t62e FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY planoclassificacao
	    ADD CONSTRAINT fk_e58suw19da1lt479cx3n7p564 FOREIGN KEY (organizacao_id) REFERENCES organizacao(id);
	
	ALTER TABLE ONLY tipodocumento
	    ADD CONSTRAINT fk_e6ymlrs3okvmjih40x1bjhw4n FOREIGN KEY (formacriacao_id) REFERENCES dominio(id);
	
	
	ALTER TABLE ONLY planoclassificacao
	    ADD CONSTRAINT fk_e9wi69j5w19s00mwgp3r8elq6 FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY configuracaosistemasigad
	    ADD CONSTRAINT fk_ea0isio03ir5ls7mcr2vjmypa FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY nivelacessotipoprocesso
	    ADD CONSTRAINT fk_ebglx9t075myubjfux6k5oqa4 FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY historicoalteracaodocumento
	    ADD CONSTRAINT fk_er7gjhwiwwy1t3v20svxe21td FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY tipoprocesso
	    ADD CONSTRAINT fk_ev7uut0q9ec3b8ypdyiydu68p FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY permissao
	    ADD CONSTRAINT fk_fe198xuadbk3s9y1grcl6d5xh FOREIGN KEY (tipopermissao_id) REFERENCES dominio(id);
	
	ALTER TABLE ONLY acompanhamento
	    ADD CONSTRAINT fk_ffrpbl6nr25ghtvqmsne7n7am FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY tipodocumentocaracteristica
	    ADD CONSTRAINT fk_fo4g820gdh8gf3f2d30p851v9 FOREIGN KEY (tipodocumento_id) REFERENCES tipodocumento(id);
	
	ALTER TABLE ONLY permissao
	    ADD CONSTRAINT fk_fywuy494vca3qhj3wi6c8tquu FOREIGN KEY (usuario_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY nivelacessotipodocumento
	    ADD CONSTRAINT fk_g3y13h4y8oqgrh2ghegc41cfm FOREIGN KEY (tipodocumento_id) REFERENCES tipodocumento(id);
	
	ALTER TABLE ONLY documentoecm
	    ADD CONSTRAINT fk_gvl8456u0kfblh45sdj2g112b FOREIGN KEY (tipodocumento_id) REFERENCES tipodocumento(id);
	
	
	ALTER TABLE ONLY acompanhamento
	    ADD CONSTRAINT fk_h6bfrrv12nyeh62jpuwb550e5 FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY destinatario
	    ADD CONSTRAINT fk_h73xj7bj95y45nirv54q1sbs1 FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY nivelacessotiposigilo
	    ADD CONSTRAINT fk_h9299p22j1bjmu3s2lejqp4ks FOREIGN KEY (tiposigilo_id) REFERENCES dominio(id);
	
	ALTER TABLE ONLY tipodocumento
	    ADD CONSTRAINT fk_hclibchys4a3rkl8igxxl6ra1 FOREIGN KEY (hipoteselegal_id) REFERENCES hipoteselegal(id);
	
	ALTER TABLE ONLY templateemail
	    ADD CONSTRAINT fk_he1t34g6emf5dgk46pguqj93a FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY tipoprocessoplanoclassificacao
	    ADD CONSTRAINT fk_hh6so963kw5j5xsnvfriprlal FOREIGN KEY (tipoprocesso_id) REFERENCES tipoprocesso(id);
	
	ALTER TABLE ONLY templateemail
	    ADD CONSTRAINT fk_hnviel70bwan6oh8ygri0jfma FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY processo
	    ADD CONSTRAINT fk_hue5sup9i72ie58eh7sud090j FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY blocoreuniao
	    ADD CONSTRAINT fk_i46v7aou6afflq3byt0tiinjx FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY assunto
	    ADD CONSTRAINT fk_ikvrqbeq8cg3fb5mljhs4nrdu FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY configuracaoplanoclassificacao
	    ADD CONSTRAINT fk_iotyal41wwhe31gc5g9q8f3qy FOREIGN KEY (planoclassificacao_id) REFERENCES planoclassificacao(id);
	
	ALTER TABLE ONLY templatedocumento
	    ADD CONSTRAINT fk_iwg86mn5ubl524myo0m9q4mou FOREIGN KEY (tipodocumento_id) REFERENCES tipodocumento(id);
	
	ALTER TABLE ONLY tipoprocessoplanoclassificacao
	    ADD CONSTRAINT fk_jeew26yxsj2v3pbb8jjpis3ac FOREIGN KEY (planoclassificacao_id) REFERENCES planoclassificacao(id);
	
	ALTER TABLE ONLY processo
	    ADD CONSTRAINT fk_jej72wrc3307lq17bbraocnqu FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY documentoecm
	    ADD CONSTRAINT fk_jpft3bnbmyc189q0rq1i7sfj FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY configuracaousuario
	    ADD CONSTRAINT fk_jt8k605utrxki79jp3h9donfb FOREIGN KEY (usuario_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY planoclassificacao
	    ADD CONSTRAINT fk_kepelyhtsupbcoy9dgaeqtvpi FOREIGN KEY (tipodestinacao_id) REFERENCES dominio(id);
	
	ALTER TABLE ONLY hipoteselegal
	    ADD CONSTRAINT fk_kj53mif1bu65of0q2xq5i43t6 FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY interessadoprocesso
	    ADD CONSTRAINT fk_kkasafdl28rkr6rqbbo5lylwm FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY tipodocumento
	    ADD CONSTRAINT fk_kkok8py0f5yl7fj2wge8xwrnw FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY historicoalteracaodocumento
	    ADD CONSTRAINT fk_km4f1x1wqbnv903iapbemo5km FOREIGN KEY (documento_id) REFERENCES documentoecm(id);
	
	ALTER TABLE ONLY acessoexterno
	    ADD CONSTRAINT fk_l7g9xjfmd3ck2lvncq4bvaah3 FOREIGN KEY (documento_id) REFERENCES documentoecm(id);
	
	ALTER TABLE ONLY processo
	    ADD CONSTRAINT fk_l832jvdhjicoxtc41wgwokma5 FOREIGN KEY (hipoteselegal_id) REFERENCES hipoteselegal(id);
	
	ALTER TABLE ONLY assinatura
	    ADD CONSTRAINT fk_l94d568l8paf16syu7vkpkarn FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY sobrestar
	    ADD CONSTRAINT fk_lfhepkvbxbopgwt4rgvygcqxw FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY planoclassificacao
	    ADD CONSTRAINT fk_lieqdrr5c6psievj9m94qq1ue FOREIGN KEY (planoclassificacaoparent_id) REFERENCES planoclassificacao(id);
	
	
	ALTER TABLE ONLY nivelacessotipodocumento
	    ADD CONSTRAINT fk_lr0n4aly4dxo07ixiu9139kg7 FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	
	ALTER TABLE ONLY documentoecm
	    ADD CONSTRAINT fk_lu9v933xru0b6mc2schk9jbp3 FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY historicoalteracaoprocesso
	    ADD CONSTRAINT fk_m5feeqtg1psj308aq8v044m72 FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY cienciadocumento
	    ADD CONSTRAINT fk_m9rpk39fs9vjgeev3tfihba6d FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY configuracaoplanoclassificacao
	    ADD CONSTRAINT fk_mdajasq6cdkkpsqycwu1ij7ni FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY processo
	    ADD CONSTRAINT fk_mrbgf61h3siclagdqwdkrghr9 FOREIGN KEY (tramitardocumento_id) REFERENCES tramitardocumento(id);
	
	ALTER TABLE ONLY tipoprocesso
	    ADD CONSTRAINT fk_mww6c312vwk0i1irk62yolure FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY assinatura
	    ADD CONSTRAINT fk_mx6gs4q5hd4j0mtncduoqtlmh FOREIGN KEY (documento_id) REFERENCES documentoecm(id);
	
	ALTER TABLE ONLY tipoprocesso
	    ADD CONSTRAINT fk_n5t1usn1bsal51d26ufhs68s9 FOREIGN KEY (hipoteselegal_id) REFERENCES hipoteselegal(id);
	
	ALTER TABLE ONLY acessoexterno
	    ADD CONSTRAINT fk_necmlwic7puwf0bq7anhhrhx8 FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY historicoalteracaoprocesso
	    ADD CONSTRAINT fk_njh6olrkug1dfkgku214eeqy FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY documentofavorito
	    ADD CONSTRAINT fk_nqst590nus3ajbugtt9qghmuf FOREIGN KEY (documento_id) REFERENCES documentoecm(id);
	
	ALTER TABLE ONLY nivelacessotiposigilo
	    ADD CONSTRAINT fk_ns5mk8042wpbq9h8rbvfcl7rh FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY processo
	    ADD CONSTRAINT fk_numldtb0i4xgv0f02pjpvq07k FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY tipoprocesso
	    ADD CONSTRAINT fk_nxa84yv0rxw4rio0priekv5r7 FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY cienciadocumento
	    ADD CONSTRAINT fk_o3o1hw28oqsd0x7q9xxhp196m FOREIGN KEY (documento_id) REFERENCES documentoecm(id);
	
	ALTER TABLE ONLY nivelacessotipoprocesso
	    ADD CONSTRAINT fk_o598yc8i9h6bke04j10dcal62 FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY configuracaoplanoclassificacao
	    ADD CONSTRAINT fk_o873aejmeg6fpxkhkvkwnampx FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY configuracaousuario
	    ADD CONSTRAINT fk_o89lfhx8lsj7vonduw7imlha5 FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	
	ALTER TABLE ONLY documentofavorito
	    ADD CONSTRAINT fk_o98m8t1vgb570mmxl01fqp6pf FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY acompanhamento
	    ADD CONSTRAINT fk_o98ojm3rlfmmmu9d2kv3vsv3m FOREIGN KEY (processo_id) REFERENCES processo(id);
	
	ALTER TABLE ONLY interessadodocumento
	    ADD CONSTRAINT fk_om4i0g3g687rley1kaoe2p85q FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	
	ALTER TABLE ONLY tramitardocumento
	    ADD CONSTRAINT fk_oslt0j8wmu1iuto29citxifi4 FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	
	ALTER TABLE ONLY configuracaosistemasigad
	    ADD CONSTRAINT fk_p0lrr3axwltatuusyd2uww3p3 FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY documentoecm
	    ADD CONSTRAINT fk_p5d2ck6dsriivel0vdw79vyn4 FOREIGN KEY (tramitardocumento_id) REFERENCES tramitardocumento(id);
	
	
	ALTER TABLE ONLY destinatario
	    ADD CONSTRAINT fk_panih9w8ivdt9ghml574qngvl FOREIGN KEY (pessoa_id) REFERENCES pessoa(id);
	
	ALTER TABLE ONLY historicoalteracaoprocesso
	    ADD CONSTRAINT fk_paqeoc3gv7wh5ypfwrphjb9hc FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY documentoecm
	    ADD CONSTRAINT fk_pd4615a85jpp7nd99q2i4a1dn FOREIGN KEY (processo_id) REFERENCES processo(id);
	
	ALTER TABLE ONLY processo
	    ADD CONSTRAINT fk_pnq9o77mwhvudke80mraho7rk FOREIGN KEY (status_id) REFERENCES dominio(id);
	
	ALTER TABLE ONLY nivelacessotipodocumento
	    ADD CONSTRAINT fk_pyf11gne0bf5s385iduqxmjl7 FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY interessadodocumento
	    ADD CONSTRAINT fk_q1qynccdst5xlssbnjpu3e6sp FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY tipoprocessoplanoclassificacao
	    ADD CONSTRAINT fk_q7xw3763xaplxs0hxagi09j9i FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY tipodocumentocaracteristica
	    ADD CONSTRAINT fk_qdrv4fhvkj34sttqvciv8mrhg FOREIGN KEY (caracteristica_id) REFERENCES caracteristica(id);
	
	ALTER TABLE ONLY interessadoprocesso
	    ADD CONSTRAINT fk_qioewpf6meu8o5kp77l8ncai3 FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY interessadoprocesso
	    ADD CONSTRAINT fk_qm1ubht2ekr70fi5upmdkl3oh FOREIGN KEY (processo_id) REFERENCES processo(id);
	
	ALTER TABLE ONLY tipoprocessoplanoclassificacao
	    ADD CONSTRAINT fk_qxxp0xg91jp6wbhmlxu0u2e82 FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	
	ALTER TABLE ONLY tipodocumentocaracteristica
	    ADD CONSTRAINT fk_qyurt1kkpx34wtiaalg44guqr FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY tramitardocumento
	    ADD CONSTRAINT fk_r3widign80ljm6va0fot5nekw FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY configuracaoplanoclassificacao
	    ADD CONSTRAINT fk_rcqv4ug5pi306ode2tj5bx4w FOREIGN KEY (tipodestinacao_id) REFERENCES dominio(id);
	
	ALTER TABLE ONLY cienciadocumento
	    ADD CONSTRAINT fk_rmiltfsmru80002aey46e7f28 FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY documentoecm
	    ADD CONSTRAINT fk_rp3oykhk2y3c88buxb935vrsa FOREIGN KEY (hipoteselegal_id) REFERENCES hipoteselegal(id);
	
	ALTER TABLE ONLY documentoecm
	    ADD CONSTRAINT fk_s1dnuxbmtisvik3mo5li5gtus FOREIGN KEY (status_id) REFERENCES dominio(id);
	
	
	ALTER TABLE ONLY assinatura
	    ADD CONSTRAINT fk_s6ows140tas2oak44aonm12p9 FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY assunto
	    ADD CONSTRAINT fk_s6tkccewjwtpf8nowvalykplr FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY permissao
	    ADD CONSTRAINT fk_sdeh7vuikkj2g1vrlqdhf2u9i FOREIGN KEY (autor_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY nivelacessotiposigilo
	    ADD CONSTRAINT fk_sforj2c22mwel8ugwmch2fg09 FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	ALTER TABLE ONLY cienciaprocesso
	    ADD CONSTRAINT fk_sly29g5ikn6tb1qohy8jl0wt4 FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	
	ALTER TABLE ONLY hipoteselegal
	    ADD CONSTRAINT fk_swskcd6pqtg84whkdht27bh28 FOREIGN KEY (editor_id) REFERENCES seguranca_usuario(id);
	
	
	ALTER TABLE ONLY tipodocumentoplanoclassificacao
	    ADD CONSTRAINT fk_t9vsla33qssau6xdwsrf2vs2q FOREIGN KEY (inativador_id) REFERENCES seguranca_usuario(id);
	
	
	ALTER TABLE ONLY historicoalteracaoprocesso
	    ADD CONSTRAINT fk_tafq70dsj8xe9muf0k7ftm7h0 FOREIGN KEY (processo_id) REFERENCES processo(id);
	
	ALTER TABLE ONLY processo
	    ADD CONSTRAINT fk_tl1s47386d1y1jrlpq51ctl6k FOREIGN KEY (tipoprocesso_id) REFERENCES tipoprocesso(id);
	
	ALTER TABLE ONLY permissao
	    ADD CONSTRAINT fk_tmjfk5n4dny1noclgnfl9007o FOREIGN KEY (documento_id) REFERENCES documentoecm(id);
	
-----Script alteração tabela tipoDocumentoPlanoClassificacao 19/11/2015 -----
	    
	    ALTER TABLE tipodocumentoplanoclassificacao  RENAME TO tpdocumentoplanoclassificacao 