package br.com.centralit.controller;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import br.com.centralit.api.model.EstruturaOrganizacional;
import br.com.centralit.api.model.EstruturaOrganizacionalECM;
import br.com.centralit.api.service.EstruturaOrganizacionalECMService;
import br.com.centralit.api.service.EstruturaOrganizacionalService;
import br.com.centralit.framework.controller.GenericController;
import br.com.centralit.framework.json.ResponseBodyWrapper;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.view.ResultResponseVH;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 14/12/2015 - 09:32:20
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Controller
@RequestMapping("/rest/estruturaOrganizacionalECM")
public class EstruturaOrganizacionalECMController extends GenericController<EstruturaOrganizacionalECM> {

	/** Atributo estruturaOrganizacionalECMService. */
	private EstruturaOrganizacionalECMService estruturaOrganizacionalECMService;

	@Autowired
	private EstruturaOrganizacionalService estruturaOrganizacionalService;

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * 
	 * @param estruturaOrganizacionalECMService
	 */
	@Autowired
	public EstruturaOrganizacionalECMController( EstruturaOrganizacionalECMService estruturaOrganizacionalECMService ) {

		super(estruturaOrganizacionalECMService);

		this.estruturaOrganizacionalECMService = estruturaOrganizacionalECMService;
	}

	/**
	 * 
	 */
	@RequestMapping(value = "/getByEstruturaOrganizacional", method = RequestMethod.GET)
	@ResponseBody
	public ResponseBodyWrapper getObject(@RequestParam(value = "idEstruturaOrganizacional") String idEstruturaOrganizacional) {

		EstruturaOrganizacional estruturaOrganizacional = this.estruturaOrganizacionalService.find(Long.parseLong(idEstruturaOrganizacional));

		EstruturaOrganizacionalECM estruturaEcm = this.estruturaOrganizacionalECMService.obterPorIdEstruturaOrganizacional(estruturaOrganizacional.getId());

		if (estruturaEcm == null && estruturaOrganizacional != null) {
			estruturaEcm = new EstruturaOrganizacionalECM();
			estruturaEcm.setEstruturaOrganizacional(estruturaOrganizacional);
		}

		ResultResponseVH<EstruturaOrganizacionalECM> resultResponseVH = new ResultResponseVH<EstruturaOrganizacionalECM>(estruturaEcm);

		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(resultResponseVH, this.getEditView());

		return responseBody;
	}

	@RequestMapping(value = "/findPorNomeEstruturaOrganizacional", method = RequestMethod.GET, produces = "application/json")
	@ResponseBody
	public ResponseBodyWrapper findPorNomeEstruturaOrganizacional(@RequestParam(value = "nome") String nome) {

		final List<EstruturaOrganizacionalECM> list = this.estruturaOrganizacionalECMService.findPorNomeEstruturaOrganizacional(nome);

		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(list, Views.EstruturaOrganizacionalECMEditView.class);

		return responseBody;
	}

	@Override
	public Class<Views.EstruturaOrganizacionalECMEditView> getEditView() {

		return Views.EstruturaOrganizacionalECMEditView.class;
	}

}
