package br.com.centralit.controller;

import java.util.Collection;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import br.com.centralit.api.model.Colaborador;
import br.com.centralit.api.model.HistoricoCredencialProcesso;
import br.com.centralit.api.service.HistoricoCredencialProcessoService;
import br.com.centralit.framework.controller.GenericController;
import br.com.centralit.framework.json.ResponseBodyWrapper;
import br.com.centralit.framework.json.Views;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 11/03/2016 - 15:51:49
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Controller
@RequestMapping("/rest/historicoCredencialProcesso")
public class HistoricoCredencialProcessoController extends GenericController<HistoricoCredencialProcesso> {

	private HistoricoCredencialProcessoService historicoCredencialProcessoService;

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * 
	 * @param historicoCredencialProcessoService
	 */
	@Autowired
	public HistoricoCredencialProcessoController( HistoricoCredencialProcessoService historicoCredencialProcessoService ) {

		super(historicoCredencialProcessoService);

		this.historicoCredencialProcessoService = historicoCredencialProcessoService;

	}

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por listar através do id do processo e processoRemocao
	 * 
	 * @author rogerio.costa
	 * 
	 * @param idProcesso
	 * 
	 * @return Collection<HistoricoCredencialProcesso>
	 */

	@RequestMapping(value = "/findByIdProcessoAndIdProcessoRemocao", method = RequestMethod.GET, produces = "application/json")
	@ResponseBody
	public ResponseBodyWrapper findByIdProcessoAndIdProcessoRemocao(@RequestParam(value = "idProcesso") Long idProcesso) {

		final Collection<HistoricoCredencialProcesso> lista = this.historicoCredencialProcessoService.findByIdProcessoAndIdProcessoRemocao(idProcesso);

		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(lista, Views.HistoricoCredencialProcesso.class);

		return responseBody;
	}

	@Override
	public Class<Views.HistoricoCredencialProcesso> getEditView() {

		return Views.HistoricoCredencialProcesso.class;
	}

}
