package br.com.centralit.controller;

import java.util.Collection;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import br.com.centralit.api.model.JustificativaAcaoProcesso;
import br.com.centralit.api.service.JustificativaAcaoProcessoService;
import br.com.centralit.framework.controller.GenericController;
import br.com.centralit.framework.json.ResponseBodyWrapper;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.view.ResultResponseVH;




/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 08/02/2016 - 10:16:04
 *
 * @version 1.0.0
 *
 * @author Maycon
 *	
 */
@Controller
@RequestMapping("/rest/justificativaAcaoProcesso")
public class JustificativaAcaoProcessoController extends GenericController<JustificativaAcaoProcesso> {

	/** Atributo justificativaAcaoProcessoService. */
	private JustificativaAcaoProcessoService justificativaAcaoProcessoService;

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * 
	 * @param justificativaAcaoProcessoService
	 */
	@Autowired
	public JustificativaAcaoProcessoController( JustificativaAcaoProcessoService justificativaAcaoProcessoService ) {

		super(justificativaAcaoProcessoService);

		this.justificativaAcaoProcessoService = justificativaAcaoProcessoService;
	}
	
	
	@RequestMapping(value = "/listByIdProcesso", method = RequestMethod.GET, produces = "application/json")
	@ResponseBody
	public ResponseBodyWrapper listByIdProcesso(@RequestParam(value = "idProcesso") Long idProcesso) {

		ResultResponseVH<Collection<JustificativaAcaoProcesso>> resultResponseVH = new ResultResponseVH<Collection<JustificativaAcaoProcesso>>(this.justificativaAcaoProcessoService.listByIdProcesso(idProcesso));

		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(resultResponseVH, Views.JustificativaAcaoProcessoView.class);

		return responseBody;
	}
	

	@Override
	public Class<Views.JustificativaAcaoProcessoView> getEditView() {

		return Views.JustificativaAcaoProcessoView.class;
	}

}
