package br.com.centralit.controller;

import java.util.Collection;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import br.com.centralit.api.framework.json.ViewsEcm;
import br.com.centralit.api.model.NivelAcessoTipoDocumento;
import br.com.centralit.api.service.NivelAcessoTipoDocumentoService;
import br.com.centralit.framework.controller.GenericController;
import br.com.centralit.framework.json.ResponseBodyWrapper;
import br.com.centralit.framework.view.ResultResponseVH;

@Controller
@RequestMapping("/rest/nivelAcessoTipoDocumento")
public class NivelAcessoTipoDocumentoController extends GenericController<NivelAcessoTipoDocumento>{
	
	private NivelAcessoTipoDocumentoService nivelAcessoTipoDocumentoService;

	@Autowired
	public NivelAcessoTipoDocumentoController(NivelAcessoTipoDocumentoService nivelAcessoTipoDocumentoService) {
		super(nivelAcessoTipoDocumentoService);
		this.nivelAcessoTipoDocumentoService = nivelAcessoTipoDocumentoService;
	}
	
	
	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por listar por id do tipoDocumento
	 *
	 * @author maycon.silva
	 *
	 * @param idTipoDocumento
	 * @return
	 */
	@RequestMapping(value = "/findPorIdTipoDocumento", method = RequestMethod.GET, produces = "application/json")
	@ResponseBody
	public ResponseBodyWrapper findPorIdTipoDocumento(@RequestParam(value = "idTipoDocumento" ) Long idTipoDocumento) {

		ResultResponseVH<Collection<NivelAcessoTipoDocumento>> resultResponseVH = new ResultResponseVH<Collection<NivelAcessoTipoDocumento>>(this.nivelAcessoTipoDocumentoService.findPorIdTipoDocumento(idTipoDocumento));

		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(resultResponseVH, ViewsEcm.NivelAcessoTipoDocumentoEdit.class);

		return responseBody;
	}
	
	
	/**
	 * 
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por
	 *
	 * @author andre.silva
	 *
	 * @return
	 */
	@RequestMapping(value = "/findAllNivelAcesso", method = RequestMethod.GET, produces = "application/json")
	@ResponseBody
	public ResponseBodyWrapper findAllNivelAcesso() {

		ResultResponseVH<Collection<NivelAcessoTipoDocumento>> resultResponseVH = new ResultResponseVH<Collection<NivelAcessoTipoDocumento>>(this.nivelAcessoTipoDocumentoService.findAll());

		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(resultResponseVH, ViewsEcm.NivelAcessoTipoDocumentoEdit.class);

		return responseBody;
	}

}
