package br.com.centralit.controller;

import java.util.Collection;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import br.com.centralit.api.framework.json.ViewsEcm;
import br.com.centralit.api.model.NivelAcessoTipoProcesso;
import br.com.centralit.api.service.NivelAcessoTipoProcessoService;
import br.com.centralit.framework.controller.GenericController;
import br.com.centralit.framework.json.ResponseBodyWrapper;
import br.com.centralit.framework.view.ResultResponseVH;

@Controller
@RequestMapping("/rest/nivelAcessoTipoProcesso")
public class NivelAcessoTipoProcessoController extends GenericController<NivelAcessoTipoProcesso>{
	
	private NivelAcessoTipoProcessoService nivelAcessoTipoProcessoService;

	@Autowired
	public NivelAcessoTipoProcessoController(NivelAcessoTipoProcessoService nivelAcessoTipoProcessoService) {
		super(nivelAcessoTipoProcessoService);
		this.nivelAcessoTipoProcessoService = nivelAcessoTipoProcessoService;
	}
	
	
	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por listar por id do tipoProcesso
	 *
	 * @author maycon.silva
	 *
	 * @param idTipoDocumento
	 * @return
	 */
	@RequestMapping(value = "/findPorIdTipoProcesso", method = RequestMethod.GET, produces = "application/json")
	@ResponseBody
	public ResponseBodyWrapper findPorIdTipoProcesso(@RequestParam(value = "idTipoProcesso" ) Long idTipoProcesso) {

		ResultResponseVH<Collection<NivelAcessoTipoProcesso>> resultResponseVH = new ResultResponseVH<Collection<NivelAcessoTipoProcesso>>(this.nivelAcessoTipoProcessoService.findPorIdTipoProcesso(idTipoProcesso));

		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(resultResponseVH, ViewsEcm.NivelAcessoTipoProcessoEdit.class);

		return responseBody;
	}

}
