package br.com.centralit.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import br.com.centralit.api.model.ProcessoRelacionado;
import br.com.centralit.api.service.ProcessoRelacionadoService;
import br.com.centralit.api.viewHelper.ProcessoRelacionadoVH;
import br.com.centralit.framework.controller.GenericController;
import br.com.centralit.framework.json.ResponseBodyWrapper;
import br.com.centralit.framework.json.Views;

@Controller
@RequestMapping("/rest/processoRelacionado")
public class ProcessoRelacionadoController extends GenericController<ProcessoRelacionado> {

	/** Atributo processoRelacionadoService. */
	public ProcessoRelacionadoService processoRelacionadoService;

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * 
	 * @param processoRelacionadoService
	 */
	@Autowired
	public ProcessoRelacionadoController( ProcessoRelacionadoService processoRelacionadoService ) {

		super(processoRelacionadoService);
		this.processoRelacionadoService = processoRelacionadoService;
	}

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por
	 * 
	 * @author maycon.silva
	 * 
	 * @param processoRelacionadoVH
	 * @return
	 * @throws Exception
	 */
	@RequestMapping(method = RequestMethod.POST, produces = "application/json", value = "salvar")
	@ResponseBody
	public ResponseBodyWrapper save(@RequestBody ProcessoRelacionadoVH processoRelacionadoVH) throws Exception {

		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(this.processoRelacionadoService.salvarProcessoRelacionado(processoRelacionadoVH), getEditView());

		return responseBody;
	}

	@RequestMapping(method = RequestMethod.POST, produces = "application/json", value = "/removeProcessoRelacionado")
	@ResponseBody
	public ResponseBodyWrapper removeProcessoRelacionado(@RequestBody ProcessoRelacionadoVH processoRelacionadoVH) {

		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(this.processoRelacionadoService.removerProcessoRelacionado(processoRelacionadoVH), getEditView());

		return responseBody;
	}

	@RequestMapping(value = "/findByIdProcesso", method = RequestMethod.GET, produces = "application/json")
	@ResponseBody
	public ResponseBodyWrapper findByIdProcesso(@RequestParam(value = "idProcesso") Long idProcesso) throws Exception {

		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(this.processoRelacionadoService.findByIdProcesso(idProcesso), getListView());

		return responseBody;
	}

	@Override
	 public Class<Views.ProcessoRelacionadoList> getListView(){
	
	 return Views.ProcessoRelacionadoList.class;
	}

}
