package br.com.centralit.controller;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;

import br.com.centralit.api.framework.json.ViewsEcm;
import br.com.centralit.api.model.TarjaAssinatura;
import br.com.centralit.api.service.TarjaAssinaturaService;
import br.com.centralit.framework.controller.GenericController;
import br.com.centralit.framework.json.ResponseBodyWrapper;
import br.com.centralit.framework.view.ResultResponseVH;

@Controller
@RequestMapping("/rest/tarjaAssinatura")
public class TarjaAssinaturaController extends GenericController<TarjaAssinatura> {

	private TarjaAssinaturaService tarjaAssinaturaService;

	@Override
	public Class<ViewsEcm.TarjaAssinaturaEditview> getEditView() {
		return ViewsEcm.TarjaAssinaturaEditview.class;
	}

	@Autowired
	public TarjaAssinaturaController( TarjaAssinaturaService tarjaAssinaturaService ) {
		super(tarjaAssinaturaService);
		this.tarjaAssinaturaService = tarjaAssinaturaService;
	}

	@ResponseBody
	@RequestMapping(value = "/uploadFileLogo", method = RequestMethod.POST)
	public void uploadFileHandle(@RequestParam(value = "filename", required = false) String name,
								@RequestParam("file") MultipartFile file, HttpServletRequest request,
								@RequestParam("idOrganizacao") Long idOrganizacao,
								@RequestParam("idTarjaAssinatura") String idTarjaAssinatura) {

		this.tarjaAssinaturaService.uploadAnexoImagemTarja(file, idOrganizacao, Long.parseLong(idTarjaAssinatura));
	}

	@ResponseBody
	@RequestMapping(value = "/saveTarjaAssinatura", method = RequestMethod.POST, produces = "application/json")
	public ResponseBodyWrapper save(@RequestBody TarjaAssinatura tarjaAssinatura) throws Exception {

		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(this.tarjaAssinaturaService.save(tarjaAssinatura), getEditView());

		return responseBody;
	}

	@ResponseBody
	@RequestMapping(value = "/removeImagem", method = RequestMethod.POST, produces = "application/json")
	public ResponseBodyWrapper removeImagem(@RequestBody TarjaAssinatura tarjaAssinatura) throws Exception {

		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(this.tarjaAssinaturaService.removeImagem(tarjaAssinatura), getEditView());

		return responseBody;
	}
	
	@RequestMapping(value = "/getTarjaAssinaturaInterna", method = RequestMethod.GET)
	@ResponseBody
	public ResponseBodyWrapper getTarjaAssinaturaInterna() {
		ResultResponseVH<TarjaAssinatura> resultResponseVH = new ResultResponseVH<TarjaAssinatura>(tarjaAssinaturaService.getTarjaAssinaturaInterna());
		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(resultResponseVH, this.getEditView());
		return responseBody;
	}

}
