package br.com.centralit.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import br.com.centralit.api.framework.json.ViewsEcm;
import br.com.centralit.api.model.TipoDocumento;
import br.com.centralit.api.service.TipoDocumentoService;
import br.com.centralit.framework.controller.GenericController;
import br.com.centralit.framework.json.ResponseBodyWrapper;
import br.com.centralit.framework.view.ResultResponseVH;

@Controller
@RequestMapping("/rest/tipoDocumento")
public class TipoDocumentoController extends GenericController<TipoDocumento> {
	private TipoDocumentoService tipoDocumentoService;

	@Autowired
	public TipoDocumentoController(TipoDocumentoService tipoDocumentoService) {
		super(tipoDocumentoService);
		this.tipoDocumentoService = tipoDocumentoService;
	}

	@Override
	public Class<ViewsEcm.TipoDocumentoEdit> getEditView() {
		return ViewsEcm.TipoDocumentoEdit.class;
	}

	@Override
	public Class<ViewsEcm.TipoDocumentoList> getListView() {
		return ViewsEcm.TipoDocumentoList.class;
	}
	
	
	@SuppressWarnings({ "rawtypes", "unchecked" })
	@RequestMapping(value = "/verificaDuplicidadeNome", method = RequestMethod.GET, produces = "application/json")
	@ResponseBody
	public ResponseBodyWrapper verificaDuplicidadeNome(@RequestParam(value = "nome") String nome) {
		ResultResponseVH resultResponseVH = new ResultResponseVH(tipoDocumentoService.verificaDuplicidadeNomeDocumento(nome));
		
		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(resultResponseVH, ViewsEcm.TipoDocumentoList.class);

		return responseBody;
	}
	
}
