package br.com.centralit.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import br.com.centralit.api.framework.json.ViewsEcm;
import br.com.centralit.api.model.TipoProcesso;
import br.com.centralit.api.service.TipoProcessoService;
import br.com.centralit.framework.controller.GenericController;
import br.com.centralit.framework.json.ResponseBodyWrapper;
import br.com.centralit.framework.view.ResultResponseVH;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 20/10/2015 - 17:33:54
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Controller
@RequestMapping("/rest/tipoProcesso")
public class TipoProcessoController extends GenericController<TipoProcesso> {
	
	private TipoProcessoService tipoProcessoService;

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * 
	 * @param tipoProcessoService
	 */
	@Autowired
	public TipoProcessoController( TipoProcessoService tipoProcessoService ) {

		super(tipoProcessoService);
		this.tipoProcessoService = tipoProcessoService;
	}

	@Override
	public Class<ViewsEcm.TipoProcessoEdit> getEditView() {
		return ViewsEcm.TipoProcessoEdit.class;
	}

	@Override
	public Class<ViewsEcm.TipoProcessoList> getListView() {
		return ViewsEcm.TipoProcessoList.class;
	}
	
	@SuppressWarnings({ "rawtypes", "unchecked" })
	@RequestMapping(value = "/verificaDuplicidadeNome", method = RequestMethod.GET, produces = "application/json")
	@ResponseBody
	public ResponseBodyWrapper verificaDuplicidadeNome(@RequestParam(value = "nome") String nome) {
		ResultResponseVH resultResponseVH = new ResultResponseVH(tipoProcessoService.verificaDuplicidadeNomeDocumento(nome));
		
		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(resultResponseVH, ViewsEcm.TipoProcessoList.class);

		return responseBody;
	}
	
}
