package br.com.centralit.controller;

import java.util.Collection;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import br.com.centralit.api.framework.json.ViewsEcm;
import br.com.centralit.api.model.TipoProcessoPlanoClassificacao;
import br.com.centralit.api.service.TipoProcessoPlanoClassificacaoService;
import br.com.centralit.framework.controller.GenericController;
import br.com.centralit.framework.json.ResponseBodyWrapper;

@Controller
@RequestMapping("/rest/tipoProcessoPlanoClassificacao")
public class TipoProcessoPlanoClassificacaoController extends GenericController<TipoProcessoPlanoClassificacao> {

	/** Atributo tipoProcessoPlanoClassificacaoService. */
	private TipoProcessoPlanoClassificacaoService tipoProcessoPlanoClassificacaoService;

	@Autowired
	public TipoProcessoPlanoClassificacaoController( TipoProcessoPlanoClassificacaoService tipoProcessoPlanoClassificacaolService ) {

		super(tipoProcessoPlanoClassificacaolService);

		this.tipoProcessoPlanoClassificacaoService = tipoProcessoPlanoClassificacaolService;
	}

	@RequestMapping(value = "/findPorTipoProcesso", method = RequestMethod.GET, produces = "application/json")
	@ResponseBody
	public ResponseBodyWrapper findPorTipoProcesso(@RequestParam(value = "idTipoProcesso") Long idTipoProcesso) {

		final Collection<TipoProcessoPlanoClassificacao> listaTipoProcessoClassificacao = this.tipoProcessoPlanoClassificacaoService.findPorIdTipoProcesso(idTipoProcesso);

		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(listaTipoProcessoClassificacao, ViewsEcm.TipoProcessoEdit.class);

		return responseBody;
	}

}
