'use strict';

citApp.controller('AnexarProcessoController', ['$scope', 'UnidadeProcessoRepository', 'AnexarProcessoRepository','$translate', '$timeout', '$filter', 'ProcessoRepository', 'UnidadeRepository', 'HistoricoAlteracaoProcessoRepository', function AnexarProcessoController($scope, UnidadeProcessoRepository, AnexarProcessoRepository, $translate, $timeout, $filter, ProcessoRepository, UnidadeRepository, HistoricoAlteracaoProcessoRepository) {
	
	
	$scope.listaHistoricos = [];
	
	$scope.processo = null;
	
	$scope.setForm = function(scope){
		
		   this.anexarProcessoForm = $scope.anexarProcessoForm;
		   
		};
	
	$scope.anexarProcessoVH = {
			
			listaProcessoAnexado : [],
			processo : null
	};
	
	
	//CONSULTA LISTA DE PROCESSO ANEXADO 
    $scope.getProcessoAnexado = function(){
    	
    	$scope.anexarProcessoVH = {
    			
    			listaProcessoAnexado : [],
    			processo : null
    	};
    	
    	$scope.setLoadingGet(true);

    	AnexarProcessoRepository.findByIdProcesso($scope.$parent.$parent.processo.id).then(function(result) {
        	angular.forEach(result, function(item, key) {
        		if(item.originalElement.processo != null){
        			
        			$scope.anexarProcessoVH.listaProcessoAnexado.push(item.originalElement);
        			
        		}
        	});
        	
             $scope.setLoading(false);
        }); 
    };
    
    $scope.getProcessoAnexadoHistorico = function(){
       	AnexarProcessoRepository.findByIdAnexoProcesso($scope.$parent.$parent.processo.id).then(function(result) {
        	angular.forEach(result, function(item, key) {
        		if(item.originalElement.processo != null){
        			$scope.listaHistoricos.push(item.originalElement);
        			
        		}
        	});
        });
    	
    };
    
    
    //Buscar processo através do nup
    $scope.autoCompleteProcessoEmAndametoByNup = function(value){
        return ProcessoRepository.autoCompleteProcessoEmAndametoByNup(value).then(function(result) {       	
        	return $filter('idNotEqualProcessoAnexadoAndProcessoPai')(result, $scope.anexarProcessoVH.listaProcessoAnexado, $scope.$parent.$parent.processo);
        });
    };
    
    
    //Setar o processo selecionado
	$scope.addAnexoProcesso = function(){
	      if(!$scope.anexarProcessoVH.listaProcessoAnexado){
	    	  $scope.anexarProcessoVH.listaProcessoAnexado = [];
	        }
	        
	      $scope.anexarProcessoVH.listaProcessoAnexado.push({processoAnexado : $scope.processo});
	        
	        $timeout(function(){
	        	$scope.processo = null;
	        });

	};
	
	
	//Salvar
	 $scope.saveOrUpdate = function(){
		 
	    //verifica se o formulario está valido para salvar
		 if($scope.anexarProcessoVH.listaProcessoAnexado.length > 0){
	        $scope.setLoadingSalva(true);
	        $scope.anexarProcessoVH.listaProcessoAnexado = $scope.retornaListaSave($scope.anexarProcessoVH.listaProcessoAnexado);
	        $scope.anexarProcessoVH.processo = $scope.$parent.$parent.processo;
	        $scope.anexarProcessoVH.idTask = $scope.$parent.$parent.task.id;
//	        $scope.updateTask(true);
	        AnexarProcessoRepository.save($scope.anexarProcessoVH).then(function(result) {
	        	$scope.historicoAlteracao($scope.anexarProcessoVH.listaProcessoAnexado);
	        	$scope.anexarProcessoVH = result.originalElement;
		        $scope.showAlert("success", $translate.instant('MSG.REGISTRO_SALVO'));
		        $scope.anexarProcessoForm.$submitted = false;
	
		        $scope.getProcessoAnexado();
		        $scope.atualizaProcesso();
	        });
	        $scope.setLoading(false);
			}else{
			    //Mensagem de erro de campos obrigatorios não preenchidos
			    $scope.showAlert('error', $translate.instant('VALIDACAO.ALERTA_OBRIGATORIOS'), " ", false);
			}
		
	        
	   };
	   
	   
		$scope.historicoAlteracao = function (listaProcessoAnexado){
			
        	angular.forEach(listaProcessoAnexado, function(item, key) {
        		
        		var processoFilho = item.processoAnexado;
        		var processoPai = $scope.$parent.$parent.processo;
   
        		$scope.AddHistoricoAlteracao(processoFilho , processoPai);
        		$scope.AddHistoricoAlteracao(processoPai , processoFilho);
        		
        	});
		};
		
		
		$scope.AddHistoricoAlteracao = function (processoPai, processoFilho){
	    	    	
    		var historicoAlteracaoProcesso = {
    				descricaoAcao :  $translate.instant('ECM.MSG_HISTORICO_ECM.ANEXAR_PROCESSO'),
    				processo : processoPai,
    				mapaAtributos : {'protocolo': processoFilho.nup},
    				autor : $scope.usuarioLogado,
    				acaoAlteracao : "ANEXAR_PROCESSO",
					idTask : $scope.$parent.$parent.task.id

    		};
    		
    		HistoricoAlteracaoProcessoRepository.saveParams(historicoAlteracaoProcesso).then(function(result){ }); 
		};
		
		$scope.retornaListaSave = function (result){
			   var arrayToReturn = [];
			   if(result.length > 0){
		            angular.forEach(result, function(item, key) {
	                if(!item.id){arrayToReturn.push(item);};
	                   
	               });

			   }
			  return arrayToReturn;	
		};
			
			
	
	//Exibe mensagem de confirmação de exclusão
	$scope.exibirDialogRemocao = function(){
		
		if(!$scope.anexarProcessoChecked){
			
			 $scope.showAlert('warning', $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_SER_REMOVIDO'));
			
		}else{
			
			$scope.$openModalConfirm({message: $translate.instant('LABEL.CONFIRMA_EXCLUSAO'), callback: $scope.excluir});
		}

	};
	
	//Exclui um processo
	$scope.excluir = function() {
		
	    var index =  $scope.anexarProcessoVH.listaProcessoAnexado.indexOf($scope.anexarProcessoChecked);
	    
	    if(!$scope.anexarProcessoVH.listRemoverAnexado){
	    	$scope.anexarProcessoVH.listRemoverAnexado = [];
	    }
	    
	    	$scope.anexarProcessoVH.processo = $scope.$parent.$parent.processo;
	    	$scope.anexarProcessoVH.listRemoverAnexado.push($scope.anexarProcessoChecked);
	    	var processoPai = $scope.anexarProcessoChecked.processo;
    		var processoFilho = $scope.anexarProcessoChecked.processoAnexado;
    		
    		if(processoPai && processoFilho){
    		   	AnexarProcessoRepository.removeProcessoAnexado($scope.anexarProcessoVH).then(function() {
    	    		$scope.historicoAlteracaoExcluirAnexos(processoPai, processoFilho);
    	    		$scope.historicoAlteracaoExcluirAnexos(processoFilho, processoPai);
    	    		$scope.anexarProcessoVH.listRemoverAnexado = [];
    			});
    		}
	 
	    
	    $scope.showAlertSucesso("success", $translate.instant('MSG.REGISTRO_EXCLUIDO'));
	    $scope.anexarProcessoVH.listaProcessoAnexado.splice(index, 1);
		$scope.$modalConfirmInstance.dismiss('cancel');
	};
	
	//Grava histórico de exclusão 
	$scope.historicoAlteracaoExcluirAnexos = function (processoPai, processoFilho){

		var historicoAlteracaoProcesso = {
				descricaoAcao :  $translate.instant('MSG_HISTORICO_ECM.REMOVER_ANEXO_PROCESSO'),
				processo : processoPai,
				mapaAtributos : {'protocolo': processoFilho.nup},
				autor : $scope.usuarioLogado,
				acaoAlteracao : "REMOVER_PROCESSO_ANEXADO",
				idTask : $scope.$parent.$parent.task.id

		};
		HistoricoAlteracaoProcessoRepository.saveParams(historicoAlteracaoProcesso).then(function(result){ }); 

};
		
    //Fechar widget
	$scope.closeWidget = function() {
    	angular.element("#searchGerenciarProcesso").scope().closeWidget();
    };
    
    
	//CRIAR RELACIONAMENTO DE PROCESSO	
	$scope.justificativaAcaoProcesso = function(action){
		
		
		$scope.flowAction = action;
		
		if(action.requireReason){
			$scope.fecharPagina();
			$scope.isJustificativaAcaoProcesso = true;
			angular.element("#justificativaAcaoProcesso").scope().resetForm();
		}else{
			
			var mensagem = $translate.instant('ECM.MSG.CONFIRMA_EXECUCAO_FLUXO');
		    mensagem += $scope.flowAction.name;

						
			 $scope.$openModalConfirm({message: mensagem, callback: $scope.avancarFluxo});

		}
	};
	
	$scope.avancarFluxo = function (){
		$scope.$modalConfirmInstance.dismiss('cancel');
		$scope.updateTask(true);
	};
	
}]);
