'use strict';

citApp.controller('AnexoGedController', ['$scope', 'AnexoGedRepository', '$translate', '$timeout', '$filter', 'FileUploader', function AnexoGedController($scope, AnexoGedRepository, $translate, $timeout, $filter, FileUploader) {

	$scope.idDocumento = {};
	
	$scope.resetForm = function(idDocumento){
		
		$scope.idDocumento = idDocumento;
		
		uploader.clearQueue();
	};
	
	var uploader = $scope.uploader = new FileUploader({
		autoUpload: false,
		queueLimit: 10,
		url : '/cit-ecm-web/rest/anexoGed/uploadAnexo?idDocumento=',
	});

	// FILTERS
	uploader.filters.push({
		name: 'imageFilter',
		fn: function(item /*{File|FileLikeObject}*/, options) {
			var type = '|' + item.type.slice(item.type.lastIndexOf('/') + 1) + '|';
			return '|jpg|png|jpeg|bmp|gif|'.indexOf(type) !== -1;
		}
	});

	// CALLBACKS
	uploader.onWhenAddingFileFailed = function(item /*{File|FileLikeObject}*/, filter, options) {
		console.info('onWhenAddingFileFailed', item, filter, options);
	};
	uploader.onAfterAddingFile = function(fileItem) {
		console.info('onAfterAddingFile', fileItem);
	};
	uploader.onAfterAddingAll = function(addedFileItems) {
		console.info('onAfterAddingAll', addedFileItems);
	};
	uploader.onBeforeUploadItem = function(item) {
		console.info('onBeforeUploadItem', item);
	};
	uploader.onProgressItem = function(fileItem, progress) {
		console.info('onProgressItem', fileItem, progress);
	};
	uploader.onProgressAll = function(progress) {
		console.info('onProgressAll', progress);
	};
	uploader.onSuccessItem = function(fileItem, response, status, headers) {
		console.info('onSuccessItem', fileItem, response, status, headers);
	};
	uploader.onErrorItem = function(fileItem, response, status, headers) {
		console.info('onErrorItem', fileItem, response, status, headers);
	};
	uploader.onCancelItem = function(fileItem, response, status, headers) {
		console.info('onCancelItem', fileItem, response, status, headers);
	};
	uploader.onCompleteItem = function(fileItem, response, status, headers) {
		console.info('onCompleteItem', fileItem, response, status, headers);
	};
	uploader.onCompleteAll = function() {
		//uploader.clearQueue();	
		console.info('onCompleteAll');
	};
	
	$scope.saveOrUpdate = function(){

	//Percorre a lista de arquivos para setar na url o id do documento
	angular.forEach(uploader.queue, function(item, key) {
		item.url =  item.url + $scope.idDocumento;
	});
	//Envia a requisição dos arquivos
	uploader.uploadAll();

	};
	
}]);