citApp.controller('AtribuirProcessoController', ['$scope', 'ProcessoRepository', '$translate', '$timeout','$filter', 'ConfiguracaoUsuarioUnidadeRepository', 'UnidadeProcessoRepository', 'HistoricoAtribuicaoProcessoRepository', 'HistoricoAlteracaoProcessoRepository', function ProcessoController($scope, ProcessoRepository, $translate, $timeout, $filter, ConfiguracaoUsuarioUnidadeRepository, UnidadeProcessoRepository, HistoricoAtribuicaoProcessoRepository, HistoricoAlteracaoProcessoRepository) {
	
	//Iniciar atribuição
	$scope.iniciar = function(){
		 $scope.usuarioSelecionado = null;
		 this.atribuirProcessoForm = $scope.atribuirProcessoController.atribuirProcessoForm;
		 $scope.findHistorico();
		 
		 $timeout(function(){
	            $scope.atribuirProcessoForm.$submitted = false;
	            $scope.atribuirProcessoForm.$setPristine();
	        });
		 
	};
	
    $scope.findAutoCompleteUsuario =  function(value){
		   return ConfiguracaoUsuarioUnidadeRepository.findPorUsernameUsuarioAndUnidade(value, $scope.usuarioLogado.unidade.id).then(function(result) {
			   var usuarios = [];
			   angular.forEach(result, function (item) {
				   usuarios.push({originalElement :item.usuario, username : item.usuario.username, id : item.usuario.id});
			   });
			   var filtroUsuarioLogado = $filter('idNotObject')(usuarios, $scope.usuarioLogado);
			   
			   return $filter('idNotObject')(filtroUsuarioLogado, $scope.unidadeProcesso.usuarioResponsavel);
		   });
		};
		
	    
    //Listar o historico de credenciais
    $scope.findHistorico = function(){
    	
    	$scope.historicos = [];
    	
      	HistoricoAtribuicaoProcessoRepository.findByIdJoin("unidadeProcesso.id", $scope.unidadeProcesso.id).then(function(result) {
	      	result.forEach(function (historico) {
	    		
	    		$scope.historicos.push(historico.originalElement);
	    	});
      	});
    };
    
	
	$scope.saveOrUpdate = function(){
		
	  $scope.atribuirProcessoForm.$submitted = true;

        //verifica se o formulario está valido para salvar
        if($scope.atribuirProcessoForm.$valid){
        	
        	$scope.setLoadingSalva(true);
        	
        	$scope.unidadeProcesso.usuarioResponsavel = $scope.usuarioSelecionado;
        	
        	UnidadeProcessoRepository.update($scope.unidadeProcesso).then(function(result) {
        		$scope.unidadeProcesso = result.originalElement;
                $scope.showAlert("success", $translate.instant('MSG.REGISTRO_SALVO'));
                $scope.findHistorico();
                $scope.atualizaProcesso();
                var historicoAlteracaoProcesso = {
                		documentoGed :  $scope.documentoGed,
                		descricaoAcao :  $translate.instant('ECM.MSG_HISTORICO_ECM.ATRIBUICAO'),
                		processo : $scope.processo,
                		autor : $scope.usuarioLogado,
                		acaoAlteracao : "ATRIBUICAO_PROCESSO"
                };
                HistoricoAlteracaoProcessoRepository.saveParams(historicoAlteracaoProcesso).then(function(result){
                	
                	$scope.setLoading(false);
                });
                

            });	        	
        }else{
        	//Mensagem de erro de campos obrigatorios não preenchidos
            $scope.showAlert('error', $translate.instant('VALIDACAO.ALERTA_OBRIGATORIOS'), " ", false);
        }
	};
	
	
}]);