'use strict';

citApp.controller('CabecalhoController', ['$scope', 'CabecalhoRepository', '$filter', '$translate', '$timeout', function CabecalhoController($scope, CabecalhoRepository, $filter, $translate, $timeout) {
	$scope.cabecalho = {};

	// Limpa formulário para novo cadastro
	$scope.resetForm = function() {
		$scope.limparCabecalho();
		$scope.edit = true;
		$timeout(function(){
			$scope.cabecalhoForm.$submitted = false;
			$scope.cabecalhoForm.$setPristine();
		});
	};

	// Atualiza pagina de pesquisa
	$scope.atualizaPaginaPesquisa = function () {
		angular.element('#searchCabecalho').scope().fetchResult();
	};

	// MODAL QUE CONFIRMA REMOVER DO PAIS
	$scope.remove = function(cabecalho){
		$scope.cabecalho = cabecalho;
		$scope.$openModalConfirm({
			message: $translate.instant('MSG.CONFIRMA_EXCLUSAO'),
			callback: function () {
				CabecalhoRepository.remove($scope.cabecalho).then(function() {

					$scope.$modalConfirmInstance.dismiss('cancel');
					$scope.showAlert("success", $translate.instant('MSG.REGISTRO_EXCLUIDO'));
					angular.element('#searchCabecalho').scope().fetchResult();

					$scope.resetForm();
				});
			}
		});
	};

	// SALVA O PAIS
	$scope.saveOrUpdate = function(){
		$scope.cabecalhoForm.$submitted = true;

		//verifica se o formulario está valido para salvar
		if($scope.cabecalhoForm.$valid && $scope.cabecalho.texto != ""){

			$scope.setLoadingSalva(true);

			CabecalhoRepository.save($scope.cabecalho).then(function(result) {
				$scope.cabecalho = result.originalElement;
				$scope.showAlert("success", $translate.instant('MSG.REGISTRO_SALVO'));
				$scope.cabecalhoForm.$submitted = false;
				$scope.setLoading(false);
			});
		}else{
			//Mensagem de erro de campos obrigatorios não preenchidos
			  $scope.showAlert('error', $translate.instant('MSG.MN001'), " ", false);
		}

	};

	// Limpa o formulario preenchido
	$scope.limparCabecalho = function(){
		$scope.cabecalho = {};
	};

	// Consulta entidade e mostra no formulario
	$scope.getCabecalho = function(cabecalho, edit){
		
		$scope.setLoadingGet(true);
		CabecalhoRepository.get(cabecalho.id).then(function(result) {
			$scope.cabecalho = result.originalElement;
			$scope.edit = edit;
			if(!edit){
				
				angular.element("#visualizacaoConteudoCabecalho")[0].srcdoc = $scope.cabecalho.texto;
			}
			
			$scope.setLoading(false);
		});
	};

}]);


