'use strict';

citApp.controller('CabecalhoListController', ['$scope', 'CabecalhoRepository', '$translate', '$timeout', 'DominioRepository', function ListController($scope, CabecalhoRepository, $translate, $timeout, DominioRepository) {
    $scope.$showAdvancedFilters = false;

    $scope.resetForm = function() {
        angular.element("#editCabecalho").scope().resetForm();
    };

    $scope.headers = [ {title : $translate.instant('LABEL.NOME'), value : 'nome' } ];

    $scope.filterCriteria = {
        start : 1,
        dir : 'asc',
        sort : 'id',
        limit : 10,
        fields: ['id', 'nome'],
        filters : [ {type : 'string', field : 'nome' } ]
    };
    
    // ABRI Documento SELECIONADA
    $scope.abrirVisualizar = function(edit){
        var cabecalho = $scope.cabecalhoChecked;

        if(!cabecalho) {
            $scope.showAlert('warning', !edit ? $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_VISUALIZACAO') : $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_EDICAO'));
            return;
        }
        angular.element('#editCabecalho').scope().getCabecalho(cabecalho, edit);
        $scope.$showPageEditWorkspace($scope.workspace);
    };
}]);
