'use strict';

citApp.controller('CancelamentoDocumentoGedController', ['$scope', 'CancelamentoDocumentoGedRepository', '$translate', '$timeout', 'HistoricoAlteracaoProcessoRepository', 'PessoaRepository', function UnidadeProcessoController($scope, CancelamentoDocumentoGedRepository, $translate, $timeout, HistoricoAlteracaoProcessoRepository, PessoaRepository) {

	$scope.resetForm = function(documento){
		
		$scope.edit = true;
		$scope.cancelamentoDocumentoGed = {
				documentoGed : {}
		};
		
        this.cancelamentoDocumentoGedForm = $scope.cancelamentoDocumentoGedController.cancelamentoDocumentoGedForm;
        $scope.cancelamentoDocumentoGed.documentoGed = documento;
		
        $timeout(function(){
            $scope.cancelamentoDocumentoGedForm.$submitted = false;
            $scope.cancelamentoDocumentoGedForm.$setPristine();
        });
	};
	
	$scope.getCancelamentoDocumento = function(idCancelamentoDocumentoGed){
		
		 CancelamentoDocumentoGedRepository.get(idCancelamentoDocumentoGed).then(function(result) {
			 
			 $scope.cancelamentoDocumentoGed = result.originalElement;
			 
			 $scope.edit = false;
		 });
	};
	
	$scope.getCancelamentoDocumentoView = function(idCancelamentoDocumentoGed){
		
		$scope.cancelamentoDocumentoGedForm = $scope.cancelamentoDocumentoGedController.cancelamentoDocumentoGedViewForm;
		
		 CancelamentoDocumentoGedRepository.get(idCancelamentoDocumentoGed).then(function(result) {
			 
			 $scope.cancelamentoDocumentoGed = result.originalElement;
			 
			 $scope.edit = false;
		 });
	};
	
	$scope.findAutoCompleteSolicitante = function(value){
		 return PessoaRepository.findAutoComplete('nome', value).then(function(result) {
			return result;
		 });
	};
	
	$scope.cancelar = function(){
		
		$scope.cancelamentoDocumentoGedForm.$submitted = true;
		
		if($scope.cancelamentoDocumentoGedForm.$invalid){
			
			   $scope.showAlert('error', $translate.instant('VALIDACAO.ALERTA_OBRIGATORIOS'), " ", false);
		}else{
			
			$scope.$openModalConfirm({message: $translate.instant('ECM.MSG.CONFIRMA_CANCELAR_DOCUMENTO'), callback: $scope.saveOrUpdate});
		}
		
	};
	
	//Salvar
	 $scope.saveOrUpdate = function(){
		 
		   $scope.setLoadingSalva(true);
		   $scope.$modalConfirmInstance.dismiss('cancel');
		   CancelamentoDocumentoGedRepository.save($scope.cancelamentoDocumentoGed).then(function(result) {
		   	
		       $scope.cancelamentoDocumentoGedForm.$submitted = false;
		       $scope.showAlert("success", $translate.instant('ECM.MSG.DOCUMENTO_CANCELADO_SUCESSO'));
		       $scope.setLoading(false);
		       
		       $timeout(function(){
		    	   $scope.saveHistoricoProcesso();
		       });
		       
		       $scope.$parent.$parent.closeWidget();
		       $scope.atualizaProcesso();
		   });
		        
	   };
	   
	   //Salvar Historico processo
	   $scope.saveHistoricoProcesso = function(){
		   
		   var processo = {
				   
				   id : $scope.$parent.$parent.processo.id
		   };
		   //Gerar historico para cada unidade enviada
		   var historicoAlteracaoProcesso = {
				   descricaoAcao :  $translate.instant('ECM.MSG_HISTORICO_ECM.CANCELAR_DOCUMENTO'),
				   processo : processo,
				   autor : $scope.usuarioLogado,
				   acaoAlteracao : "CANCELAR_DOCUMENTO",
				   mapaAtributos : {"tipo_documento" :  $scope.cancelamentoDocumentoGed.documentoGed.tipoDocumento.nome, "numero_documento" : $scope.cancelamentoDocumentoGed.documentoGed.numero}
		   };
		   
		   HistoricoAlteracaoProcessoRepository.saveParams(historicoAlteracaoProcesso).then(function(result){
			   
		   }); 
	   
	   };
	
}]);