'use strict';

citApp.controller('ClassificarDocumentoProcessoController', ['$scope', 'ProcessoRepository', '$translate', '$timeout', 'DominioRepository', '$compile', '$injector', 'DocumentoGedRepository', 'appService', 'NivelAcessoTipoProcessoRepository', 'HipoteseLegalRepository', 'NivelAcessoTipoDocumentoRepository', 'HistoricoAlteracaoProcessoRepository', 'SigiloRepository', function ClassificarDocumentoProcessoController($scope, ProcessoRepository, $translate, $timeout, DominioRepository, $compile, $injector, DocumentoGedRepository, appService, NivelAcessoTipoProcessoRepository, HipoteseLegalRepository, NivelAcessoTipoDocumentoRepository, HistoricoAlteracaoProcessoRepository, SigiloRepository) {
    
	 //Iniciar classificação
	  $scope.iniciar = function(processo){
		  
		  $scope.setLoading(true);
		  
		  $scope.processoValidacao = processo;
		  
		  $scope.validado =  $scope.processoValidacao.validado;
		  
		  $scope.contemDocumentoParaValidar = $.grep($scope.processoValidacao.documentos, function(e){ return e.status.codigo == 0; })[0] != null;
	      
		  $scope.findPorIdTipoProcesso(processo.tipoProcesso.id);
		  
		  if($scope.processoValidacao.documentos){
			  
			  angular.forEach($scope.processoValidacao.documentos, function (item) {
				  
				  $scope.findNivelAcessoTipoDocumento(item);
				  
			  });
		  };
		  
		  $scope.setLoading(false);
	        
	  };
	
	$scope.removerAtributos = function(){
	       angular.forEach($scope.processoValidacao.documentos, function (item) {
           	delete item.autorUserName;
           	delete item.unidadeNome;
           	delete item.documentoVersao;
           	delete item.originalElement;
           	
        	if(item.nivelAcesso != undefined && item.nivelAcesso.sigilos != null){
             	 angular.forEach(item.nivelAcesso.sigilos, function (item) {
               		 delete item.tipoSigiloDescricao;
               	 });
        	}
 
           	 
           	if(item.nivelAcessoOriginal != undefined && item.nivelAcessoOriginal.sigilos != null){
              	 angular.forEach(item.nivelAcessoOriginal.sigilos, function (item) {
               		 delete item.tipoSigiloDescricao;
               	 });
           	}
        
           	
           });
           
	};
    // SALVA O Processo
    $scope.saveOrUpdate = function(){
    	
       $scope.classificarDocumentoProcessoForm.$submitted = true;
        //verifica se o formulario está valido para salvar
        if($scope.classificarDocumentoProcessoForm.$valid){

            $scope.setLoadingSalva(true);
            $scope.removerAtributos();
            $scope.processoValidacao.validado = $scope.validado;
            ProcessoRepository.atualizarSigiloProcesso($scope.processoValidacao).then(function(result) {
                $scope.historicoAlteracao(result.originalElement);
                $scope.classificarDocumentoProcessoForm.$submitted = false;
                $scope.atualizaProcesso();
                $scope.showAlert("success", $translate.instant('ECM.MSG.VALIDADO'));
                $scope.setLoading(false);
                
                $timeout(function(){
                	$scope.$parent.$parent.closeWidget();
                });
            });
        }else{
            //Mensagem de erro de campos obrigatorios não preenchidos
        	  $scope.showAlert('error', $translate.instant('MSG.MN001'), " ", false);
        }
    };
    
    
	$scope.historicoAlteracao = function (processo){
    	
		var historicoAlteracaoProcesso = {
				descricaoAcao :  $translate.instant('ECM.MSG_HISTORICO_ECM.VALIDAR_PROCESSO'),
				processo : processo,
				mapaAtributos : {'protocolo': processo.nup},
				autor : $scope.usuarioLogado,
				acaoAlteracao : "VALIDAR_PROCESSO"

		};
		
		HistoricoAlteracaoProcessoRepository.saveParams(historicoAlteracaoProcesso).then(function(result){ }); 
	};
	
	  //Fechar widget
	$scope.closeWidget = function() {
    	angular.element("#searchGerenciarProcesso").scope().closeWidget();
    };
	  
     //Listar nivelAcessoTipoDocumento
	  $scope.findNivelAcessoTipoDocumento = function(documento){
		  
		  documento.nivelAcessoList = [];
		
		  return NivelAcessoTipoDocumentoRepository.findPorIdTipoDocumento(documento.tipoDocumento.id).then(function(result) {
				
			  angular.forEach(result, function (nivelAcesso) {
				  //seta o originalElement do result
				  documento.nivelAcessoList.push(nivelAcesso.originalElement);
				  //substitui o nivelAcesso do documento
				  if(documento.nivelAcesso.id === nivelAcesso.originalElement.id){
				 
					  documento.nivelAcesso = nivelAcesso.originalElement;

				 	}

				});
		  	  });
	  };
	  
	$scope.limparSigilo = function(object){
		 
		$timeout(function(){
			if(object.nivelAcesso && object.nivelAcesso.nivelAcesso.codigo != 0){
				
				object.sigilo = null;
				
			}
		 });
	};
	  
    $scope.findPorIdTipoProcesso = function(idTipoProcesso){
    	
    	$scope.nivelAcessoList = [];
    	
  	   NivelAcessoTipoProcessoRepository.findPorIdTipoProcesso(idTipoProcesso).then(function(result) {
  	    	
  		   	  $scope.nivelAcessoList = result;
  	    	
      	});
      };
      
}]);
