'use strict';

citApp.controller('ClassificarDocumentoProcessoListController', ['$scope', 'ProcessoRepository', '$translate', '$timeout', 'DominioRepository', '$compile', '$injector', 'DocumentoGedRepository', 'appService', function ClassificarDocumentoProcessoListController($scope, ProcessoRepository, $translate, $timeout, DominioRepository, $compile, $injector, DocumentoGedRepository, appService) {
    
    
    $scope.headers = [{title : $translate.instant('ECM.LABEL.PROTOCOLO'), value : 'nup' }, 
                      {title : $translate.instant('ECM.LABEL.PROPOSTA'), value : 'sigiloOriginal.tipoSigilo.descricao'},
                      {title : $translate.instant('ECM.LABEL.NIVEL_FINAL'), value : 'sigilo.tipoSigilo.descricao'} , 
                      {title : $translate.instant('ECM.LABEL.PRAZO_SIGILO'),  value : 'prazoSigilo',  filter : 'dateBR' }];

    $scope.filterCriteria = {
        start : 1,
        nome : "GRID_CLASSIFICACAO_PROCESSO_DOCUMENTO",
        dir : 'asc',
        sort : 'id',
        limit : 10,
        fields: ['id', 'nup', 'sigiloOriginal.tipoSigilo.descricao', 'sigilo.tipoSigilo.descricao', 'prazoSigilo'],
        filters : [{type : 'string', field : 'nup' }, 
                   {type : 'string', field : 'sigiloOriginal.tipoSigilo.descricao' } , 
                   {type : 'string', field : 'sigilo.tipoSigilo.descricao'},
                   {type : 'date',   field : 'prazoSigilo' }]
    };
    
	$scope.atualizarGrid = function() {
		$scope.filterResult();
	};
    
	
    // ABRI Processo SELECIONADA
    $scope.abreValidar = function(){
    	
    	if($scope.modelSelecionado && $scope.modelSelecionado.id){
    		
	    	var pagina = '/cit-ecm-web/html/gerenciarProcesso/gerenciarProcesso.html';
	    	
	    	if (appService.existsWorkspace(pagina)) {
				$scope.$openModalConfirm({message:$translate.instant('ECM.MSG.EXISTE_PROCESSO_ABERTO'), callback: function(){
					$scope.$modalConfirmInstance.dismiss('cancel');
					$scope.setLoading(true);
					$scope.openWorkspaceIfNotOpen($translate.instant('ECM.LABEL.PROCESSO'), pagina, 'mod-orange');
					$timeout(function() { 
						angular.element('#searchGerenciarProcesso').scope().getProcesso($scope.modelSelecionado);
							
				   }, 100);
					$scope.setLoading(false);
				}});
			}else{
				$scope.openWorkspaceIfNotOpen($translate.instant('ECM.LABEL.PROCESSO'), pagina, 'mod-orange');
				$timeout(function() { 
					angular.element('#searchGerenciarProcesso').scope().getProcesso($scope.modelSelecionado);
						
			   }, 100);
			}
    	}else{
    		$scope.showAlert('warning', $translate.instant('ECM.MSG.SELECIONE_UM_ITEM_PARA_VALIDACAO'));
    	}

    };
    
    //adiciona a lista de documentos ao processo    
	$scope.findDocumentos = function() {
		
		_getProcesso();
		
		if($scope.modelSelecionado.id){
			
			DocumentoGedRepository.findByProcessoSigilo($scope.modelSelecionado.id).then(function(result) {
				$scope.modelSelecionado.documentos = result;
			});
		}
		
		$scope.modelSelecionado.$expandido = !$scope.modelSelecionado.$expandido;
		
		
	};
	
	function _getProcesso(){
		$scope.modelSelecionado = {};
		for(var count = 0; count < $scope.processos.length; count++){
			if($scope.processos[count].$show) {
				$scope.modelSelecionado = $scope.processos[count];
				break;
			};
		};

	};

}]);
