'use strict';

citApp.controller('DocumentoGedController', ['$scope', 'DocumentoGedRepository', '$translate', '$timeout', 'TipoDocumentoRepository', 'PlanoClassificacaoRepository', 'HipoteseLegalRepository', 'PessoaRepository', 'NivelAcessoTipoDocumentoRepository', 'TipoDocumentoPlanoClassificacaoRepository', '$filter', 'FileUploader', 'AnexoGedRepository', 'HistoricoAlteracaoProcessoRepository', 'DominioRepository', 
                                             'TemplatePadraoRepository', 'CabecalhoRepository', 'RodapeRepository', 'InteressadoDocumentoRepository', 'TipoSuporteDocumentoRepository', function DocumentoGedController($scope, DocumentoGedRepository, $translate, $timeout, TipoDocumentoRepository, PlanoClassificacaoRepository, HipoteseLegalRepository, PessoaRepository, NivelAcessoTipoDocumentoRepository, TipoDocumentoPlanoClassificacaoRepository, $filter, FileUploader, AnexoGedRepository, HistoricoAlteracaoProcessoRepository, DominioRepository, TemplatePadraoRepository, CabecalhoRepository, RodapeRepository, InteressadoDocumentoRepository, TipoSuporteDocumentoRepository) {

    $scope.documentoGed = {};
    $scope.changeWatch = false;
    $scope.outrosSuporte = false;
    
    $scope.setForm = function(scope){
    	   this.documentoGedForm = scope.documentoGedForm;
    };
    
    // Limpa formulário para novo cadastro
    $scope.resetForm = function() {
    	$scope.documentoGedForm = $scope.documentoGedController.documentoGedForm;
        $scope.limparDocumentoGed();
        $scope.edit = true;
        $scope.changeWatch = false;
        $scope.mantido =  false;
        $scope.sugestoes = null;
        angular.element('#sugestoes').scope().model = null;
    	angular.element('#assuntoSelecionado').scope().model = null;
        $scope.documentoGed.formaCriacao = {
        		codigo : 2
        };
        uploader.clearQueue();
        $timeout(function(){
            $scope.documentoGedForm.$submitted = false;
            $scope.documentoGedForm.$setPristine();
            $scope.widgetDocumentoIsCollapsed = false;
        });
    };

    // MODAL QUE CONFIRMA REMOVER DA CIDADE
    $scope.remove = function(documentoGed){
        $scope.documentoGed = documentoGed;
        $scope.$openModalConfirm({
            message: $translate.instant('MSG.CONFIRMA_EXCLUSAO'),
            callback: function () {
                DocumentoGedRepository.remove($scope.documentoGed).then(function() {

                    $scope.$modalConfirmInstance.dismiss('cancel');
                    $scope.showAlert("success", $translate.instant('MSG.REGISTRO_EXCLUIDO'));
                    angular.element('#searchDocumentoGed').scope().fetchResult();
	                  delete $scope.documentoGed.documentoVersao;
	                  delete $scope.documentoGed.autorUserName;
	                  delete $scope.documentoGed.unidadeNome;
                    var historicoAlteracaoProcesso = {
                    		documentoGed :  $scope.documentoGed,
                    		descricaoAcao :  $translate.instant('ECM.MSG_HISTORICO_ECM.REMOCAO_DOCUMENTO'),
                    		processo : $scope.processo,
                    		autor : $scope.usuarioLogado,
                    		idTask : $scope.task.id,
                    		acaoAlteracao : "REMOCAO_DOCUMENTO"
                    };
                    HistoricoAlteracaoProcessoRepository.saveParams(historicoAlteracaoProcesso).then(function(result){
                    	
                    });
                    $scope.resetForm();
                });
            }
        });
    };
    
    //Abre a tela de cadastro de tipoSuporte
	$scope.novoTipoSuporteDocumento = function() {
		$scope.openWorkspaceIfNotOpen($translate.instant('ECM.LABEL.TIPO_SUPORTE_DOCUMENTO'), '/cit-ecm-web/html/tipoSuporteDocumento/tipoSuporteDocumento.html', 'mod-orange');

		$timeout(function() {
			angular.element('#searchTipoSuporteDocumento').scope().$showPageEditWorkspace(angular.element('#searchTipoSuporteDocumento').scope().workspace);
			angular.element('#tipoSuporteDocumentoEdit').scope().resetForm();

	    }, 300);

	};

	//Remove o primeiro documento criado
	$scope.removeDocumento = function(){
		var idRaiz = this.item;
		DocumentoGedRepository.removerDocumento(idRaiz).then(function(result) {
			if(result){
				$scope.saveDocumento();
				$scope.$modalConfirmInstance.dismiss('cancel');
				$scope.showAlert("success",  $translate.instant('MSG.MG001'));
			}
		});
	};
	
    //Remove as propriedades para realizar a requisição do ducmentoGed
	 $scope.removePropriedades = function(){
    	
	     delete $scope.documentoGed.documentoVersao;
	     delete $scope.documentoGed.autorUserName;
	     delete $scope.documentoGed.unidadeNome;
	    
		 for(var i = 0;  i < $scope.documentoGed.nivelAcesso.sigilos.length; i++){
				
				delete $scope.documentoGed.nivelAcesso.sigilos[i].tipoSigiloDescricao;
		 };
	 };
	 
	 $scope.formularioValido = function(){
		 
		 if($scope.documentoGedForm.$valid){
	
		 	if($scope.documentoGed.tipoDocumento &&  $scope.documentoGed.formaCriacao &&	$scope.documentoGed.formaCriacao.codigo == 2){
	
		 		return $scope.uploader.queue.length > 0 || $scope.documentoGed.anexo;
	
		 	} 
		 	return true;
		 	}
			 
		  
		 return false;
	 };
  
    // SALVA O Documento
    $scope.saveOrUpdate = function(novaVersao){
        $scope.documentoGedForm.$submitted = true;
        
        //verifica se o formulario está valido para salvar
        if($scope.formularioValido()){

            $scope.setLoadingSalva(true);
            
            // VINCULA O DOCUMENTO A UM PROCESSO
            $scope.documentoGed.processo.id = $scope.$parent.processo.id;
            
            var isNew = $scope.documentoGed.id;
            $scope.documentoGed.novaVersao = novaVersao;
            
            var documento = $scope.documentoGed;
            
        	var idRaiz = documento.idRaiz;
    		if(!idRaiz){
    			idRaiz = documento.id;
    		}
    		
    		if(isNew != null){
    		      DocumentoGedRepository.validaQuantidadeVersoes(idRaiz).then(function(result) {
    	            	if(result && result == true){
    	            		$scope.$openModalConfirm({message: $translate.instant('ECM.MSG.SUBSTITUIR_VERSAO_DOCUMENTO'),  callback: $scope.removeDocumento, item : idRaiz});
    	            	}else{
    	            		 $scope.saveDocumento();
    	            	}
    	            });
    		}else{
    			  $scope.saveDocumento();
    		}
    		
        }else{
            //Mensagem de erro de campos obrigatorios não preenchidos
        	  $scope.showAlert('error', $translate.instant('MSG.MN001'), " ", false);
        }
    };
    
    $scope.saveDocumento = function(){

    	   var isNew = $scope.documentoGed.id;
    		
    	   //Remove as propriedades para realizar a requisição do ducmentoGed
    	 	$scope.removePropriedades();
    		
            DocumentoGedRepository.save($scope.documentoGed).then(function(result) {
            	
                $scope.documentoGed = result.originalElement;
                $scope.saveHistorico(isNew);
                $scope.saveUpload();
                $scope.showAlert("success", $translate.instant('MSG.REGISTRO_SALVO'));
                $scope.documentoGedForm.$submitted = false;
                //Remove as propriedades para realizar a requisição do ducmentoGed
                $scope.removePropriedades();

                $timeout(function(){
                    $scope.$parent.$parent.closeWidget();
                    $scope.atualizaProcesso();
                    $scope.setLoadingSalva(false);
                }, 300);
            
            });
            
    };
    
    //Salvar o histórico do documento
    $scope.saveHistorico = function(isNew){

    	if(!isNew){
            var historicoAlteracaoProcesso = {
            		descricaoAcao :  $translate.instant('ECM.MSG_HISTORICO_ECM.INCLUSAO_DOCUMENTO'),
            		processo : $scope.documentoGed.processo,
            		autor : $scope.usuarioLogado,
            		acaoAlteracao : "INCLUSAO_DOCUMENTO",
            		idTask : $scope.task ?  $scope.task.id :  null,
            		mapaAtributos : {"tipo_documento" :  $scope.documentoGed.tipoDocumento.nome, "numero_documento" : $scope.documentoGed.numero}
            };
            HistoricoAlteracaoProcessoRepository.saveParams(historicoAlteracaoProcesso).then(function(result){
            	
            }); 
            
        } else {
            var historicoAlteracaoProcesso = {
            		descricaoAcao :  $translate.instant('ECM.MSG_HISTORICO_ECM.CRIACAO_NOVA_VERSAO_DOCUMENTO'),
            		processo : $scope.documentoGed.processo,
            		autor : $scope.usuarioLogado,
            		acaoAlteracao : "CRIACAO_NOVA_VERSAO_DOCUMENTO",
            		idTask : $scope.task ?  $scope.task.id :  null,
            		mapaAtributos : {"tipo_documento" :  $scope.documentoGed.tipoDocumento.nome, "numero_documento" : $scope.documentoGed.numero, "numero_versao" :  $scope.documentoGed.versaoDocumento.toFixed(1)}
            };
            HistoricoAlteracaoProcessoRepository.saveParams(historicoAlteracaoProcesso).then(function(result){
            }); 
        }
    };
    
    // Limpa o formulario preenchido
    $scope.limparDocumentoGed = function(){
        $scope.documentoGed = {
        		processo: {id: null}
        };

        $scope.isTipoSelecionado= false;
        $scope.isHabilitaHipoteseLegal = false;
        $scope.assuntos = null;
        $scope.sugestoes = null;
    };

    $scope.findAutoCompleteTipoDocumento = function(value){
        return TipoDocumentoRepository.findAutoComplete( $scope.documentoGed.formaCriacao.codigo, value).then(function(result) {
            return result;
        });
    };
    
    //Limpar os campos do documento de acordo com a formaCriacao
    $scope.limparCamposDocumento = function(){
    	
    	$scope.documentoGed.tipoDocumento = null;
    	$scope.documentoGed.planoClassificacao = null;
    	//Verifica se a forma de criação selecionada é documento Online
    	if($scope.documentoGed.formaCriacao.codigo === 1){
    		
    		$scope.uploader.clearQueue;
    		$scope.mantido = false;
    		$scope.documentoGed.localizacao = null;
    		$scope.documentoGed.numero = null;
    		DominioRepository.findAllDominio('estadoDocumentoGed').then(function(result) {
    	        $scope.estadoList = result;
    	    });
    		
    	}else{
    		
    		$scope.documentoGed.conteudo = {};
    		
    		if($.grep($scope.estadoList, function(e){ return e.codigo === 3; })[0]){

    			$scope.estadoList.splice($.grep($scope.estadoList, function(e){ return e.codigo === 3; })[0].$index, 1);
    		}
    	}
    	
    	$scope.documentoGedForm.$submitted = false;
        $scope.documentoGedForm.$setPristine();
        
 	   $timeout(function(){
 		  angular.element("#metadadosDocumentoGedCollapsed").css('height', 'auto');
       });
    };
    
   $scope.construirRelacionamento = function(item){
	   
	   if(!$scope.documentoGed.id){
	   
			   $scope.nivelAcessoTipoDocumentoList = [];
			   
			   if(!$scope.documentoGed.id)  {
				   $scope.documentoGed.conteudo = "";
				   $scope.sugestoes = null;
				   if( $scope.documentoGed.formaCriacao.codigo === 1){
					   
					   $scope.setLoadingGet(true);
					   
					   TemplatePadraoRepository.get(item.templatePadrao.id).then(function(result) {
						   
						   $scope.documentoGed.conteudo += result.cabecalho.texto + result.conteudo + result.rodape.texto;
						   
						   $scope.setLoadingGet(false);
					   });
				   }
			   }
			   $scope.findNivelAcessoPorTipoDocumento(item);
			   
			   $scope.findSugestaoAssunto(item);
			  
			   //Limpar o assuntoSelecionado e as sugestões.
			   $timeout(function(){
			     $scope.assuntoSelecionado = null;
			     if($scope.documentoGedForm && $scope.documentoGedForm['assuntoSelecionado']) {
						$scope.documentoGedForm['assuntoSelecionado'].$setViewValue('');
						$scope.documentoGedForm['assuntoSelecionado'].$render();
						 $scope.documentoGedForm.$submitted = false;
					 	 $scope.documentoGedForm.$setPristine();
					
					}
			     if($scope.documentoGedForm && $scope.documentoGedForm['sugestoes']) {
						$scope.documentoGedForm['sugestoes'].$setViewValue('');
						$scope.documentoGedForm['sugestoes'].$render();
					}
			   });
			  
		    };
   };
    
    $scope.findNivelAcessoPorTipoDocumento = function(tipoDocumento){
    	
	  return NivelAcessoTipoDocumentoRepository.findPorIdTipoDocumento(tipoDocumento.id).then(function(result) {
	   $scope.nivelAcessoTipoDocumentoList = result;
	  });
    };
            
    $scope.findAutoCompleteSugestao = function(value){
        return PlanoClassificacaoRepository.findAssuntoAutoComplete(value).then(function(result) {
            return result;
        });
    };
    
           
    $scope.findAutoCompleteDestinatario = function(value){
        return PessoaRepository.findAutoComplete('nome', value).then(function(result) {
            return result;
        });
    };
    
    DominioRepository.findAllDominio('estadoDocumentoGed').then(function(result) {
        $scope.estadoList = result;
    });
    
	//SET HIPOTESE LEGAL #INICIO	
	$scope.setHipoteseLegal = function(){
		
		$scope.hipoteses = [];
		
		$scope.documentoGed.hipoteseLegal = null;
		
		 $timeout(function(){
			//Limpar o tipoSigiloDocumento caso o nivel selecionado seja diferente de sigiloso
			if($scope.documentoGed.nivelAcesso && $scope.documentoGed.nivelAcesso.nivelAcesso.codigo != 0){
				
				$scope.documentoGed.sigilo = null;
			};
			//Verifica se o sigilo foi selecionado, busca as hipoteses referente ao sigilo.
			if($scope.documentoGed.sigilo && $scope.documentoGed.sigilo.id){
	
	 			HipoteseLegalRepository.findPorNivelAcesso($scope.documentoGed.sigilo.id).then(function(result) {
	 				
	 				$scope.hipoteses = result;
	 				
	 			});
	 		}else if($scope.documentoGed.nivelAcesso && $scope.documentoGed.nivelAcesso.nivelAcesso.codigo === 1){
	 			
	 			HipoteseLegalRepository.findPorNivelAcesso($scope.documentoGed.nivelAcesso.nivelAcesso.id).then(function(result) {
	 				
	 				$scope.hipoteses = result;
	 				
	 			});
	 		}
		 });
	};
	//AUTOCOMPLETE HIPOTESE LEGAL #FIM	            
    $scope.findAutoCompleteInteressados = function(value){
        return PessoaRepository.findAutoComplete('nome', value).then(function(result) {
        	return $filter('idNotEqualObj')(result, $scope.documentoGed.interessados, 'interessado');
        });
    };

    //Setar o item selecionado na lista de interessados
    $scope.setInteressados = function(item){
        if(!$scope.documentoGed.interessados){
            $scope.documentoGed.interessados = [];
        }
        $scope.documentoGed.interessados.push({
            interessado : item
        });
        //Limpa autoComplete de interessado
        $timeout(function(){
        	 if($scope.documentoGedForm && $scope.documentoGedForm['interessado']) {
 				$scope.documentoGedForm['interessado'].$setViewValue('');
 				$scope.documentoGedForm['interessado'].$render();
        	 };
        });
    };

    $scope.removerInteressados = function(){
        if($scope.interessadoChecked){
            $scope.$openModalConfirm({message: $translate.instant('MSG.DESEJA_EXCLUIR_ITENS'), callback: $scope.excluirInteressado, item: $scope.interessadoChecked});
        }else{
        	  $scope.showAlert('warning', $translate.instant('MSG.SELECIONE_ITEM_EXCLUIR'), " ", false);
        }
    };
    
    //Limpar os campos do tipo processo, na ação borracha
    $scope.limparCamposTipoProcesso = function(){
    	
    	$scope.documentoGed.nivelAcesso = null;
    	$scope.documentoGed.sigilo = null;
    	
    };
    
    //Setar o interessado para remoção.
    $scope.setInteressadoRemocao = function(interessadoRemocao, $index){
    	$scope.interessadoChecked = interessadoRemocao;
    	$scope.interessadoChecked.$index = $index;
    };

    //Remove o interessado
    $scope.excluirInteressado = function() {
        var obj = this.item;
        if (obj.id) {
        	InteressadoDocumentoRepository.remove(obj).then(function() {
        		
        	});
        	
        }
        $scope.showAlertSucesso("success", $translate.instant('MSG.REGISTRO_EXCLUIDO'));
        $scope.documentoGed.interessados.splice(obj.$index, 1);
        $scope.$modalConfirmInstance.dismiss('cancel');
        
        $scope.interessadoChecked = null;
    };
    
    // Consulta entidade e mostra no formulario
    $scope.getDocumentoGed = function(idDocumento, edit, scope){
        $scope.setLoadingGet(true);
        
        if(edit){
        	$scope.documentoGedForm = $scope.documentoGedController.documentoGedForm;
        }
        
        uploader.clearQueue();
        $scope.assuntoSelecionado = null;
        $scope.assuntos = null;
        $scope.sugestoes = null;
        DocumentoGedRepository.get(idDocumento).then(function(result) {
            $scope.documentoGed = result.originalElement;
            $scope.edit = edit;
            $scope.mantido =  $scope.documentoGed.localizacao !=  "" &&  $scope.documentoGed.localizacao != undefined;
            $scope.findNivelAcessoPorTipoDocumento($scope.documentoGed.tipoDocumento);
            $scope.montarHipotese();
            $scope.setAssuntoModelByTipoAssunto();
            $scope.widgetDocumentoIsCollapsed = !edit;
            
            $timeout(function(){
	            //Verifica se o documento é do tipo anexo
	            if(!edit && $scope.documentoGed.formaCriacao.codigo == 2){
	            	
	        		   $scope.urlAnexo = {};
	        		   $scope.urlAnexo = "/cit-ecm-web/rest/anexoGed/visualizar?idAnexo=" +  $scope.documentoGed.anexo.id;
	            		   
	            	// Verifica se o documento é do tipo documento online
	            }else if(!edit && $scope.documentoGed.formaCriacao.codigo == 1){
	            	angular.element("#visualizacao_online_" + $scope.$parent.processo.id)[0].srcdoc = $scope.documentoGed.conteudo;	   	             
	            };
            });
            
            
            $timeout(function(){
            	angular.element("#metadadosDocumentoGedCollapsed").css('height', 'auto');
            },360);
            $scope.setLoading(false);
            
        });
        
    };
    
	//SET HIPOTESE LEGAL #INICIO	
	$scope.montarHipotese = function(){

		if($scope.documentoGed.tipoSigiloDocumento && $scope.documentoGed.tipoSigiloDocumento.id){

 			HipoteseLegalRepository.findPorNivelAcesso($scope.documentoGed.tipoSigiloDocumento.id).then(function(result) {
 				
 				$scope.hipoteses = result;
 				
 			});
 		}else if($scope.documentoGed.nivelAcesso.nivelAcesso.codigo === 1){
 			
 			HipoteseLegalRepository.findPorNivelAcesso($scope.documentoGed.nivelAcesso.nivelAcesso.id).then(function(result) {
 				
 				$scope.hipoteses = result;
 				
 			});
 		}
	};
    
    
    // Consulta entidade e mostra no formulario
    $scope.getDocumentoGedView = function(idDocumento, edit, scope){

        $scope.documentoGedForm = $scope.documentoGedController.documentoGedViewForm;
       
        $scope.getDocumentoGed(idDocumento, edit, scope);
      
    };
    
    var uploader = $scope.uploader = new FileUploader({
		autoUpload: false,
		queueLimit: 10,
		url : '/cit-ecm-web/rest/anexoGed/uploadAnexo?idDocumento=',
	});

	// FILTERS
    uploader.filters.push({
        name: 'customFilter',
        fn: function(item /*{File|FileLikeObject}*/, options) {
            return this.queue.length < 10;
        }
    });

	// CALLBACKS
	uploader.onWhenAddingFileFailed = function(item /*{File|FileLikeObject}*/, filter, options) {
		console.info('onWhenAddingFileFailed', item, filter, options);
	};
	uploader.onAfterAddingFile = function(fileItem) {
		console.info('onAfterAddingFile', fileItem);
	};
	uploader.onAfterAddingAll = function(addedFileItems) {
		console.info('onAfterAddingAll', addedFileItems);
	};
	uploader.onBeforeUploadItem = function(item) {
		console.info('onBeforeUploadItem', item);
	};
	uploader.onProgressItem = function(fileItem, progress) {
		console.info('onProgressItem', fileItem, progress);
	};
	uploader.onProgressAll = function(progress) {
		console.info('onProgressAll', progress);
	};
	uploader.onSuccessItem = function(fileItem, response, status, headers) {
		console.info('onSuccessItem', fileItem, response, status, headers);
	};
	uploader.onErrorItem = function(fileItem, response, status, headers) {
		console.info('onErrorItem', fileItem, response, status, headers);
	};
	uploader.onCancelItem = function(fileItem, response, status, headers) {
		console.info('onCancelItem', fileItem, response, status, headers);
	};
	uploader.onCompleteItem = function(fileItem, response, status, headers) {
		console.info('onCompleteItem', fileItem, response, status, headers);
	};
	uploader.onCompleteAll = function() {
		//uploader.clearQueue();	
		console.info('onCompleteAll');
	};
	
	$scope.saveUpload = function(){
	//Percorre a lista de arquivos para setar na url o id do documento
	angular.forEach(uploader.queue, function(item, key) {
		item.url =  item.url + $scope.documentoGed.id;
	});
	//Envia a requisição dos arquivos
	uploader.uploadAll();

	};
	
	//Exibir o dialog de confirmação para remoção do upload
	$scope.exibirDialogRemocaoUpload = function(){
		
		$scope.$openModalConfirm({message: $translate.instant('LABEL.CONFIRMA_EXCLUSAO'), callback: $scope.removeUpload});
		
	};
	
	//Remove o upload
	$scope.removeUpload = function(){
	
		if($scope.documentoGed.anexo && $scope.documentoGed.anexo.id){
			
			AnexoGedRepository.remove($scope.documentoGed.anexo).then(function() {
				$scope.showAlert("success",  $translate.instant('MSG.MG001'));
			     $scope.changeWatch = true;
				$scope.documentoGed.anexo = null;
			});
		}
		
		 uploader.clearQueue();
		 
		 $scope.$modalConfirmInstance.dismiss('cancel');
	};
	
	$scope.eventoChange = function(){
		$scope.changeWatch = $scope.documentoGedForm.$dirty;
	};
	 // fim verificação
	
	$scope.limparLocalizacao = function(){
		
		if(!$scope.mantido){
			
			$scope.documentoGed.localizacao = null;
		}
	};
	
	//Realiza o download do anexo
	$scope.download = function(){
		
		 $scope.urlAnexo = "/cit-ecm-web/rest/anexoGed/visualizar?idAnexo=" +  $scope.documentoGed.anexo.id;
	};
	
    DominioRepository.findAllDominio('tipoFormaCriacao').then(function(result) {
        $scope.formaCriacaoList = result;
        
        $scope.formaCriacaoList.splice($.grep($scope.formaCriacaoList, function(e){ return e.codigo === 3; })[0].$index, 1);
        
    });
    
    $scope.findSugestaoAssunto = function(tipoDocumento){
    	
    	$scope.assuntos = [];
    	$scope.sugestoes = [];
    	TipoDocumentoPlanoClassificacaoRepository.findByIdJoin('tipoDocumento.id', tipoDocumento.id).then(function(result){
    		angular.forEach(result, function (item) {
				$scope.assuntos.push(item.planoClassificacao);
			});
			
    	});
    };
    
    //Setar a sugestão
	$scope.setAssunto = function(itens){
		
		$scope.documentoGed.tipoAssunto = 1;

		if(itens.length > 1){
			$scope.documentoGed.planoClassificacao = itens[itens.length - 1];
			$scope.sugestoes = [];
			$scope.sugestoes.push($scope.documentoGed.planoClassificacao);
			
		}else{
			
			$scope.documentoGed.planoClassificacao = itens[0];
		}
	};
	
	$scope.setTipoAssunto = function(assuntoSelecionado){
		
		$scope.documentoGed.tipoAssunto = 2;
		$scope.documentoGed.planoClassificacao = assuntoSelecionado;
		$scope.assuntoSelecionado =  assuntoSelecionado;
		
	};
	
    $scope.setAssuntoModelByTipoAssunto = function(){
    	$scope.sugestoes = [];
    	$scope.assuntos = [];
        angular.element('#sugestoes').scope().model = null;
        angular.element('#sugestoes').scope().sugestoes = null;
    	angular.element('#assuntoSelecionado').scope().model = null;
    	angular.element('#assuntoSelecionado').scope().assuntoSelecionado = null;
    	TipoDocumentoPlanoClassificacaoRepository.findByIdJoin('tipoDocumento.id', $scope.documentoGed.tipoDocumento.id).then(function(result){
    		angular.forEach(result, function (item) {
				$scope.assuntos.push(item.planoClassificacao);
			});
    		
        	if($scope.documentoGed.tipoAssunto == 1){
        		$scope.sugestoes.push($scope.documentoGed.planoClassificacao);
        		angular.element('#sugestoes').scope().sugestoes = [];
        		angular.element('#sugestoes').scope().sugestoes.push($scope.documentoGed.planoClassificacao);
        	}else if($scope.documentoGed.tipoAssunto == 2 ) {

        		$scope.assuntoSelecionado = $scope.documentoGed.planoClassificacao;
        		angular.element('#assuntoSelecionado').scope().model =  $scope.assuntoSelecionado;
        		
        	}
    	});
 
    };
    
    $scope.downloadArquivo = function(idDocumento){
    	href = "/cit-ecm-web/rest/anexoGed/visualizar?idAnexo="+idDocumento;
    	
        $window.location.href = (href);

    };
    
    $scope.findAutoCompleteTipoSuporte = function(value){
    	return TipoSuporteDocumentoRepository.findAutoComplete("nome", value).then(function(result) {
            return result;
        });
    };
   
}]);
