'use strict';

citApp.controller('DocumentoGedListController', ['$scope', 'DocumentoGedRepository', '$translate', '$timeout', 'DominioRepository', function DocumentoGedListController($scope, DocumentoGedRepository, $translate, $timeout, DominioRepository) {
    $scope.$showAdvancedFilters = false;

    $scope.resetForm = function() {
        angular.element("#editDocumentoGed").scope().resetForm();
    };

    $scope.headers = [ {title : $translate.instant('LABEL.NUMERO'), value : 'numero' } ];

    $scope.filterCriteria = {
        start : 1,
        dir : 'asc',
        sort : 'id',
        limit : 10,
        fields: ['id', 'numero'],
        filters : [ {type : 'string', field : 'numero' } ]
    };
    
    // ABRI Documento SELECIONADA
    $scope.abrirVisualizar = function(edit){
        var documentoGed = $scope.documentoGedChecked;

        if(!documentoGed) {
            $scope.showAlert('warning', !edit ? $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_VISUALIZACAO') : $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_EDICAO'));
            return;
        }
        angular.element('#editDocumentoGed').scope().getDocumentoGed(documentoGed, edit);
        $scope.$showPageEditWorkspace($scope.workspace);
    };
}]);
