'use strict';

citApp.controller('GerenciarProcessoListUnidadeController', ['$scope', 'workflowFilterCriteriaService', 'appService', 'environmentService', 'FormBuilderRepository', 'FlowRepository', 'BusinessProcessRepository', 'RuntimeManagerRepository', 'DomainRepository', '$compile', '$translate', '$modal', '$injector', '$parse', '$rootScope', '$timeout', 'BusinessProcessCategoryRepository', 'GerenciarProcessoRepository', 'UnidadeProcessoRepository', 'DominioRepository', '$filter',
		function GerenciarProcessoListUnidadeController($scope, workflowFilterCriteriaService, appService, environmentService, FormBuilderRepository, FlowRepository, BusinessProcessRepository, RuntimeManagerRepository, DomainRepository, $compile, $translate, $modal, $injector, $parse, $rootScope, $timeout, BusinessProcessCategoryRepository, GerenciarProcessoRepository, UnidadeProcessoRepository, DominioRepository, $filter) {
	
	$scope.$showAdvancedFilters = false;
	$scope.btnAction = false;
	
	$scope.headers = [ {
		title : $translate.instant('ECM.LABEL.PROTOCOLO'),
		value : 'processo.nup'
	}, {
		title : $translate.instant('ECM.LABEL.TIPOPROCESSO'),
		value : 'processo.tipoProcesso.descricao'
	}, {
		title : $translate.instant('ECM.LABEL.ASSUNTO_COMPLEMENTAR'),
		value : 'processo.assuntoComplementar'
	}, {
		title : $translate.instant('ECM.LABEL.ATRIBUIDOA'),
		value : 'usuarioResponsavel.username'
	}, {
		title : $translate.instant('LABEL.SITUACAO'),
		value : 'processo.status.descricao'
	}, {
		title : $translate.instant('ECM.LABEL.NIVEL_DE_ACESSO'),
		value : 'processo.nivelAcesso.nivelAcesso.descricao'
	}];
	
	$scope.filterCriteria = {
		nome : 'GRID_PROCESSO_NA_UNIDADE',
		start : 1,
		dir : 'desc',
		sort : 'processo.dataCriacao',
		limit : 10,
		fields: ['id', 'processo.nup', 'processo.tipoProcesso.descricao', 'processo.assuntoComplementar','usuarioResponsavel.username', 'processo.status.descricao', 'processo.nivelAcesso.nivelAcesso.descricao', 'processo.dataCriacao', 'processo.idProcessInstance', 'processo.dataReferencia', 'processo.assunto'],
		filters : [
		           { type : 'string', field : 'processo.nup'},
		           { type : 'string', field : 'processo.tipoProcesso.descricao'},
		           { type : 'string', field : 'processo.assuntoComplementar'},
		           { type : 'string', field : 'usuarioResponsavel.username'},
		           { type : 'string', field : 'processo.status.descricao', listaDominio : []},
		           { type : 'string', field : 'processo.nivelAcesso.nivelAcesso.descricao'}
		          ]
	};
	
	function carregarDominiosStatusProcesso() {
		DominioRepository.findAllDominio('statusProcesso').then(function(result) {
			$scope.filterCriteria.filters[4].listaDominio = $filter('orderBy')(result, 'originalElement.descricao', true);
		});
	};
	
	var filterCriteriaDefault = angular.copy($scope.filterCriteria);
	
	$scope.atualizarGrid = function() {
		$scope.filterCriteria = angular.copy(filterCriteriaDefault);
		carregarDominiosStatusProcesso();
		$scope.filterResult();
	};
	
	$scope.abrirNovoProcesso = function() {
		$scope.openWorkspaceIfNotOpen($translate.instant('ECM.LABEL.NOVOPROCESSO'), '/cit-ecm-web/html/processo/processoNew.html', 'mod-orange');
		$timeout(function() {
			angular.element('#newProcesso').scope().$showPageEditWorkspace(angular.element('#newProcesso').scope().workspace);
			$timeout(function(){
				angular.element('#newProcesso').scope().resetForm();
			}, 1000);

	    }, 300);
	};
	
	$scope.obterTransclude = function() {
		$scope.setLoadingGet(true);
		 _getProcesso();
		 if($scope.modelSelecionado){
			 _getFilterCriteriaTarefa();
			 _fetchBusinessProcess();
		 } else {
			 $scope.setLoading(true);
		 }
	};
	
	function _getProcesso(){
		$scope.modelSelecionado = {};
		for(var count = 0; count < $scope.processos.length; count++){
			if($scope.processos[count].$show) {
				$scope.modelSelecionado = $scope.processos[count];
				break;
			}
		}

	};
	
	function _getFilterCriteriaTarefa(){
		var filterService = workflowFilterCriteriaService.getDefaultFilterCriteria();
		$scope.filterCriteriaBusinessProcess = {
				start : 1,
				sort : 'workItem.processInstance.id',
				limit : 10,
				deadline : 1,
				processDeadline : 1,
				timeManagementStatus : "",
				fields : [ 'workItem.id', 'workItem.processInstance.id'],
				filters : [{type: 'numeric', field: 'workItem.processInstance.id', value : $scope.modelSelecionado['processo.idProcessInstance']}
						 , {type: 'string', field: 'workItem.flowElement.name'}
						 , {type: 'string', field: 'workItem.processInstance.businessProcess.description'}
						 , {type: 'string', field: 'workItem.processInstance.flowStatus.name'}]
		};
		$scope.filterCriteriaBusinessProcess.username = filterService.username;
		$scope.filterCriteriaBusinessProcess.groups = filterService.groups;
	}
	
	function _fetchBusinessProcess() {
		$scope.assignments = [];
		$scope.btnAction = false;
		$scope.workItem = null;
		BusinessProcessRepository.tasksByParam($scope.filterCriteriaBusinessProcess).then(function(result) {
			$scope.assignments = result.originalElement.objects;
			if($scope.assignments.length > 0)
				_recuperarPermissoes($scope.assignments[0].id);
			else {
				$scope.modelSelecionado.$expandido = !$scope.modelSelecionado.$expandido;
				$scope.setLoading(false);
			}
		});
	};
	
	function _recuperarPermissoes(idAssignment){
		BusinessProcessRepository.getPermissions({id: idAssignment}).then(function(result) {
			$scope.workItem = result.originalElement;
			vincularWorkItemAssignments();
			$scope.btnAction = !(!$scope.workItem.execute && !$scope.workItem.suspend && !$scope.workItem.delegate && !$scope.workItem.restart && !$scope.workItem.visualize);
			$scope.modelSelecionado.$expandido = !$scope.modelSelecionado.$expandido;
			$scope.modelSelecionado.workItem = $scope.workItem;
			$scope.setLoading(false);
		});
	};
	
	function vincularWorkItemAssignments(){
		$scope.assignments.forEach(function(assignment){
			assignment.workItem = $scope.workItem;
			assignment.checked = false;
		});
		if($scope.assignments.length > 0){
			$scope.assignments[0].checked = true;
		}
	};

	$scope.selectAssignment = function(assignmentSelect) {
		$scope.assignments.forEach(function(assignment){
			assignment.checked = false;
			if(assignment.id == assignmentSelect.id){
				assignment.checked = true;
			}
		});
	};
	
	function _getAssignmentSelected() {
		for(var pos = 0; pos < $scope.assignments.length; pos++){
			if($scope.assignments[pos].checked){
				$scope.modelSelecionado.workItem = $scope.assignments[pos];
				break;
			}
		}
	};
	
	$scope.executarTarefa = function(){
		_getAssignmentSelected();
		if($scope.workItem){
			var pagina = '/cit-esi-web/assets/js/angular/custom/directive/html/userTask.html';
			if ($scope.workItem.flowElement.userInterface && $scope.workItem.flowElement.userInterface.executeCustomPage) {
				pagina = $scope.workItem.flowElement.userInterface.URLCustomPage;
				_abrirPaginaTarefa(pagina);
			}else if ($scope.workItem.flowElement.userInterface && $scope.workItem.flowElement.userInterface.resource && $scope.workItem.flowElement.userInterface.resourceName) {
				FormBuilderRepository.getByName($scope.workItem.flowElement.userInterface.resourceName).then(function(result) {
					pagina = '/cit-esi-web/forms/'+result.originalElement.path+'/'+result.originalElement.resource.name+"_task.html";
					_abrirPaginaTarefa(pagina);
				});
			}else{
				_abrirPaginaTarefa(pagina);
			}
		}
	};
	
	function _abrirPaginaTarefa(pagina){
		if (appService.existsWorkspace(pagina)) {
			$scope.showAlert('warning', $translate.instant('ESI.MSG.JA_EXISTE_TELA_TAREFA'));
			return ;
		}
		$scope.processInstance = $scope.modelSelecionado.workItem.processInstance;
		$scope.processInstance.collapsed = true;
		$scope.processInstance.collapsedError = true;
		$rootScope.task = $scope.workItem;
		$rootScope.processInstance = $scope.processInstance;
		$rootScope.controllerScope = $scope;

		var nome = $scope.task.flowElement.description;
		if (!nome || nome == '')
			nome = $scope.workItem.flowElement.name;

		$scope.addNewWorkspace($translate.instant('ESI.PERMISSAO.EXECUTAR')+" "+$translate.instant('ESI.TAREFA').toLowerCase()+" '"+nome+"'", pagina, true, 'mod-red-dark', $scope.workItem);
	};
	
	$scope.suspenderProcesso = function(){
		_getAssignmentSelected();
		$scope.$openModalConfirm({
			message: $translate.instant('ECM.MSG.CONFIRMA_SOBRESTAMENTO_TAREFA'),
			callback: function () {
				$scope.$modalConfirmInstance.dismiss('cancel');
				$scope.setLoading(true);
				RuntimeManagerRepository.suspendProcessInstance($scope.modelSelecionado.workItem.processInstance.id).then(function(result) {
					$scope.setLoading(false);
					$scope.modelSelecionado.$expandido = !$scope.modelSelecionado.$expandido;
					$scope.modelSelecionado.$show = !$scope.modelSelecionado.$show;
					$scope.showAlert("success","ECM.MSG.TAREFA_SOBRESTADA_SUCESSO","");
				});
			}
		});
	};
	
	$scope.reativarProcesso = function(){
		_getAssignmentSelected();
		$scope.$openModalConfirm({
			message: $translate.instant('ECM.MSG.CONFIRMA_REATIVACAO_TAREFA'),
			callback: function () {
				$scope.$modalConfirmInstance.dismiss('cancel');
				$scope.setLoading(true);
				RuntimeManagerRepository.restartProcessInstance($scope.modelSelecionado.workItem.processInstance.id).then(function(result) {
					$scope.setLoading(false);
					$scope.modelSelecionado.$expandido = !$scope.modelSelecionado.$expandido;
					$scope.modelSelecionado.$show = !$scope.modelSelecionado.$show;
					$scope.showAlert("success","ECM.MSG.TAREFA_REATIVADA","");
				});
			}
		});
	};

	$scope.visualizarFluxo = function(){
		_getAssignmentSelected();
		var pagina = '/cit-esi-web/assets/js/angular/custom/directive/html/visualizacaoEsi.html';
		if (appService.existsWorkspace(pagina)) {
			$scope.showAlert('warning', $translate.instant('ESI.MSG.JA_EXISTE_TELA_VISUALIZACAO'));
			return ;
		}
		$scope.tarefa = $scope.modelSelecionado.workItem;
		$scope.instancia = $scope.tarefa.processInstance;
		$rootScope.tarefa = $scope.tarefa;
		$rootScope.instancia = $scope.instancia;
		$rootScope.controllerScope = $scope;
		$scope.addNewWorkspace($scope.modelSelecionado.workItem.processInstance.businessProcess.description, pagina, true, 'mod-red-dark', $scope.tarefa);
	};
	
	$scope.consultarHistorico = function(){
		_getAssignmentSelected();
		var pagina = '/cit-esi-web/assets/js/angular/custom/directive/html/consultaLog.html';
		if (appService.existsWorkspace(pagina)) {
			$scope.showAlert('warning', $translate.instant('ESI.MSG.JA_EXISTE_TELA_HISTORICO'));
			return ;
		}
		$scope.processInstance = $scope.modelSelecionado.workItem.processInstance;
		$rootScope.processInstance = $scope.processInstance;
		$rootScope.controllerScope = $scope;
		$scope.processInstance.collapsed = true;
		$scope.processInstance.collapsedError = true;
		$scope.processInstance.instances = [];
		$scope.addNewWorkspace($scope.modelSelecionado.workItem.processInstance.businessProcess.description, pagina, true, 'mod-red-dark', $scope.processInstance);
	};
	
	carregarDominiosStatusProcesso();
}]);