'use strict';

citApp.controller('HipoteseLegalController', ['$scope', 'HipoteseLegalRepository', '$translate', '$timeout', 'DominioRepository', 'SigiloRepository', function HipoteseLegalController($scope, HipoteseLegalRepository, $translate, $timeout, DominioRepository, SigiloRepository) {

    $scope.hipoteseLegal = {
    		sigilo : {}
    };
    
    // Limpa formulário para novo cadastro   
	$scope.resetForm = function() {
		$scope.limparHipoteseLegal();
		$scope.edit = true;
		$scope.pgEdit = true;
		$scope.isBloquear = false;
		$scope.isDesbloquear = $scope.isBloquear;
		$timeout(function(){
			$scope.hipoteseLegalForm.$submitted = false;
			$scope.hipoteseLegalForm.$setPristine();
		});
	};
    

    // Atualiza pagina de pesquisa
    $scope.atualizaPaginaPesquisa = function () {
        angular.element('#searchHipoteseLegal').scope().fetchResult();
    };

    // MODAL QUE CONFIRMA REMOVER DA CIDADE
    $scope.remove = function(hipoteseLegal){
        $scope.hipoteseLegal = hipoteseLegal;
        $scope.$openModalConfirm({
            message: $translate.instant('MSG.CONFIRMA_EXCLUSAO'),
            callback: function () {
                HipoteseLegalRepository.remove($scope.hipoteseLegal).then(function() {

                    $scope.$modalConfirmInstance.dismiss('cancel');
                    $scope.showAlert("success", $translate.instant('MSG.REGISTRO_EXCLUIDO'));
                    angular.element('#searchHipoteseLegal').scope().fetchResult();

                    $scope.resetForm();
                });
            }
        });
    };

    // SALVA O HipoteseLegal
    $scope.saveOrUpdate = function(){
        $scope.hipoteseLegalForm.$submitted = true;
        
        //verifica se o formulario está valido para salvar
        if($scope.hipoteseLegalForm.$valid){

            $scope.setLoadingSalva(true);

            HipoteseLegalRepository.save($scope.hipoteseLegal).then(function(result) {
                $scope.hipoteseLegal = result.originalElement;
                $scope.showAlert("success", $translate.instant('MSG.REGISTRO_SALVO'));
                $scope.hipoteseLegalForm.$submitted = false;
            });
            $scope.setLoading(false);
        }else{
            //Mensagem de erro de campos obrigatorios não preenchidos
        	  $scope.showAlert('error', $translate.instant('MSG.MN001'), " ", false);
        }
    };
    
	DominioRepository.findAllDominio('tipoNivelAcesso').then(function(result) {
		
		$scope.dominiosNivelSigilo = [];
		
		angular.forEach(result, function (item) {
			
			if(item.codigo != 2){
				
				$scope.dominiosNivelSigilo.push(item);
			}
			
		});
		
	});

    // Limpa o formulario preenchido
    $scope.limparHipoteseLegal = function(){
        $scope.hipoteseLegal = {};
    };
    
    //Limpa o campo tipo sigilo
    $scope.limparSigilo = function(){
    	
    	if($scope.hipoteseLegal.nivelAcesso && $scope.hipoteseLegal.nivelAcesso.codigo != 0){
    		
    		$scope.hipoteseLegal.sigilo = null;
    	}
    };
    
	SigiloRepository.getList().then(function(result) {
		$scope.sigiloList = result;
	});

    // Consulta entidade e mostra no formulario
    $scope.getHipoteseLegal = function(hipoteseLegal, edit){
        $scope.setLoadingGet(true);

        HipoteseLegalRepository.get(hipoteseLegal.id).then(function(result) {
            $scope.hipoteseLegal = result.originalElement;
            $scope.edit = edit;
            $scope.setLoading(false);
        });
    };
}]);
