'use strict';

citApp.controller('HipoteseLegalListController', ['$scope', 'HipoteseLegalRepository', '$translate', '$timeout', 'DominioRepository', 'ProcessoRepository', 'DocumentoGedRepository', function HipoteseLegalListController($scope, HipoteseLegalRepository, $translate, $timeout, DominioRepository, ProcessoRepository, DocumentoGedRepository) {
    $scope.$showAdvancedFilters = false;

    $scope.resetForm = function() {
        angular.element("#editHipoteseLegal").scope().resetForm();
    };

   
    $scope.headers = [ {title : $translate.instant('ECM.LABEL.DATACRIACAO'), value : 'dataCriacao', filter : 'dateBR' } , {title : $translate.instant('LABEL.NOME'), value : 'nome' } ,
                       {title : $translate.instant('LABEL.DESCRICAO'), value : 'descricao' }, {title : $translate.instant('ECM.LABEL.NIVEL_ACESSO'), value : 'nivelAcesso.descricao'}];

    $scope.filterCriteria = {
        start : 1,
        dir : 'asc',
        sort : 'id',
        limit : 10,
        fields: ['id', 'dataCriacao', 'nome', 'descricao', 'nivelAcesso.descricao'],
        filters : [ {type : 'date', field : 'dataCriacao' } , {type : 'string', field : 'nome' } , {type : 'string', field : 'descricao' }, {type : 'string', field : 'nivelAcesso.descricao' }]
    };
    
    
    
    // ABRI HipoteseLegal SELECIONADA
    $scope.abrirVisualizar = function(edit){
        var hipoteseLegal = $scope.hipoteseLegalChecked;
        
        $scope.contemVinculoProcesso = null;
        $scope.contemVinculoDocumento = null;

        if(!hipoteseLegal) {
            $scope.showAlert('warning', !edit ? $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_VISUALIZACAO') : $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_EDICAO'));
            return;
        }
        
        if(edit){
        	
        	ProcessoRepository.existeVinculo({"joinClass": 'hipoteseLegal.id', "id": hipoteseLegal.id}).then(function(result) {
        		 
        		$scope.contemVinculoProcesso = result;
        		
        		DocumentoGedRepository.existeVinculo({"joinClass": 'hipoteseLegal.id', "id": hipoteseLegal.id}).then(function(result) {
        			
        			$scope.contemVinculoDocumento = result;	
        		
        		});

        		
        	 });
           
        }
        
       	$timeout(function(){
   		 if($scope.contemVinculoProcesso || $scope.contemVinculoDocumento){

                $scope.showAlert('warning', $translate.instant('MSG.EDICAO_HIPOTESE_LEGAL'));
                 return;
            }else{
                angular.element('#editHipoteseLegal').scope().getHipoteseLegal(hipoteseLegal, edit);
                $scope.$showPageEditWorkspace($scope.workspace);
            }
   		 
		});
   
    };
}]);
