'use strict';

citApp.controller('HistoricoAlteracaoProcessoController', ['$scope', 'HistoricoAlteracaoProcessoRepository', '$translate', '$timeout', function HistoricoAlteracaoProcessoController($scope, HistoricoAlteracaoProcessoRepository, $translate, $timeout) {

	$scope.idProcesso = {};
	$scope.listHistoricos = {};
	$scope.numeroHistoricos = 0;
	$scope.exibidos = 0;
	$scope.maxExibidos = 0;
	$scope.expandido = false;

	$scope.$watch('$parent.idProcesso', function(newVal, oldVal){
		$scope.idProcesso = newVal;
		if($scope.idProcesso && newVal != oldVal){
			$scope.findByProcessoPaginado($scope.idProcesso, 0, 5);
			$scope.countByProcesso($scope.idProcesso);
		}
	});
	
    $scope.atualizar = function (){
        $scope.findByProcessoPaginado($scope.idProcesso, 0, 5);
        $scope.countByProcesso($scope.idProcesso);
    };
    
    $scope.atualizar = function (idProcesso){
    	$scope.idProcesso = $scope.idProcesso;
        $scope.findByProcessoPaginado($scope.idProcesso, 0, 5);
        $scope.countByProcesso($scope.idProcesso);
    };

	
	$scope.verMais = function() {
		$scope.findByProcessoPaginado($scope.idProcesso, 0, $scope.maxExibidos);
		$scope.expandido = true;
	};
	
	$scope.minimizar = function() {
		$scope.findByProcessoPaginado($scope.idProcesso, 0, 5);
		$scope.expandido = false;
	};
	
	$scope.findByProcessoPaginado = function(idProcesso, inicio, max) {
		$scope.setLoading(true);
		HistoricoAlteracaoProcessoRepository.findByProcessoPaginado(idProcesso, inicio, max).then(function(result) {
			$scope.listHistoricos = result;
			$scope.exibidos = max;
			$scope.maxExibidos = max + 10;
			$scope.setLoading(false);
		});	
	};
	
	$scope.countByProcesso = function(idProcesso) {
		$scope.setLoading(true);
		HistoricoAlteracaoProcessoRepository.countByProcesso(idProcesso).then(function(result) {
			$scope.setLoading(false);
			$scope.numeroHistoricos = result;
		});	
	};
	
	
}]);
