'use strict';

citApp.controller('JustificativaAcaoProcessoController', ['$scope',  '$translate', '$timeout','JustificativaAcaoProcessoRepository','HistoricoAlteracaoProcessoRepository', function JustificativaAcaoProcessoController($scope, $translate, $timeout, JustificativaAcaoProcessoRepository, HistoricoAlteracaoProcessoRepository) {

	$scope.resetForm = function( ){
		
		$scope.edit = true;
		$scope.justificativaAcaoProcesso = {
			   processo : $scope.$parent.processo,
			   idTask : $scope.$parent.$parent.task.id,
			   acaoProcesso : $scope.$parent.$parent.flowAction.name
		};
		
	
		  this.justificativaAcaoProcessoForm = $scope.justificativaAcaoProcessoController.justificativaAcaoProcessoForm;

        
        $timeout(function(){
            $scope.justificativaAcaoProcessoForm.$submitted = false;
            $scope.justificativaAcaoProcessoForm.$setPristine();
        });
        		

	};
	
	$scope.getJustificativaAcaoProcesso = function(idJustificativaAcaoProcesso){
		
		 JustificativaAcaoProcessoRepository.get(idJustificativaAcaoProcesso).then(function(result) {
			 
			 $scope.justificativaAcaoProcesso = result.originalElement;
			 
			 $scope.edit = false;
		 });
	};
	
	$scope.findAutoCompleteSolicitante = function(value){
		 return PessoaRepository.findAutoComplete('nome', value).then(function(result) {
			return result;
		 });
	};
	
	$scope.justificar = function(){
		
		$scope.justificativaAcaoProcessoForm.$submitted = true;
		
		if($scope.justificativaAcaoProcessoForm.$invalid){
			
			   $scope.showAlert('error', $translate.instant('VALIDACAO.ALERTA_OBRIGATORIOS'), " ", false);
		}else{
			var mensagem = $translate.instant('MSG.CONFIRMA_EXECUCAO_FLUXO');
			    mensagem += $scope.justificativaAcaoProcesso.acaoProcesso;
			    $scope.$openModalConfirm({message: mensagem , callback: $scope.saveOrUpdate});
		}
		
	};
	
	//Salvar
	 $scope.saveOrUpdate = function(){
		 
		   $scope.setLoadingSalva(true);
		   $scope.$modalConfirmInstance.dismiss('cancel');
		   JustificativaAcaoProcessoRepository.save($scope.justificativaAcaoProcesso).then(function(result) {
		   	
		       $scope.justificativaAcaoProcessoForm.$submitted = false;
		       $scope.showAlert("success", $translate.instant('MSG.REGISTRO_SALVO'));
		       $scope.setLoading(false);
		       
		       $timeout(function(){
		    	   $scope.saveHistoricoProcesso();
		       });
		       
		       $scope.$parent.$parent.updateTask(true);       
		       
		   });
		        
	   };
	   
	   //Salvar Historico processo
	   $scope.saveHistoricoProcesso = function(){
		   
		   var processo = {
				   
				   id : $scope.processo.id
		   };
		   //Gerar historico de justificativa
		   var historicoAlteracaoProcesso = {
				   descricaoAcao :  $translate.instant('ECM.MSG_HISTORICO_ECM.JUSTIFICATIVA_ACAO_PROCESSO'),
				   processo : processo,
				   autor : $scope.usuarioLogado,
				   acaoAlteracao : "JUSTIFICATIVA_ACAO_PROCESSO",
				   mapaAtributos : {"protocolo" :  $scope.processo.nup, 
					   				"acao" : $scope.$parent.flowAction.name,
					   				"justificativa": $scope.justificativaAcaoProcesso.justificativa
					   				
				   					}
		   };
		   
		   HistoricoAlteracaoProcessoRepository.saveParams(historicoAlteracaoProcesso).then(function(result){
			   
		   }); 
	   
	   };

}]);