'use strict';

citApp.controller('PlanoClassificacaoController', ['$scope', 'PlanoClassificacaoRepository', '$translate', '$timeout', 'DominioRepository', '$filter', function PlanoClassificacaoController($scope, PlanoClassificacaoRepository, $translate, $timeout, DominioRepository, $filter) {

    $scope.planoClassificacao = {};

    // Limpa formulário para novo cadastro
    $scope.resetForm = function(planoCLassificacaoPai) {
    	
    	$scope.planoClassificacao = {
    			
    			permitirUsarComoClassificacao : false
    	};
    	 
    	$scope.edit = true;
        
		if(planoCLassificacaoPai){
			 $scope.planoClassificacao.planoClassificacaoParent = planoCLassificacaoPai.originalElement;
		}
        $timeout(function(){
            $scope.planoClassificacaoForm.$submitted = false;
            $scope.planoClassificacaoForm.$setPristine();
        });
    };
    
    //Listar plano de classificacao
    $scope.findClassificacaoSuperior =  function(value){
        return PlanoClassificacaoRepository.findAutoComplete('nome', value).then(function(result) {
        	return $filter('idNotObject')(result, $scope.planoClassificacao);
        });
      };

    // Atualiza pagina de pesquisa
    $scope.atualizaPaginaPesquisa = function () {
        angular.element('#searchPlanoClassificacao').scope().voltar();
    };

    // MODAL QUE CONFIRMA REMOVER DA CIDADE
    $scope.remove = function(planoClassificacao){
        $scope.planoClassificacao = planoClassificacao;
        $scope.$openModalConfirm({
            message: $translate.instant('MSG.CONFIRMA_EXCLUSAO'),
            callback: function () {
                PlanoClassificacaoRepository.remove($scope.planoClassificacao).then(function() {

                    $scope.$modalConfirmInstance.dismiss('cancel');
                    $scope.showAlert("success", $translate.instant('MSG.REGISTRO_EXCLUIDO'));
                    angular.element('#searchPlanoClassificacao').scope().fetchResult();

                    $scope.resetForm();
                });
            }
        });
    };

    // SALVA O PlanoClassificacao
    $scope.saveOrUpdate = function(){
        $scope.planoClassificacaoForm.$submitted = true;

        //verifica se o formulario está valido para salvar
        if($scope.planoClassificacaoForm.$valid){

            $scope.setLoadingSalva(true);
            
              delete $scope.planoClassificacao.contemFilhos;
     
              if($scope.planoClassificacao.planoClassificacaoParent){
                 delete $scope.planoClassificacao.planoClassificacaoParent.contemFilhos;
            	  
              }
            $scope.planoClassificacao.nome = $scope.planoClassificacao.nome.toUpperCase();
            PlanoClassificacaoRepository.save($scope.planoClassificacao).then(function(result) {
                $scope.planoClassificacao = result.originalElement;
                $scope.showAlert("success", $translate.instant('MSG.MG001'));
                $scope.planoClassificacaoForm.$submitted = false;
            });
            $scope.setLoading(false);
        }else{
            //Mensagem de erro de campos obrigatorios não preenchidos
        	  $scope.showAlert('error', $translate.instant('MSG.MN001'), " ", false);
        }
    };

    // Consulta entidade e mostra no formulario
    $scope.getPlanoClassificacao = function(planoClassificacao, edit){
        $scope.setLoadingGet(true);

        PlanoClassificacaoRepository.get(planoClassificacao.id).then(function(result) {
            $scope.planoClassificacao = result.originalElement;
            $scope.edit = edit;
            $scope.setLoading(false);
        });
        
        $timeout(function(){
            $scope.planoClassificacaoForm.$submitted = false;
            $scope.planoClassificacaoForm.$setPristine();
        });
    };

    //# Obter dominios
    DominioRepository.findAllDominio('tipoDestinacao').then(function(result) {
        $scope.tipoDestinacaoList = result;
    });
    //Obter tipoPlanoClassificação
    DominioRepository.findAllDominio('tipoPlanoClassificacao').then(function(result) {
    	
    	$scope.tipoPlanoClassificacaoList = [];
    	
    	angular.forEach(result, function(item) {
    		$scope.tipoPlanoClassificacaoList.push(item.originalElement);
    		
    	});
    	
    }); 

}]);
