'use strict';

citApp.controller('ProcessoController', ['$scope', 'ProcessoRepository', 'DominioRepository', '$translate', '$timeout', 'TipoDocumentoRepository', 'EstruturaOrganizacionalRepository', 'PessoaRepository', 'NivelAcessoTipoProcessoRepository', 'TipoProcessoRepository', 'PlanoClassificacaoRepository', 'TipoProcessoPlanoClassificacaoRepository', '$filter', 'HipoteseLegalRepository', 'HistoricoAlteracaoProcessoRepository','InteressadoProcessoRepository', function ProcessoController($scope, ProcessoRepository, DominioRepository, $translate, $timeout, TipoDocumentoRepository , EstruturaOrganizacionalRepository , PessoaRepository,  NivelAcessoTipoProcessoRepository,TipoProcessoRepository ,PlanoClassificacaoRepository, TipoProcessoPlanoClassificacaoRepository, $filter, HipoteseLegalRepository, HistoricoAlteracaoProcessoRepository, InteressadoProcessoRepository) {

    $scope.processo = {};
    $scope.assuntoPlanoClassificacao = null;
    $scope.edit = true;
    $scope.processo.tipoProtocolo = {
    		codigo : 1
    };
    
    $scope.setForm = function(scope){
 	   this.processoForm = scope.processoForm;
    };

    // Limpa formulário para novo cadastro
    $scope.resetForm = function() {

    	$scope.limparProcesso();
       
        $scope.edit = true;
        $timeout(function(){
            $scope.processoForm.$submitted = false;
            $scope.processoForm.$setPristine();
        });
        
    };

    // Atualiza pagina de pesquisa
    $scope.atualizaPaginaPesquisa = function () {
        angular.element('#searchProcesso').scope().fetchResult();
    };

    // MODAL QUE CONFIRMA REMOVER DA CIDADE
    $scope.remove = function(processo){
        $scope.processo = processo;
        $scope.$openModalConfirm({
            message: $translate.instant('MSG.CONFIRMA_EXCLUSAO'),
            callback: function () {
                ProcessoRepository.remove($scope.processo).then(function() {

                    $scope.$modalConfirmInstance.dismiss('cancel');
                    $scope.showAlert("success", $translate.instant('MSG.REGISTRO_EXCLUIDO'));
                    angular.element('#searchProcesso').scope().fetchResult();

                    $scope.resetForm();
                });
            }
        });
    };

    // SALVA O Processo
    $scope.saveOrUpdate = function(){
    	
       $scope.processoForm.$submitted = true;

        //verifica se o formulario está valido para salvar
        if($scope.processoForm.$valid){
        	
        	var isNew = true;
        	if($scope.processo.id != null){
        		isNew = false;
        	}

        	$scope.removerPropriedades();
        	
        	$scope.setLoadingSalva(true);

            ProcessoRepository.save($scope.processo).then(function(result) {
                $scope.processo = result.originalElement;

            	if(isNew){
            		
            		$scope.showAlert("success", $translate.instant('ECM.MSG.SALVO_SUCESSO'), $translate.instant('ECM.MSG.O_PROCESSO') + " " + $scope.processo.nup);
            		
	                $scope.setLoadingSalva(false);
	                
	                $scope.resetForm();
	                
            	} else {
            		$scope.showAlert("success", $translate.instant('MSG.REGISTRO_SALVO'));
	                var historicoAlteracaoProcesso = {
	                		descricaoAcao :  $translate.instant('ECM.MSG_HISTORICO_ECM.ALTERACAO_METADADO_PROCESSO'),
	                		processo : $scope.processo,
	                		autor : $scope.usuarioLogado,
	                		acaoAlteracao : "ALTERACAO_METADADO_PROCESSO"
	                };
	                HistoricoAlteracaoProcessoRepository.saveParams(historicoAlteracaoProcesso).then(function(result){
	                	
	                	$scope.setLoadingSalva(false);
	                	
	                }); 
	                
	                $scope.$parent.$parent.atualizaProcesso();
            	}
            	$scope.processoForm.$submitted = false;
            });
          
        }else{
            //Mensagem de erro de campos obrigatorios não preenchidos
        	  $scope.showAlert('error', $translate.instant('MSG.MN001'), " ", false);
        }
    };

    // Limpa o formulario preenchido
    $scope.limparProcesso = function(){
        $scope.processo = {};
        $scope.assuntoPlanoClassificacao = null;
        $scope.assuntoSelecionado = null;
    	$scope.sugestoes = null;
    	$scope.assuntos = [];
    	angular.element('#sugestoes').scope().sugestoes = null;
    	angular.element('#assuntoSelecionado').scope().limparCampo();
    	
        $scope.processo.tipoProtocolo = {
        		codigo : 1
        };

    };

    // Consulta entidade e mostra no formulario
    $scope.getProcesso = function(processo, edit){
    	
    	$scope.processoForm = $scope.processoEditController.processoForm;
    	
        $scope.setLoadingGet(true);

        ProcessoRepository.get(processo.id).then(function(result) {
            $scope.processo = result.originalElement;
            $scope.edit = edit;
            $scope.setLoading(false);            
  	 	    $scope.findSugestaoAssunto($scope.processo.tipoProcesso);
	 	    $scope.findNivelAcessoTipoProcesso($scope.processo.tipoProcesso);
            $scope.montarHipotese();
            $scope.setAssuntoModelByTipoAssunto();           
        });
    };
    
    $scope.setAssuntoModelByTipoAssunto = function(){
    	$scope.sugestoes = [];
    	$scope.assuntos = [];
    	    	
	   	if($scope.processo.tipoAssunto == 1){
    		$scope.sugestoes.push($scope.processo.assunto);    		
    	}else if($scope.processo.tipoAssunto == 2 ) {
    		$scope.assuntoSelecionado = $scope.processo.assunto; 
    	}
 
    };
    
    
    $scope.removerPropriedades = function(){
        delete $scope.processo.nivelAcesso.nivelAcessoDescricao;

    };

    
    $scope.findAutoCompleteTipoProcesso = function(value){
        return TipoProcessoRepository.findAutoComplete('nome', value).then(function(result) {
            return result;
        });
    };
            
    $scope.findAutoCompleteUnidade = function(value){
        return EstruturaOrganizacionalRepository.listarEstruturasOrganizacionaisBuscaSimples(value).then(function(result) {
            return result;
        });
    };
            
    $scope.findAutoCompleteInteressados = function(value){
    	 return PessoaRepository.findAutoComplete('nome', value).then(function(result) {
    		 return $filter('idNotEqualObj')(result, $scope.processo.interessados, 'interessado');
         });
    };
            
    $scope.findAutoCompleteAssunto = function(value){
    	
        return PlanoClassificacaoRepository.findAssuntoAutoComplete(value).then(function(result) {
            return result;
        });
    };
    
    $scope.findSugestaoAssunto = function(tipoProcesso){
    
    	$scope.assuntos = [];
    	
    	TipoProcessoPlanoClassificacaoRepository.findPorTipoProcesso(tipoProcesso.id).then(function(result){
    		
    		angular.forEach(result, function (item) {
				$scope.assuntos.push(item.planoClassificacao);
			});
			
    	});
    };
    
    $scope.findNivelAcessoTipoProcesso = function(tipoProcesso){
    	$scope.nivelAcessoList = [];
    	
  	   NivelAcessoTipoProcessoRepository.findPorIdTipoProcesso(tipoProcesso.id).then(function(result) { 		   
	    	$scope.nivelAcessoList = result;
	    	
	    	/* $scope.processo.nivelAcesso = $.grep($scope.nivelAcessoList, function(e){ return e.nivelAcesso.codigo == 2; })[0].originalElement;	 */
    	});    	
    };
    
    $scope.constroiRelacionamentoTipoProcesso = function(tipoProcesso){
	
	 	  $scope.findSugestaoAssunto(tipoProcesso);
	 	   
	 	  $scope.findNivelAcessoTipoProcesso(tipoProcesso);
	 	  
    };

     
 	//SET HIPOTESE LEGAL #INICIO	
 	$scope.setHipoteseLegal = function(){
 		
 		$scope.hipoteses = [];
 		
 		$scope.processo.hipoteseLegal = null;
 		
 		 $timeout(function(){
 			//Limpar o tipoSigiloDocumento caso o nivel selecionado seja diferente de sigiloso
 			if($scope.processo.nivelAcesso && $scope.processo.nivelAcesso.nivelAcesso.codigo != 0 || !$scope.processo.nivelAcesso){
 				
 				$scope.processo.sigilo = {};
 			};
 			if($scope.processo.sigilo && $scope.processo.sigilo.id){
 	
 	 			HipoteseLegalRepository.findPorNivelAcesso($scope.processo.sigilo.id).then(function(result) {
 	 				
 	 				$scope.hipoteses = result;
 	 				
 	 			});
 	 		}else if($scope.processo.nivelAcesso && $scope.processo.nivelAcesso.nivelAcesso.codigo === 1){
 	 			
 	 			HipoteseLegalRepository.findPorNivelAcesso($scope.processo.nivelAcesso.nivelAcesso.id).then(function(result) {
 	 				
 	 				$scope.hipoteses = result;
 	 				
 	 			});
 	 		}
 		 });
 	};
 	
	//SET HIPOTESE LEGAL #INICIO	
	$scope.montarHipotese = function(){
		
		$scope.hipoteses = null;

			if($scope.processo.sigilo && $scope.processo.sigilo.id){
			 	
 	 			HipoteseLegalRepository.findPorNivelAcesso($scope.processo.sigilo.id).then(function(result) {
 	 				
 	 				$scope.hipoteses = result;
 	 				
 	 			});
 	 		}else if($scope.processo.nivelAcesso && $scope.processo.nivelAcesso.nivelAcesso.codigo === 1){
 	 			
 	 			HipoteseLegalRepository.findPorNivelAcesso($scope.processo.nivelAcesso.nivelAcesso.id).then(function(result) {
 	 				
 	 				$scope.hipoteses = result;
 	 				
 	 			});
 	 		}
	};

    $scope.setInteressados = function(item){
        if(!$scope.processo.interessados){
            $scope.processo.interessados = [];
        }
        $scope.processo.interessados.push({
            interessado : item
        });
        //Limpa autoComplete de interessado
        $timeout(function(){
        	 if($scope.processoForm && $scope.processoForm['interessado']) {
 				$scope.processoForm['interessado'].$setViewValue('');
 				$scope.processoForm['interessado'].$render();
        	 };
        });
    };

    $scope.removerInteressados = function(){
        if($scope.interessadoChecked){
            $scope.$openModalConfirm({message: $translate.instant('MSG.DESEJA_EXCLUIR_ITENS'), callback: $scope.excluirInteressado, item: $scope.interessadoChecked});
        }else{
        	  $scope.showAlert('warning', $translate.instant('MSG.SELECIONE_ITEM_EXCLUIR'), " ", false);
        }
    };
    
    //Setar o interessado para remoção.
    $scope.setInteressadoRemocao = function(interessadoRemocao, $index){
    	$scope.interessadoChecked = interessadoRemocao;
    	$scope.interessadoChecked.$index = $index;
    };
   
    //Remove o interessado
    $scope.excluirInteressado = function() {
        var obj = this.item;
        if (obj.id) {
        	InteressadoProcessoRepository.remove(obj).then(function() {
        		
        	});        	
        }
        $scope.showAlertSucesso("success", $translate.instant('MSG.REGISTRO_EXCLUIDO'));
        $scope.processo.interessados.splice(obj.$index, 1);
        $scope.$modalConfirmInstance.dismiss('cancel');
        
        $scope.interessadoChecked = null;
    };
    
    
    

    DominioRepository.findAllDominio('tipoProtocoloNup').then(function(result) {
        $scope.dominiosTipoProtocoloNup = result;
    });
    
    
	$scope.novaPessoa = function() {
		$scope.openWorkspaceIfNotOpen($translate.instant('LABEL.PESSOA'), '/cit-tabelas-corp-web/html/pessoa/pessoa.html', 'mod-blue');

		$timeout(function() {
			angular.element('#searchPessoa').scope().$showPageEditWorkspace(angular.element('#searchPessoa').scope().workspace);
			angular.element('#pessoaEdit').scope().resetForm();

	    }, 600);

	};

	
	$scope.setAssunto = function(itens){
		
		$scope.processo.tipoAssunto = 1;
		if(itens.length > 1){
			
			$scope.processo.assunto = itens[itens.length - 1];
			$scope.sugestoes = [];
			$scope.sugestoes.push($scope.assunto);
			
		}else{
			
			$scope.processo.assunto = itens[0];
		}
	};
	
	$scope.setTipoAssunto = function(assuntoSelecionado){
		
		$scope.processo.tipoAssunto = 2;
		$scope.processo.assunto = assuntoSelecionado;
	};
	
	$scope.inicializarProcesso = function(){
	
		$timeout(function() {
			$scope.processoForm = $scope.processoNewController.processoForm;
		 });
	};
	
            
}]);
