'use strict';

citApp.controller('ProcessoListController', ['$scope', 'ProcessoRepository', '$translate', '$timeout', 'DominioRepository', function ProcessoListController($scope, ProcessoRepository, $translate, $timeout, DominioRepository) {
    $scope.$showAdvancedFilters = false;

    $scope.resetForm = function() {
        angular.element("#editProcesso").scope().resetForm();
    };

    $scope.headers = [{title : $translate.instant('ECM.LABEL.TIPOPROCESSO'), value : 'tipoProcesso.nome'}, {title : $translate.instant('LABEL.NUP'), value : 'nup' } , {title : $translate.instant('ECM.LABEL.ASSUNTOCOMPLEMENTAR'), value : 'assuntoComplementar' }];

    $scope.filterCriteria = {
        start : 1,
        dir : 'asc',
        sort : 'id',
        limit : 10,
        fields: ['id', 'tipoProcesso.nome', 'nup', 'assuntoComplementar'],
        filters : [{type : 'string', field : 'tipoProcesso.nome' }, {type : 'string', field : 'nup' } ,  {type : 'string', field : 'assuntoComplementar' } ]
    };
    
    // ABRI Processo SELECIONADA
    $scope.abrirVisualizar = function(edit){
        var processo = $scope.processoChecked;

        if(!processo) {
            $scope.showAlert('warning', !edit ? $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_VISUALIZACAO') : $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_EDICAO'));
            return;
        }
        angular.element('#editProcesso').scope().getProcesso(processo, edit);
        $scope.$showPageEditWorkspace($scope.workspace);
    };
}]);
