'use strict';

citApp.controller('ProcessoRelacionadoController', ['$scope', 'ProcessoRelacionadoRepository', 'ProcessoRepository','HistoricoAlteracaoProcessoRepository','$filter', '$translate', '$timeout', function ProcessoRelacionadoController($scope, ProcessoRelacionadoRepository,ProcessoRepository, HistoricoAlteracaoProcessoRepository, $filter, $translate, $timeout) {
		
		$scope.processo = null;
		
    	$scope.processoRelacionadoVH = {
	        	processo : null,
				listaProcessoRelacionado : []
		};
		
		$scope.setForm = function(scope){
			
		   this.processoRelacionadoForm = $scope.processoRelacionadoForm;
		   
		};
		
		$scope.saveOrUpdate = function(){
						
		    $scope.processoRelacionadoForm.$submitted = true;
		
		    //verifica se o formulario está valido para salvar
		if($scope.processoRelacionadoForm.$valid){
		
			$scope.processoRelacionadoVH.listaProcessoRelacionado = $scope.retornaListaSave($scope.processoRelacionadoVH.listaProcessoRelacionado);
			
		    $scope.setLoadingSalva(true);
		    $scope.processoRelacionadoVH.processo = $scope.$parent.$parent.processo;
		    ProcessoRelacionadoRepository.save($scope.processoRelacionadoVH).then(function(result) {
		    	$scope.historicoAlteracao($scope.processoRelacionadoVH.listaProcessoRelacionado);
		        $scope.processoRelacionadoVH = result.originalElement;
		        $scope.showAlert("success", $translate.instant('MSG.REGISTRO_SALVO'));
		        $scope.processoRelacionadoForm.$submitted = false;

		        $scope.getProcessoRelacionado();
		    });
		    
		    $scope.setLoading(false);
		    
		}else{
		    //Mensagem de erro de campos obrigatorios não preenchidos
		    $scope.showAlert('error', $translate.instant('VALIDACAO.ALERTA_OBRIGATORIOS'), " ", false);
		   }
		};
		
		
		$scope.historicoAlteracao = function (listaProcessoRelacionado){
			
        	angular.forEach(listaProcessoRelacionado, function(item, key) {
        		
        		var processoFilho = item.processoRelacionado;
        		var processoPai = $scope.$parent.$parent.processo;
   
        		$scope.AddHistoricoAlteracao(processoFilho , processoPai);
        		$scope.AddHistoricoAlteracao(processoPai , processoFilho);
        		
        	});
		};
		
		
		$scope.AddHistoricoAlteracao = function (processoPai, processoFilho){
	    	    	
    		var historicoAlteracaoProcesso = {
    				descricaoAcao :  $translate.instant('ECM.MSG_HISTORICO_ECM.RELACIONAR_PROCESSO'),
    				processo : processoPai,
    				mapaAtributos : {'protocolo': processoFilho.nup},
    				autor : $scope.usuarioLogado,
    				acaoAlteracao : "RELACIONAR_PROCESSO",
					idTask : $scope.$parent.$parent.task.id

    		};
    		
    		HistoricoAlteracaoProcessoRepository.saveParams(historicoAlteracaoProcesso).then(function(result){ }); 
		};

		
		$scope.retornaListaSave = function (result){
		   var arrayToReturn = [];
		   if(result.length > 0){
	            angular.forEach(result, function(item, key) {
                   
                if(!item.id){arrayToReturn.push(item);};
                   
               });

		   }
		  return arrayToReturn;	
		};
		
		//CONSULTA LISTA DE PROCESSO RELACIONADO 
	    $scope.getProcessoRelacionado = function(){
	    	
	    	$scope.processoRelacionadoVH = {
		        	processo : null,
					listaProcessoRelacionado : []
			};
		       
	    	$scope.setLoadingGet(true);

	        ProcessoRelacionadoRepository.findByIdProcesso($scope.$parent.$parent.processo.id).then(function(result) {
	        	angular.forEach(result, function(item, key) {
	        		if(item.originalElement.processo != null){
	        			$scope.processoRelacionadoVH.listaProcessoRelacionado.push(item.originalElement);
	        			
	        		}
	        	});
	        	
                 $scope.setLoading(false);
	        }); 
	    };
	    
		
		// ABRE A VIEW DE GERENCIAR PROCESSO
		$scope.viewProcesso = function (processoView){
			if(processoView != null){

				var pagina = '/cit-ecm-web/html/gerenciarProcessoView/gerenciarProcessoView.html';
				
				$scope.openWorkspaceIfNotOpen($translate.instant('ECM.LABEL.PROCESSO'), pagina, 'mod-orange');
				
				$timeout(function() { 		
					angular.element('#viewGerenciarProcesso').scope().getProcessoRelacionado(processoView);
						
			   }, 400);
			}
		};
		//FIM
		
		//ADICIONA PROCESSO NA GRID
		$scope.findAutoCompleteProcesso = function(value){
			
		    return ProcessoRepository.findAutoComplete('nup', value).then(function(result) {
		    	
		    	return $filter('idNotEqualProcessoRelacionadoAndProcessoPai')(result, $scope.processoRelacionadoVH.listaProcessoRelacionado, $scope.$parent.$parent.processo );
		        	
		    });
		};
		
		$scope.setRelacionados = function(item){
			
		        if(!$scope.processoRelacionadoVH.listaProcessoRelacionado){
		        	$scope.processoRelacionadoVH.listaProcessoRelacionado = [];
		        }
		        
		        $scope.processoRelacionadoVH.listaProcessoRelacionado.push({processoRelacionado : item  });
		        
		        $timeout(function(){
		        	$scope.processo = null;
		        });
		};
		//FIM
		
		//EXCLUIR RELACIONAMENTO DA GRID
	    $scope.excluirRelacionamento = function(processoRelacionado){
	        if(processoRelacionado){
	            $scope.$openModalConfirm({message: $translate.instant('MSG.DESEJA_EXCLUIR_ITENS'), callback: $scope.excluir, item: processoRelacionado});
	        }
		};
				
		$scope.excluir = function() {
			
		    var obj = this.item ;
		    var index = $scope.processoRelacionadoVH.listaProcessoRelacionado.indexOf(obj);
		    
		    if(!$scope.processoRelacionadoVH.listRemoverRelacinamento){
		    	$scope.processoRelacionadoVH.listRemoverRelacinamento = [];
		    }
		    
		    if (obj.id) {
		    	$scope.processoRelacionadoVH.processo = $scope.$parent.$parent.processo;
		    	$scope.processoRelacionadoVH.listRemoverRelacinamento.push(obj);
		    	ProcessoRelacionadoRepository.removeProcessoRelacionado($scope.processoRelacionadoVH).then(function() {
		    		var processoPai = obj.processo;
		    		var processoFilho = obj.processoRelacionado;
		    		
		    		$scope.historicoAlteracaoExcluirRelacionamento (processoPai,processoFilho);
		    		$scope.historicoAlteracaoExcluirRelacionamento (processoFilho, processoPai);
		    		
		    		obj = null;
		    		$scope.processoRelacionadoVH.listRemoverRelacinamento = [];
				});
			}
		    
		    $scope.showAlertSucesso("success", $translate.instant('MSG.REGISTRO_EXCLUIDO'));
		    $scope.processoRelacionadoVH.listaProcessoRelacionado.splice(index, 1);
			$scope.$modalConfirmInstance.dismiss('cancel');
		};
		//FIM
		
		$scope.historicoAlteracaoExcluirRelacionamento = function (processoPai, processoFilho){

        		var historicoAlteracaoProcesso = {
        				descricaoAcao :  $translate.instant('ECM.MSG_HISTORICO_ECM.REMOVER_RELACIONAMENTO_PROCESSO'),
        				processo : processoPai,
        				mapaAtributos : {'protocolo': processoFilho.nup},
        				autor : $scope.usuarioLogado,
        				acaoAlteracao : "REMOVER_RELACIONAMENTO_PROCESSO",
						idTask : $scope.$parent.$parent.task.id

        		};
        		HistoricoAlteracaoProcessoRepository.saveParams(historicoAlteracaoProcesso).then(function(result){ }); 

		};
		
		
		$scope.resetForm = function(){
			
	    	$scope.processoRelacionadoVH = {
		        	processo : null,
					listaProcessoRelacionado : []
			};
		};	

}]);
