'use strict';

citApp.controller('ReabrirProcessoController', ['$scope', 'ReabrirProcessoRepository', 'ProcessoRepository', 'DominioRepository','$filter', '$translate', '$timeout', "appService",
                                                function ReabrirProcessoController($scope, ReabrirProcessoRepository, ProcessoRepository, DominioRepository, $filter, $translate, $timeout, appService) {
	$scope.reabrirProcesso = {};

	// Limpa formulário para novo cadastro
	$scope.resetForm = function() {
		$scope.limparReabrirProcesso();
		$scope.edit = true;
		$timeout(function(){
			$scope.reabrirProcessoForm.$submitted = false;
			$scope.reabrirProcessoForm.$setPristine();
		});
	};

	// Atualiza pagina de pesquisa
	$scope.atualizaPaginaPesquisa = function () {
		angular.element('#searchReabrirProcesso').scope().fetchResult();
	};

	// MODAL QUE CONFIRMA REMOVER DO PAIS
	$scope.remove = function(reabrirProcesso){
		$scope.reabrirProcesso = reabrirProcesso;
		$scope.$openModalConfirm({
			message: $translate.instant('MSG.CONFIRMA_EXCLUSAO'),
			callback: function () {
				ReabrirProcessoRepository.remove($scope.reabrirProcesso).then(function() {

					$scope.$modalConfirmInstance.dismiss('cancel');
					$scope.showAlert("success", $translate.instant('MSG.REGISTRO_EXCLUIDO'));
					angular.element('#searchReabrirProcesso').scope().fetchResult();
					
					$scope.resetForm();
					
					$scope.edit = false;
				});
			}
		});
	};

	// SALVA O PAIS
	$scope.saveOrUpdate = function(){
		$scope.reabrirProcessoForm.$submitted = true;

		//verifica se o formulario está valido para salvar
		if($scope.reabrirProcessoForm.$valid){

			$scope.setLoadingSalva(true);

			ReabrirProcessoRepository.save($scope.reabrirProcesso).then(function(result) {
				$scope.reabrirProcesso = result.originalElement;
				$scope.showAlert("success", $translate.instant('MSG.REGISTRO_SALVO'));
				$scope.reabrirProcessoForm.$submitted = false;
				$scope.setLoading(false);
				$scope.atualizaPaginaPesquisa();
				
			});
			
		}else{
			//Mensagem de erro de campos obrigatorios não preenchidos
			  $scope.showAlert('error', $translate.instant('MSG.MN001'), " ", false);
		}

	};

	// Limpa o formulario preenchido
	$scope.limparReabrirProcesso = function(){
		$scope.reabrirProcesso = {};
	};

	
	$scope.findAutoCompleteProcesso = function(value){
		
	    return ProcessoRepository.findAutoComplete('nup', value).then(function(result) {	
	    	return result;
	        	
	    });
	};
	
	
    DominioRepository.findAllDominio('statusSolicitaoProcesso').then(function(result) {
        $scope.statusList = result;
    });
	

	// Consulta entidade e mostra no formulario
	$scope.getReabrirProcesso = function(reabrirProcesso, edit){
		
		$scope.setLoadingGet(true);
		ReabrirProcessoRepository.get(reabrirProcesso.id).then(function(result) {
			$scope.reabrirProcesso = result.originalElement;		
			$scope.edit = edit;
			$scope.setLoading(false);
		});
	};
	
	$scope.visualizarProcesso = function (){
		
		if($scope.reabrirProcesso.processo){
			
			var pagina = '/cit-ecm-web/html/gerenciarProcessoView/gerenciarProcessoView.html';
			
			$scope.openWorkspaceIfNotOpen($translate.instant('ECM.LABEL.PROCESSO'), pagina, 'mod-orange');
			
			$timeout(function() { 		
				angular.element('#viewGerenciarProcesso').scope().getProcessoView($scope.reabrirProcesso.processo);
					
		   }, 400);
			
		}else{
			$scope.showAlert("success", "selecione um processo");
		}
	};
	
	

	// Abre a tela de visualização de processo e documentos
	$scope.visualizarProcesso = function () {

		var pagina = '/cit-ecm-web/html/processoVisualizacao/processoView.html';

		var paginaGerenciamento = '/cit-ecm-web/html/gerenciarProcesso/gerenciarProcesso.html';

		if ( appService.existsWorkspace( paginaGerenciamento ) ) {
			$scope.$openModalConfirm( {
				message : $translate.instant( 'ECM.MSG.EXISTE_PROCESSO_ABERTO' ),
				callback : function () {
					$scope.$modalConfirmInstance.dismiss( 'cancel' );
					$scope.setLoading( true );
					$scope.openWorkspaceIfNotOpen( $translate.instant( 'ECM.LABEL.PROCESSO' ), pagina, 'mod-orange' );
					$timeout( function () {
						angular.element( '#visualizarGerenciarProcesso' ).scope().getProcessoVH( $scope.reabrirProcesso.processo.id);

					}, 100 );
					$scope.setLoading( false );
				}
			} );
		} else {
			$scope.openWorkspaceIfNotOpen( $translate.instant( 'ECM.LABEL.PROCESSO' ), pagina, 'mod-orange' );
			$timeout( function () {
				angular.element( '#visualizarGerenciarProcesso' ).scope().getProcessoVH($scope.reabrirProcesso.processo.id);

			}, 100 );
		}
		;
	};

}]);


