'use strict';

citApp.controller('ReabrirProcessoListController', ['$scope', 'ReabrirProcessoRepository', '$translate', '$timeout', 'DominioRepository',  function ReabrirProcessoListController($scope, ReabrirProcessoRepository, $translate, $timeout, DominioRepository) {
	$scope.$showAdvancedFilters = false;

    $scope.resetForm = function() {
        angular.element("#editReabrirProcesso").scope().resetForm();
    };

   
    $scope.headers = [ {title : $translate.instant('ECM.LABEL.PROTOCOLO'), value : 'processo.nup'},
                       {title : $translate.instant('ECM.LABEL.JUSTIFICATIVA'), value : 'justificativaSolicitacao' },
                       {title : $translate.instant('ECM.LABEL.STATUS'), value : 'status.descricao' }];

    $scope.filterCriteria = {
        start : 1,
        dir : 'asc',
        sort : 'id',
        limit : 10,
        fields: ['id','processo.nup','justificativaSolicitacao','status.descricao'],
        filters : [ {type : 'string', field : 'processo.nup' },
                    {type : 'string', field : 'justificativaSolicitacao' }, 
                    {type : 'string', field : 'status.descricao', listaDominio : [] , comparison : 'eq', value: 'Em Aberto'}]

    };
    
    
    
    DominioRepository.findAllDominioByCodigo('statusSolicitaoProcesso', 1).then(function(result) {
		
    	$scope.filterCriteria.filters[2].listaDominio.push(result.originalElement);
    	
	});
        
    // ABRI Documento SELECIONADA
    $scope.abrirVisualizar = function(edit){
        var reabrirProcesso = $scope.reabrirProcessoChecked;

        if(!reabrirProcesso) {
            $scope.showAlert('warning', !edit ? $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_VISUALIZACAO') : $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_EDICAO'));
            return;
        }
        angular.element('#editReabrirProcesso').scope().getReabrirProcesso(reabrirProcesso, edit);
        $scope.$showPageEditWorkspace($scope.workspace);
    };
    
}]);
