'use strict';

citApp.controller('RodapeController', ['$scope', 'RodapeRepository', '$filter', '$translate', '$timeout', function RodapeController($scope, RodapeRepository, $filter, $translate, $timeout) {
	$scope.rodape = {};

	// Limpa formulário para novo cadastro
	$scope.resetForm = function() {
		$scope.limparRodape();
		$scope.edit = true;
		$timeout(function(){
			$scope.rodapeForm.$submitted = false;
			$scope.rodapeForm.$setPristine();
		});
	};

	// Atualiza pagina de pesquisa
	$scope.atualizaPaginaPesquisa = function () {
		angular.element('#searchRodape').scope().fetchResult();
	};

	// MODAL QUE CONFIRMA REMOVER DO PAIS
	$scope.remove = function(rodape){
		$scope.rodape = rodape;
		$scope.$openModalConfirm({
			message: $translate.instant('MSG.CONFIRMA_EXCLUSAO'),
			callback: function () {
				RodapeRepository.remove($scope.rodape).then(function() {

					$scope.$modalConfirmInstance.dismiss('cancel');
					$scope.showAlert("success", $translate.instant('MSG.REGISTRO_EXCLUIDO'));
					angular.element('#searchRodape').scope().fetchResult();

					$scope.resetForm();
				});
			}
		});
	};

	// SALVA O PAIS
	$scope.saveOrUpdate = function(){
		$scope.rodapeForm.$submitted = true;

		//verifica se o formulario está valido para salvar
		if($scope.rodapeForm.$valid && $scope.rodape.texto != ""){

			$scope.setLoadingSalva(true);

			RodapeRepository.save($scope.rodape).then(function(result) {
				$scope.rodape = result.originalElement;
				$scope.showAlert("success", $translate.instant('MSG.REGISTRO_SALVO'));
				$scope.rodapeForm.$submitted = false;
				$scope.setLoading(false);
			});
		}else{
			//Mensagem de erro de campos obrigatorios não preenchidos
			  $scope.showAlert('error', $translate.instant('MSG.MN001'), " ", false);
		}

	};

	// Limpa o formulario preenchido
	$scope.limparRodape = function(){
		$scope.rodape = {};
	};

	// Consulta entidade e mostra no formulario
	$scope.getRodape = function(rodape, edit){
		
		$scope.setLoadingGet(true);
		RodapeRepository.get(rodape.id).then(function(result) {
			$scope.rodape = result.originalElement;
			$scope.edit = edit;
			if(!edit){
				angular.element("#visualizacaoConteudoRodape")[0].srcdoc = $scope.rodape.texto;
			}
			$scope.setLoading(false);
		});
	};

}]);


