'use strict';

citApp.controller('SolicitacaoReaberturaProcessoController', ['$scope','ReabrirProcessoRepository', 'ProcessoRepository','UnidadeRepository','$filter', '$translate', '$timeout',"appService", function SolicitacaoReaberturaProcessoController($scope, ReabrirProcessoRepository, ProcessoRepository, UnidadeRepository, $filter, $translate, $timeout, appService) {
	$scope.solicitacaoReaberturaProcesso = {};

	// Limpa formulário para novo cadastro
	$scope.resetForm = function() {
		$scope.limparSolicitacaoReaberturaProcesso();
		$scope.edit = true;
		$timeout(function(){
			$scope.solicitacaoReaberturaProcessoForm.$submitted = false;
			$scope.solicitacaoReaberturaProcessoForm.$setPristine();
		});
	};

	// Atualiza pagina de pesquisa
	$scope.atualizaPaginaPesquisa = function () {
		angular.element('#searchSolicitacaoReaberturaProcesso').scope().fetchResult();
	};

	// MODAL QUE CONFIRMA REMOVER DO PAIS
	$scope.remove = function(solicitacaoReaberturaProcesso){
		$scope.solicitacaoReaberturaProcesso = solicitacaoReaberturaProcesso;
		$scope.$openModalConfirm({
			message: $translate.instant('MSG.CONFIRMA_EXCLUSAO'),
			callback: function () {
				ReabrirProcessoRepository.remove($scope.solicitacaoReaberturaProcesso).then(function() {

					$scope.$modalConfirmInstance.dismiss('cancel');
					$scope.showAlert("success", $translate.instant('MSG.REGISTRO_EXCLUIDO'));
					angular.element('#searchSolicitacaoReaberturaProcesso').scope().fetchResult();

					$scope.resetForm();
				});
			}
		});
	};

	// SALVA O PAIS
	$scope.saveOrUpdate = function(){
		
		$scope.solicitacaoReaberturaProcessoForm.$submitted = true;

		//verifica se o formulario está valido para salvar
		if($scope.solicitacaoReaberturaProcessoForm.$valid){

			$scope.setLoadingSalva(true);

			ReabrirProcessoRepository.save($scope.solicitacaoReaberturaProcesso).then(function(result) {
				$scope.solicitacaoReaberturaProcesso = result.originalElement;
				$scope.showAlert("success", $translate.instant('MSG.REGISTRO_SALVO'));
				$scope.status = $scope.solicitacaoReaberturaProcesso.status.descricao;
				$scope.solicitacaoReaberturaProcessoForm.$submitted = false;
				$scope.edit = false;
				$scope.setLoading(false);
			});
			
		}else{
			//Mensagem de erro de campos obrigatorios não preenchidos
			  $scope.showAlert('error', $translate.instant('MSG.MN001'), " ", false);
		}

	};

	// Limpa o formulario preenchido
	$scope.limparSolicitacaoReaberturaProcesso = function(){
		$scope.solicitacaoReaberturaProcesso = {};
		$scope.status = null;
	};

	
	$scope.findAutoCompleteProcesso = function(value){		
		
	    return ProcessoRepository.autoCompleteProcessoConcluidoByNup( value).then(function(result) {
	    	    	
	    	return result;
	        	
	    });
	};

	// Consulta entidade e mostra no formulario
	$scope.getSolicitacaoReaberturaProcesso = function(processo, edit){
		
		$scope.setLoadingGet(true);
		ReabrirProcessoRepository.get(processo.id).then(function(result) {
			
			$scope.solicitacaoReaberturaProcesso = result.originalElement;
			
			$scope.status = $scope.solicitacaoReaberturaProcesso.status.descricao;
			
			$scope.edit = edit;
			
			$scope.setLoading(false);
		});
	};
	
	// Abre a tela de visualização de processo e documentos
	$scope.visualizarProcesso = function () {

		var pagina = '/cit-ecm-web/html/processoVisualizacao/processoView.html';

		var paginaGerenciamento = '/cit-ecm-web/html/gerenciarProcesso/gerenciarProcesso.html';

		if ( appService.existsWorkspace( paginaGerenciamento ) ) {
			$scope.$openModalConfirm( {
				message : $translate.instant( 'ECM.MSG.EXISTE_PROCESSO_ABERTO' ),
				callback : function () {
					$scope.$modalConfirmInstance.dismiss( 'cancel' );
					$scope.setLoading( true );
					$scope.openWorkspaceIfNotOpen( $translate.instant( 'ECM.LABEL.PROCESSO' ), pagina, 'mod-orange' );
					$timeout( function () {
						angular.element( '#visualizarGerenciarProcesso' ).scope().getProcessoVH( $scope.solicitacaoReaberturaProcesso.processo.id);

					}, 100 );
					$scope.setLoading( false );
				}
			} );
		} else {
			$scope.openWorkspaceIfNotOpen( $translate.instant( 'ECM.LABEL.PROCESSO' ), pagina, 'mod-orange' );
			$timeout( function () {
				angular.element( '#visualizarGerenciarProcesso' ).scope().getProcessoVH($scope.solicitacaoReaberturaProcesso.processo.id);

			}, 100 );
		}
		;
	};

}]);


