'use strict';

citApp.controller('SolicitacaoReaberturaProcessoListController', ['$scope', 'ReabrirProcessoRepository', '$translate', '$timeout', 'DominioRepository',  function SolicitacaoReaberturaProcessoListController($scope, ReabrirProcessoRepository, $translate, $timeout, DominioRepository) {
    $scope.$showAdvancedFilters = false;

    $scope.resetForm = function() {
        angular.element("#editSolicitacaoReaberturaProcesso").scope().resetForm();
    };

   
    $scope.headers = [ {title : $translate.instant('ECM.LABEL.PROTOCOLO'), value : 'processo.nup'},
                       {title : $translate.instant('ECM.LABEL.JUSTIFICATIVA'), value : 'justificativaSolicitacao' },
                       {title : $translate.instant('ECM.LABEL.STATUS'), value : 'status.descricao' }];

    $scope.filterCriteria = {
        start : 1,
        dir : 'asc',
        sort : 'id',
        limit : 10,
        fields: ['id','processo.nup','justificativaSolicitacao', 'status.descricao'],
        filters : [ {type : 'string', field : 'processo.nup' },
                    {type : 'string', field : 'justificativaSolicitacao' }, 
                    {type : 'string', field : 'status.descricao'}]
    };
        
    // ABRI Documento SELECIONADA
    $scope.abrirVisualizar = function(edit){
        var solicitacaoReaberturaProcesso = $scope.solicitacaoReaberturaProcessoChecked;

        if(!solicitacaoReaberturaProcesso) {
            $scope.showAlert('warning', !edit ? $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_VISUALIZACAO') : $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_EDICAO'));
            return;
        }
        angular.element('#editSolicitacaoReaberturaProcesso').scope().getSolicitacaoReaberturaProcesso(solicitacaoReaberturaProcesso, edit);
        $scope.$showPageEditWorkspace($scope.workspace);
    };
    
}]);
