'use strict';

citApp.controller('TarjaAssinaturaController',
                 ['$scope',
                  '$filter',
                  '$translate',
                  '$timeout',
                  'TarjaAssinaturaRepository',
                  'DominioRepository',
                  'FileUploader',
                  function TarjaAssinaturaController($scope,
                                                     $filter,
                                                     $translate,
                                                     $timeout,
                                                     TarjaAssinaturaRepository,
                                                     DominioRepository,
                                                     FileUploader) {

  $scope.resetForm = function() {

    if($scope.tarjaAssinatura) {
      var originalTipoAssinatura = $scope.tarjaAssinatura.tipoAssinatura;
      $scope.tarjaAssinatura = {
        tipoAssinatura : originalTipoAssinatura
      }
    }

      if ($scope.uploaderLogo){
        $scope.uploaderLogo.clearQueue();
        $scope.uploaderLogo.url = '/cit-ecm-web/rest/tarjaAssinatura/uploadFileLogo?idOrganizacao=' + $scope.usuarioLogado.organizacao.id + '&idTarjaAssinatura=';
      }

//      $scope.edit = true;
      $timeout(function(){
        if($scope.tarjaAssinaturaForm){
          $scope.tarjaAssinaturaForm.$submitted = false;
          $scope.tarjaAssinaturaForm.$setPristine();
        }
      });
    };

  DominioRepository.buscaDominioByCodigoAndChave(1, 'tipoAssinatura').then(function(result) {
    $scope.tipoAssinaturaInterna = result.originalElement;
  });
  DominioRepository.buscaDominioByCodigoAndChave(2, 'tipoAssinatura').then(function(result) {
    $scope.tipoAssinaturaCertificado = result.originalElement;
  });

  $scope.saveOrUpdate = function(form){

    form.$submitted = true;

    if(form.$invalid){
        $scope.showAlert('error', $translate.instant('MSG.MN001'), " ", false);
        return;
    }

    $scope.setLoadingSalva(true);

    TarjaAssinaturaRepository.save($scope.tarjaAssinatura).then(function(result) {
      $scope.tarjaAssinatura = result.originalElement;
      $scope.showAlert("success", $translate.instant('MSG.REGISTRO_SALVO'));
      form.$submitted = false;
      $scope.setLoading(false);
      if($scope.uploaderLogo.queue.length > 0){
        $scope.uploaderLogo.uploadAll();
      }
      $scope.$showPageSearchWorkspace($scope.workspace);
      $scope.fetchResult();
    });
  };

  $scope.cancelarEdicao = function () {
    $scope.resetForm();
    $scope.$showPageSearchWorkspace($scope.workspace);
    $scope.fetchResult();
    $scope.edit= false
  }

  $scope.fetchResult = function(){
    angular.element('#searchTarjaAssinatura').scope().fetchResult();
  };

  $scope.removeImagem = function (){
    if($scope.tarjaAssinatura.anexoImagem){
      TarjaAssinaturaRepository.removeImagem($scope.tarjaAssinatura).then(function (result) {
        $scope.tarjaAssinatura = result.originalElement;
        if($scope.uploaderLogo.queue.length > 0){
          $scope.uploaderLogo.clearQueue();
            }
      })
    }
  }
  $scope.openFile = function () {
    if($scope.edit){
      angular.element('#uploadLogoTarjaAssinatura').trigger('click');
    }
  }

//INSTANCIA DO OBJETO PARA FAZER UPLOAD
  $scope.uploaderLogo = new FileUploader({
    autoUpload: false,
    queueLimit: 1,
    url : '/cit-ecm-web/rest/tarjaAssinatura/uploadFileLogo?idOrganizacao=' + $scope.usuarioLogado.organizacao.id + '&idTarjaAssinatura='
  });

  // FILTERS
  $scope.uploaderLogo.filters.push({
    name: 'imageFilter',
    fn: function(item , options) {
      var type = '|' + item.type.slice(item.type.lastIndexOf('/') + 1) + '|';
      return '|jpg|png|jpeg|bmp|gif|'.indexOf(type) !== -1;
    }
  });

  // CALLBACKS
  $scope.uploaderLogo.onWhenAddingFileFailed = function(item , filter, options) {
    $scope.uploaderLogo.clearQueue();
//    console.info('onWhenAddingFileFailed', item, filter, options);
  };
  $scope.uploaderLogo.onAfterAddingFile = function(fileItem) {
//    console.info('onAfterAddingFile', fileItem);
  };
  $scope.uploaderLogo.onAfterAddingAll = function(addedFileItems) {
//    console.info('onAfterAddingAll', addedFileItems);
  };
  $scope.uploaderLogo.onBeforeUploadItem = function(item) {
//    console.info('onBeforeUploadItem', item);
  };
  $scope.uploaderLogo.onProgressItem = function(fileItem, progress) {
//    console.info('onProgressItem', fileItem, progress);
  };
  $scope.uploaderLogo.onProgressAll = function(progress) {
//    console.info('onProgressAll', progress);
  };
  $scope.uploaderLogo.onSuccessItem = function(fileItem, response, status, headers) {
//    console.info('onSuccessItem', fileItem, response, status, headers);
  };
  $scope.uploaderLogo.onErrorItem = function(fileItem, response, status, headers) {
//    console.info('onErrorItem', fileItem, response, status, headers);
  };
  $scope.uploaderLogo.onCancelItem = function(fileItem, response, status, headers) {
//    console.info('onCancelItem', fileItem, response, status, headers);
  };
  $scope.uploaderLogo.onCompleteItem = function(fileItem, response, status, headers) {
//    console.info('onCompleteItem', fileItem, response, status, headers);
  };
  $scope.uploaderLogo.onCompleteAll = function() {
    $scope.uploaderLogo.clearQueue();
    $scope.getTarjaAssinatura($scope.tarjaAssinatura.id, $scope.edit)
//    console.info('onCompleteAll');
  };

  $scope.getTarjaAssinatura = function(id, edit) {
      $scope.setLoadingGet(true);
      TarjaAssinaturaRepository.get(id).then(function(result) {
        $scope.tarjaAssinatura = result.originalElement;
        vincularIdTarjaUploader();
        $scope.edit = edit;
        $scope.setLoading(false);
      });
    };

  var vincularIdTarjaUploader = function () {
    if($scope.tarjaAssinatura.id){
      $scope.uploaderLogo.url += $scope.tarjaAssinatura.id;
    }
  };

  $scope.insertTextEditor = function(button){
    CKEDITOR.instances.editorConteudo.insertText(button);
  }
}]);
