'use strict';

citApp.controller('TarjaAssinaturaListController',
                 ['$scope',
                  '$translate',
                  '$timeout',
                  'TarjaAssinaturaRepository',
                  'DominioRepository',
                  function ListController($scope,
                                          $translate,
                                          $timeout,
                                          TarjaAssinaturaRepository,
                                          DominioRepository) {
    $scope.$showAdvancedFilters = false;

    $scope.resetForm = function() {
        angular.element("#editTarjaAssinatura").scope().resetForm();
    };

    $scope.headers = [ {title : $translate.instant('LABEL.DESCRICAO'), value : 'descricao' },
                       {title : $translate.instant('ECM.LABEL.TIPO_ASSINATURA'), value : 'tipoAssinatura.descricao' }];

    $scope.filterCriteria = {
        start : 1,
        dir : 'asc',
        sort : 'id',
        limit : 10,
        fields: ['id', 'descricao', 'tipoAssinatura.descricao'],
        filters : [{type : 'string', field : 'descricao' },
                   {type : 'string', field : 'tipoAssinatura.descricao', listaDominio : [] }]
    };

	DominioRepository.findAllDominio('tipoAssinatura').then(function(result) {
		$scope.filterCriteria.filters[0].listaDominio = result;
	});

    $scope.editarVisualizarTarjaAssinatura = function(edit){
        var tarjaAssinatura = $scope.tarjaAssinaturaChecked;

        if(!tarjaAssinatura) {
            $scope.showAlert('warning', !edit ? $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_VISUALIZACAO') :
            									$translate.instant('MSG.SELECIONE_UM_ITEM_PARA_EDICAO'));
            return;
        }
        angular.element('#editTarjaAssinatura').scope().getTarjaAssinatura(tarjaAssinatura.id, edit);
        $scope.$showPageEditWorkspace($scope.workspace);
    };
}]);
