'use strict';

citApp.controller('TemplatePadraoController', ['$scope', 'TemplatePadraoRepository', '$filter', '$translate', '$timeout', 'RodapeRepository', 'CabecalhoRepository', function TemplatePadraoController($scope, TemplatePadraoRepository, $filter, $translate, $timeout, RodapeRepository, CabecalhoRepository) {
	
	$scope.templatePadrao = {};
	
	$scope.conteudoVisualizacao = {};

	  // Editor options.
	  $scope.options = {
	    language: 'pt-br',
	    allowedContent: true,
	    entities: false
	  };

	// Limpa formulário para novo cadastro
	$scope.resetForm = function() {
		$scope.limparTemplatePadrao();
		$scope.edit = true;
		$scope.visualizar = false;
		$timeout(function(){
			$scope.templatePadraoForm.$submitted = false;
			$scope.templatePadraoForm.$setPristine();
		});
	};

	// Atualiza pagina de pesquisa
	$scope.atualizaPaginaPesquisa = function () {
		angular.element('#searchTemplatePadrao').scope().fetchResult();
	};

	// MODAL QUE CONFIRMA REMOVER DO PAIS
	$scope.remove = function(templatePadrao){
		$scope.templatePadrao = templatePadrao;
		$scope.$openModalConfirm({
			message: $translate.instant('MSG.CONFIRMA_EXCLUSAO'),
			callback: function () {
				TemplatePadraoRepository.remove($scope.templatePadrao).then(function() {

					$scope.$modalConfirmInstance.dismiss('cancel');
					$scope.showAlert("success", $translate.instant('MSG.REGISTRO_EXCLUIDO'));
					angular.element('#searchTemplatePadrao').scope().fetchResult();

					$scope.resetForm();
				});
			}
		});
	};

	// SALVA O PAIS
	$scope.saveOrUpdate = function(){
		$scope.templatePadraoForm.$submitted = true;

		//verifica se o formulario está valido para salvar
		if($scope.templatePadraoForm.$valid && $scope.templatePadrao.conteudo != ""){

			$scope.setLoadingSalva(true);

			TemplatePadraoRepository.save($scope.templatePadrao).then(function(result) {
				$scope.templatePadrao = result.originalElement;
				$scope.showAlert("success", $translate.instant('MSG.REGISTRO_SALVO'));
				$scope.templatePadraoForm.$submitted = false;
				$scope.setLoading(false);
			});
		}else{
			//Mensagem de erro de campos obrigatorios não preenchidos
			  $scope.showAlert('error', $translate.instant('MSG.MN001'), " ", false);
		}

	};

	// Limpa o formulario preenchido
	$scope.limparTemplatePadrao = function(){
		$scope.templatePadrao = {};
	};

	// Consulta entidade e mostra no formulario
	$scope.getTemplatePadrao = function(templatePadrao, edit){
		
		$scope.setLoadingGet(true);
		TemplatePadraoRepository.get(templatePadrao.id).then(function(result) {
			$scope.templatePadrao = result.originalElement;
			$scope.edit = edit;
			
			if(!edit){
				angular.element("#visualizacaoConteudo")[0].srcdoc = $scope.templatePadrao.cabecalho.texto + $scope.templatePadrao.conteudo + $scope.templatePadrao.rodape.texto;
			}
			
			$scope.setLoading(false);
		});
	};
	
   $scope.findAutoCompleteRodape = function(value){
        return RodapeRepository.findAutoComplete('nome', value).then(function(result) {
            return result;
        });
    };
    
    $scope.findAutoCompleteCabecalho = function(value){
        return CabecalhoRepository.findAutoComplete('nome', value).then(function(result) {
            return result;
        });
    };
    
    //Visualizar o conteudo complete
    $scope.visualizarConteudo = function(){

    	angular.element("#visualizacaoConteudo")[0].srcdoc = $scope.templatePadrao.cabecalho.texto + $scope.templatePadrao.conteudo + $scope.templatePadrao.rodape.texto;
    	
    	$scope.visualizar = true;
    };
    
    $scope.fecharVisualizacao = function(){
    	
    	$scope.visualizar = false;
    };
    
    // Adicionar numero do documento
    $scope.addTagNumero = function(){
    	
    	$scope.templatePadrao.conteudo = $scope.templatePadrao.conteudo + "<span id='numeroDocumento'>{0}</span>";
    };


}]);


