'use strict';

citApp.controller('TemplatePadraoListController', ['$scope', 'TemplatePadraoRepository', '$translate', '$timeout', 'DominioRepository', function ListController($scope, TemplatePadraoRepository, $translate, $timeout, DominioRepository) {
    $scope.$showAdvancedFilters = false;

    $scope.resetForm = function() {
        angular.element("#editTemplatePadrao").scope().resetForm();
    };

    $scope.headers = [ {title : $translate.instant('LABEL.NOME'), value : 'nome' }, {title : $translate.instant('ECM.LABEL.CABECALHO'), value : 'cabecalho.nome' }, {title : $translate.instant('ECM.LABEL.RODAPE'), value : 'rodape.nome' }   ];

    $scope.filterCriteria = {
        start : 1,
        dir : 'asc',
        sort : 'id',
        limit : 10,
        fields: ['id', 'nome', 'cabecalho.nome', 'rodape.nome' ],
        filters : [ {type : 'string', field : 'nome' }, {type : 'string', field : 'cabecalho.nome' }, {type : 'string', field : 'rodape.nome' }]
    };
    
    // ABRI Documento SELECIONADA
    $scope.abrirVisualizar = function(edit){
        var templatePadrao = $scope.templatePadraoChecked;

        if(!templatePadrao) {
            $scope.showAlert('warning', !edit ? $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_VISUALIZACAO') : $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_EDICAO'));
            return;
        }
        angular.element('#editTemplatePadrao').scope().getTemplatePadrao(templatePadrao, edit);
        $scope.$showPageEditWorkspace($scope.workspace);
    };
}]);
