'use strict';

citApp.controller('TipoDocumentoController',['$scope', 'TipoDocumentoRepository', '$translate', '$timeout', 'DominioRepository', 'PlanoClassificacaoRepository', 'TipoDocumentoPlanoClassificacaoRepository', '$filter', 'HipoteseLegalRepository', 'TemplatePadraoRepository','DocumentoGedRepository',
                                             'SigiloRepository', function TipoDocumentoController($scope, TipoDocumentoRepository, $translate, $timeout, DominioRepository, PlanoClassificacaoRepository, TipoDocumentoPlanoClassificacaoRepository, $filter, HipoteseLegalRepository, TemplatePadraoRepository, DocumentoGedRepository, SigiloRepository) {

    $scope.tipoDocumento = {
    		tipoDocumentoPlanoClassificacoes : []
    };
    
    $scope.tipoDocumento.acessos = [];


    // Limpa formulário para novo cadastro
    $scope.resetForm = function() {
        $scope.limparTipoDocumento();
        $scope.limparCamposTipoSigiloso();
        $scope.findDominioNivelAcesso(true);
        $scope.findSigiloList();
        $scope.sigilosSelecionados = [];
        $scope.isSigilo = false;
        $scope.edit = true;
        $timeout(function(){
            $scope.tipoDocumentoForm.$submitted = false;
            $scope.tipoDocumentoForm.$setPristine();
        });
    };

    // Atualiza pagina de pesquisa
    $scope.atualizaPaginaPesquisa = function () {
        angular.element('#searchTipoDocumento').scope().fetchResult();
    };
    
	$scope.novaHipoteseLegal = function() {
		$scope.openWorkspaceIfNotOpen($translate.instant('ECM.ECM.LABEL.HIPOTESELEGAL'), '/cit-ecm-web/html/hipoteseLegal/hipoteseLegalEdit.html', 'mod-orange');

		$timeout(function() {
			angular.element('#searchHipoteseLegal').scope().$showPageEditWorkspace(angular.element('#searchHipoteseLegal').scope().workspace);
			angular.element('#hipoteseLegalEdit').scope().resetForm();

	    }, 600);

	};
	
  //AUTOCOMPLETE HIPOTESE LEGAL #INICIO	
	$scope.findHiposeLegal = function(value){
	    return HipoteseLegalRepository.findAutoComplete('nome',value).then(function(result) {
	    	return result;
	    	});
		};

    // MODAL QUE CONFIRMA REMOVER DA CIDADE
    $scope.remove = function(tipoDocumento){
    	
    	DocumentoGedRepository.existeVinculo({"joinClass": 'tipoDocumento.id', "id": tipoDocumento.id}).then(function(result) {
			
    		if(result){
    			$scope.showAlert('error', $translate.instant('ECM.MSG.EXISTE_VINCULO_PROCESSO'));
    			
    		}else{
    			$scope.tipoDocumento = tipoDocumento;
    			$scope.$openModalConfirm({message: $translate.instant('MSG.CONFIRMA_EXCLUSAO'),	callback: function () {
    				TipoDocumentoRepository.remove($scope.tipoDocumento).then(function() {
    					
    					$scope.$modalConfirmInstance.dismiss('cancel');
    					$scope.showAlert("success", $translate.instant('MSG.REGISTRO_EXCLUIDO'));
    					angular.element('#searchTipoDocumento').scope().fetchResult();
    					
    					$scope.resetForm();
    				});
    			}
    			});
    		}
		});	

    };

    // SALVA O TipoDocumento
    $scope.saveOrUpdate = function(){
        $scope.tipoDocumentoForm.$submitted = true;

        //verifica se o formulario está valido para salvar
        if($scope.tipoDocumentoForm.$valid && (!$scope.isSigilo || $scope.isTipoSigiloSelecionado())){

            $scope.setLoadingSalva(true);
            
	        if($scope.tipoSigilo && $scope.tipoSigilo.id){
	            	
            	angular.forEach($scope.tipoDocumento.acessos, function (item) {
            		
            		if(item.nivelAcesso.codigo == 0){
            			
            			item.tipoSigilo = $scope.tipoSigilo;
            		}
            		
            	});
	            }

            TipoDocumentoRepository.save($scope.tipoDocumento).then(function(result) {
                $scope.tipoDocumento = result.originalElement;
                $scope.showAlert("success", $translate.instant('MSG.REGISTRO_SALVO'));
                $scope.tipoDocumentoForm.$submitted = false;
                $scope.resetForm();
            });
            $scope.setLoading(false);
        }else{
            //Mensagem de erro de campos obrigatorios não preenchidos
            $scope.showAlert('error', $translate.instant('MSG.MN001'), " ", false);
        }
    };

    // Limpa o formulario preenchido
    $scope.limparTipoDocumento = function(){
        $scope.tipoDocumento = {
        		tipoDocumentoPlanoClassificacoes : [],
        		acessos : []
        };
    };

    // Consulta entidade e mostra no formulario
    $scope.getTipoDocumento = function(tipoDocumento, edit){
        $scope.setLoadingGet(true);
        $scope.findSigiloList();
        TipoDocumentoRepository.get(tipoDocumento.id).then(function(result) {
            $scope.tipoDocumento = result.originalElement;
            $scope.edit = edit;
            $scope.montarNivelAcesso();
            $scope.verificarSigiloSelecionado();
            $scope.setLoading(false);
        });
    };
        
    //Adiciona assunto a lista de assuntos #INICIO
      
    $scope.findAutoCompleteSugestao = function(value){
        return PlanoClassificacaoRepository.findAssuntoAutoComplete(value).then(function(result) {
        	return $filter('idNotEqualObj')(result, $scope.tipoDocumento.tipoDocumentoPlanoClassificacoes, 'planoClassificacao');
        	});
    	};
    
	$scope.setAssunto = function(value){
		$scope.TipoDocumentoPlanoClassificacao = {
				planoClassificacao : value
		};
		
		$scope.tipoDocumento.tipoDocumentoPlanoClassificacoes.push($scope.TipoDocumentoPlanoClassificacao);

		$timeout(function(){
			$scope.assunto = null;
		});
	};
	
	//MONTA E EXCLUIR LISTA DE ASSUNTOS SELECIOANDO #INICIO
	
	$scope.montaListaDelete = function(){
		
			
		var excluir = false;

		for (var i = $scope.tipoDocumento.tipoDocumentoPlanoClassificacoes.length - 1; i >= 0; i--){
			if($scope.tipoDocumento.tipoDocumentoPlanoClassificacoes[i].$selected){
				excluir = true;
				break;
			}
		}

		if(excluir){
			$scope.$openModalConfirm({
				message: $translate.instant("MSG.DESEJA_EXCLUIR_ITENS"), callback: function () {
					for (var i = $scope.tipoDocumento.tipoDocumentoPlanoClassificacoes.length - 1; i >= 0; i--){

						if($scope.tipoDocumento.tipoDocumentoPlanoClassificacoes[i].$selected){
							if($scope.tipoDocumento.tipoDocumentoPlanoClassificacoes[i].planoClassificacao.id !== undefined){								
								$scope.tipoDocumento.tipoDocumentoPlanoClassificacoes.splice(i, 1).planoClassificacao;
							}
						}
					}
					
					$timeout(function(){
						$scope.tipoDocumentoForm.$submitted = false;
						$scope.tipoDocumentoForm.$setPristine();
					});

					if($scope.selectedAll){
						$scope.selectedAll = false;
					}
					
					$scope.$modalConfirmInstance.dismiss('cancel');
					$scope.showAlert("success", $translate.instant("ECM.MSG.ITEM_EXCLUIDO"));
				}
			});

		}else{
			$scope.showAlert("warning", $translate.instant("MSG.SELECIONE_ITEM_EXCLUIR"));
		}
	};
	//MONTA E EXCLUIR LISTA DE ASSUNTOS SELECIOANDO #FIM
	
	//SELECIONA TODOS ITENS DA LISTA DE ASSUNTO	 #INICIO
	$scope.checkAll = function(value) {
		angular.forEach($scope.tipoDocumento.tipoDocumentoPlanoClassificacoes, function (item) {
			item.$selected = value;
        });
	};
	
	$scope.verificaSelectedAll = function(PlanoClassificacao) {
		var verificaSelected = true;

		if(!PlanoClassificacao.$selected){
			$scope.selectedAll = false;
		}else{
			angular.forEach($scope.tipoDocumento.tipoDocumentoPlanoClassificacoes, function (item) {
				if(!item.$selected){
					verificaSelected = false;
				}
	        });

			if(verificaSelected){
				$scope.selectedAll = true;
			}
		}
	};
	//SELECIONA TODOS ITENS DA LISTA DE ASSUNTO	 #FIM
	
	//Adiciona assunto a lista de assuntos #FIM	
	//Setar nivel acesso
	
	/*
	 * Público  = 2
	 * Restrito = 1
	 * Sigiloso = 0
	 * */
	$scope.setNivelAcesso = function(nivelAcesso){
		
		 $timeout(function(){
			 //verifica se o nivelAcesso foi checado
			if(nivelAcesso.checked){
				
				var nivelAcessoTipoDocumento = {};
				nivelAcessoTipoDocumento.nivelAcesso = nivelAcesso.originalElement;
				if(nivelAcesso.codigo === 0){
					nivelAcessoTipoDocumento.sigilos = [];
					$scope.isSigilo = true;
					
					$scope.setNivelRestrito(nivelAcesso);
					
					$scope.setSigilosoAutomatico();
					
				}
				
				$scope.tipoDocumento.acessos.push(nivelAcessoTipoDocumento);
				
			}else{
				//verifica se o nivel acesso removido é sigiloso
				 if(nivelAcesso.codigo == 0){
					 
					 $scope.isSigilo = false;
					 //remove os sigilos do nivelAcesso
					 $.grep($scope.tipoDocumento.acessos, function(e){ return e.nivelAcesso.codigo === 0; })[0].sigilos = [];
					 
					//Remover a seleção dos sigilos selecionados
					removerSelecaoSigilo();
				 }else if(nivelAcesso.codigo == 1){
					 $scope.desabilitaNivelSigiloso(nivelAcesso);
				 }
				 //Remove nivelAcesso
				 $scope.removeNivelAcesso(nivelAcesso);
			}
			
		 });
	
	};

	/*checked no nivel de acesso RESTRITO quando Nivel acesso SIGILOSO for checked
	 * Público  = 2
	 * Restrito = 1
	 * Sigiloso = 0
	 * */
	$scope.setNivelRestrito = function(nivelAcessoAutomatico){
		angular.forEach($scope.tipoNivelAcessoList, function (item, index) {
			if( nivelAcessoAutomatico.codigo == 0 && (item.codigo == 1 && !item.checked)){
				item.checked = true;
				$scope.setNivelAcesso(item);
			}
	    });
	};
	
	/*Desabilita o nivel de acesso  SIGILOSO quando Nivel acesso RESTRITO for desabilitado * */
	$scope.desabilitaNivelSigiloso = function(nivelAcessoAutomatico){
		angular.forEach($scope.tipoNivelAcessoList, function (item, index) {
			
			if(!$scope.isSigilo && item.codigo == 0 ){
				item.checked = false;
				$scope.setNivelAcesso(item);
				return;
			} else if(nivelAcessoAutomatico && nivelAcessoAutomatico.codigo == 1 && (item.codigo == 0 && item.checked)){
				item.checked = false;
				$scope.setNivelAcesso(item);
				return;
			}
		
		});
		
	};

	//seta o tipoSigilo selecionado 
	
	/*
	 * Reservado     = 0
	 * Secreto       = 1
	 * Ultrassecreto = 2
	 * */
	$scope.setSigilo = function(sigilo){ 

		if(sigilo.checked){
			
			var sigiloTipoDocumento = {
					
					sigilo : sigilo 		
							
					
			};
			
			$scope.setSigilosoAutomatico(sigilo);
			
			$.grep($scope.tipoDocumento.acessos, function(e){ return e.nivelAcesso.codigo === 0; })[0].sigilos.push(sigiloTipoDocumento);
			
			
		}else{
			//Remove o tipoSigilo da lista de selecionados
			angular.forEach($.grep($scope.tipoDocumento.acessos, function(e){ return e.nivelAcesso.codigo === 0; })[0].sigilos,  function (item, index) {
				
				if(sigilo.tipoSigilo.codigo === item.sigilo.tipoSigilo.codigo){
					
					$.grep($scope.tipoDocumento.acessos, function(e){ return e.nivelAcesso.codigo === 0; })[0].sigilos.splice(index, 1);
				}
			});
			
			$scope.desabilitaNivelSigilosoAutomatico(sigilo);
	
		}
	};
	
	/*Seta hierarquia de sigilo caso Sigilo
	 * Reservado     = 0
	 * Secreto       = 1
	 * Ultrassecreto = 2
	 * */
	$scope.setSigilosoAutomatico = function(sigilo){
		angular.forEach($scope.sigiloList, function (item, index) {
			//Identifica sigilo RESERVADO caso nivel acesso SIGILOSO seja selecionado
			if ($scope.isSigilo && (item.tipoSigilo.codigo == 0 && !item.checked)){
				$timeout(function(){
					item.checked = true;
				    $scope.setSigilo(item);
				});
			    
			}else if( sigilo){
				//Identifica sigilo SECRETO caso ULTRASSECRETO seja selecionado
				if( sigilo.tipoSigilo.codigo == 2 && (item.tipoSigilo.codigo == 1 && !item.checked)){
					item.checked = true;
					$scope.setSigilo(item);
					return;	
				}
			}
			
	    });
	};
	
	/*
	 * Desabilita nivel acesso SIGILOSO
	 * Codigos
	 * Reservado  = 0
	 * Secreto = 1
	 * Ultrassecreto = 2
	 * */
	$scope.desabilitaNivelSigilosoAutomatico = function(sigilo){
		
	  angular.forEach($scope.sigiloList, function (item, index) {
		 //Chama função para desabilitar SIGILOSO caso sigilo RESERVADO seja selecionado
		  if(sigilo.tipoSigilo.codigo == 0 && (item.tipoSigilo.codigo == 0 && !item.checked)){
			    $scope.isSigilo = false;
			    $scope.desabilitaNivelSigiloso();
			    return;
			    
	     //Identifica sigilo ULTRASSECRETO caso SECRETO seja selecionado
			}else if ( sigilo.tipoSigilo.codigo == 1 && (item.tipoSigilo.codigo == 2 && item.checked)){
				item.checked = false;
			    $scope.setSigilo(item);
			    return;
			}
			
	    });
		
	};
	
		
	//Verifica se foi selecionado algum tipo de segilo
	$scope.isTipoSigiloSelecionado = function() {
	    return $scope.isSigilo && $.grep($scope.tipoDocumento.acessos, function(e){ return e.nivelAcesso.codigo === 0; })[0].sigilos.length > 0;
	};

	//Remove o nivel acesso
	$scope.removeNivelAcesso = function(nivelRemocao){
		
		angular.forEach($scope.tipoDocumento.acessos, function (item, index) {
			
			if(nivelRemocao.id == item.nivelAcesso.id){
				
				$scope.tipoDocumento.acessos.splice(index, 1);  
			}
        });
		
	};
	
	//Verificar se o siligio foi selecionado.
	$scope.verificarSigiloSelecionado = function(){
		$scope.isSigilo = $scope.tipoNivelAcessoList.some(function(item){
			return item.codigo == 0 && item.checked;
			
		});
	};
	
	//Limpar campos do tipo sigiloso
	$scope.limparCamposTipoSigiloso = function(){
		
		 $scope.tipoDocumento.hipoteseLegal = null;
		 
		 $scope.tipoSigilo = {};
		 
		 $scope.isSigilo = false;
	};
	
	
	//Inicia o nivel acesso publico como true.
	$scope.iniciarNivelAcessoPublico = function(){
		 // checked true no tipoNivelAcesso público.
		 $.grep($scope.tipoNivelAcessoList, function(e){ return e.codigo === 2; })[0].checked = true;
		 var nivelAcessoTipoDocumento = {};
		 nivelAcessoTipoDocumento.nivelAcesso = $.grep($scope.tipoNivelAcessoList, function(e){ return e.codigo === 2; })[0].originalElement;
		 //add o nivel acesso público
		 $scope.tipoDocumento.acessos.push(nivelAcessoTipoDocumento);
	};
	
		
    //monta o nivel de acesso persistido
    $scope.montarNivelAcesso = function(){
    	
    	if( $scope.tipoDocumento.acessos){
    		
    		angular.forEach($scope.tipoNivelAcessoList, function (item) {
    			
    			item.checked = $scope.contemNivelAcesso(item);
    				
    		});
    		
    		angular.forEach($scope.sigiloList, function (item) {
    			
    			item.checked = $scope.contemSigilo(item);
    				
    		});
    		
    	}
    	
    };
    
    //Verifica se a lista acessos do tipo processo contem nivelAcesso passado por parametro
	$scope.contemNivelAcesso = function(nivelAcesso){
		return $scope.tipoDocumento.acessos.some(function(item){
			if(item.nivelAcesso.codigo == 0){
				$scope.tipoSigilo = item.tipoSigilo;
			}
			return item.nivelAcesso.id == nivelAcesso.id;
			
		});
	};
	
	$scope.contemSigilo = function(sigilo){
		
		var contemSigilo = false;
		
		angular.forEach($scope.tipoDocumento.acessos, function (nivelAcessoTipoDocumento) {
			
			if(nivelAcessoTipoDocumento.nivelAcesso.codigo === 0){
				
				contemSigilo = nivelAcessoTipoDocumento.sigilos.some(function(sigiloTipoDocumento){
					return sigiloTipoDocumento.sigilo.id === sigilo.id;
					
				});
			}
			
		});
		
		return contemSigilo;
	};
	
	//Remove a seleção dos sigilos selecionados
	var removerSelecaoSigilo = function(){
		 
		 angular.forEach($scope.sigiloList,  function (item, index) {
			 
			 item.checked = false;
		 });
	};
	
	//## Iniciar Dominios ##
	$scope.findDominioNivelAcesso = function(iniciarNivelAcessoPublico){
		
		DominioRepository.findAllDominio('tipoNivelAcesso').then(function(result) {
			$scope.tipoNivelAcessoList = result;

			if(iniciarNivelAcessoPublico){
				$scope.iniciarNivelAcessoPublico();
			}
		});
		
	};
	
	 $scope.findDominioNivelAcesso(false);
    
	 //Lista todos os Sigilos do sistema
	$scope.findSigiloList = function(){
		
		$scope.sigiloList = [];
		
		SigiloRepository.getList().then(function(result) {
			
			angular.forEach(result,  function (item) {
				
				$scope.sigiloList.push(item.originalElement);
			});
			
		});
	};
	   
    DominioRepository.findAllDominio('tipoFormaCriacao').then(function(result) {
        $scope.formaCriacaoList = result;
    });
    
    DominioRepository.findAllDominio('formaNumeracao').then(function(result) {
        $scope.formaNumeracaoList = result;
    });
    
	$scope.findAutoCompleteTemplatePadrao = function(value){
	    return TemplatePadraoRepository.findAutoComplete('nome',value).then(function(result) {
	    	return result;
	    	});
		};
    
}]);
