'use strict';

citApp.controller('TipoDocumentoListController',['$scope', 'TipoDocumentoRepository', '$translate', '$timeout', 'DominioRepository', 'DocumentoGedRepository', function TipoDocumentoListController($scope, TipoDocumentoRepository, $translate, $timeout, DominioRepository, DocumentoGedRepository) {
    $scope.$showAdvancedFilters = false;

    $scope.resetForm = function() {
        angular.element("#editTipoDocumento").scope().resetForm();
    };

    $scope.headers = [ {title : $translate.instant('LABEL.NOME'), value : 'nome' } , {title : $translate.instant('LABEL.DESCRICAO'), value : 'descricao' } ];

    $scope.filterCriteria = {
        start : 1,
        dir : 'asc',
        sort : 'id',
        limit : 10,
        fields: ['id', 'nome', 'descricao'],
        filters : [ {type : 'string', field : 'nome' } , {type : 'string', field : 'descricao' }]
    };
    
            
    // ABRI TipoDocumento SELECIONADA
    $scope.abrirVisualizar = function(edit){
        var tipoDocumento = $scope.tipoDocumentoChecked;

        if(!tipoDocumento) {
            $scope.showAlert('warning', !edit ? $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_VISUALIZACAO') : $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_EDICAO'));
            return;
        }
        angular.element('#editTipoDocumento').scope().getTipoDocumento(tipoDocumento, edit);
        $scope.$showPageEditWorkspace($scope.workspace);
    };
    
    // MODAL QUE CONFIRMA REMOVER DA CIDADE
    $scope.removeDocumento = function(){
    	
    	var tipoDocumento = $scope.tipoDocumentoChecked;
    	
        if(!tipoDocumento) {
            $scope.showAlert('warning', $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_SER_REMOVIDO'));
            return;
        }
    	
    	DocumentoGedRepository.existeVinculo({"joinClass": 'tipoDocumento.id', "id": tipoDocumento.id}).then(function(result) {
			
    		if(result){
    			$scope.showAlert('error', $translate.instant('ECM.MSG.EXISTE_VINCULO_PROCESSO'));
    			
    		}else{
    			$scope.tipoDocumento = tipoDocumento;
    			$scope.$openModalConfirm({message: $translate.instant('MSG.CONFIRMA_EXCLUSAO'),	callback: function () {
    				TipoDocumentoRepository.remove($scope.tipoDocumento).then(function() {
    					
    					$scope.$modalConfirmInstance.dismiss('cancel');
    					$scope.showAlert("success", $translate.instant('MSG.REGISTRO_EXCLUIDO'));
    					angular.element('#searchTipoDocumento').scope().fetchResult();
    					
    					$scope.resetForm();
    				});
    			}
    		  });
	    	}
		});	

    };
    
}]);
