'use strict';

citApp.controller('TipoProcessoListController',['$scope', 'TipoProcessoRepository', '$translate', '$timeout', 'DominioRepository','ProcessoRepository', function TipoProcessoListController($scope, TipoProcessoRepository, $translate, $timeout, DominioRepository, ProcessoRepository) {
    $scope.$showAdvancedFilters = false;

    $scope.resetForm = function() {
        angular.element("#editTipoProcesso").scope().resetForm();
    };

    $scope.headers = [ {title : $translate.instant('LABEL.NOME'), value : 'nome' } , {title : $translate.instant('LABEL.DESCRICAO'), value : 'descricao' }, {title : $translate.instant('ECM.LABEL.PROCESSO_NEGOCIO'), value : 'processoNegocio' }];

    $scope.filterCriteria = {
        start : 1,
        dir : 'asc',
        sort : 'id',
        limit : 10,
        fields: ['id', 'nome', 'descricao', 'processoNegocio'],
        filters : [ {type : 'string', field : 'nome' } , {type : 'string', field : 'descricao' }, {type : 'string', field : 'processoNegocio' }]
    };
    
    // ABRI TipoProcesso SELECIONADA
    $scope.abrirVisualizar = function(edit){
        var tipoProcesso = $scope.tipoProcessoChecked;

        if(!tipoProcesso) {
            $scope.showAlert('warning', !edit ? $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_VISUALIZACAO') : $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_EDICAO'));
            return;
        }
        angular.element('#editTipoProcesso').scope().getTipoProcesso(tipoProcesso, edit);
        $scope.$showPageEditWorkspace($scope.workspace);
    };
    
    // MODAL QUE CONFIRMA REMOVER DO TIPO PROCESSO
    $scope.removeProcesso = function(){
    	
    	var tipoProcesso = $scope.tipoProcessoChecked; 
    	
        if(!tipoProcesso) {
            $scope.showAlert('warning', $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_SER_REMOVIDO'));
            return;
        }
    	
    	ProcessoRepository.existeVinculo({"joinClass": 'tipoProcesso.id', "id": tipoProcesso.id}).then(function(result) {
			
    		if(result){
    			$scope.showAlert('error', $translate.instant('MSG.EXISTE_VINCULO_PROCESSO'));
    			
    		}else{
    	        $scope.tipoProcesso = tipoProcesso;
    	        $scope.$openModalConfirm({
    	            message: $translate.instant('MSG.CONFIRMA_EXCLUSAO'),
    	            callback: function () {
    	                TipoProcessoRepository.remove($scope.tipoProcesso).then(function() {

    	                    $scope.$modalConfirmInstance.dismiss('cancel');
    	                    $scope.showAlert("success", $translate.instant('MSG.REGISTRO_EXCLUIDO'));
    	                    angular.element('#searchTipoProcesso').scope().fetchResult();

    	                    $scope.resetForm();
    	                });
    	            }
    	        });
    		}
		});
    };
}]);
