'use strict';

citApp.controller('TipoSuporteDocumentoController', ['$scope', 'TipoSuporteDocumentoRepository', '$filter', '$translate', '$timeout', function TipoSuporteDocumentoController($scope, TipoSuporteDocumentoRepository, $filter, $translate, $timeout) {
	$scope.tipoSuporteDocumento = {};


	// Limpa formulário para novo cadastro
	$scope.resetForm = function() {
		$scope.limparPrivilegio();
		$scope.edit = true;
		$timeout(function(){
			$scope.tipoSuporteDocumentoForm.$submitted = false;
			$scope.tipoSuporteDocumentoForm.$setPristine();
		});
	};

	// Atualiza pagina de pesquisa
	$scope.atualizaPaginaPesquisa = function () {
		angular.element('#searchTipoSuporteDocumento').scope().fetchResult();
	};

	// SALVA O PAIS
	$scope.saveOrUpdate = function(){
		$scope.tipoSuporteDocumentoForm.$submitted = true;

		//verifica se o formulario está valido para salvar
		if($scope.tipoSuporteDocumentoForm.$valid){

			$scope.setLoadingSalva(true);

			TipoSuporteDocumentoRepository.save($scope.tipoSuporteDocumento).then(function(result) {
				$scope.tipoSuporteDocumento = result.originalElement;
		         $scope.showAlert("success", $translate.instant('MSG.REGISTRO_SALVO'));
				$scope.tipoSuporteDocumentoForm.$submitted = false;
				$scope.setLoading(false);
			});
		}else{
			//Mensagem de erro de campos obrigatorios não preenchidos
			$scope.showAlert('error', $translate.instant('VALIDACAO.ALERTA_OBRIGATORIOS'), " ", false);
		}

	};

	// Limpa o formulario preenchido
	$scope.limparPrivilegio = function(){
		$scope.tipoSuporteDocumento = {};
	};



	// Consulta entidade e mostra no formulario
	$scope.getTipoSuporteDocumento = function(tipoSuporteDocumento, edit){
		$scope.setLoadingGet(true);

		TipoSuporteDocumentoRepository.get(tipoSuporteDocumento.id).then(function(result) {
			$scope.tipoSuporteDocumento = result.originalElement;
			$scope.pgEdit = edit;
			$scope.edit = edit;
			$scope.setLoading(false);
		});
	};
	
}]);


