'use strict';

citApp.controller('TipoSuporteDocumentoListController', ['$scope', 'TipoSuporteDocumentoRepository', '$translate', '$modal', '$timeout', function TipoSuporteDocumentoListController($scope, TipoSuporteDocumentoRepository, $translate, $modal, $timeout) {

	$scope.$showAdvancedFilters = false;

	// Chama controlleredit para limpar o formulario de cadastro
	$scope.resetForm = function() {
		angular.element("#editTipoSuporteDocumento").scope().resetForm();
	};

	$scope.headers = [
	{title : $translate.instant('LABEL.NOME'), value : 'nome'}];

	// default criteria that will be sent to the server
	$scope.filterCriteria = {
		start : 1,
		dir : 'asc',
		sort : 'id',
		limit : 10,
		fields: ['id','nome'],
		filters : [{type: 'string', field: 'nome'}]
	};

	// ABRI PAIS SELECIONADO
	$scope.abrirTipoSuporteDocumento = function(edit){
		var tipoSuporteDocumento = $scope.tipoSuporteDocumentoChecked;

		if(!edit && !tipoSuporteDocumento) {
			$scope.showAlert('warning', $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_VISUALIZACAO'));
			return;
		}

		if(edit && !tipoSuporteDocumento) {
			$scope.showAlert('warning', $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_EDICAO'));
			return;
		}

		angular.element('#editTipoSuporteDocumento').scope().getTipoSuporteDocumento(tipoSuporteDocumento, edit);
		$scope.$showPageEditWorkspace($scope.workspace);
	};

}]);