'use strict';

citApp.factory('ConfiguracaoUsuarioUnidadeRepository', ['RestangularEcm', 'AbstractRepository', function (restangularEcm, AbstractRepository) {

    function ConfiguracaoUsuarioUnidadeRepository() {
    	AbstractRepository.call(this, restangularEcm, 'rest/configuracaoUsuarioUnidade');
    	
    	this.save = function(configuracaoUsuarioUnidadeVH) {
			return restangularEcm.all(this.route + '/salvar').post(configuracaoUsuarioUnidadeVH).then();
		};
		
		this.findPorUsuarioOrganizacao = function() {
			return restangularEcm.one(this.route).getList("findPorUsuarioOrganizacao").then();
		};
		
		this.findPorEstruturaOrganizacionalECM = function(idUnidade) {
			return restangularEcm.one(this.route).getList("findPorEstruturaOrganizacionalECM", {"idUnidade": idUnidade}).then();
		};
		
		this.findPorUsernameUsuarioAndUnidade = function(username, idUnidade){
    		return restangularEcm.one(this.route + "/findPorUsernameUsuarioAndUnidade").get({"username": username, "idUnidade" : idUnidade}).then();
    	}; 
    }
    
    AbstractRepository.extend(ConfiguracaoUsuarioUnidadeRepository);
    
    return new ConfiguracaoUsuarioUnidadeRepository();
}]);