'use strict';

citApp.factory('PlanoClassificacaoRepository', ['RestangularEcm', 'AbstractRepository', function (restangularEcm, AbstractRepository) {

    function PlanoClassificacaoRepository() {
    	AbstractRepository.call(this, restangularEcm, 'rest/planoClassificacao');
    	//Listar o nó 0 da árvore.
    	this.findParent = function(idOrganizacao) {
    		return restangularEcm.one(this.route).getList("findParent", {idOrganizacao : idOrganizacao}).then();
    	};
    	
    	//Listar filhos
    	this.findChildrens = function(idPlanoClassificacao) {
    		return restangularEcm.one(this.route).getList("findChildrens", {idPlanoClassificacao : idPlanoClassificacao}).then();
    	};
    	
    	//Listar recursivo
    	this.findTree = function(nome) {
    		return restangularEcm.one(this.route).getList("findTree", {nome : nome}).then();
    	};
    	
    	//Listar assunto recursivo autoComplete
    	this.findAssuntoAutoComplete = function(codigoNome) {
    		return restangularEcm.one(this.route).getList("findAssuntoAutoComplete", {codigoNome : codigoNome}).then();
    	};
    }
    

    AbstractRepository.extend(PlanoClassificacaoRepository);

    return new PlanoClassificacaoRepository();
}]);
