'use strict';

citApp.factory('ProcessoRepository', ['RestangularEcm', 'AbstractRepository', function (restangularEcm, AbstractRepository) {

    function ProcessoRepository() {
    	AbstractRepository.call(this, restangularEcm, 'rest/processo');
    	
    	this.atualizaProcesso = function(id) {
			return restangularEcm.one(this.route + '/findProcessoDocumentoAtualById').get({"id": id}).then();
		};
		
		this.concluir = function(paramsGet) {
			return restangularEcm.one(this.route + "/concluir").get(paramsGet);
		};
		

		this.atualizarSigiloProcesso = function(paramsGet) {
			return restangularEcm.all(this.route + '/atualizarSigiloProcesso').post(paramsGet);
		};
		
		this.getProcessoByIdProcessInstance = function (idProcessInstance){
			return restangularEcm.one(this.route + '/getProcessoByIdProcessInstance').get({"idProcessInstance": idProcessInstance}).then();
		};
		
		this.getProcessoByProtocolo = function (nup){
			return restangularEcm.one(this.route + '/getProcessoByProtocolo').get({"nup": nup}).then();

		};
		
		this.getProcessoGerenciamento = function (idProcesso){
			return restangularEcm.one(this.route + '/getProcessoGerenciamento').get({"idProcesso": idProcesso});

		};
		
		this.getProcessoVH = function (idProcesso){
			return restangularEcm.one(this.route + '/getProcessoVH').get({"idProcesso": idProcesso});

		};
		
		this.verificarAtribuicaoProcessoPrimeiroAcesso = function (idProcesso){
			return restangularEcm.one(this.route + '/verificarAtribuicaoProcessoPrimeiroAcesso').get({"idProcesso": idProcesso});

		};
		
		this.getMetadadoProcesso = function (idProcesso){
			return restangularEcm.one(this.route + '/getMetadadoProcesso').get({"idProcesso": idProcesso});

		};
		
		this.autoCompleteProcessoEmAndametoByNup = function (nup){
			return restangularEcm.one(this.route + '/autoCompleteProcessoEmAndametoByNup').get({"nup": nup}).then();

		};		
		
		this.autoCompleteProcessoConcluidoByNup = function (nup){
			return restangularEcm.one(this.route + '/autoCompleteProcessoConcluidoByNup').get({"nup": nup}).then();

		};

    }

    AbstractRepository.extend(ProcessoRepository);

    return new ProcessoRepository();
}]);
