'use strict';

citApp.factory('UnidadeProcessoRepository', ['RestangularEcm', 'AbstractRepository', function (restangularEcm, AbstractRepository) {

    function UnidadeProcessoRepository() {
    	AbstractRepository.call(this, restangularEcm, 'rest/unidadeProcesso');
    	
    	this.save = function(unidadeProcessoVH) {
			return restangularEcm.all(this.route + '/save').post(unidadeProcessoVH).then();
		};
		
		this.findByIdProcesso = function(idProcesso) {
			return restangularEcm.one(this.route).getList("findByIdProcesso", {"idProcesso": idProcesso}).then();
		};
		
		this.obterPorUnidadeEProcesso = function(idUnidade, idProcesso) {
			return restangularEcm.one(this.route + "/obterPorUnidadeEProcesso").get({"idProcesso" : idProcesso, "idUnidade" : idUnidade});
			
		};
		
		this.findByPorIdProcessoEmExecucao = function(idProcesso) {
			return restangularEcm.one(this.route).getList("findByPorIdProcessoEmExecucao", {"idProcesso": idProcesso}).then();
		};
		
			
		this.isProcessoNaUnidadeUsuarioLogado = function(idProcesso) {
			return restangularEcm.one(this.route + "/isProcessoNaUnidadeUsuarioLogado").get({"idProcesso" : idProcesso});
			
		};
		
    }

    AbstractRepository.extend(UnidadeProcessoRepository);

    return new UnidadeProcessoRepository();
}]);
