<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib prefix="sec" uri="http://www.springframework.org/security/tags"%>

<div ng-controller="CredencialProcessoController as credencialProcessoController">
	<form name="credencialProcessoController.credenciarProcessoForm" novalidate autocomplete="off">

		<div id="widget-credenciarProcesso" class="widget-box margin-bottom">
			<div class="widget-header">
				<h2 class="widget-title">
					<translate>ECM.LABEL.GERENCIAR_CREDENCIAIS_ACESSO</translate>
				</h2>

				<div class="widget-toolbar">
					<a href="#void" ng-click="closeWidget('widget-credenciarProcesso')"> <i class="fa fa-close"></i>
					</a>
				</div>
			</div>
			<div class="widget-main clearfix">
				<div id="credencialProcessoEdit" class="page-content clearfix">

					<p>
						<small>( <span class="red">*</span> ) <translate>LABEL.CAMPOS_OBRIGATORIOS</translate></small>
					</p>

					<fieldset>
						<legend>
							<label ng-class="{'has-error' : credenciarProcessoForm.$submitted && credencialProcessoList.length < 1}"> <translate>ECM.LABEL.CREDENCIAR_USUARIO_GRUPO</translate> <span class='red'>*</span>
								<i ng-show="credenciarProcessoForm.$submitted && credencialProcessoList.length < 1" class='fa fa-warning red'
								tooltip="{{$translate.instant('ECM.LABEL.CREDENCIAR_USUARIO_GRUPO') + ' ' +$translate.instant('LABEL.CAMPO_OBRIGATORIO')}}" tooltip-placement='top'></i>
							</label>
						</legend>


						<div class="row">

							<div class="col-md-8">
								<auto-complete ng-id="credencialProcesso.grupoUsuario" ng-label="ECM.LABEL.USUARIO_GRUPO" ng-model="credencialProcesso.grupoUsuario" ng-find="findAutoCompleteGrupoUsuario(value)"
									ng-item="item.nome" />
							</div>

							<div class="col-sm-4">
								<label-input-checkbox ng-id="credencialProcesso.permiteCredenciar" ng-model="credencialProcesso.permiteCredenciar" ng-label="ECM.LABEL.PODE_CREDENCIAR"></label-input-checkbox>
							</div>

						</div>

						<div class="row">

							<div class="col-md-12">
								<div class="row">
									<div class="col-sm-12">
										<div class="panel panel-default">
											<div class="panel-heading clearfix">
												<button title="{{$translate.instant('LABEL.ADICIONAR')}}" alt="{{$translate.instant('LABEL.ADICIONAR')}}" class="btn btn-clear" ng-click="addCredencial()"
													ng-disabled="!credencialProcesso.grupoUsuario.id" type="button">
													<i class="fa fa-plus-circle yellow-dark"></i>
													<translate>LABEL.ADICIONAR</translate>
													</a>
												</button>

											</div>
											<table class="table table-striped table-bordered table-hover">
												<thead>
													<tr>
														<th width="5%" class="text-center"></th>
														<th width="35%" class="text-center"><translate>LABEL.NOME</translate></th>
														<th width="20%" class="text-center"><translate>LABEL.UNIDADE</translate></th>
														<th width="20%" class="text-center"><translate>ECM.LABEL.PODE_CREDENCIAR</translate></th>
														<th width="10%" class="text-center"><translate>LABEL.ACOES</translate></th>
													</tr>
												</thead>
												<tbody>
													<tr ng-repeat="credencialProcesso in credenciais">

														<td class="text-center"><i class="{{credencialProcesso.icon}}" title="{{credencialProcesso.grupo  ? $translate.instant('LABEL.GRUPO') : $translate.instant('LABEL.USUARIO')}}"></i></td>
														<td class="text-center">{{credencialProcesso.grupo.nome}}{{credencialProcesso.usuario.username}}</td>
														<td class="text-center">{{credencialProcesso.usuario.unidade.nome}}</td>
														<td class="text-center">{{credencialProcesso.permiteCredenciar ? $translate.instant('LABEL.SIM') : $translate.instant('LABEL.NAO')}}</td>
														<td class="text-center">
															<button class="btn btn-clear" type="button" ng-if="!credencialProcesso.id || credencialProcesso.permiteEdicao"  title="{{$translate.instant('LABEL.REMOVER')}}" ng-click="exibirDialogRemocao(credencialProcesso)">
																<i class="fa fa-times red"></i>
															</button>
															<button type="button" class="btn btn-clear" ng-if="!credencialProcesso.id || credencialProcesso.permiteEdicao" title="{{$translate.instant('LABEL.EDITAR')}}" ng-click="editCredencial(credencialProcesso);">
																<i class="fa fa-pencil blue"></i>
															</button>
														</td>

													</tr>
													<tr ng-hide="credenciais.length > 0">
														<td colspan="5" class="text-center"><translate>LABEL.TABELA_VAZIA</translate></td>
													</tr>
												</tbody>
											</table>
										</div>
									</div>
								</div>
							</div>
						</div>

					</fieldset>

					<fieldset>

						<legend>
							<translate>ECM.LABEL.HERANCA_SISTEMA</translate>
						</legend>

						<div class="col-md-12">
							<div class="row">
								<div class="col-sm-12">
									<div class="panel panel-default">
										<div class="panel-heading clearfix"></div>
										<table class="table table-striped table-bordered table-hover">
											<thead>
												<tr>
													<th class="text-center"><translate>ECM.LABEL.USUARIO_GRUPO</translate></th>
													<th class="text-center"><translate>LABEL.UNIDADE</translate></th>
												</tr>
											</thead>
											<tbody>
												<tr ng-repeat="hecanca in herdadas">
													<td class="text-center">{{hecanca.nome}}</td>
													<td class="text-center">{{hecanca.nomeUnidade}}</td>
												</tr>
												<tr ng-hide="historicos.length > 0">
													<td colspan="2" class="text-center"><translate>LABEL.TABELA_VAZIA</translate></td>
												</tr>
											</tbody>
										</table>
									</div>
								</div>
							</div>
						</div>

					</fieldset>

					<div class="row">
						<div class="col-md-12">
							<button class="btn btn-sm btn-primary" ng-click="saveOrUpdate()" type="button" ng-disabled="credencialProcesso.grupoUsuario.id || credenciais.length == 0">
								<translate>LABEL.SALVAR</translate>
							</button>

							<button class="btn btn-sm btn-primary" ng-click="closeWidget('widget-credenciarProcesso')" type="button">
								<translate>LABEL.CANCELAR</translate>
							</button>
						</div>
					</div>
				</div>
			</div>
		</div>

		<div id="widget-historicoCredenciarProcesso" class="widget-box margin-bottom">
			<div class="widget-header">
				<h2 class="widget-title">
					<translate>ECM.LABEL.HISTORICO_CREDENCIAL</translate>
				</h2>

				<div class="widget-toolbar">
					<a href="#void" ng-click="closeWidget('widget-historicoCredenciarProcesso')"> <i class="fa fa-close"></i> <a href="#void"
						ng-click="widgetCredencialProcessoIsCollapsed = !widgetCredencialProcessoIsCollapsed"> <i class="fa"
							ng-class="{'fa-chevron-up': !widgetCredencialProcessoIsCollapsed, 'fa-chevron-down': widgetCredencialProcessoIsCollapsed}"></i>
					</a>
				</div>
			</div>
			<div id="metadadosDocumentoGedCollapsed" collapse="widgetCredencialProcessoIsCollapsed" class="widget-body">
				<div class="widget-main clearfix">
					<div id="historicoCredencialProcesso" class="page-content clearfix">
						<div class="col-md-12">
							<div class="row">
								<div class="col-sm-12">
									<div class="panel panel-default">
										<div class="panel-heading clearfix"></div>
										<table class="table table-striped table-bordered table-hover">
											<thead>
												<tr>
													<th class="text-center"><translate>ECM.LABEL.USUARIO_GRUPO</translate></th>
													<th class="text-center"><translate>LABEL.UNIDADE</translate></th>
													<th class="text-center"><translate>ECM.LABEL.CREDENCIADOR</translate></th>
													<th class="text-center"><translate>ECM.LABEL.CREDENCIADO_EM</translate></th>
													<th class="text-center"><translate>ECM.LABEL.DESCREDENCIADOR</translate></th>
													<th class="text-center"><translate>ECM.LABEL.DATA_DESCREDENCIAMENTO</translate></th>
												</tr>
											</thead>
											<tbody>
												<tr ng-repeat="historicoCredencialProcesso in historicos">

													<td class="text-center">{{historicoCredencialProcesso.credencialProcesso.grupo.nome}} {{historicoCredencialProcesso.credencialProcesso.usuario.username}}</td>
													<td class="text-center">{{historicoCredencialProcesso.unidadeUsuarioCredenciado}}</td>
													<td class="text-center">{{historicoCredencialProcesso.credencialProcesso.autor.username}}</td>
													<td class="text-center">{{historicoCredencialProcesso.credencialProcesso.dataCriacao | date:'dd-MM-yyyy HH:mm'}}</td>
													<td class="text-center">{{historicoCredencialProcesso.descredenciador.username}}</td>
													<td class="text-center">{{historicoCredencialProcesso.dataDescredenciado | date:'dd-MM-yyyy HH:mm'}}</td>

												</tr>
												<tr ng-hide="historicos.length > 0">
													<td colspan="6" class="text-center"><translate>LABEL.TABELA_VAZIA</translate></td>
												</tr>
											</tbody>
										</table>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>

	</form>

</div>
