<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib prefix="sec" uri="http://www.springframework.org/security/tags"%>

<button ng-show="task.flowElement.actions && task.flowElement.actions.length == 1" title="{{$translate.instant('ESI.EXECUCAO_TAREFA.GRAVAR_TAREFA_AVANCAR')}}"
	alt="{{$translate.instant('ESI.EXECUCAO_TAREFA.GRAVAR_TAREFA_AVANCAR')}}" class="btn btn-clear" ng-click="executarProcesso(task.flowElement.actions[0])">
	<i class="fa fa-play-circle green"></i>
	<translate>ECM.LABEL.AVANCAR_FLUXO</translate>
</button>

<div class="btn-group dropdown" role="group" dropdown ng-show=" task.flowElement.actions && task.flowElement.actions.length > 1">
	<button type="button" class="btn btn-clear" dropdown-toggle>
		<i class="fa fa-play-circle green"></i>
		<translate>ECM.LABEL.AVANCAR_FLUXO</translate>
		<span class="fa fa-caret-down icon-on-right"></span>
	</button>

	<ul class="dropdown-menu-center dropdown-menu dropdown-caret" role="menu" ng-repeat="action in task.flowElement.actions">
		<li ng-repeat="action in task.flowElement.actions"><a href="javascript: return false;" ng-click='executarProcesso(action);'><i class="fa fa-circle"> <translate>{{action.name}}</translate></i></a>
		</li>

	</ul>
</div>

<span class="divider-vertical"></span>

<button type="button" class="btn btn-clear" ng-click="novoProcesso();">
	<i class="fa fa-plus-circle yellow-dark"></i>
	<translate>ECM.LABEL.NOVOPROCESSO</translate>
</button>

<button type="button" class="btn btn-clear" ng-click="editProcessoECM()">
	<i class="fa fa-pencil blue"></i>
	<translate>LABEL.EDITAR</translate>
</button>

<button type="button" class="btn btn-clear" ng-click="concluir()" ng-if="task.id">
	<i class="ace-icon fa fa-check green"></i>
	<translate>ECM.LABEL.CONCLUIR</translate>
</button>

<button type="button" class="btn btn-clear" ng-click="newDocument()">
	<i class="fa fa-book blue"></i>
	<translate>ECM.LABEL.INCLUIRDOCUMENTO</translate>
</button>

<button type="button" ng-if="unidadeProcesso.usuarioResponsavel.id != usuarioLogado.id && task.id" class="btn btn-clear" ng-click="exibirAlertaCapturar()">
	<i class="fa fa-thumb-tack"></i>
	<translate>ECM.LABEL.CAPTURAR</translate>
</button>

<span class="divider-vertical"></span>

<div class="btn-group dropdown" role="group" dropdown>
	<button type="button" class="btn btn-clear" dropdown-toggle>
		<i class="fa fa-list"></i>
		<translate>ECM.LABEL.ACAODEPROCESSO</translate>
		<span class="fa fa-caret-down icon-on-right"></span>
	</button>

	<ul class="dropdown-menu-center dropdown-menu dropdown-caret" role="menu">
		<li><a href="#void" ng-click="editProcessoRelacionado();" ng-if="task.id"><i class="fa fa-link"></i> <translate>ECM.LABEL.PROCESSORELACIONADOS</translate></a></li>
		<li><a href="#void" ng-click='enviarProcesso();' ng-if="task.id"><i class="fa fa-share-square-o">&nbsp </i> <translate>ECM.LABEL.ENVIAR_PROCESSO</translate> </a></li>
		<li><a href="#void" ng-click='anexarProcesso();' ng-if="task.id"><i class="fa fa-paperclip">&nbsp </i> <translate>ECM.LABEL.ANEXAR_ESTE_PROCESSO</translate> </a></li>

		<sec:authorize access="permiteCredenciar()">
			<li><a href="#void;" ng-click='gerenciarCredenciaisProcesso();' ng-if="task.id"><i class="fa fa-user-plus">&nbsp </i> <translate>ECM.LABEL.GERENCIAR_CREDENCIAIS_ACESSO</translate> </a></li>
		</sec:authorize>

		<sec:authorize access="permiteRenunciar()">
			<li><a href="javascript: return false;" ng-click='exibirDialogConfirmacaoRemoverCredencial()' ng-if="task.id"><i class="fa fa-user-times">&nbsp </i> <translate>ECM.LABEL.RENUNCIAR_CREDENCIAL</translate> </a></li>
		</sec:authorize>

		<sec:authorize access="hasAnyRole('USER_RESERVADO', 'USER_SECRETO', 'USER_ULTRASSECRETO')">
			<li><a href="#void" ng-click='classificarDocumentoProceso();'><i class="fa fa fa-eye">&nbsp </i> <translate>ECM.LABEL.VALIDAR_NIVEL_ACESSO</translate> </a></li>
		</sec:authorize>

		<li><a href="javascript: return false;" ng-click='atribuirProcesso()' ng-if="unidadeProcesso.id && task.id"><i class="fa fa-male">&nbsp </i> <translate>ECM.LABEL.ATRIBUIR_PROCESSO</translate> </a></li>

	</ul>
</div>


