<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib prefix="sec" uri="http://www.springframework.org/security/tags"%>

<fieldset style="margin-left: 5%; width: 90%; margin-top: 10px;">

	<div ng-if="assignments.length < 1 && doc.nivelAcesso == 'Restrito'" style="text-align: center;" class="alert alert-warning ng-scope" role="alert">
		<span class="small" style="font-size: 122%"><translate>ECM.MSG.INFORMACAO_RESTRITA</translate></span>
	</div>
	
	<div ng-if="doc.nivelAcesso== 'Pblico' || assignments.length > 0" class="row" style="margin-top: 6px; margin-bottom: -25px;">
		<div class="panel panel-default">
			<sec:authorize access="permiteExecutar()">
				<div class="panel-heading clearfix" style="background-color: rgba(170, 170, 170, 0.34); border-color: rgba(170, 170, 170, 0.78);">
					<button class="btn btn-clear" title="{{$translate.instant('LABEL.EXECUTAR')}}" alt="{{$translate.instant('LABEL.EXECUTAR')}}" type="button" ng-click="executarTarefa();"
						ng-if="btnAction && doc.workItem.processInstance.status != 'SUSPENDED'">
						<i class="fa fa-play-circle-o green"></i>
						<translate>LABEL.EXECUTAR</translate>
					</button>
					<button class="btn btn-clear" title="{{$translate.instant('LABEL.VISUALIZAR')}}" alt="{{$translate.instant('LABEL.VISUALIZAR')}}" type="button" ng-click="abreVisualizar();">
						<i class="fa fa-search blue"></i>
						<translate>LABEL.VISUALIZAR</translate>
					</button>
					<button class="btn btn-clear" title="{{$translate.instant('ECM.LABEL.SOBRESTAR_SEM')}}" alt="{{$translate.instant('ECM.LABEL.SOBRESTAR_SEM')}}" type="button" ng-click="suspenderProcesso();"
						ng-if="btnAction &&modelSelecionado.workItem.processInstance.status != 'SUSPENDED'">
						<i class="fa fa-pause red"></i>
						<translate>ECM.LABEL.SOBRESTAR_SEM</translate>
					</button>
					<button class="btn btn-clear" title="{{$translate.instant('LABEL.REATIVAR')}}" alt="{{$translate.instant('LABEL.REATIVAR')}}" type="button" ng-click="reativarProcesso();"
						ng-if="btnAction && modelSelecionado.workItem.processInstance.status == 'SUSPENDED'">
						<i class="fa fa-play green"></i>
						<translate>LABEL.REATIVAR</translate>
					</button>
					<button class="btn btn-clear" title="{{$translate.instant('PORTAL.LABEL.VISUALIZAR_FLUXO')}}" alt="{{$translate.instant('PORTAL.LABEL.VISUALIZAR_FLUXO')}}" type="button"
						ng-click="visualizarFluxo();" ng-if="btnAction">
						<i class="fa fa-search blue"></i>
						<translate>PORTAL.LABEL.VISUALIZAR_FLUXO</translate>
					</button>
					<button class="btn btn-clear" ng-if="btnAction" title="{{$translate.instant('ESI.LOG.CONSULTA_LOG')}}" alt="{{$translate.instant('ESI.LOG.CONSULTA_LOG')}}" type="button"
						ng-click="consultarHistorico();">
						<i class="fa fa-history yellow-dark"></i>
						<translate>ESI.LOG.CONSULTA_LOG</translate>
					</button>
				</div>
			</sec:authorize>
			<div class="panel-body">

				<table class="table table-striped table-bordered table-hover" style="width: 100%; margin-left: 0%; margin-right: 1%; margin-bottom: 1%; margin-top: 1%">
					<thead>
						<tr>
							<th style="width: 5%;"></th>
							<th colspan="2" style="width: 60%;"><small><translate>ESI.TAREFA</translate></small></th>
							<th style="align: center;"><small><translate>ECM.LABEL.SITUACAO_INSTANCIA_TAREFA</translate></small></th>
						</tr>
					</thead>
					<tbody>
						<tr ng-repeat="assignment in assignments">
							<td class="text-center" style="width: 5%;"><input type="radio" id="{{assignment.id}}" name="assignments" ng-checked="assignment.checked === true" ng-click="selectAssignment(assignment);" />
							</td>
							<td class="text-center" style="width: 5%;"><span class="small green">{{assignment.id}}</span></td>
							<td><span class="small green">{{assignment.flowElement.name}}</span></td>
							<td><label ng-show="assignment.workItem.processInstance.status != 'SUSPENDED' && assignment.workItem.processInstance.flowStatus"> <span class="small badge black"
									style="background-color: {{assignment.workItem.processInstance.flowStatus.backgroundColor"> <b><font color="{{assignment.workItem.processInstance.flowStatus.textColor}}"> <translate>{{assignment.workItem.processInstance.flowStatus.name}}</translate></b></font>
								</span>
							</label> <label ng-show="assignment.workItem.processInstance.status == 'SUSPENDED'"> <span class="small badge black" style="background-color: red !important"> <b><font color="white">
												<translate>ECM.LABEL.SOBRESTADA</translate></b></font>
								</span>
							</label></td>
						</tr>
						<tr ng-show="assignments.length <= 0">
							<td colspan="4"><strong><translate>ECM.MSG.NAO_EXISTE_TAREFA_EXECUTAR</translate></strong></td>
						</tr>
					</tbody>
				</table>

			</div>
		</div>
	</div>

</fieldset>